/* Application.c generated by valac 0.56.18, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_APPLICATION_0_PROPERTY,
	HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_OVERRIDE_DARK_STYLE_PROPERTY,
	HE_APPLICATION_OVERRIDE_CONTRAST_PROPERTY,
	HE_APPLICATION_DEFAULT_CONTRAST_PROPERTY,
	HE_APPLICATION_IS_CONTENT_PROPERTY,
	HE_APPLICATION_IS_MONO_PROPERTY,
	HE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* he_application_properties[HE_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _he_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_rgb_color_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
enum  {
	HE_APPLICATION_ACCENT_COLOR_CHANGED_SIGNAL,
	HE_APPLICATION_NUM_SIGNALS
};
static guint he_application_signals[HE_APPLICATION_NUM_SIGNALS] = {0};

struct _HeApplicationPrivate {
	HeDesktop* desktop;
	HeStyleManager* style_manager;
	HeRGBColor* _default_accent_color;
	gboolean _override_accent_color;
	gboolean _override_dark_style;
	gboolean _override_contrast;
	gdouble _default_contrast;
	gboolean _is_content;
	gboolean _is_mono;
};

static gint HeApplication_private_offset;
static gpointer he_application_parent_class = NULL;

static void he_application_update_style_manager (HeApplication* self);
static HeSchemeVariant* _he_scheme_variant_dup (HeSchemeVariant* self);
static void he_application_init_app_styles (HeApplication* self);
VALA_EXTERN void he_misc_init_css_provider_from_file (GtkCssProvider* provider,
                                          GFile* file);
static void he_application_real_startup (GApplication* base);
static void __lambda184_ (HeApplication* self);
static void ___lambda184__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void _he_application_update_style_manager_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void he_application_finalize (GObject * obj);
static GType he_application_get_type_once (void);
static void _vala_he_application_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_application_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
he_application_get_instance_private (HeApplication* self)
{
	return G_STRUCT_MEMBER_P (self, HeApplication_private_offset);
}

HeRGBColor*
he_application_get_default_accent_color (HeApplication* self)
{
	HeRGBColor* result;
	HeRGBColor* _tmp0_;
#line 32 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../lib/Models/Application.vala"
	_tmp0_ = self->priv->_default_accent_color;
#line 32 "../lib/Models/Application.vala"
	result = _tmp0_;
#line 32 "../lib/Models/Application.vala"
	return result;
#line 122 "Application.c"
}

static gpointer
_he_rgb_color_dup0 (gpointer self)
{
#line 33 "../lib/Models/Application.vala"
	return self ? he_rgb_color_dup (self) : NULL;
#line 130 "Application.c"
}

void
he_application_set_default_accent_color (HeApplication* self,
                                         HeRGBColor* value)
{
	HeRGBColor* _tmp0_;
#line 33 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Models/Application.vala"
	_tmp0_ = _he_rgb_color_dup0 (value);
#line 33 "../lib/Models/Application.vala"
	_he_rgb_color_free0 (self->priv->_default_accent_color);
#line 33 "../lib/Models/Application.vala"
	self->priv->_default_accent_color = _tmp0_;
#line 33 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 33 "../lib/Models/Application.vala"
	g_signal_emit (self, he_application_signals[HE_APPLICATION_ACCENT_COLOR_CHANGED_SIGNAL], 0);
#line 33 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY]);
#line 152 "Application.c"
}

gboolean
he_application_get_override_accent_color (HeApplication* self)
{
	gboolean result;
#line 41 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../lib/Models/Application.vala"
	result = self->priv->_override_accent_color;
#line 41 "../lib/Models/Application.vala"
	return result;
#line 165 "Application.c"
}

void
he_application_set_override_accent_color (HeApplication* self,
                                          gboolean value)
{
#line 42 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 42 "../lib/Models/Application.vala"
	self->priv->_override_accent_color = value;
#line 42 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 42 "../lib/Models/Application.vala"
	g_signal_emit (self, he_application_signals[HE_APPLICATION_ACCENT_COLOR_CHANGED_SIGNAL], 0);
#line 42 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY]);
#line 182 "Application.c"
}

gboolean
he_application_get_override_dark_style (HeApplication* self)
{
	gboolean result;
#line 50 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../lib/Models/Application.vala"
	result = self->priv->_override_dark_style;
#line 50 "../lib/Models/Application.vala"
	return result;
#line 195 "Application.c"
}

void
he_application_set_override_dark_style (HeApplication* self,
                                        gboolean value)
{
#line 51 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 51 "../lib/Models/Application.vala"
	self->priv->_override_dark_style = value;
#line 51 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 51 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_OVERRIDE_DARK_STYLE_PROPERTY]);
#line 210 "Application.c"
}

gboolean
he_application_get_override_contrast (HeApplication* self)
{
	gboolean result;
#line 59 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../lib/Models/Application.vala"
	result = self->priv->_override_contrast;
#line 59 "../lib/Models/Application.vala"
	return result;
#line 223 "Application.c"
}

void
he_application_set_override_contrast (HeApplication* self,
                                      gboolean value)
{
#line 60 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 60 "../lib/Models/Application.vala"
	self->priv->_override_contrast = value;
#line 60 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 60 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_OVERRIDE_CONTRAST_PROPERTY]);
#line 238 "Application.c"
}

gdouble
he_application_get_default_contrast (HeApplication* self)
{
	gdouble result;
#line 69 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 69 "../lib/Models/Application.vala"
	result = self->priv->_default_contrast;
#line 69 "../lib/Models/Application.vala"
	return result;
#line 251 "Application.c"
}

void
he_application_set_default_contrast (HeApplication* self,
                                     gdouble value)
{
#line 70 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 70 "../lib/Models/Application.vala"
	self->priv->_default_contrast = CLAMP (value, -1.0, 1.0);
#line 70 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 70 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_DEFAULT_CONTRAST_PROPERTY]);
#line 266 "Application.c"
}

gboolean
he_application_get_is_content (HeApplication* self)
{
	gboolean result;
#line 79 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "../lib/Models/Application.vala"
	result = self->priv->_is_content;
#line 79 "../lib/Models/Application.vala"
	return result;
#line 279 "Application.c"
}

void
he_application_set_is_content (HeApplication* self,
                               gboolean value)
{
#line 80 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 80 "../lib/Models/Application.vala"
	self->priv->_is_content = value;
#line 80 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 80 "../lib/Models/Application.vala"
	g_signal_emit (self, he_application_signals[HE_APPLICATION_ACCENT_COLOR_CHANGED_SIGNAL], 0);
#line 80 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_IS_CONTENT_PROPERTY]);
#line 296 "Application.c"
}

gboolean
he_application_get_is_mono (HeApplication* self)
{
	gboolean result;
#line 89 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../lib/Models/Application.vala"
	result = self->priv->_is_mono;
#line 89 "../lib/Models/Application.vala"
	return result;
#line 309 "Application.c"
}

void
he_application_set_is_mono (HeApplication* self,
                            gboolean value)
{
#line 90 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 90 "../lib/Models/Application.vala"
	self->priv->_is_mono = value;
#line 90 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 90 "../lib/Models/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_IS_MONO_PROPERTY]);
#line 324 "Application.c"
}

/**
     * Gets the effective accent color that should be used for content drawing.
     * When is_content is true and default_accent_color is set, returns the default_accent_color.
     * Otherwise returns the desktop accent color.
     */
HeRGBColor*
he_application_get_effective_accent_color (HeApplication* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	HeDesktop* _tmp8_;
	HeRGBColor* _tmp9_;
	HeRGBColor* _tmp10_;
	HeRGBColor* _tmp11_;
	HeRGBColor* result;
#line 103 "../lib/Models/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../lib/Models/Application.vala"
	_tmp1_ = he_application_get_is_content (self);
#line 104 "../lib/Models/Application.vala"
	_tmp2_ = _tmp1_;
#line 104 "../lib/Models/Application.vala"
	if (_tmp2_) {
#line 351 "Application.c"
		HeRGBColor* _tmp3_;
		HeRGBColor* _tmp4_;
#line 104 "../lib/Models/Application.vala"
		_tmp3_ = he_application_get_default_accent_color (self);
#line 104 "../lib/Models/Application.vala"
		_tmp4_ = _tmp3_;
#line 104 "../lib/Models/Application.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 360 "Application.c"
	} else {
#line 104 "../lib/Models/Application.vala"
		_tmp0_ = FALSE;
#line 364 "Application.c"
	}
#line 104 "../lib/Models/Application.vala"
	if (_tmp0_) {
#line 368 "Application.c"
		HeRGBColor* _tmp5_;
		HeRGBColor* _tmp6_;
		HeRGBColor* _tmp7_;
#line 105 "../lib/Models/Application.vala"
		_tmp5_ = he_application_get_default_accent_color (self);
#line 105 "../lib/Models/Application.vala"
		_tmp6_ = _tmp5_;
#line 105 "../lib/Models/Application.vala"
		_tmp7_ = _he_rgb_color_dup0 (_tmp6_);
#line 105 "../lib/Models/Application.vala"
		result = _tmp7_;
#line 105 "../lib/Models/Application.vala"
		return result;
#line 382 "Application.c"
	}
#line 107 "../lib/Models/Application.vala"
	_tmp8_ = self->priv->desktop;
#line 107 "../lib/Models/Application.vala"
	_tmp9_ = he_desktop_get_accent_color (_tmp8_);
#line 107 "../lib/Models/Application.vala"
	_tmp10_ = _tmp9_;
#line 107 "../lib/Models/Application.vala"
	_tmp11_ = _he_rgb_color_dup0 (_tmp10_);
#line 107 "../lib/Models/Application.vala"
	result = _tmp11_;
#line 107 "../lib/Models/Application.vala"
	return result;
#line 396 "Application.c"
}

static HeSchemeVariant*
_he_scheme_variant_dup (HeSchemeVariant* self)
{
	HeSchemeVariant* dup;
#line 123 "../lib/Models/Application.vala"
	dup = g_new0 (HeSchemeVariant, 1);
#line 123 "../lib/Models/Application.vala"
	memcpy (dup, self, sizeof (HeSchemeVariant));
#line 123 "../lib/Models/Application.vala"
	return dup;
#line 409 "Application.c"
}

static gpointer
__he_scheme_variant_dup0 (gpointer self)
{
#line 123 "../lib/Models/Application.vala"
	return self ? _he_scheme_variant_dup (self) : NULL;
#line 417 "Application.c"
}

static void
he_application_update_style_manager (HeApplication* self)
{
	gboolean _tmp0_ = FALSE;
	HeRGBColor* _tmp1_;
	HeRGBColor* _tmp2_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	HeStyleManager* _tmp68_;
	HeDesktop* _tmp69_;
	gdouble _tmp70_;
	gdouble _tmp71_;
	HeStyleManager* _tmp72_;
	HeDesktop* _tmp73_;
	gdouble _tmp74_;
	gdouble _tmp75_;
	HeStyleManager* _tmp76_;
#line 110 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 111 "../lib/Models/Application.vala"
	_tmp1_ = he_application_get_default_accent_color (self);
#line 111 "../lib/Models/Application.vala"
	_tmp2_ = _tmp1_;
#line 111 "../lib/Models/Application.vala"
	if (_tmp2_ != NULL) {
#line 449 "Application.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 111 "../lib/Models/Application.vala"
		_tmp3_ = he_application_get_override_accent_color (self);
#line 111 "../lib/Models/Application.vala"
		_tmp4_ = _tmp3_;
#line 111 "../lib/Models/Application.vala"
		_tmp0_ = _tmp4_;
#line 458 "Application.c"
	} else {
#line 111 "../lib/Models/Application.vala"
		_tmp0_ = FALSE;
#line 462 "Application.c"
	}
#line 111 "../lib/Models/Application.vala"
	if (_tmp0_) {
#line 466 "Application.c"
		HeStyleManager* _tmp5_;
		HeRGBColor* _tmp6_;
		HeRGBColor* _tmp7_;
		HeRGBColor* _tmp8_;
#line 112 "../lib/Models/Application.vala"
		_tmp5_ = self->priv->style_manager;
#line 112 "../lib/Models/Application.vala"
		_tmp6_ = he_application_get_default_accent_color (self);
#line 112 "../lib/Models/Application.vala"
		_tmp7_ = _tmp6_;
#line 112 "../lib/Models/Application.vala"
		_tmp8_ = _he_rgb_color_dup0 (_tmp7_);
#line 112 "../lib/Models/Application.vala"
		_he_rgb_color_free0 (_tmp5_->accent_color);
#line 112 "../lib/Models/Application.vala"
		_tmp5_->accent_color = _tmp8_;
#line 483 "Application.c"
	} else {
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		HeRGBColor* _tmp11_;
		HeRGBColor* _tmp12_;
#line 113 "../lib/Models/Application.vala"
		_tmp11_ = he_application_get_default_accent_color (self);
#line 113 "../lib/Models/Application.vala"
		_tmp12_ = _tmp11_;
#line 113 "../lib/Models/Application.vala"
		if (_tmp12_ != NULL) {
#line 495 "Application.c"
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 113 "../lib/Models/Application.vala"
			_tmp13_ = he_application_get_override_accent_color (self);
#line 113 "../lib/Models/Application.vala"
			_tmp14_ = _tmp13_;
#line 113 "../lib/Models/Application.vala"
			_tmp10_ = _tmp14_;
#line 504 "Application.c"
		} else {
#line 113 "../lib/Models/Application.vala"
			_tmp10_ = FALSE;
#line 508 "Application.c"
		}
#line 113 "../lib/Models/Application.vala"
		if (_tmp10_) {
#line 512 "Application.c"
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 113 "../lib/Models/Application.vala"
			_tmp15_ = he_application_get_is_content (self);
#line 113 "../lib/Models/Application.vala"
			_tmp16_ = _tmp15_;
#line 113 "../lib/Models/Application.vala"
			_tmp9_ = _tmp16_;
#line 521 "Application.c"
		} else {
#line 113 "../lib/Models/Application.vala"
			_tmp9_ = FALSE;
#line 525 "Application.c"
		}
#line 113 "../lib/Models/Application.vala"
		if (_tmp9_) {
#line 529 "Application.c"
			HeStyleManager* _tmp17_;
			HeRGBColor* _tmp18_;
			HeRGBColor* _tmp19_;
			HeRGBColor* _tmp20_;
			HeDesktop* _tmp21_;
			HeRGBColor* _tmp22_;
			HeRGBColor* _tmp23_;
#line 114 "../lib/Models/Application.vala"
			_tmp17_ = self->priv->style_manager;
#line 114 "../lib/Models/Application.vala"
			_tmp18_ = he_application_get_default_accent_color (self);
#line 114 "../lib/Models/Application.vala"
			_tmp19_ = _tmp18_;
#line 114 "../lib/Models/Application.vala"
			_tmp20_ = _he_rgb_color_dup0 (_tmp19_);
#line 114 "../lib/Models/Application.vala"
			_he_rgb_color_free0 (_tmp17_->accent_color);
#line 114 "../lib/Models/Application.vala"
			_tmp17_->accent_color = _tmp20_;
#line 115 "../lib/Models/Application.vala"
			_tmp21_ = self->priv->desktop;
#line 115 "../lib/Models/Application.vala"
			_tmp22_ = he_application_get_default_accent_color (self);
#line 115 "../lib/Models/Application.vala"
			_tmp23_ = _tmp22_;
#line 115 "../lib/Models/Application.vala"
			he_desktop_set_accent_color (_tmp21_, _tmp23_);
#line 557 "Application.c"
		} else {
			HeDesktop* _tmp24_;
			HeRGBColor* _tmp25_;
			HeRGBColor* _tmp26_;
#line 116 "../lib/Models/Application.vala"
			_tmp24_ = self->priv->desktop;
#line 116 "../lib/Models/Application.vala"
			_tmp25_ = he_desktop_get_accent_color (_tmp24_);
#line 116 "../lib/Models/Application.vala"
			_tmp26_ = _tmp25_;
#line 116 "../lib/Models/Application.vala"
			if (_tmp26_ != NULL) {
#line 570 "Application.c"
				HeStyleManager* _tmp27_;
				HeDesktop* _tmp28_;
				HeRGBColor* _tmp29_;
				HeRGBColor* _tmp30_;
				HeRGBColor* _tmp31_;
#line 117 "../lib/Models/Application.vala"
				_tmp27_ = self->priv->style_manager;
#line 117 "../lib/Models/Application.vala"
				_tmp28_ = self->priv->desktop;
#line 117 "../lib/Models/Application.vala"
				_tmp29_ = he_desktop_get_accent_color (_tmp28_);
#line 117 "../lib/Models/Application.vala"
				_tmp30_ = _tmp29_;
#line 117 "../lib/Models/Application.vala"
				_tmp31_ = _he_rgb_color_dup0 (_tmp30_);
#line 117 "../lib/Models/Application.vala"
				_he_rgb_color_free0 (_tmp27_->accent_color);
#line 117 "../lib/Models/Application.vala"
				_tmp27_->accent_color = _tmp31_;
#line 590 "Application.c"
			} else {
				HeStyleManager* _tmp32_;
				HeRGBColor* _tmp33_;
				HeRGBColor* _tmp34_;
				HeRGBColor* _tmp35_;
#line 119 "../lib/Models/Application.vala"
				_tmp32_ = self->priv->style_manager;
#line 119 "../lib/Models/Application.vala"
				_tmp33_ = he_application_get_default_accent_color (self);
#line 119 "../lib/Models/Application.vala"
				_tmp34_ = _tmp33_;
#line 119 "../lib/Models/Application.vala"
				_tmp35_ = _he_rgb_color_dup0 (_tmp34_);
#line 119 "../lib/Models/Application.vala"
				_he_rgb_color_free0 (_tmp32_->accent_color);
#line 119 "../lib/Models/Application.vala"
				_tmp32_->accent_color = _tmp35_;
#line 608 "Application.c"
			}
		}
	}
#line 122 "../lib/Models/Application.vala"
	_tmp36_ = he_application_get_is_content (self);
#line 122 "../lib/Models/Application.vala"
	_tmp37_ = _tmp36_;
#line 122 "../lib/Models/Application.vala"
	if (_tmp37_) {
#line 618 "Application.c"
		HeStyleManager* _tmp38_;
		HeSchemeVariant _tmp39_;
		HeSchemeVariant* _tmp40_;
#line 123 "../lib/Models/Application.vala"
		_tmp38_ = self->priv->style_manager;
#line 123 "../lib/Models/Application.vala"
		_tmp39_ = HE_SCHEME_VARIANT_CONTENT;
#line 123 "../lib/Models/Application.vala"
		_tmp40_ = __he_scheme_variant_dup0 (&_tmp39_);
#line 123 "../lib/Models/Application.vala"
		_g_free0 (_tmp38_->scheme_variant);
#line 123 "../lib/Models/Application.vala"
		_tmp38_->scheme_variant = _tmp40_;
#line 632 "Application.c"
	} else {
		gboolean _tmp41_;
		gboolean _tmp42_;
#line 124 "../lib/Models/Application.vala"
		_tmp41_ = he_application_get_is_mono (self);
#line 124 "../lib/Models/Application.vala"
		_tmp42_ = _tmp41_;
#line 124 "../lib/Models/Application.vala"
		if (_tmp42_) {
#line 642 "Application.c"
			HeStyleManager* _tmp43_;
			HeSchemeVariant _tmp44_;
			HeSchemeVariant* _tmp45_;
#line 125 "../lib/Models/Application.vala"
			_tmp43_ = self->priv->style_manager;
#line 125 "../lib/Models/Application.vala"
			_tmp44_ = HE_SCHEME_VARIANT_MONOCHROME;
#line 125 "../lib/Models/Application.vala"
			_tmp45_ = __he_scheme_variant_dup0 (&_tmp44_);
#line 125 "../lib/Models/Application.vala"
			_g_free0 (_tmp43_->scheme_variant);
#line 125 "../lib/Models/Application.vala"
			_tmp43_->scheme_variant = _tmp45_;
#line 656 "Application.c"
		} else {
			HeStyleManager* _tmp46_;
			HeDesktop* _tmp47_;
			HeDesktopEnsorScheme _tmp48_;
			HeDesktopEnsorScheme _tmp49_;
			HeSchemeVariant _tmp50_;
			HeSchemeVariant* _tmp51_;
#line 127 "../lib/Models/Application.vala"
			_tmp46_ = self->priv->style_manager;
#line 127 "../lib/Models/Application.vala"
			_tmp47_ = self->priv->desktop;
#line 127 "../lib/Models/Application.vala"
			_tmp48_ = he_desktop_get_ensor_scheme (_tmp47_);
#line 127 "../lib/Models/Application.vala"
			_tmp49_ = _tmp48_;
#line 127 "../lib/Models/Application.vala"
			_tmp50_ = he_desktop_ensor_scheme_to_variant (_tmp49_);
#line 127 "../lib/Models/Application.vala"
			_tmp51_ = __he_scheme_variant_dup0 (&_tmp50_);
#line 127 "../lib/Models/Application.vala"
			_g_free0 (_tmp46_->scheme_variant);
#line 127 "../lib/Models/Application.vala"
			_tmp46_->scheme_variant = _tmp51_;
#line 680 "Application.c"
		}
	}
#line 130 "../lib/Models/Application.vala"
	_tmp52_ = he_application_get_override_dark_style (self);
#line 130 "../lib/Models/Application.vala"
	_tmp53_ = _tmp52_;
#line 130 "../lib/Models/Application.vala"
	if (_tmp53_) {
#line 689 "Application.c"
		HeStyleManager* _tmp54_;
#line 131 "../lib/Models/Application.vala"
		_tmp54_ = self->priv->style_manager;
#line 131 "../lib/Models/Application.vala"
		_tmp54_->is_dark = TRUE;
#line 695 "Application.c"
	} else {
		HeStyleManager* _tmp55_;
		HeDesktop* _tmp56_;
		HeDesktopColorScheme _tmp57_;
		HeDesktopColorScheme _tmp58_;
#line 133 "../lib/Models/Application.vala"
		_tmp55_ = self->priv->style_manager;
#line 133 "../lib/Models/Application.vala"
		_tmp56_ = self->priv->desktop;
#line 133 "../lib/Models/Application.vala"
		_tmp57_ = he_desktop_get_prefers_color_scheme (_tmp56_);
#line 133 "../lib/Models/Application.vala"
		_tmp58_ = _tmp57_;
#line 133 "../lib/Models/Application.vala"
		_tmp55_->is_dark = _tmp58_ == HE_DESKTOP_COLOR_SCHEME_DARK;
#line 711 "Application.c"
	}
#line 136 "../lib/Models/Application.vala"
	_tmp59_ = he_application_get_override_contrast (self);
#line 136 "../lib/Models/Application.vala"
	_tmp60_ = _tmp59_;
#line 136 "../lib/Models/Application.vala"
	if (_tmp60_) {
#line 719 "Application.c"
		gdouble rounded_contrast = 0.0;
		gdouble _tmp61_;
		gdouble _tmp62_;
		HeStyleManager* _tmp63_;
#line 138 "../lib/Models/Application.vala"
		_tmp61_ = he_application_get_default_contrast (self);
#line 138 "../lib/Models/Application.vala"
		_tmp62_ = _tmp61_;
#line 138 "../lib/Models/Application.vala"
		rounded_contrast = round (_tmp62_ * 100) / 100;
#line 139 "../lib/Models/Application.vala"
		_tmp63_ = self->priv->style_manager;
#line 139 "../lib/Models/Application.vala"
		_tmp63_->contrast = rounded_contrast;
#line 734 "Application.c"
	} else {
		gdouble rounded_contrast = 0.0;
		HeDesktop* _tmp64_;
		gdouble _tmp65_;
		gdouble _tmp66_;
		HeStyleManager* _tmp67_;
#line 142 "../lib/Models/Application.vala"
		_tmp64_ = self->priv->desktop;
#line 142 "../lib/Models/Application.vala"
		_tmp65_ = he_desktop_get_contrast (_tmp64_);
#line 142 "../lib/Models/Application.vala"
		_tmp66_ = _tmp65_;
#line 142 "../lib/Models/Application.vala"
		rounded_contrast = round (_tmp66_ * 100) / 100;
#line 143 "../lib/Models/Application.vala"
		_tmp67_ = self->priv->style_manager;
#line 143 "../lib/Models/Application.vala"
		_tmp67_->contrast = rounded_contrast;
#line 753 "Application.c"
	}
#line 146 "../lib/Models/Application.vala"
	_tmp68_ = self->priv->style_manager;
#line 146 "../lib/Models/Application.vala"
	_tmp69_ = self->priv->desktop;
#line 146 "../lib/Models/Application.vala"
	_tmp70_ = he_desktop_get_font_weight (_tmp69_);
#line 146 "../lib/Models/Application.vala"
	_tmp71_ = _tmp70_;
#line 146 "../lib/Models/Application.vala"
	_tmp68_->font_weight = _tmp71_;
#line 147 "../lib/Models/Application.vala"
	_tmp72_ = self->priv->style_manager;
#line 147 "../lib/Models/Application.vala"
	_tmp73_ = self->priv->desktop;
#line 147 "../lib/Models/Application.vala"
	_tmp74_ = he_desktop_get_roundness (_tmp73_);
#line 147 "../lib/Models/Application.vala"
	_tmp75_ = _tmp74_;
#line 147 "../lib/Models/Application.vala"
	_tmp72_->roundness = _tmp75_;
#line 148 "../lib/Models/Application.vala"
	_tmp76_ = self->priv->style_manager;
#line 148 "../lib/Models/Application.vala"
	he_style_manager_update (_tmp76_);
#line 779 "Application.c"
}

static void
he_application_init_app_styles (HeApplication* self)
{
	gchar* base_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* base_uri = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* base_file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	HeStyleManager* _tmp7_;
	GtkCssProvider* _tmp8_;
	GtkCssProvider* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	HeStyleManager* _tmp13_;
	GtkCssProvider* _tmp14_;
	GtkCssProvider* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
#line 151 "../lib/Models/Application.vala"
	g_return_if_fail (self != NULL);
#line 152 "../lib/Models/Application.vala"
	_tmp0_ = g_application_get_resource_base_path ((GApplication*) self);
#line 152 "../lib/Models/Application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 152 "../lib/Models/Application.vala"
	base_path = _tmp1_;
#line 153 "../lib/Models/Application.vala"
	_tmp2_ = base_path;
#line 153 "../lib/Models/Application.vala"
	if (_tmp2_ == NULL) {
#line 154 "../lib/Models/Application.vala"
		_g_free0 (base_path);
#line 154 "../lib/Models/Application.vala"
		return;
#line 823 "Application.c"
	}
#line 157 "../lib/Models/Application.vala"
	_tmp3_ = base_path;
#line 157 "../lib/Models/Application.vala"
	_tmp4_ = g_strconcat ("resource://", _tmp3_, NULL);
#line 157 "../lib/Models/Application.vala"
	base_uri = _tmp4_;
#line 158 "../lib/Models/Application.vala"
	_tmp5_ = base_uri;
#line 158 "../lib/Models/Application.vala"
	_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 158 "../lib/Models/Application.vala"
	base_file = _tmp6_;
#line 160 "../lib/Models/Application.vala"
	_tmp7_ = self->priv->style_manager;
#line 160 "../lib/Models/Application.vala"
	_tmp8_ = he_style_manager_get_user_base (_tmp7_);
#line 160 "../lib/Models/Application.vala"
	_tmp9_ = _tmp8_;
#line 160 "../lib/Models/Application.vala"
	_tmp10_ = base_file;
#line 160 "../lib/Models/Application.vala"
	_tmp11_ = g_file_get_child (_tmp10_, "style.css");
#line 160 "../lib/Models/Application.vala"
	_tmp12_ = _tmp11_;
#line 160 "../lib/Models/Application.vala"
	he_misc_init_css_provider_from_file (_tmp9_, _tmp12_);
#line 160 "../lib/Models/Application.vala"
	_g_object_unref0 (_tmp12_);
#line 161 "../lib/Models/Application.vala"
	_tmp13_ = self->priv->style_manager;
#line 161 "../lib/Models/Application.vala"
	_tmp14_ = he_style_manager_get_user_dark (_tmp13_);
#line 161 "../lib/Models/Application.vala"
	_tmp15_ = _tmp14_;
#line 161 "../lib/Models/Application.vala"
	_tmp16_ = base_file;
#line 161 "../lib/Models/Application.vala"
	_tmp17_ = g_file_get_child (_tmp16_, "style-dark.css");
#line 161 "../lib/Models/Application.vala"
	_tmp18_ = _tmp17_;
#line 161 "../lib/Models/Application.vala"
	he_misc_init_css_provider_from_file (_tmp15_, _tmp18_);
#line 161 "../lib/Models/Application.vala"
	_g_object_unref0 (_tmp18_);
#line 151 "../lib/Models/Application.vala"
	_g_object_unref0 (base_file);
#line 151 "../lib/Models/Application.vala"
	_g_free0 (base_uri);
#line 151 "../lib/Models/Application.vala"
	_g_free0 (base_path);
#line 875 "Application.c"
}

static void
__lambda184_ (HeApplication* self)
{
#line 171 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 172 "../lib/Models/Application.vala"
	g_signal_emit (self, he_application_signals[HE_APPLICATION_ACCENT_COLOR_CHANGED_SIGNAL], 0);
#line 885 "Application.c"
}

static void
___lambda184__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 170 "../lib/Models/Application.vala"
	__lambda184_ ((HeApplication*) self);
#line 895 "Application.c"
}

static void
_he_application_update_style_manager_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 174 "../lib/Models/Application.vala"
	he_application_update_style_manager ((HeApplication*) self);
#line 905 "Application.c"
}

static void
he_application_real_startup (GApplication* base)
{
	HeApplication * self;
	HeDesktop* _tmp0_;
	HeDesktop* _tmp1_;
	HeDesktop* _tmp2_;
	HeDesktop* _tmp3_;
	HeDesktop* _tmp4_;
	HeDesktop* _tmp5_;
	HeStyleManager* _tmp6_;
#line 164 "../lib/Models/Application.vala"
	self = (HeApplication*) base;
#line 165 "../lib/Models/Application.vala"
	he_init ();
#line 167 "../lib/Models/Application.vala"
	he_application_init_app_styles (self);
#line 168 "../lib/Models/Application.vala"
	he_application_update_style_manager (self);
#line 170 "../lib/Models/Application.vala"
	_tmp0_ = self->priv->desktop;
#line 170 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::accent-color", (GCallback) ___lambda184__g_object_notify, self, 0);
#line 174 "../lib/Models/Application.vala"
	_tmp1_ = self->priv->desktop;
#line 174 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::ensor-scheme", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 175 "../lib/Models/Application.vala"
	_tmp2_ = self->priv->desktop;
#line 175 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::font-weight", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 176 "../lib/Models/Application.vala"
	_tmp3_ = self->priv->desktop;
#line 176 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::prefers-color-scheme", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 177 "../lib/Models/Application.vala"
	_tmp4_ = self->priv->desktop;
#line 177 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::contrast", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 178 "../lib/Models/Application.vala"
	_tmp5_ = self->priv->desktop;
#line 178 "../lib/Models/Application.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::roundness", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
#line 180 "../lib/Models/Application.vala"
	_tmp6_ = self->priv->style_manager;
#line 180 "../lib/Models/Application.vala"
	he_style_manager_register (_tmp6_);
#line 181 "../lib/Models/Application.vala"
	G_APPLICATION_CLASS (he_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 957 "Application.c"
}

/**
     * Creates a new application.
     *
     * @param application_id The application ID in reverse domain name notation
     * @param flags The application flags, as defined in GIO.ApplicationFlags
     */
HeApplication*
he_application_construct (GType object_type,
                          const gchar* application_id,
                          GApplicationFlags flags)
{
	HeApplication * self = NULL;
#line 190 "../lib/Models/Application.vala"
	self = (HeApplication*) g_object_new (object_type, NULL);
#line 191 "../lib/Models/Application.vala"
	g_application_set_application_id ((GApplication*) self, application_id);
#line 192 "../lib/Models/Application.vala"
	g_application_set_flags ((GApplication*) self, flags);
#line 190 "../lib/Models/Application.vala"
	return self;
#line 980 "Application.c"
}

HeApplication*
he_application_new (const gchar* application_id,
                    GApplicationFlags flags)
{
#line 190 "../lib/Models/Application.vala"
	return he_application_construct (HE_TYPE_APPLICATION, application_id, flags);
#line 989 "Application.c"
}

static void
he_application_class_init (HeApplicationClass * klass,
                           gpointer klass_data)
{
#line 23 "../lib/Models/Application.vala"
	he_application_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Models/Application.vala"
	g_type_class_adjust_private_offset (klass, &HeApplication_private_offset);
#line 23 "../lib/Models/Application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) he_application_real_startup;
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_application_get_property;
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_application_set_property;
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = he_application_finalize;
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("default-accent-color", "default-accent-color", "default-accent-color", HE_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY] = g_param_spec_boolean ("override-accent-color", "override-accent-color", "override-accent-color", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_OVERRIDE_DARK_STYLE_PROPERTY, he_application_properties[HE_APPLICATION_OVERRIDE_DARK_STYLE_PROPERTY] = g_param_spec_boolean ("override-dark-style", "override-dark-style", "override-dark-style", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_OVERRIDE_CONTRAST_PROPERTY, he_application_properties[HE_APPLICATION_OVERRIDE_CONTRAST_PROPERTY] = g_param_spec_boolean ("override-contrast", "override-contrast", "override-contrast", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_DEFAULT_CONTRAST_PROPERTY, he_application_properties[HE_APPLICATION_DEFAULT_CONTRAST_PROPERTY] = g_param_spec_double ("default-contrast", "default-contrast", "default-contrast", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_IS_CONTENT_PROPERTY, he_application_properties[HE_APPLICATION_IS_CONTENT_PROPERTY] = g_param_spec_boolean ("is-content", "is-content", "is-content", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../lib/Models/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_IS_MONO_PROPERTY, he_application_properties[HE_APPLICATION_IS_MONO_PROPERTY] = g_param_spec_boolean ("is-mono", "is-mono", "is-mono", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1022 "Application.c"
	/**
	     * Signal emitted when the effective accent color changes.
	     */
#line 23 "../lib/Models/Application.vala"
	he_application_signals[HE_APPLICATION_ACCENT_COLOR_CHANGED_SIGNAL] = g_signal_new ("accent-color-changed", HE_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1028 "Application.c"
}

static void
he_application_instance_init (HeApplication * self,
                              gpointer klass)
{
	HeDesktop* _tmp0_;
	HeStyleManager* _tmp1_;
#line 23 "../lib/Models/Application.vala"
	self->priv = he_application_get_instance_private (self);
#line 24 "../lib/Models/Application.vala"
	_tmp0_ = he_desktop_new ();
#line 24 "../lib/Models/Application.vala"
	self->priv->desktop = _tmp0_;
#line 25 "../lib/Models/Application.vala"
	_tmp1_ = he_style_manager_new ();
#line 25 "../lib/Models/Application.vala"
	self->priv->style_manager = _tmp1_;
#line 30 "../lib/Models/Application.vala"
	self->priv->_default_accent_color = NULL;
#line 39 "../lib/Models/Application.vala"
	self->priv->_override_accent_color = FALSE;
#line 48 "../lib/Models/Application.vala"
	self->priv->_override_dark_style = FALSE;
#line 57 "../lib/Models/Application.vala"
	self->priv->_override_contrast = FALSE;
#line 67 "../lib/Models/Application.vala"
	self->priv->_default_contrast = 0.0;
#line 77 "../lib/Models/Application.vala"
	self->priv->_is_content = FALSE;
#line 87 "../lib/Models/Application.vala"
	self->priv->_is_mono = FALSE;
#line 1061 "Application.c"
}

static void
he_application_finalize (GObject * obj)
{
	HeApplication * self;
#line 23 "../lib/Models/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION, HeApplication);
#line 24 "../lib/Models/Application.vala"
	_g_object_unref0 (self->priv->desktop);
#line 25 "../lib/Models/Application.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 30 "../lib/Models/Application.vala"
	_he_rgb_color_free0 (self->priv->_default_accent_color);
#line 23 "../lib/Models/Application.vala"
	G_OBJECT_CLASS (he_application_parent_class)->finalize (obj);
#line 1078 "Application.c"
}

/**
 * An application.
 */
static GType
he_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeApplication), 0, (GInstanceInitFunc) he_application_instance_init, NULL };
	GType he_application_type_id;
	he_application_type_id = g_type_register_static (gtk_application_get_type (), "HeApplication", &g_define_type_info, 0);
	HeApplication_private_offset = g_type_add_instance_private (he_application_type_id, sizeof (HeApplicationPrivate));
	return he_application_type_id;
}

GType
he_application_get_type (void)
{
	static volatile gsize he_application_type_id__once = 0;
	if (g_once_init_enter (&he_application_type_id__once)) {
		GType he_application_type_id;
		he_application_type_id = he_application_get_type_once ();
		g_once_init_leave (&he_application_type_id__once, he_application_type_id);
	}
	return he_application_type_id__once;
}

static void
_vala_he_application_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
#line 23 "../lib/Models/Application.vala"
	switch (property_id) {
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
#line 1118 "Application.c"
		{
			HeRGBColor* boxed;
#line 23 "../lib/Models/Application.vala"
			boxed = he_application_get_default_accent_color (self);
#line 23 "../lib/Models/Application.vala"
			g_value_set_boxed (value, boxed);
#line 1125 "Application.c"
		}
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_boolean (value, he_application_get_override_accent_color (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_DARK_STYLE_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_boolean (value, he_application_get_override_dark_style (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_CONTRAST_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_boolean (value, he_application_get_override_contrast (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_DEFAULT_CONTRAST_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_double (value, he_application_get_default_contrast (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_IS_CONTENT_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_boolean (value, he_application_get_is_content (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_IS_MONO_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		g_value_set_boolean (value, he_application_get_is_mono (self));
#line 23 "../lib/Models/Application.vala"
		break;
#line 1165 "Application.c"
		default:
#line 23 "../lib/Models/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Models/Application.vala"
		break;
#line 1171 "Application.c"
	}
}

static void
_vala_he_application_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
#line 23 "../lib/Models/Application.vala"
	switch (property_id) {
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_default_accent_color (self, g_value_get_boxed (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_override_accent_color (self, g_value_get_boolean (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_DARK_STYLE_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_override_dark_style (self, g_value_get_boolean (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_OVERRIDE_CONTRAST_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_override_contrast (self, g_value_get_boolean (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_DEFAULT_CONTRAST_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_default_contrast (self, g_value_get_double (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_IS_CONTENT_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_is_content (self, g_value_get_boolean (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 23 "../lib/Models/Application.vala"
		case HE_APPLICATION_IS_MONO_PROPERTY:
#line 23 "../lib/Models/Application.vala"
		he_application_set_is_mono (self, g_value_get_boolean (value));
#line 23 "../lib/Models/Application.vala"
		break;
#line 1227 "Application.c"
		default:
#line 23 "../lib/Models/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Models/Application.vala"
		break;
#line 1233 "Application.c"
	}
}

