/* Math.c generated by valac 0.56.18, the Vala compiler
 * generated from Math.vala, do not modify */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "libhelium-1.h"
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static gdouble* _vala_array_dup3 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup4 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup5 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup6 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup7 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup8 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup9 (gdouble* self,
                           gssize length);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gdouble HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB[3][3] = {{0.001200833568784504, 0.002389694492170889, 0.0002795742885861124}, {0.0005891086651375999, 0.0029785502573438758, 0.0003270666104008398}, {0.00010146692491640572, 0.0005364214359186694, 0.0032979401770712076}};
const gdouble HE_MATH_UTILS_LINRGB_FROM_SCALED_DISCOUNT[3][3] = {{1373.2198709594231, -1100.4251190754821, -7.278681089101213}, {-271.815969077903, 559.6580465940733, -32.46047482791194}, {1.9622899599665666, -57.173814538844006, 308.7233197812385}};
VALA_EXTERN const gdouble HE_CRITICAL_PLANES[255];

gint
he_math_utils_clamp_int (gint min,
                         gint max,
                         gint input)
{
	gint result;
#line 26 "../lib/Utils/Math.vala"
	if (input < min) {
#line 27 "../lib/Utils/Math.vala"
		result = min;
#line 27 "../lib/Utils/Math.vala"
		return result;
#line 53 "Math.c"
	} else {
#line 28 "../lib/Utils/Math.vala"
		if (input > max) {
#line 29 "../lib/Utils/Math.vala"
			result = max;
#line 29 "../lib/Utils/Math.vala"
			return result;
#line 61 "Math.c"
		}
	}
#line 32 "../lib/Utils/Math.vala"
	result = input;
#line 32 "../lib/Utils/Math.vala"
	return result;
#line 68 "Math.c"
}

gdouble
he_math_utils_clamp_double (gdouble min,
                            gdouble max,
                            gdouble input)
{
	gdouble result;
#line 36 "../lib/Utils/Math.vala"
	if (input < min) {
#line 37 "../lib/Utils/Math.vala"
		result = min;
#line 37 "../lib/Utils/Math.vala"
		return result;
#line 83 "Math.c"
	} else {
#line 38 "../lib/Utils/Math.vala"
		if (input > max) {
#line 39 "../lib/Utils/Math.vala"
			result = max;
#line 39 "../lib/Utils/Math.vala"
			return result;
#line 91 "Math.c"
		}
	}
#line 42 "../lib/Utils/Math.vala"
	result = input;
#line 42 "../lib/Utils/Math.vala"
	return result;
#line 98 "Math.c"
}

gint
he_math_utils_signum (gdouble num)
{
	gint result;
#line 46 "../lib/Utils/Math.vala"
	if (num < ((gdouble) 0)) {
#line 47 "../lib/Utils/Math.vala"
		result = -1;
#line 47 "../lib/Utils/Math.vala"
		return result;
#line 111 "Math.c"
	} else {
#line 48 "../lib/Utils/Math.vala"
		if (num == ((gdouble) 0)) {
#line 49 "../lib/Utils/Math.vala"
			result = 0;
#line 49 "../lib/Utils/Math.vala"
			return result;
#line 119 "Math.c"
		} else {
#line 51 "../lib/Utils/Math.vala"
			result = 1;
#line 51 "../lib/Utils/Math.vala"
			return result;
#line 125 "Math.c"
		}
	}
}

gdouble
he_math_utils_to_degrees (gdouble radians)
{
	gdouble result;
#line 57 "../lib/Utils/Math.vala"
	result = radians * (180.0 / G_PI);
#line 57 "../lib/Utils/Math.vala"
	return result;
#line 138 "Math.c"
}

gdouble
he_math_utils_to_radians (gdouble degrees)
{
	gdouble result;
#line 62 "../lib/Utils/Math.vala"
	result = degrees * (G_PI / 180.0);
#line 62 "../lib/Utils/Math.vala"
	return result;
#line 149 "Math.c"
}

gdouble
he_math_utils_chromatic_adaptation (gdouble component)
{
	gdouble af = 0.0;
	gdouble result;
#line 66 "../lib/Utils/Math.vala"
	af = pow (fabs (component), 0.42);
#line 67 "../lib/Utils/Math.vala"
	result = ((he_math_utils_signum (component) * 400.0) * af) / (af + 27.13);
#line 67 "../lib/Utils/Math.vala"
	return result;
#line 163 "Math.c"
}

gdouble
he_math_utils_inverse_chromatic_adaptation (gdouble adapted)
{
	gdouble adapted_abs = 0.0;
	gdouble b = 0.0;
	gdouble result;
#line 71 "../lib/Utils/Math.vala"
	adapted_abs = fabs (adapted);
#line 72 "../lib/Utils/Math.vala"
	b = fmax (0.0, (27.13 * adapted_abs) / (400.0 - adapted_abs));
#line 73 "../lib/Utils/Math.vala"
	result = he_math_utils_signum (adapted) * pow (b, 1.0 / 0.42);
#line 73 "../lib/Utils/Math.vala"
	return result;
#line 180 "Math.c"
}

gdouble*
he_math_utils_lerp_point (gdouble* source,
                          gint source_length1,
                          gdouble t,
                          gdouble* target,
                          gint target_length1,
                          gint* result_length1)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble* _tmp9_;
	gdouble* _tmp10_;
	gint _tmp10__length1;
	gdouble* result;
#line 77 "../lib/Utils/Math.vala"
	_tmp0_ = source[0];
#line 77 "../lib/Utils/Math.vala"
	_tmp1_ = target[0];
#line 77 "../lib/Utils/Math.vala"
	_tmp2_ = source[0];
#line 77 "../lib/Utils/Math.vala"
	_tmp3_ = source[1];
#line 77 "../lib/Utils/Math.vala"
	_tmp4_ = target[1];
#line 77 "../lib/Utils/Math.vala"
	_tmp5_ = source[1];
#line 77 "../lib/Utils/Math.vala"
	_tmp6_ = source[2];
#line 77 "../lib/Utils/Math.vala"
	_tmp7_ = target[2];
#line 77 "../lib/Utils/Math.vala"
	_tmp8_ = source[2];
#line 77 "../lib/Utils/Math.vala"
	_tmp9_ = g_new0 (gdouble, 3);
#line 77 "../lib/Utils/Math.vala"
	_tmp9_[0] = _tmp0_ + ((_tmp1_ - _tmp2_) * t);
#line 77 "../lib/Utils/Math.vala"
	_tmp9_[1] = _tmp3_ + ((_tmp4_ - _tmp5_) * t);
#line 77 "../lib/Utils/Math.vala"
	_tmp9_[2] = _tmp6_ + ((_tmp7_ - _tmp8_) * t);
#line 77 "../lib/Utils/Math.vala"
	_tmp10_ = _tmp9_;
#line 77 "../lib/Utils/Math.vala"
	_tmp10__length1 = 3;
#line 77 "../lib/Utils/Math.vala"
	if (result_length1) {
#line 77 "../lib/Utils/Math.vala"
		*result_length1 = _tmp10__length1;
#line 238 "Math.c"
	}
#line 77 "../lib/Utils/Math.vala"
	result = _tmp10_;
#line 77 "../lib/Utils/Math.vala"
	return result;
#line 244 "Math.c"
}

gdouble
he_math_utils_lerp (gdouble a,
                    gdouble b,
                    gdouble t)
{
	gdouble result;
#line 85 "../lib/Utils/Math.vala"
	result = a + ((b - a) * t);
#line 85 "../lib/Utils/Math.vala"
	return result;
#line 257 "Math.c"
}

gdouble
he_math_utils_sanitize_radians (gdouble angle)
{
	gdouble result;
#line 89 "../lib/Utils/Math.vala"
	result = fmod (angle + (G_PI * 8.0), G_PI * 2.0);
#line 89 "../lib/Utils/Math.vala"
	return result;
#line 268 "Math.c"
}

gboolean
he_math_utils_is_bounded_rgb (gdouble x)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 93 "../lib/Utils/Math.vala"
	if (0.0 <= x) {
#line 93 "../lib/Utils/Math.vala"
		_tmp0_ = x <= 100.0;
#line 280 "Math.c"
	} else {
#line 93 "../lib/Utils/Math.vala"
		_tmp0_ = FALSE;
#line 284 "Math.c"
	}
#line 93 "../lib/Utils/Math.vala"
	result = _tmp0_;
#line 93 "../lib/Utils/Math.vala"
	return result;
#line 290 "Math.c"
}

gdouble
he_math_utils_adapt (gdouble color_channel)
{
	gdouble result;
#line 97 "../lib/Utils/Math.vala"
	if (color_channel > 0.0031308) {
#line 98 "../lib/Utils/Math.vala"
		result = (1.055 * pow (color_channel, 1.0 / 2.4)) - 0.055;
#line 98 "../lib/Utils/Math.vala"
		return result;
#line 303 "Math.c"
	} else {
#line 100 "../lib/Utils/Math.vala"
		result = color_channel * 12.92;
#line 100 "../lib/Utils/Math.vala"
		return result;
#line 309 "Math.c"
	}
}

gdouble*
he_math_utils_elem_mul (gdouble* row,
                        gint row_length1,
                        gdouble* matrix,
                        gint matrix_length1,
                        gint matrix_length2,
                        gint* result_length1)
{
	gdouble* prod = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble* _tmp18_;
	gint prod_length1;
	gint _prod_size_;
	gdouble* _tmp19_;
	gint _tmp19__length1;
	gdouble* result;
#line 105 "../lib/Utils/Math.vala"
	_tmp0_ = row[0];
#line 105 "../lib/Utils/Math.vala"
	_tmp1_ = matrix[(0 * matrix_length2) + 0];
#line 105 "../lib/Utils/Math.vala"
	_tmp2_ = row[1];
#line 105 "../lib/Utils/Math.vala"
	_tmp3_ = matrix[(0 * matrix_length2) + 1];
#line 105 "../lib/Utils/Math.vala"
	_tmp4_ = row[2];
#line 105 "../lib/Utils/Math.vala"
	_tmp5_ = matrix[(0 * matrix_length2) + 2];
#line 105 "../lib/Utils/Math.vala"
	_tmp6_ = row[0];
#line 105 "../lib/Utils/Math.vala"
	_tmp7_ = matrix[(1 * matrix_length2) + 0];
#line 105 "../lib/Utils/Math.vala"
	_tmp8_ = row[1];
#line 105 "../lib/Utils/Math.vala"
	_tmp9_ = matrix[(1 * matrix_length2) + 1];
#line 105 "../lib/Utils/Math.vala"
	_tmp10_ = row[2];
#line 105 "../lib/Utils/Math.vala"
	_tmp11_ = matrix[(1 * matrix_length2) + 2];
#line 105 "../lib/Utils/Math.vala"
	_tmp12_ = row[0];
#line 105 "../lib/Utils/Math.vala"
	_tmp13_ = matrix[(2 * matrix_length2) + 0];
#line 105 "../lib/Utils/Math.vala"
	_tmp14_ = row[1];
#line 105 "../lib/Utils/Math.vala"
	_tmp15_ = matrix[(2 * matrix_length2) + 1];
#line 105 "../lib/Utils/Math.vala"
	_tmp16_ = row[2];
#line 105 "../lib/Utils/Math.vala"
	_tmp17_ = matrix[(2 * matrix_length2) + 2];
#line 105 "../lib/Utils/Math.vala"
	_tmp18_ = g_new0 (gdouble, 3);
#line 105 "../lib/Utils/Math.vala"
	_tmp18_[0] = ((_tmp0_ * _tmp1_) + (_tmp2_ * _tmp3_)) + (_tmp4_ * _tmp5_);
#line 105 "../lib/Utils/Math.vala"
	_tmp18_[1] = ((_tmp6_ * _tmp7_) + (_tmp8_ * _tmp9_)) + (_tmp10_ * _tmp11_);
#line 105 "../lib/Utils/Math.vala"
	_tmp18_[2] = ((_tmp12_ * _tmp13_) + (_tmp14_ * _tmp15_)) + (_tmp16_ * _tmp17_);
#line 105 "../lib/Utils/Math.vala"
	prod = _tmp18_;
#line 105 "../lib/Utils/Math.vala"
	prod_length1 = 3;
#line 105 "../lib/Utils/Math.vala"
	_prod_size_ = prod_length1;
#line 110 "../lib/Utils/Math.vala"
	_tmp19_ = prod;
#line 110 "../lib/Utils/Math.vala"
	_tmp19__length1 = prod_length1;
#line 110 "../lib/Utils/Math.vala"
	if (result_length1) {
#line 110 "../lib/Utils/Math.vala"
		*result_length1 = _tmp19__length1;
#line 404 "Math.c"
	}
#line 110 "../lib/Utils/Math.vala"
	result = _tmp19_;
#line 110 "../lib/Utils/Math.vala"
	return result;
#line 410 "Math.c"
}

gdouble
he_math_utils_lab_inverse_fovea (gdouble ft)
{
	gdouble e = 0.0;
	gdouble kappa = 0.0;
	gdouble ft3 = 0.0;
	gdouble result;
#line 114 "../lib/Utils/Math.vala"
	e = 216.0 / 24389.0;
#line 115 "../lib/Utils/Math.vala"
	kappa = 24389.0 / 27.0;
#line 116 "../lib/Utils/Math.vala"
	ft3 = (ft * ft) * ft;
#line 117 "../lib/Utils/Math.vala"
	if (ft3 > e) {
#line 118 "../lib/Utils/Math.vala"
		result = ft3;
#line 118 "../lib/Utils/Math.vala"
		return result;
#line 432 "Math.c"
	} else {
#line 120 "../lib/Utils/Math.vala"
		result = ((116 * ft) - 16) / kappa;
#line 120 "../lib/Utils/Math.vala"
		return result;
#line 438 "Math.c"
	}
}

gdouble
he_math_utils_lab_fovea (gdouble t)
{
	gdouble e = 0.0;
	gdouble kappa = 0.0;
	gdouble result;
#line 125 "../lib/Utils/Math.vala"
	e = 216.0 / 24389.0;
#line 126 "../lib/Utils/Math.vala"
	kappa = 24389.0 / 27.0;
#line 127 "../lib/Utils/Math.vala"
	if (t > e) {
#line 128 "../lib/Utils/Math.vala"
		result = pow (t, 1.0 / 3.0);
#line 128 "../lib/Utils/Math.vala"
		return result;
#line 458 "Math.c"
	} else {
#line 130 "../lib/Utils/Math.vala"
		result = ((kappa * t) + 16) / 116;
#line 130 "../lib/Utils/Math.vala"
		return result;
#line 464 "Math.c"
	}
}

gdouble
he_math_utils_sanitize_degrees (gdouble degrees)
{
	gdouble result;
#line 135 "../lib/Utils/Math.vala"
	degrees = fmod (degrees, 360.0);
#line 136 "../lib/Utils/Math.vala"
	if (degrees < 0.0) {
#line 137 "../lib/Utils/Math.vala"
		degrees = degrees + 360.0;
#line 478 "Math.c"
	}
#line 139 "../lib/Utils/Math.vala"
	result = degrees;
#line 139 "../lib/Utils/Math.vala"
	return result;
#line 484 "Math.c"
}

gint
he_math_utils_sanitize_degrees_int (gint degrees)
{
	gint result;
#line 143 "../lib/Utils/Math.vala"
	degrees = degrees % 360;
#line 144 "../lib/Utils/Math.vala"
	if (degrees < 0) {
#line 145 "../lib/Utils/Math.vala"
		degrees = degrees + 360;
#line 497 "Math.c"
	}
#line 147 "../lib/Utils/Math.vala"
	result = degrees;
#line 147 "../lib/Utils/Math.vala"
	return result;
#line 503 "Math.c"
}

gdouble
he_math_utils_rotate_direction (gdouble from,
                                gdouble to)
{
	gdouble inc_diff = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 151 "../lib/Utils/Math.vala"
	inc_diff = he_math_utils_sanitize_degrees (to - from);
#line 152 "../lib/Utils/Math.vala"
	if (inc_diff <= 180.0) {
#line 152 "../lib/Utils/Math.vala"
		_tmp0_ = 1.0;
#line 519 "Math.c"
	} else {
#line 152 "../lib/Utils/Math.vala"
		_tmp0_ = -1.0;
#line 523 "Math.c"
	}
#line 152 "../lib/Utils/Math.vala"
	result = _tmp0_;
#line 152 "../lib/Utils/Math.vala"
	return result;
#line 529 "Math.c"
}

gdouble
he_math_utils_difference_degrees (gdouble a,
                                  gdouble b)
{
	gdouble result;
#line 156 "../lib/Utils/Math.vala"
	result = 180.0 - fabs (fabs (a - b) - 180.0);
#line 156 "../lib/Utils/Math.vala"
	return result;
#line 541 "Math.c"
}

gdouble
he_math_utils_abs (gdouble n)
{
	gdouble result;
#line 160 "../lib/Utils/Math.vala"
	result = fabs (n);
#line 160 "../lib/Utils/Math.vala"
	return result;
#line 552 "Math.c"
}

gint
he_math_utils_iabs (gint n)
{
	gint _tmp0_ = 0;
	gint result;
#line 164 "../lib/Utils/Math.vala"
	if (n > 0) {
#line 164 "../lib/Utils/Math.vala"
		_tmp0_ = n;
#line 564 "Math.c"
	} else {
#line 164 "../lib/Utils/Math.vala"
		_tmp0_ = -n;
#line 568 "Math.c"
	}
#line 164 "../lib/Utils/Math.vala"
	result = _tmp0_;
#line 164 "../lib/Utils/Math.vala"
	return result;
#line 574 "Math.c"
}

gdouble
he_math_utils_pow (gdouble b,
                   gdouble e)
{
	gdouble result;
#line 168 "../lib/Utils/Math.vala"
	result = pow (b, e);
#line 168 "../lib/Utils/Math.vala"
	return result;
#line 586 "Math.c"
}

gint
he_math_utils_round (gdouble n)
{
	gint result;
#line 172 "../lib/Utils/Math.vala"
	result = (gint) round (n);
#line 172 "../lib/Utils/Math.vala"
	return result;
#line 597 "Math.c"
}

gdouble
he_math_utils_round_double (gdouble n)
{
	gdouble result;
#line 176 "../lib/Utils/Math.vala"
	result = round (n);
#line 176 "../lib/Utils/Math.vala"
	return result;
#line 608 "Math.c"
}

gdouble
he_math_utils_max (gdouble n,
                   gdouble m)
{
	gdouble result;
#line 180 "../lib/Utils/Math.vala"
	result = fmax (n, m);
#line 180 "../lib/Utils/Math.vala"
	return result;
#line 620 "Math.c"
}

gdouble
he_math_utils_min (gdouble n,
                   gdouble m)
{
	gdouble result;
#line 184 "../lib/Utils/Math.vala"
	result = fmin (n, m);
#line 184 "../lib/Utils/Math.vala"
	return result;
#line 632 "Math.c"
}

gdouble
he_math_utils_linearized (gint rgb_component)
{
	gdouble normalized = 0.0;
	gdouble result;
#line 188 "../lib/Utils/Math.vala"
	normalized = rgb_component / 255.0;
#line 189 "../lib/Utils/Math.vala"
	if (normalized <= 0.040449936) {
#line 190 "../lib/Utils/Math.vala"
		result = (normalized / 12.92) * 100.0;
#line 190 "../lib/Utils/Math.vala"
		return result;
#line 648 "Math.c"
	} else {
#line 192 "../lib/Utils/Math.vala"
		result = pow ((normalized + 0.055) / 1.055, 2.4) * 100.0;
#line 192 "../lib/Utils/Math.vala"
		return result;
#line 654 "Math.c"
	}
}

gint
he_math_utils_delinearized (gdouble rgb_component)
{
	gdouble normalized = 0.0;
	gdouble delinearized = 0.0;
	gint result;
#line 197 "../lib/Utils/Math.vala"
	normalized = rgb_component / 100.0;
#line 198 "../lib/Utils/Math.vala"
	delinearized = 0.0;
#line 199 "../lib/Utils/Math.vala"
	if (normalized <= 0.0031308) {
#line 200 "../lib/Utils/Math.vala"
		delinearized = normalized * 12.92;
#line 672 "Math.c"
	} else {
#line 202 "../lib/Utils/Math.vala"
		delinearized = (1.055 * pow (normalized, 1.0 / 2.4)) - 0.055;
#line 676 "Math.c"
	}
#line 204 "../lib/Utils/Math.vala"
	result = he_math_utils_clamp_int (0, 255, he_math_utils_round (delinearized * 255));
#line 204 "../lib/Utils/Math.vala"
	return result;
#line 682 "Math.c"
}

gdouble
he_math_utils_double_delinearized (gdouble rgb_component)
{
	gdouble normalized = 0.0;
	gdouble delinearized = 0.0;
	gdouble result;
#line 208 "../lib/Utils/Math.vala"
	normalized = rgb_component / 100.0;
#line 209 "../lib/Utils/Math.vala"
	delinearized = 0.0;
#line 210 "../lib/Utils/Math.vala"
	if (normalized <= 0.0031308) {
#line 211 "../lib/Utils/Math.vala"
		delinearized = normalized * 12.92;
#line 699 "Math.c"
	} else {
#line 213 "../lib/Utils/Math.vala"
		delinearized = (1.055 * pow (normalized, 1.0 / 2.4)) - 0.055;
#line 703 "Math.c"
	}
#line 215 "../lib/Utils/Math.vala"
	result = delinearized * 255.0;
#line 215 "../lib/Utils/Math.vala"
	return result;
#line 709 "Math.c"
}

gdouble*
he_math_utils_midpoint (gdouble* a,
                        gint a_length1,
                        gdouble* b,
                        gint b_length1,
                        gint* result_length1)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gdouble* result;
#line 219 "../lib/Utils/Math.vala"
	_tmp0_ = a[0];
#line 219 "../lib/Utils/Math.vala"
	_tmp1_ = b[0];
#line 219 "../lib/Utils/Math.vala"
	_tmp2_ = a[1];
#line 219 "../lib/Utils/Math.vala"
	_tmp3_ = b[1];
#line 219 "../lib/Utils/Math.vala"
	_tmp4_ = a[2];
#line 219 "../lib/Utils/Math.vala"
	_tmp5_ = b[2];
#line 219 "../lib/Utils/Math.vala"
	_tmp6_ = g_new0 (gdouble, 3);
#line 219 "../lib/Utils/Math.vala"
	_tmp6_[0] = (_tmp0_ + _tmp1_) / 2.0;
#line 219 "../lib/Utils/Math.vala"
	_tmp6_[1] = (_tmp2_ + _tmp3_) / 2.0;
#line 219 "../lib/Utils/Math.vala"
	_tmp6_[2] = (_tmp4_ + _tmp5_) / 2.0;
#line 219 "../lib/Utils/Math.vala"
	_tmp7_ = _tmp6_;
#line 219 "../lib/Utils/Math.vala"
	_tmp7__length1 = 3;
#line 219 "../lib/Utils/Math.vala"
	if (result_length1) {
#line 219 "../lib/Utils/Math.vala"
		*result_length1 = _tmp7__length1;
#line 757 "Math.c"
	}
#line 219 "../lib/Utils/Math.vala"
	result = _tmp7_;
#line 219 "../lib/Utils/Math.vala"
	return result;
#line 763 "Math.c"
}

gdouble
he_math_utils_intercept (gdouble source,
                         gdouble mid,
                         gdouble target)
{
	gdouble result;
#line 225 "../lib/Utils/Math.vala"
	result = (mid - source) / (target - source);
#line 225 "../lib/Utils/Math.vala"
	return result;
#line 776 "Math.c"
}

gdouble
he_math_utils_hue_of (gdouble* linrgb,
                      gint linrgb_length1)
{
	gdouble* scaled_discount = NULL;
	gint _tmp0_ = 0;
	gdouble* _tmp1_;
	gint scaled_discount_length1;
	gint _scaled_discount_size_;
	gdouble r_a = 0.0;
	gdouble _tmp2_;
	gdouble g_a = 0.0;
	gdouble _tmp3_;
	gdouble b_a = 0.0;
	gdouble _tmp4_;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble result;
#line 229 "../lib/Utils/Math.vala"
	_tmp1_ = he_math_utils_elem_mul (linrgb, (gint) linrgb_length1, HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB, (gint) G_N_ELEMENTS (HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB), (gint) G_N_ELEMENTS (HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB[0]), &_tmp0_);
#line 229 "../lib/Utils/Math.vala"
	scaled_discount = _tmp1_;
#line 229 "../lib/Utils/Math.vala"
	scaled_discount_length1 = _tmp0_;
#line 229 "../lib/Utils/Math.vala"
	_scaled_discount_size_ = scaled_discount_length1;
#line 230 "../lib/Utils/Math.vala"
	_tmp2_ = scaled_discount[0];
#line 230 "../lib/Utils/Math.vala"
	r_a = he_math_utils_chromatic_adaptation (_tmp2_);
#line 231 "../lib/Utils/Math.vala"
	_tmp3_ = scaled_discount[1];
#line 231 "../lib/Utils/Math.vala"
	g_a = he_math_utils_chromatic_adaptation (_tmp3_);
#line 232 "../lib/Utils/Math.vala"
	_tmp4_ = scaled_discount[2];
#line 232 "../lib/Utils/Math.vala"
	b_a = he_math_utils_chromatic_adaptation (_tmp4_);
#line 234 "../lib/Utils/Math.vala"
	a = (((11.0 * r_a) + ((-12.0) * g_a)) + b_a) / 11.0;
#line 236 "../lib/Utils/Math.vala"
	b = ((r_a + g_a) - (2.0 * b_a)) / 9.0;
#line 237 "../lib/Utils/Math.vala"
	result = atan2 (b, a);
#line 237 "../lib/Utils/Math.vala"
	scaled_discount = (g_free (scaled_discount), NULL);
#line 237 "../lib/Utils/Math.vala"
	return result;
#line 827 "Math.c"
}

gdouble*
he_math_utils_nth_vertex (gdouble y,
                          gint n,
                          gint* result_length1)
{
	gdouble k_r = 0.0;
	gdouble k_g = 0.0;
	gdouble k_b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble coord_a = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble coord_b = 0.0;
	gdouble* result;
#line 241 "../lib/Utils/Math.vala"
	k_r = 0.2126;
#line 242 "../lib/Utils/Math.vala"
	k_g = 0.7152;
#line 243 "../lib/Utils/Math.vala"
	k_b = 0.0722;
#line 244 "../lib/Utils/Math.vala"
	if ((n % 4) <= 1) {
#line 244 "../lib/Utils/Math.vala"
		_tmp0_ = 0.0;
#line 853 "Math.c"
	} else {
#line 244 "../lib/Utils/Math.vala"
		_tmp0_ = 100.0;
#line 857 "Math.c"
	}
#line 244 "../lib/Utils/Math.vala"
	coord_a = _tmp0_;
#line 245 "../lib/Utils/Math.vala"
	if ((n % 2) == 0) {
#line 245 "../lib/Utils/Math.vala"
		_tmp1_ = 0.0;
#line 865 "Math.c"
	} else {
#line 245 "../lib/Utils/Math.vala"
		_tmp1_ = 100.0;
#line 869 "Math.c"
	}
#line 245 "../lib/Utils/Math.vala"
	coord_b = _tmp1_;
#line 246 "../lib/Utils/Math.vala"
	if (n < 4) {
#line 875 "Math.c"
		gdouble g = 0.0;
		gdouble b = 0.0;
		gdouble r = 0.0;
#line 247 "../lib/Utils/Math.vala"
		g = coord_a;
#line 248 "../lib/Utils/Math.vala"
		b = coord_b;
#line 249 "../lib/Utils/Math.vala"
		r = ((y - (g * k_g)) - (b * k_b)) / k_r;
#line 250 "../lib/Utils/Math.vala"
		if (he_math_utils_is_bounded_rgb (r)) {
#line 887 "Math.c"
			gdouble* _tmp2_;
			gdouble* _tmp3_;
			gint _tmp3__length1;
#line 251 "../lib/Utils/Math.vala"
			_tmp2_ = g_new0 (gdouble, 3);
#line 251 "../lib/Utils/Math.vala"
			_tmp2_[0] = r;
#line 251 "../lib/Utils/Math.vala"
			_tmp2_[1] = g;
#line 251 "../lib/Utils/Math.vala"
			_tmp2_[2] = b;
#line 251 "../lib/Utils/Math.vala"
			_tmp3_ = _tmp2_;
#line 251 "../lib/Utils/Math.vala"
			_tmp3__length1 = 3;
#line 251 "../lib/Utils/Math.vala"
			if (result_length1) {
#line 251 "../lib/Utils/Math.vala"
				*result_length1 = _tmp3__length1;
#line 907 "Math.c"
			}
#line 251 "../lib/Utils/Math.vala"
			result = _tmp3_;
#line 251 "../lib/Utils/Math.vala"
			return result;
#line 913 "Math.c"
		} else {
			gdouble* _tmp4_;
			gdouble* _tmp5_;
			gint _tmp5__length1;
#line 253 "../lib/Utils/Math.vala"
			_tmp4_ = g_new0 (gdouble, 3);
#line 253 "../lib/Utils/Math.vala"
			_tmp4_[0] = -1.0;
#line 253 "../lib/Utils/Math.vala"
			_tmp4_[1] = -1.0;
#line 253 "../lib/Utils/Math.vala"
			_tmp4_[2] = -1.0;
#line 253 "../lib/Utils/Math.vala"
			_tmp5_ = _tmp4_;
#line 253 "../lib/Utils/Math.vala"
			_tmp5__length1 = 3;
#line 253 "../lib/Utils/Math.vala"
			if (result_length1) {
#line 253 "../lib/Utils/Math.vala"
				*result_length1 = _tmp5__length1;
#line 934 "Math.c"
			}
#line 253 "../lib/Utils/Math.vala"
			result = _tmp5_;
#line 253 "../lib/Utils/Math.vala"
			return result;
#line 940 "Math.c"
		}
	} else {
#line 255 "../lib/Utils/Math.vala"
		if (n < 8) {
#line 945 "Math.c"
			gdouble b = 0.0;
			gdouble r = 0.0;
			gdouble g = 0.0;
#line 256 "../lib/Utils/Math.vala"
			b = coord_a;
#line 257 "../lib/Utils/Math.vala"
			r = coord_b;
#line 258 "../lib/Utils/Math.vala"
			g = ((y - (r * k_r)) - (b * k_b)) / k_g;
#line 259 "../lib/Utils/Math.vala"
			if (he_math_utils_is_bounded_rgb (g)) {
#line 957 "Math.c"
				gdouble* _tmp6_;
				gdouble* _tmp7_;
				gint _tmp7__length1;
#line 260 "../lib/Utils/Math.vala"
				_tmp6_ = g_new0 (gdouble, 3);
#line 260 "../lib/Utils/Math.vala"
				_tmp6_[0] = r;
#line 260 "../lib/Utils/Math.vala"
				_tmp6_[1] = g;
#line 260 "../lib/Utils/Math.vala"
				_tmp6_[2] = b;
#line 260 "../lib/Utils/Math.vala"
				_tmp7_ = _tmp6_;
#line 260 "../lib/Utils/Math.vala"
				_tmp7__length1 = 3;
#line 260 "../lib/Utils/Math.vala"
				if (result_length1) {
#line 260 "../lib/Utils/Math.vala"
					*result_length1 = _tmp7__length1;
#line 977 "Math.c"
				}
#line 260 "../lib/Utils/Math.vala"
				result = _tmp7_;
#line 260 "../lib/Utils/Math.vala"
				return result;
#line 983 "Math.c"
			} else {
				gdouble* _tmp8_;
				gdouble* _tmp9_;
				gint _tmp9__length1;
#line 262 "../lib/Utils/Math.vala"
				_tmp8_ = g_new0 (gdouble, 3);
#line 262 "../lib/Utils/Math.vala"
				_tmp8_[0] = -1.0;
#line 262 "../lib/Utils/Math.vala"
				_tmp8_[1] = -1.0;
#line 262 "../lib/Utils/Math.vala"
				_tmp8_[2] = -1.0;
#line 262 "../lib/Utils/Math.vala"
				_tmp9_ = _tmp8_;
#line 262 "../lib/Utils/Math.vala"
				_tmp9__length1 = 3;
#line 262 "../lib/Utils/Math.vala"
				if (result_length1) {
#line 262 "../lib/Utils/Math.vala"
					*result_length1 = _tmp9__length1;
#line 1004 "Math.c"
				}
#line 262 "../lib/Utils/Math.vala"
				result = _tmp9_;
#line 262 "../lib/Utils/Math.vala"
				return result;
#line 1010 "Math.c"
			}
		} else {
			gdouble r = 0.0;
			gdouble g = 0.0;
			gdouble b = 0.0;
#line 265 "../lib/Utils/Math.vala"
			r = coord_a;
#line 266 "../lib/Utils/Math.vala"
			g = coord_b;
#line 267 "../lib/Utils/Math.vala"
			b = ((y - (r * k_r)) - (g * k_g)) / k_b;
#line 268 "../lib/Utils/Math.vala"
			if (he_math_utils_is_bounded_rgb (b)) {
#line 1024 "Math.c"
				gdouble* _tmp10_;
				gdouble* _tmp11_;
				gint _tmp11__length1;
#line 269 "../lib/Utils/Math.vala"
				_tmp10_ = g_new0 (gdouble, 3);
#line 269 "../lib/Utils/Math.vala"
				_tmp10_[0] = r;
#line 269 "../lib/Utils/Math.vala"
				_tmp10_[1] = g;
#line 269 "../lib/Utils/Math.vala"
				_tmp10_[2] = b;
#line 269 "../lib/Utils/Math.vala"
				_tmp11_ = _tmp10_;
#line 269 "../lib/Utils/Math.vala"
				_tmp11__length1 = 3;
#line 269 "../lib/Utils/Math.vala"
				if (result_length1) {
#line 269 "../lib/Utils/Math.vala"
					*result_length1 = _tmp11__length1;
#line 1044 "Math.c"
				}
#line 269 "../lib/Utils/Math.vala"
				result = _tmp11_;
#line 269 "../lib/Utils/Math.vala"
				return result;
#line 1050 "Math.c"
			} else {
				gdouble* _tmp12_;
				gdouble* _tmp13_;
				gint _tmp13__length1;
#line 271 "../lib/Utils/Math.vala"
				_tmp12_ = g_new0 (gdouble, 3);
#line 271 "../lib/Utils/Math.vala"
				_tmp12_[0] = -1.0;
#line 271 "../lib/Utils/Math.vala"
				_tmp12_[1] = -1.0;
#line 271 "../lib/Utils/Math.vala"
				_tmp12_[2] = -1.0;
#line 271 "../lib/Utils/Math.vala"
				_tmp13_ = _tmp12_;
#line 271 "../lib/Utils/Math.vala"
				_tmp13__length1 = 3;
#line 271 "../lib/Utils/Math.vala"
				if (result_length1) {
#line 271 "../lib/Utils/Math.vala"
					*result_length1 = _tmp13__length1;
#line 1071 "Math.c"
				}
#line 271 "../lib/Utils/Math.vala"
				result = _tmp13_;
#line 271 "../lib/Utils/Math.vala"
				return result;
#line 1077 "Math.c"
			}
		}
	}
}

gboolean
he_math_utils_are_in_cyclic_order (gdouble a,
                                   gdouble b,
                                   gdouble c)
{
	gdouble delta_ab = 0.0;
	gdouble delta_ac = 0.0;
	gboolean result;
#line 277 "../lib/Utils/Math.vala"
	delta_ab = he_math_utils_sanitize_radians (b - a);
#line 278 "../lib/Utils/Math.vala"
	delta_ac = he_math_utils_sanitize_radians (c - a);
#line 279 "../lib/Utils/Math.vala"
	result = delta_ab < delta_ac;
#line 279 "../lib/Utils/Math.vala"
	return result;
#line 1099 "Math.c"
}

gdouble*
he_math_utils_set_coordinate (gdouble* source,
                              gint source_length1,
                              gdouble coordinate,
                              gdouble* target,
                              gint target_length1,
                              gint axis,
                              gint* result_length1)
{
	gdouble t = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble* result;
#line 283 "../lib/Utils/Math.vala"
	_tmp0_ = source[axis];
#line 283 "../lib/Utils/Math.vala"
	_tmp1_ = target[axis];
#line 283 "../lib/Utils/Math.vala"
	t = he_math_utils_intercept (_tmp0_, coordinate, _tmp1_);
#line 284 "../lib/Utils/Math.vala"
	_tmp3_ = he_math_utils_lerp_point (source, (gint) source_length1, t, target, (gint) target_length1, &_tmp2_);
#line 284 "../lib/Utils/Math.vala"
	_tmp4_ = _tmp3_;
#line 284 "../lib/Utils/Math.vala"
	_tmp4__length1 = _tmp2_;
#line 284 "../lib/Utils/Math.vala"
	if (result_length1) {
#line 284 "../lib/Utils/Math.vala"
		*result_length1 = _tmp4__length1;
#line 1135 "Math.c"
	}
#line 284 "../lib/Utils/Math.vala"
	result = _tmp4_;
#line 284 "../lib/Utils/Math.vala"
	return result;
#line 1141 "Math.c"
}

gdouble
he_math_utils_convert (gdouble value)
{
	gdouble epsilon = 0.0;
	gdouble kappa = 0.0;
	gdouble delta = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble result;
#line 288 "../lib/Utils/Math.vala"
	epsilon = 6.0 / 29.0;
#line 289 "../lib/Utils/Math.vala"
	kappa = 108.0 / 841.0;
#line 290 "../lib/Utils/Math.vala"
	delta = 4.0 / 29.0;
#line 291 "../lib/Utils/Math.vala"
	if (value > epsilon) {
#line 291 "../lib/Utils/Math.vala"
		_tmp0_ = pow (value, 3.0);
#line 1162 "Math.c"
	} else {
#line 291 "../lib/Utils/Math.vala"
		_tmp0_ = (value - delta) * kappa;
#line 1166 "Math.c"
	}
#line 291 "../lib/Utils/Math.vala"
	result = _tmp0_;
#line 291 "../lib/Utils/Math.vala"
	return result;
#line 1172 "Math.c"
}

static gdouble*
_vala_array_dup3 (gdouble* self,
                  gssize length)
{
#line 296 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 296 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1183 "Math.c"
	}
#line 296 "../lib/Utils/Math.vala"
	return NULL;
#line 1187 "Math.c"
}

static gdouble*
_vala_array_dup4 (gdouble* self,
                  gssize length)
{
#line 308 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 308 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1198 "Math.c"
	}
#line 308 "../lib/Utils/Math.vala"
	return NULL;
#line 1202 "Math.c"
}

static gdouble*
_vala_array_dup5 (gdouble* self,
                  gssize length)
{
#line 309 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 309 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1213 "Math.c"
	}
#line 309 "../lib/Utils/Math.vala"
	return NULL;
#line 1217 "Math.c"
}

static gdouble*
_vala_array_dup6 (gdouble* self,
                  gssize length)
{
#line 318 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 318 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1228 "Math.c"
	}
#line 318 "../lib/Utils/Math.vala"
	return NULL;
#line 1232 "Math.c"
}

static gdouble*
_vala_array_dup7 (gdouble* self,
                  gssize length)
{
#line 321 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 321 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1243 "Math.c"
	}
#line 321 "../lib/Utils/Math.vala"
	return NULL;
#line 1247 "Math.c"
}

gdouble*
he_math_utils_bisect_to_segment (gdouble y,
                                 gdouble target_hue,
                                 gint* result_length1)
{
	gdouble* left = NULL;
	gdouble* _tmp0_;
	gint left_length1;
	gint _left_size_;
	gdouble* right = NULL;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint right_length1;
	gint _right_size_;
	gdouble left_hue = 0.0;
	gdouble right_hue = 0.0;
	gboolean initialized = FALSE;
	gboolean uncut = FALSE;
	gdouble* _tmp19_;
	gint _tmp19__length1;
	gdouble _tmp20_;
	gdouble* _tmp21_;
	gint _tmp21__length1;
	gdouble _tmp22_;
	gdouble* _tmp23_;
	gint _tmp23__length1;
	gdouble _tmp24_;
	gdouble* _tmp25_;
	gint _tmp25__length1;
	gdouble _tmp26_;
	gdouble* _tmp27_;
	gint _tmp27__length1;
	gdouble _tmp28_;
	gdouble* _tmp29_;
	gint _tmp29__length1;
	gdouble _tmp30_;
	gdouble* _tmp31_;
	gdouble* _tmp32_;
	gint _tmp32__length1;
	gdouble* result;
#line 295 "../lib/Utils/Math.vala"
	_tmp0_ = g_new0 (gdouble, 3);
#line 295 "../lib/Utils/Math.vala"
	_tmp0_[0] = -1.0;
#line 295 "../lib/Utils/Math.vala"
	_tmp0_[1] = -1.0;
#line 295 "../lib/Utils/Math.vala"
	_tmp0_[2] = -1.0;
#line 295 "../lib/Utils/Math.vala"
	left = _tmp0_;
#line 295 "../lib/Utils/Math.vala"
	left_length1 = 3;
#line 295 "../lib/Utils/Math.vala"
	_left_size_ = left_length1;
#line 296 "../lib/Utils/Math.vala"
	_tmp1_ = left;
#line 296 "../lib/Utils/Math.vala"
	_tmp1__length1 = left_length1;
#line 296 "../lib/Utils/Math.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup3 (_tmp1_, _tmp1__length1) : _tmp1_;
#line 296 "../lib/Utils/Math.vala"
	_tmp2__length1 = _tmp1__length1;
#line 296 "../lib/Utils/Math.vala"
	right = _tmp2_;
#line 296 "../lib/Utils/Math.vala"
	right_length1 = _tmp2__length1;
#line 296 "../lib/Utils/Math.vala"
	_right_size_ = right_length1;
#line 297 "../lib/Utils/Math.vala"
	left_hue = 0.0;
#line 298 "../lib/Utils/Math.vala"
	right_hue = 0.0;
#line 299 "../lib/Utils/Math.vala"
	initialized = FALSE;
#line 300 "../lib/Utils/Math.vala"
	uncut = TRUE;
#line 1328 "Math.c"
	{
		gint n = 0;
#line 301 "../lib/Utils/Math.vala"
		n = 0;
#line 1333 "Math.c"
		{
			gboolean _tmp3_ = FALSE;
#line 301 "../lib/Utils/Math.vala"
			_tmp3_ = TRUE;
#line 301 "../lib/Utils/Math.vala"
			while (TRUE) {
#line 1340 "Math.c"
				gdouble* mid = NULL;
				gint _tmp5_ = 0;
				gdouble* _tmp6_;
				gint mid_length1;
				gint _mid_size_;
				gdouble* _tmp7_;
				gint _tmp7__length1;
				gdouble _tmp8_;
				gdouble mid_hue = 0.0;
				gdouble* _tmp9_;
				gint _tmp9__length1;
				gboolean _tmp14_ = FALSE;
#line 301 "../lib/Utils/Math.vala"
				if (!_tmp3_) {
#line 1355 "Math.c"
					gint _tmp4_;
#line 301 "../lib/Utils/Math.vala"
					_tmp4_ = n;
#line 301 "../lib/Utils/Math.vala"
					n = _tmp4_ + 1;
#line 1361 "Math.c"
				}
#line 301 "../lib/Utils/Math.vala"
				_tmp3_ = FALSE;
#line 301 "../lib/Utils/Math.vala"
				if (!(n < 12)) {
#line 301 "../lib/Utils/Math.vala"
					break;
#line 1369 "Math.c"
				}
#line 302 "../lib/Utils/Math.vala"
				_tmp6_ = he_math_utils_nth_vertex (y, n, &_tmp5_);
#line 302 "../lib/Utils/Math.vala"
				mid = _tmp6_;
#line 302 "../lib/Utils/Math.vala"
				mid_length1 = _tmp5_;
#line 302 "../lib/Utils/Math.vala"
				_mid_size_ = mid_length1;
#line 303 "../lib/Utils/Math.vala"
				_tmp7_ = mid;
#line 303 "../lib/Utils/Math.vala"
				_tmp7__length1 = mid_length1;
#line 303 "../lib/Utils/Math.vala"
				_tmp8_ = _tmp7_[0];
#line 303 "../lib/Utils/Math.vala"
				if (_tmp8_ < 0.0) {
#line 304 "../lib/Utils/Math.vala"
					mid = (g_free (mid), NULL);
#line 304 "../lib/Utils/Math.vala"
					continue;
#line 1391 "Math.c"
				}
#line 306 "../lib/Utils/Math.vala"
				_tmp9_ = mid;
#line 306 "../lib/Utils/Math.vala"
				_tmp9__length1 = mid_length1;
#line 306 "../lib/Utils/Math.vala"
				mid_hue = he_math_utils_hue_of (_tmp9_, (gint) _tmp9__length1);
#line 307 "../lib/Utils/Math.vala"
				if (!initialized) {
#line 1401 "Math.c"
					gdouble* _tmp10_;
					gint _tmp10__length1;
					gdouble* _tmp11_;
					gint _tmp11__length1;
					gdouble* _tmp12_;
					gint _tmp12__length1;
					gdouble* _tmp13_;
					gint _tmp13__length1;
#line 308 "../lib/Utils/Math.vala"
					_tmp10_ = mid;
#line 308 "../lib/Utils/Math.vala"
					_tmp10__length1 = mid_length1;
#line 308 "../lib/Utils/Math.vala"
					_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup4 (_tmp10_, _tmp10__length1) : _tmp10_;
#line 308 "../lib/Utils/Math.vala"
					_tmp11__length1 = _tmp10__length1;
#line 308 "../lib/Utils/Math.vala"
					left = (g_free (left), NULL);
#line 308 "../lib/Utils/Math.vala"
					left = _tmp11_;
#line 308 "../lib/Utils/Math.vala"
					left_length1 = _tmp11__length1;
#line 308 "../lib/Utils/Math.vala"
					_left_size_ = left_length1;
#line 309 "../lib/Utils/Math.vala"
					_tmp12_ = mid;
#line 309 "../lib/Utils/Math.vala"
					_tmp12__length1 = mid_length1;
#line 309 "../lib/Utils/Math.vala"
					_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup5 (_tmp12_, _tmp12__length1) : _tmp12_;
#line 309 "../lib/Utils/Math.vala"
					_tmp13__length1 = _tmp12__length1;
#line 309 "../lib/Utils/Math.vala"
					right = (g_free (right), NULL);
#line 309 "../lib/Utils/Math.vala"
					right = _tmp13_;
#line 309 "../lib/Utils/Math.vala"
					right_length1 = _tmp13__length1;
#line 309 "../lib/Utils/Math.vala"
					_right_size_ = right_length1;
#line 310 "../lib/Utils/Math.vala"
					left_hue = mid_hue;
#line 311 "../lib/Utils/Math.vala"
					right_hue = mid_hue;
#line 312 "../lib/Utils/Math.vala"
					initialized = TRUE;
#line 313 "../lib/Utils/Math.vala"
					mid = (g_free (mid), NULL);
#line 313 "../lib/Utils/Math.vala"
					continue;
#line 1452 "Math.c"
				}
#line 315 "../lib/Utils/Math.vala"
				if (uncut) {
#line 315 "../lib/Utils/Math.vala"
					_tmp14_ = TRUE;
#line 1458 "Math.c"
				} else {
#line 315 "../lib/Utils/Math.vala"
					_tmp14_ = he_math_utils_are_in_cyclic_order (left_hue, mid_hue, right_hue);
#line 1462 "Math.c"
				}
#line 315 "../lib/Utils/Math.vala"
				if (_tmp14_) {
#line 316 "../lib/Utils/Math.vala"
					uncut = FALSE;
#line 317 "../lib/Utils/Math.vala"
					if (he_math_utils_are_in_cyclic_order (left_hue, target_hue, mid_hue)) {
#line 1470 "Math.c"
						gdouble* _tmp15_;
						gint _tmp15__length1;
						gdouble* _tmp16_;
						gint _tmp16__length1;
#line 318 "../lib/Utils/Math.vala"
						_tmp15_ = mid;
#line 318 "../lib/Utils/Math.vala"
						_tmp15__length1 = mid_length1;
#line 318 "../lib/Utils/Math.vala"
						_tmp16_ = (_tmp15_ != NULL) ? _vala_array_dup6 (_tmp15_, _tmp15__length1) : _tmp15_;
#line 318 "../lib/Utils/Math.vala"
						_tmp16__length1 = _tmp15__length1;
#line 318 "../lib/Utils/Math.vala"
						right = (g_free (right), NULL);
#line 318 "../lib/Utils/Math.vala"
						right = _tmp16_;
#line 318 "../lib/Utils/Math.vala"
						right_length1 = _tmp16__length1;
#line 318 "../lib/Utils/Math.vala"
						_right_size_ = right_length1;
#line 319 "../lib/Utils/Math.vala"
						right_hue = mid_hue;
#line 1493 "Math.c"
					} else {
						gdouble* _tmp17_;
						gint _tmp17__length1;
						gdouble* _tmp18_;
						gint _tmp18__length1;
#line 321 "../lib/Utils/Math.vala"
						_tmp17_ = mid;
#line 321 "../lib/Utils/Math.vala"
						_tmp17__length1 = mid_length1;
#line 321 "../lib/Utils/Math.vala"
						_tmp18_ = (_tmp17_ != NULL) ? _vala_array_dup7 (_tmp17_, _tmp17__length1) : _tmp17_;
#line 321 "../lib/Utils/Math.vala"
						_tmp18__length1 = _tmp17__length1;
#line 321 "../lib/Utils/Math.vala"
						left = (g_free (left), NULL);
#line 321 "../lib/Utils/Math.vala"
						left = _tmp18_;
#line 321 "../lib/Utils/Math.vala"
						left_length1 = _tmp18__length1;
#line 321 "../lib/Utils/Math.vala"
						_left_size_ = left_length1;
#line 322 "../lib/Utils/Math.vala"
						left_hue = mid_hue;
#line 1517 "Math.c"
					}
				}
#line 301 "../lib/Utils/Math.vala"
				mid = (g_free (mid), NULL);
#line 1522 "Math.c"
			}
		}
	}
#line 326 "../lib/Utils/Math.vala"
	_tmp19_ = left;
#line 326 "../lib/Utils/Math.vala"
	_tmp19__length1 = left_length1;
#line 326 "../lib/Utils/Math.vala"
	_tmp20_ = _tmp19_[0];
#line 326 "../lib/Utils/Math.vala"
	_tmp21_ = left;
#line 326 "../lib/Utils/Math.vala"
	_tmp21__length1 = left_length1;
#line 326 "../lib/Utils/Math.vala"
	_tmp22_ = _tmp21_[1];
#line 326 "../lib/Utils/Math.vala"
	_tmp23_ = left;
#line 326 "../lib/Utils/Math.vala"
	_tmp23__length1 = left_length1;
#line 326 "../lib/Utils/Math.vala"
	_tmp24_ = _tmp23_[2];
#line 326 "../lib/Utils/Math.vala"
	_tmp25_ = right;
#line 326 "../lib/Utils/Math.vala"
	_tmp25__length1 = right_length1;
#line 326 "../lib/Utils/Math.vala"
	_tmp26_ = _tmp25_[0];
#line 326 "../lib/Utils/Math.vala"
	_tmp27_ = right;
#line 326 "../lib/Utils/Math.vala"
	_tmp27__length1 = right_length1;
#line 326 "../lib/Utils/Math.vala"
	_tmp28_ = _tmp27_[1];
#line 326 "../lib/Utils/Math.vala"
	_tmp29_ = right;
#line 326 "../lib/Utils/Math.vala"
	_tmp29__length1 = right_length1;
#line 326 "../lib/Utils/Math.vala"
	_tmp30_ = _tmp29_[2];
#line 326 "../lib/Utils/Math.vala"
	_tmp31_ = g_new0 (gdouble, 6);
#line 326 "../lib/Utils/Math.vala"
	_tmp31_[0] = _tmp20_;
#line 326 "../lib/Utils/Math.vala"
	_tmp31_[1] = _tmp22_;
#line 326 "../lib/Utils/Math.vala"
	_tmp31_[2] = _tmp24_;
#line 326 "../lib/Utils/Math.vala"
	_tmp31_[3] = _tmp26_;
#line 326 "../lib/Utils/Math.vala"
	_tmp31_[4] = _tmp28_;
#line 326 "../lib/Utils/Math.vala"
	_tmp31_[5] = _tmp30_;
#line 326 "../lib/Utils/Math.vala"
	_tmp32_ = _tmp31_;
#line 326 "../lib/Utils/Math.vala"
	_tmp32__length1 = 6;
#line 326 "../lib/Utils/Math.vala"
	if (result_length1) {
#line 326 "../lib/Utils/Math.vala"
		*result_length1 = _tmp32__length1;
#line 1584 "Math.c"
	}
#line 326 "../lib/Utils/Math.vala"
	result = _tmp32_;
#line 326 "../lib/Utils/Math.vala"
	right = (g_free (right), NULL);
#line 326 "../lib/Utils/Math.vala"
	left = (g_free (left), NULL);
#line 326 "../lib/Utils/Math.vala"
	return result;
#line 1594 "Math.c"
}

static gdouble*
_vala_array_dup8 (gdouble* self,
                  gssize length)
{
#line 354 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 354 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1605 "Math.c"
	}
#line 354 "../lib/Utils/Math.vala"
	return NULL;
#line 1609 "Math.c"
}

static gdouble*
_vala_array_dup9 (gdouble* self,
                  gssize length)
{
#line 357 "../lib/Utils/Math.vala"
	if (length > 0) {
#line 357 "../lib/Utils/Math.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 1620 "Math.c"
	}
#line 357 "../lib/Utils/Math.vala"
	return NULL;
#line 1624 "Math.c"
}

gdouble*
he_math_utils_bisect_to_limit (gdouble y,
                               gdouble target_hue,
                               gint* result_length1)
{
	gdouble* segment = NULL;
	gint _tmp0_ = 0;
	gdouble* _tmp1_;
	gint segment_length1;
	gint _segment_size_;
	gdouble* left = NULL;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gdouble _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble _tmp5_;
	gdouble* _tmp6_;
	gint _tmp6__length1;
	gdouble _tmp7_;
	gdouble* _tmp8_;
	gint left_length1;
	gint _left_size_;
	gdouble left_hue = 0.0;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* right = NULL;
	gdouble* _tmp10_;
	gint _tmp10__length1;
	gdouble _tmp11_;
	gdouble* _tmp12_;
	gint _tmp12__length1;
	gdouble _tmp13_;
	gdouble* _tmp14_;
	gint _tmp14__length1;
	gdouble _tmp15_;
	gdouble* _tmp16_;
	gint right_length1;
	gint _right_size_;
	gdouble* _tmp47_;
	gint _tmp47__length1;
	gdouble* _tmp48_;
	gint _tmp48__length1;
	gint _tmp49_ = 0;
	gdouble* _tmp50_;
	gdouble* _tmp51_;
	gint _tmp51__length1;
	gdouble* result;
#line 330 "../lib/Utils/Math.vala"
	_tmp1_ = he_math_utils_bisect_to_segment (y, target_hue, &_tmp0_);
#line 330 "../lib/Utils/Math.vala"
	segment = _tmp1_;
#line 330 "../lib/Utils/Math.vala"
	segment_length1 = _tmp0_;
#line 330 "../lib/Utils/Math.vala"
	_segment_size_ = segment_length1;
#line 331 "../lib/Utils/Math.vala"
	_tmp2_ = segment;
#line 331 "../lib/Utils/Math.vala"
	_tmp2__length1 = segment_length1;
#line 331 "../lib/Utils/Math.vala"
	_tmp3_ = _tmp2_[0];
#line 331 "../lib/Utils/Math.vala"
	_tmp4_ = segment;
#line 331 "../lib/Utils/Math.vala"
	_tmp4__length1 = segment_length1;
#line 331 "../lib/Utils/Math.vala"
	_tmp5_ = _tmp4_[1];
#line 331 "../lib/Utils/Math.vala"
	_tmp6_ = segment;
#line 331 "../lib/Utils/Math.vala"
	_tmp6__length1 = segment_length1;
#line 331 "../lib/Utils/Math.vala"
	_tmp7_ = _tmp6_[2];
#line 331 "../lib/Utils/Math.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 331 "../lib/Utils/Math.vala"
	_tmp8_[0] = _tmp3_;
#line 331 "../lib/Utils/Math.vala"
	_tmp8_[1] = _tmp5_;
#line 331 "../lib/Utils/Math.vala"
	_tmp8_[2] = _tmp7_;
#line 331 "../lib/Utils/Math.vala"
	left = _tmp8_;
#line 331 "../lib/Utils/Math.vala"
	left_length1 = 3;
#line 331 "../lib/Utils/Math.vala"
	_left_size_ = left_length1;
#line 332 "../lib/Utils/Math.vala"
	_tmp9_ = left;
#line 332 "../lib/Utils/Math.vala"
	_tmp9__length1 = left_length1;
#line 332 "../lib/Utils/Math.vala"
	left_hue = he_math_utils_hue_of (_tmp9_, (gint) _tmp9__length1);
#line 333 "../lib/Utils/Math.vala"
	_tmp10_ = segment;
#line 333 "../lib/Utils/Math.vala"
	_tmp10__length1 = segment_length1;
#line 333 "../lib/Utils/Math.vala"
	_tmp11_ = _tmp10_[3];
#line 333 "../lib/Utils/Math.vala"
	_tmp12_ = segment;
#line 333 "../lib/Utils/Math.vala"
	_tmp12__length1 = segment_length1;
#line 333 "../lib/Utils/Math.vala"
	_tmp13_ = _tmp12_[4];
#line 333 "../lib/Utils/Math.vala"
	_tmp14_ = segment;
#line 333 "../lib/Utils/Math.vala"
	_tmp14__length1 = segment_length1;
#line 333 "../lib/Utils/Math.vala"
	_tmp15_ = _tmp14_[5];
#line 333 "../lib/Utils/Math.vala"
	_tmp16_ = g_new0 (gdouble, 3);
#line 333 "../lib/Utils/Math.vala"
	_tmp16_[0] = _tmp11_;
#line 333 "../lib/Utils/Math.vala"
	_tmp16_[1] = _tmp13_;
#line 333 "../lib/Utils/Math.vala"
	_tmp16_[2] = _tmp15_;
#line 333 "../lib/Utils/Math.vala"
	right = _tmp16_;
#line 333 "../lib/Utils/Math.vala"
	right_length1 = 3;
#line 333 "../lib/Utils/Math.vala"
	_right_size_ = right_length1;
#line 1753 "Math.c"
	{
		gint axis = 0;
#line 334 "../lib/Utils/Math.vala"
		axis = 0;
#line 1758 "Math.c"
		{
			gboolean _tmp17_ = FALSE;
#line 334 "../lib/Utils/Math.vala"
			_tmp17_ = TRUE;
#line 334 "../lib/Utils/Math.vala"
			while (TRUE) {
#line 1765 "Math.c"
				gdouble* _tmp19_;
				gint _tmp19__length1;
				gdouble _tmp20_;
				gdouble* _tmp21_;
				gint _tmp21__length1;
				gdouble _tmp22_;
#line 334 "../lib/Utils/Math.vala"
				if (!_tmp17_) {
#line 1774 "Math.c"
					gint _tmp18_;
#line 334 "../lib/Utils/Math.vala"
					_tmp18_ = axis;
#line 334 "../lib/Utils/Math.vala"
					axis = _tmp18_ + 1;
#line 1780 "Math.c"
				}
#line 334 "../lib/Utils/Math.vala"
				_tmp17_ = FALSE;
#line 334 "../lib/Utils/Math.vala"
				if (!(axis < 3)) {
#line 334 "../lib/Utils/Math.vala"
					break;
#line 1788 "Math.c"
				}
#line 335 "../lib/Utils/Math.vala"
				_tmp19_ = left;
#line 335 "../lib/Utils/Math.vala"
				_tmp19__length1 = left_length1;
#line 335 "../lib/Utils/Math.vala"
				_tmp20_ = _tmp19_[axis];
#line 335 "../lib/Utils/Math.vala"
				_tmp21_ = right;
#line 335 "../lib/Utils/Math.vala"
				_tmp21__length1 = right_length1;
#line 335 "../lib/Utils/Math.vala"
				_tmp22_ = _tmp21_[axis];
#line 335 "../lib/Utils/Math.vala"
				if (_tmp20_ != _tmp22_) {
#line 1804 "Math.c"
					gint l_plane = 0;
					gint r_plane = 0;
					gdouble* _tmp23_;
					gint _tmp23__length1;
					gdouble _tmp24_;
					gdouble* _tmp25_;
					gint _tmp25__length1;
					gdouble _tmp26_;
#line 336 "../lib/Utils/Math.vala"
					l_plane = -1;
#line 337 "../lib/Utils/Math.vala"
					r_plane = 255;
#line 338 "../lib/Utils/Math.vala"
					_tmp23_ = left;
#line 338 "../lib/Utils/Math.vala"
					_tmp23__length1 = left_length1;
#line 338 "../lib/Utils/Math.vala"
					_tmp24_ = _tmp23_[axis];
#line 338 "../lib/Utils/Math.vala"
					_tmp25_ = right;
#line 338 "../lib/Utils/Math.vala"
					_tmp25__length1 = right_length1;
#line 338 "../lib/Utils/Math.vala"
					_tmp26_ = _tmp25_[axis];
#line 338 "../lib/Utils/Math.vala"
					if (_tmp24_ < _tmp26_) {
#line 1831 "Math.c"
						gdouble* _tmp27_;
						gint _tmp27__length1;
						gdouble _tmp28_;
						gdouble* _tmp29_;
						gint _tmp29__length1;
						gdouble _tmp30_;
#line 339 "../lib/Utils/Math.vala"
						_tmp27_ = left;
#line 339 "../lib/Utils/Math.vala"
						_tmp27__length1 = left_length1;
#line 339 "../lib/Utils/Math.vala"
						_tmp28_ = _tmp27_[axis];
#line 339 "../lib/Utils/Math.vala"
						l_plane = he_critical_plane_below (he_math_utils_double_delinearized (_tmp28_));
#line 340 "../lib/Utils/Math.vala"
						_tmp29_ = right;
#line 340 "../lib/Utils/Math.vala"
						_tmp29__length1 = right_length1;
#line 340 "../lib/Utils/Math.vala"
						_tmp30_ = _tmp29_[axis];
#line 340 "../lib/Utils/Math.vala"
						r_plane = he_critical_plane_above (he_math_utils_double_delinearized (_tmp30_));
#line 1854 "Math.c"
					} else {
						gdouble* _tmp31_;
						gint _tmp31__length1;
						gdouble _tmp32_;
						gdouble* _tmp33_;
						gint _tmp33__length1;
						gdouble _tmp34_;
#line 342 "../lib/Utils/Math.vala"
						_tmp31_ = left;
#line 342 "../lib/Utils/Math.vala"
						_tmp31__length1 = left_length1;
#line 342 "../lib/Utils/Math.vala"
						_tmp32_ = _tmp31_[axis];
#line 342 "../lib/Utils/Math.vala"
						l_plane = he_critical_plane_above (he_math_utils_double_delinearized (_tmp32_));
#line 343 "../lib/Utils/Math.vala"
						_tmp33_ = right;
#line 343 "../lib/Utils/Math.vala"
						_tmp33__length1 = right_length1;
#line 343 "../lib/Utils/Math.vala"
						_tmp34_ = _tmp33_[axis];
#line 343 "../lib/Utils/Math.vala"
						r_plane = he_critical_plane_below (he_math_utils_double_delinearized (_tmp34_));
#line 1878 "Math.c"
					}
					{
						gint i = 0;
#line 345 "../lib/Utils/Math.vala"
						i = 0;
#line 1884 "Math.c"
						{
							gboolean _tmp35_ = FALSE;
#line 345 "../lib/Utils/Math.vala"
							_tmp35_ = TRUE;
#line 345 "../lib/Utils/Math.vala"
							while (TRUE) {
#line 345 "../lib/Utils/Math.vala"
								if (!_tmp35_) {
#line 1893 "Math.c"
									gint _tmp36_;
#line 345 "../lib/Utils/Math.vala"
									_tmp36_ = i;
#line 345 "../lib/Utils/Math.vala"
									i = _tmp36_ + 1;
#line 1899 "Math.c"
								}
#line 345 "../lib/Utils/Math.vala"
								_tmp35_ = FALSE;
#line 345 "../lib/Utils/Math.vala"
								if (!(i < 8)) {
#line 345 "../lib/Utils/Math.vala"
									break;
#line 1907 "Math.c"
								}
#line 346 "../lib/Utils/Math.vala"
								if (fabs ((gdouble) (r_plane - l_plane)) <= 1.0) {
#line 347 "../lib/Utils/Math.vala"
									break;
#line 1913 "Math.c"
								} else {
									gint m_plane = 0;
									gdouble mid_plane_coord = 0.0;
									gdouble _tmp37_;
									gdouble* mid = NULL;
									gdouble* _tmp38_;
									gint _tmp38__length1;
									gdouble* _tmp39_;
									gint _tmp39__length1;
									gint _tmp40_ = 0;
									gdouble* _tmp41_;
									gint mid_length1;
									gint _mid_size_;
									gdouble mid_hue = 0.0;
									gdouble* _tmp42_;
									gint _tmp42__length1;
#line 349 "../lib/Utils/Math.vala"
									m_plane = (gint) floor ((l_plane + r_plane) / 2.0);
#line 350 "../lib/Utils/Math.vala"
									_tmp37_ = HE_CRITICAL_PLANES[m_plane];
#line 350 "../lib/Utils/Math.vala"
									mid_plane_coord = _tmp37_;
#line 351 "../lib/Utils/Math.vala"
									_tmp38_ = left;
#line 351 "../lib/Utils/Math.vala"
									_tmp38__length1 = left_length1;
#line 351 "../lib/Utils/Math.vala"
									_tmp39_ = right;
#line 351 "../lib/Utils/Math.vala"
									_tmp39__length1 = right_length1;
#line 351 "../lib/Utils/Math.vala"
									_tmp41_ = he_math_utils_set_coordinate (_tmp38_, (gint) _tmp38__length1, mid_plane_coord, _tmp39_, (gint) _tmp39__length1, axis, &_tmp40_);
#line 351 "../lib/Utils/Math.vala"
									mid = _tmp41_;
#line 351 "../lib/Utils/Math.vala"
									mid_length1 = _tmp40_;
#line 351 "../lib/Utils/Math.vala"
									_mid_size_ = mid_length1;
#line 352 "../lib/Utils/Math.vala"
									_tmp42_ = mid;
#line 352 "../lib/Utils/Math.vala"
									_tmp42__length1 = mid_length1;
#line 352 "../lib/Utils/Math.vala"
									mid_hue = he_math_utils_hue_of (_tmp42_, (gint) _tmp42__length1);
#line 353 "../lib/Utils/Math.vala"
									if (he_math_utils_are_in_cyclic_order (left_hue, target_hue, mid_hue)) {
#line 1960 "Math.c"
										gdouble* _tmp43_;
										gint _tmp43__length1;
										gdouble* _tmp44_;
										gint _tmp44__length1;
#line 354 "../lib/Utils/Math.vala"
										_tmp43_ = mid;
#line 354 "../lib/Utils/Math.vala"
										_tmp43__length1 = mid_length1;
#line 354 "../lib/Utils/Math.vala"
										_tmp44_ = (_tmp43_ != NULL) ? _vala_array_dup8 (_tmp43_, _tmp43__length1) : _tmp43_;
#line 354 "../lib/Utils/Math.vala"
										_tmp44__length1 = _tmp43__length1;
#line 354 "../lib/Utils/Math.vala"
										right = (g_free (right), NULL);
#line 354 "../lib/Utils/Math.vala"
										right = _tmp44_;
#line 354 "../lib/Utils/Math.vala"
										right_length1 = _tmp44__length1;
#line 354 "../lib/Utils/Math.vala"
										_right_size_ = right_length1;
#line 355 "../lib/Utils/Math.vala"
										r_plane = m_plane;
#line 1983 "Math.c"
									} else {
										gdouble* _tmp45_;
										gint _tmp45__length1;
										gdouble* _tmp46_;
										gint _tmp46__length1;
#line 357 "../lib/Utils/Math.vala"
										_tmp45_ = mid;
#line 357 "../lib/Utils/Math.vala"
										_tmp45__length1 = mid_length1;
#line 357 "../lib/Utils/Math.vala"
										_tmp46_ = (_tmp45_ != NULL) ? _vala_array_dup9 (_tmp45_, _tmp45__length1) : _tmp45_;
#line 357 "../lib/Utils/Math.vala"
										_tmp46__length1 = _tmp45__length1;
#line 357 "../lib/Utils/Math.vala"
										left = (g_free (left), NULL);
#line 357 "../lib/Utils/Math.vala"
										left = _tmp46_;
#line 357 "../lib/Utils/Math.vala"
										left_length1 = _tmp46__length1;
#line 357 "../lib/Utils/Math.vala"
										_left_size_ = left_length1;
#line 358 "../lib/Utils/Math.vala"
										left_hue = mid_hue;
#line 359 "../lib/Utils/Math.vala"
										l_plane = m_plane;
#line 2009 "Math.c"
									}
#line 346 "../lib/Utils/Math.vala"
									mid = (g_free (mid), NULL);
#line 2013 "Math.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 365 "../lib/Utils/Math.vala"
	_tmp47_ = left;
#line 365 "../lib/Utils/Math.vala"
	_tmp47__length1 = left_length1;
#line 365 "../lib/Utils/Math.vala"
	_tmp48_ = right;
#line 365 "../lib/Utils/Math.vala"
	_tmp48__length1 = right_length1;
#line 365 "../lib/Utils/Math.vala"
	_tmp50_ = he_math_utils_midpoint (_tmp47_, (gint) _tmp47__length1, _tmp48_, (gint) _tmp48__length1, &_tmp49_);
#line 365 "../lib/Utils/Math.vala"
	_tmp51_ = _tmp50_;
#line 365 "../lib/Utils/Math.vala"
	_tmp51__length1 = _tmp49_;
#line 365 "../lib/Utils/Math.vala"
	if (result_length1) {
#line 365 "../lib/Utils/Math.vala"
		*result_length1 = _tmp51__length1;
#line 2040 "Math.c"
	}
#line 365 "../lib/Utils/Math.vala"
	result = _tmp51_;
#line 365 "../lib/Utils/Math.vala"
	right = (g_free (right), NULL);
#line 365 "../lib/Utils/Math.vala"
	left = (g_free (left), NULL);
#line 365 "../lib/Utils/Math.vala"
	segment = (g_free (segment), NULL);
#line 365 "../lib/Utils/Math.vala"
	return result;
#line 2052 "Math.c"
}

gdouble
he_math_utils_y_from_lstar (gdouble lstar)
{
	gdouble result;
#line 369 "../lib/Utils/Math.vala"
	result = 100.0 * he_math_utils_lab_inverse_fovea ((lstar + 16.0) / 116.0);
#line 369 "../lib/Utils/Math.vala"
	return result;
#line 2063 "Math.c"
}

gint
he_math_utils_argb_from_lstar (gdouble lstar)
{
	gdouble y = 0.0;
	gint component = 0;
	gint result;
#line 373 "../lib/Utils/Math.vala"
	y = he_math_utils_y_from_lstar (lstar);
#line 374 "../lib/Utils/Math.vala"
	component = he_math_utils_delinearized (y);
#line 375 "../lib/Utils/Math.vala"
	result = he_argb_from_rgb_int (component, component, component);
#line 375 "../lib/Utils/Math.vala"
	return result;
#line 2080 "Math.c"
}

gdouble
he_math_utils_lstar_from_argb (gint argb)
{
	gdouble y = 0.0;
	HeXYZColor _tmp0_ = {0};
	gdouble result;
#line 379 "../lib/Utils/Math.vala"
	he_argb_to_xyz (argb, &_tmp0_);
#line 379 "../lib/Utils/Math.vala"
	y = _tmp0_.y;
#line 380 "../lib/Utils/Math.vala"
	result = (116.0 * he_math_utils_lab_fovea (y / 100.0)) - 16.0;
#line 380 "../lib/Utils/Math.vala"
	return result;
#line 2097 "Math.c"
}

gdouble
he_math_utils_lstar_from_y (gdouble y)
{
	gdouble result;
#line 384 "../lib/Utils/Math.vala"
	result = (116.0 * he_math_utils_lab_fovea (y / 100.0)) - 16.0;
#line 384 "../lib/Utils/Math.vala"
	return result;
#line 2108 "Math.c"
}

gdouble
he_math_utils_clamp (gdouble start,
                     gdouble end,
                     gdouble value)
{
	gdouble result;
#line 388 "../lib/Utils/Math.vala"
	if (value < start) {
#line 389 "../lib/Utils/Math.vala"
		result = start;
#line 389 "../lib/Utils/Math.vala"
		return result;
#line 2123 "Math.c"
	} else {
#line 390 "../lib/Utils/Math.vala"
		if (value > end) {
#line 391 "../lib/Utils/Math.vala"
			result = end;
#line 391 "../lib/Utils/Math.vala"
			return result;
#line 2131 "Math.c"
		} else {
#line 393 "../lib/Utils/Math.vala"
			result = value;
#line 393 "../lib/Utils/Math.vala"
			return result;
#line 2137 "Math.c"
		}
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

