/* AboutWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from AboutWindow.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <gdk/gdk.h>

#define HE_ABOUT_WINDOW_TOP_MARGIN 56
#define HE_ABOUT_WINDOW_DESKTOP_EDGE_MARGIN 114
#define HE_ABOUT_WINDOW_MIN_EDGE_MARGIN 56
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_ABOUT_WINDOW_0_PROPERTY,
	HE_ABOUT_WINDOW_VISIBLE_PROPERTY,
	HE_ABOUT_WINDOW_COLOR_PROPERTY,
	HE_ABOUT_WINDOW_LICENSE_PROPERTY,
	HE_ABOUT_WINDOW_VERSION_PROPERTY,
	HE_ABOUT_WINDOW_APP_NAME_PROPERTY,
	HE_ABOUT_WINDOW_ICON_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY,
	HE_ABOUT_WINDOW_APP_ID_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY,
	HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY,
	HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY,
	HE_ABOUT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_about_window_properties[HE_ABOUT_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
enum  {
	HE_ABOUT_WINDOW_HIDDEN_SIGNAL,
	HE_ABOUT_WINDOW_NUM_SIGNALS
};
static guint he_about_window_signals[HE_ABOUT_WINDOW_NUM_SIGNALS] = {0};

struct _HeAboutWindowPrivate {
	GtkWidget* dimming;
	GtkBox* about_bin;
	GtkWindow* parent_window;
	GtkBox* about_box;
	GtkBox* content_box;
	GtkBox* button_box;
	GtkBox* info_box;
	GtkBox* title_box;
	GtkBox* text_box;
	GtkBox* developers_box;
	GtkBox* translators_box;
	GtkLabel* title_label;
	GtkLabel* license_label;
	GtkImage* icon_image;
	GtkScrolledWindow* developers_box_scroller;
	GtkScrolledWindow* translators_box_scroller;
	HeButton* translate_app_button;
	HeButton* report_button;
	HeButton* more_info_button;
	HeButton* close_button;
	HeModifierBadge* version_badge;
	gboolean _visible;
	HeColors _color;
	HeAboutWindowLicenses _license;
	gchar** translators;
	gint translators_length1;
	gint _translators_size_;
	gchar** developers;
	gint developers_length1;
	gint _developers_size_;
	gint _copyright_year;
	gchar* _translate_url;
	gchar* _issue_url;
	gchar* _more_info_url;
	gchar* _app_id;
};

struct _Block4Data {
	int _ref_count_;
	HeAboutWindow* self;
	GtkUriLauncher* uri_launcher;
};

static gint HeAboutWindow_private_offset;
static gpointer he_about_window_parent_class = NULL;

static gchar** _vala_array_dup13 (gchar** self,
                           gssize length);
static void he_about_window_update_copyright (HeAboutWindow* self,
                                       gint year,
                                       gchar** developers,
                                       gint developers_length1);
static gchar** _vala_array_dup14 (gchar** self,
                           gssize length);
static void he_about_window_find_and_overlay_on_parent (HeAboutWindow* self);
static GtkWidget* he_about_window_find_overlay_target (HeAboutWindow* self,
                                                GtkWidget* widget);
static void he_about_window_real_dispose (GObject* base);
static gboolean he_about_window_real_contains (GtkWidget* base,
                                        gdouble x,
                                        gdouble y);
static void he_about_window_real_measure (GtkWidget* base,
                                   GtkOrientation orientation,
                                   gint for_size,
                                   gint* min,
                                   gint* nat,
                                   gint* min_baseline,
                                   gint* nat_baseline);
static void he_about_window_real_size_allocate (GtkWidget* base,
                                         gint width,
                                         gint height,
                                         gint baseline);
static GObject * he_about_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _he_about_window___lambda101_ (Block4Data* _data4_);
static void __he_about_window___lambda101__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda102_ (Block4Data* _data4_);
static void __he_about_window___lambda102__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda103_ (Block4Data* _data4_);
static void __he_about_window___lambda103__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda104_ (HeAboutWindow* self);
static void __he_about_window___lambda104__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda105_ (HeAboutWindow* self);
static void __he_about_window___lambda105__gtk_gesture_end (GtkGesture* _sender,
                                                     GdkEventSequence* sequence,
                                                     gpointer self);
static void he_about_window_finalize (GObject * obj);
static GType he_about_window_get_type_once (void);
static void _vala_he_about_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_about_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_about_window_get_instance_private (HeAboutWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeAboutWindow_private_offset);
}

/**
     * An enum of commonly used licenses to be used in AboutWindow.
     */
/**
         * Returns the license url for the license.
         */
gchar*
he_about_window_licenses_get_url (HeAboutWindowLicenses self)
{
	gchar* result;
#line 101 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 210 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 103 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("https://choosealicense.com/licenses/gpl-3.0");
#line 103 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 103 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 219 "AboutWindow.c"
		}
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 223 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 105 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("https://choosealicense.com/licenses/mit");
#line 105 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 105 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 232 "AboutWindow.c"
		}
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 236 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 107 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("https://choosealicense.com/licenses/mpl-2.0");
#line 107 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 107 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 245 "AboutWindow.c"
		}
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 249 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 109 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("https://choosealicense.com/licenses/unlicense");
#line 109 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 109 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 258 "AboutWindow.c"
		}
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 262 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 111 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("https://choosealicense.com/licenses/apache-2.0");
#line 111 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 111 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 271 "AboutWindow.c"
		}
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 275 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 113 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("https://choosealicense.com/licenses/wtfpl");
#line 113 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 113 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 284 "AboutWindow.c"
		}
#line 101 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 288 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 115 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("https://choosealicense.com/no-permission");
#line 115 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 115 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 297 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 117 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("about:blank");
#line 117 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 117 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 308 "AboutWindow.c"
		}
	}
}

/**
         * Returns the license name for the license.
         */
gchar*
he_about_window_licenses_get_name (HeAboutWindowLicenses self)
{
	gchar* result;
#line 125 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 324 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 127 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("GPLv3");
#line 127 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 127 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 333 "AboutWindow.c"
		}
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 337 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 129 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("MIT");
#line 129 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 129 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 346 "AboutWindow.c"
		}
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 350 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 131 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("MPLv2");
#line 131 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 131 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 359 "AboutWindow.c"
		}
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 363 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 133 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("Unlicense");
#line 133 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 133 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 372 "AboutWindow.c"
		}
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 376 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 135 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("Apache License v2");
#line 135 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 135 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 385 "AboutWindow.c"
		}
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 389 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 137 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("WTFPL");
#line 137 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 137 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 398 "AboutWindow.c"
		}
#line 125 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 402 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 139 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("a proprietary license");
#line 139 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 139 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 411 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 141 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("N/A");
#line 141 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 141 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 422 "AboutWindow.c"
		}
	}
}

static GType
he_about_window_licenses_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_ABOUT_WINDOW_LICENSES_GPLV3, "HE_ABOUT_WINDOW_LICENSES_GPLV3", "gplv3"}, {HE_ABOUT_WINDOW_LICENSES_MIT, "HE_ABOUT_WINDOW_LICENSES_MIT", "mit"}, {HE_ABOUT_WINDOW_LICENSES_MPLV2, "HE_ABOUT_WINDOW_LICENSES_MPLV2", "mplv2"}, {HE_ABOUT_WINDOW_LICENSES_UNLICENSE, "HE_ABOUT_WINDOW_LICENSES_UNLICENSE", "unlicense"}, {HE_ABOUT_WINDOW_LICENSES_APACHEV2, "HE_ABOUT_WINDOW_LICENSES_APACHEV2", "apachev2"}, {HE_ABOUT_WINDOW_LICENSES_WTFPL, "HE_ABOUT_WINDOW_LICENSES_WTFPL", "wtfpl"}, {HE_ABOUT_WINDOW_LICENSES_PROPRIETARY, "HE_ABOUT_WINDOW_LICENSES_PROPRIETARY", "proprietary"}, {0, NULL, NULL}};
	GType he_about_window_licenses_type_id;
	he_about_window_licenses_type_id = g_enum_register_static ("HeAboutWindowLicenses", values);
	return he_about_window_licenses_type_id;
}

GType
he_about_window_licenses_get_type (void)
{
	static volatile gsize he_about_window_licenses_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_licenses_type_id__once)) {
		GType he_about_window_licenses_type_id;
		he_about_window_licenses_type_id = he_about_window_licenses_get_type_once ();
		g_once_init_leave (&he_about_window_licenses_type_id__once, he_about_window_licenses_type_id);
	}
	return he_about_window_licenses_type_id__once;
}

gboolean
he_about_window_get_visible (HeAboutWindow* self)
{
	gboolean result;
#line 66 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 66 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_visible;
#line 66 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 458 "AboutWindow.c"
}

void
he_about_window_set_visible (HeAboutWindow* self,
                             gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 67 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 68 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_about_window_get_visible (self);
#line 68 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 68 "../lib/Widgets/AboutWindow.vala"
	if (_tmp1_ == value) {
#line 69 "../lib/Widgets/AboutWindow.vala"
		return;
#line 477 "AboutWindow.c"
	}
#line 71 "../lib/Widgets/AboutWindow.vala"
	self->priv->_visible = value;
#line 73 "../lib/Widgets/AboutWindow.vala"
	if (value) {
#line 483 "AboutWindow.c"
		GtkWidget* _tmp2_;
		GtkBox* _tmp3_;
#line 74 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->dimming;
#line 74 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_child_visible (_tmp2_, TRUE);
#line 75 "../lib/Widgets/AboutWindow.vala"
		_tmp3_ = self->priv->about_bin;
#line 75 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_child_visible ((GtkWidget*) _tmp3_, TRUE);
#line 494 "AboutWindow.c"
	} else {
		GtkWidget* _tmp4_;
		GtkBox* _tmp5_;
#line 77 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = self->priv->dimming;
#line 77 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_child_visible (_tmp4_, FALSE);
#line 78 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = self->priv->about_bin;
#line 78 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_child_visible ((GtkWidget*) _tmp5_, FALSE);
#line 79 "../lib/Widgets/AboutWindow.vala"
		g_signal_emit (self, he_about_window_signals[HE_ABOUT_WINDOW_HIDDEN_SIGNAL], 0);
#line 508 "AboutWindow.c"
	}
#line 81 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_queue_allocate ((GtkWidget*) self);
#line 67 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_VISIBLE_PROPERTY]);
#line 514 "AboutWindow.c"
}

HeColors
he_about_window_get_color (HeAboutWindow* self)
{
	HeColors result;
#line 152 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 153 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_color;
#line 153 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 527 "AboutWindow.c"
}

void
he_about_window_set_color (HeAboutWindow* self,
                           HeColors value)
{
	HeButton* _tmp0_;
	HeButton* _tmp1_;
	HeButton* _tmp2_;
	HeModifierBadge* _tmp3_;
#line 155 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 156 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = value;
#line 157 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translate_app_button;
#line 157 "../lib/Widgets/AboutWindow.vala"
	he_button_set_custom_color (_tmp0_, value);
#line 158 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->report_button;
#line 158 "../lib/Widgets/AboutWindow.vala"
	he_button_set_custom_color (_tmp1_, value);
#line 159 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->more_info_button;
#line 159 "../lib/Widgets/AboutWindow.vala"
	he_button_set_custom_color (_tmp2_, value);
#line 160 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = self->priv->version_badge;
#line 160 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_color (_tmp3_, value);
#line 155 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY]);
#line 560 "AboutWindow.c"
}

HeAboutWindowLicenses
he_about_window_get_license (HeAboutWindow* self)
{
	HeAboutWindowLicenses result;
#line 170 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 170 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_license;
#line 170 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 573 "AboutWindow.c"
}

void
he_about_window_set_license (HeAboutWindow* self,
                             HeAboutWindowLicenses value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 171 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 172 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = value;
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->license_label;
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("This program is licensed under %s"), "<a href=\"%s\">%s</a>");
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = he_about_window_licenses_get_url (value);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = _tmp3_;
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = he_about_window_licenses_get_name (value);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = _tmp5_;
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = g_strdup_printf (_tmp2_, _tmp4_, _tmp6_);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = _tmp7_;
#line 173 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_markup (_tmp0_, _tmp8_);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp8_);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp6_);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp4_);
#line 173 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp2_);
#line 171 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY]);
#line 623 "AboutWindow.c"
}

const gchar*
he_about_window_get_version (HeAboutWindow* self)
{
	const gchar* result;
	HeModifierBadge* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 181 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 181 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_modifier_badge_get_label (_tmp0_);
#line 181 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 181 "../lib/Widgets/AboutWindow.vala"
	result = _tmp2_;
#line 181 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 645 "AboutWindow.c"
}

void
he_about_window_set_version (HeAboutWindow* self,
                             const gchar* value)
{
	HeModifierBadge* _tmp0_;
#line 182 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 182 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 182 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_label (_tmp0_, value);
#line 182 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY]);
#line 661 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_name (HeAboutWindow* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 189 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 189 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 189 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 189 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 680 "AboutWindow.c"
}

void
he_about_window_set_app_name (HeAboutWindow* self,
                              const gchar* value)
{
	GtkLabel* _tmp0_;
#line 190 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 190 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 190 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_text (_tmp0_, value);
#line 190 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY]);
#line 696 "AboutWindow.c"
}

const gchar*
he_about_window_get_icon (HeAboutWindow* self)
{
	const gchar* result;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
#line 197 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 197 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 197 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
#line 197 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 197 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 715 "AboutWindow.c"
}

void
he_about_window_set_icon (HeAboutWindow* self,
                          const gchar* value)
{
	GtkImage* _tmp0_;
#line 198 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 198 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 198 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_from_icon_name (_tmp0_, value);
#line 198 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY]);
#line 731 "AboutWindow.c"
}

gchar**
he_about_window_get_translator_names (HeAboutWindow* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 206 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translators;
#line 206 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->translators_length1;
#line 206 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 206 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 206 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 206 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 757 "AboutWindow.c"
	}
#line 206 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 206 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 763 "AboutWindow.c"
}

static gchar**
_vala_array_dup13 (gchar** self,
                   gssize length)
{
#line 208 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 772 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 208 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 208 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 779 "AboutWindow.c"
			gchar* _tmp0_;
#line 208 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 208 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 785 "AboutWindow.c"
		}
#line 208 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 789 "AboutWindow.c"
	}
#line 208 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 793 "AboutWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 210 "../lib/Widgets/AboutWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 801 "AboutWindow.c"
}

void
he_about_window_set_translator_names (HeAboutWindow* self,
                                      gchar** value,
                                      gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	GtkWidget* first_child = NULL;
	GtkBox* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkBox* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
#line 207 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 208 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup13 (value, value_length1) : value;
#line 208 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 208 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 208 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp0_;
#line 208 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = _tmp0__length1;
#line 208 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 210 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->translators_box;
#line 210 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = gtk_widget_get_first_child ((GtkWidget*) _tmp1_);
#line 210 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 210 "../lib/Widgets/AboutWindow.vala"
	first_child = _tmp3_;
#line 211 "../lib/Widgets/AboutWindow.vala"
	while (TRUE) {
#line 842 "AboutWindow.c"
		GtkWidget* _tmp4_;
		GtkBox* _tmp5_;
		GtkWidget* _tmp6_;
		GtkBox* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
#line 211 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = first_child;
#line 211 "../lib/Widgets/AboutWindow.vala"
		if (!(_tmp4_ != NULL)) {
#line 211 "../lib/Widgets/AboutWindow.vala"
			break;
#line 855 "AboutWindow.c"
		}
#line 212 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = self->priv->translators_box;
#line 212 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = first_child;
#line 212 "../lib/Widgets/AboutWindow.vala"
		gtk_box_remove (_tmp5_, _tmp6_);
#line 213 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = self->priv->translators_box;
#line 213 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
#line 213 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 213 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (first_child);
#line 213 "../lib/Widgets/AboutWindow.vala"
		first_child = _tmp9_;
#line 873 "AboutWindow.c"
	}
	{
		gint i = 0;
#line 216 "../lib/Widgets/AboutWindow.vala"
		i = 0;
#line 879 "AboutWindow.c"
		{
			gboolean _tmp10_ = FALSE;
#line 216 "../lib/Widgets/AboutWindow.vala"
			_tmp10_ = TRUE;
#line 216 "../lib/Widgets/AboutWindow.vala"
			while (TRUE) {
#line 886 "AboutWindow.c"
				gchar** _tmp12_;
				gint _tmp12__length1;
				GtkLabel* translator_label = NULL;
				GtkLabel* _tmp13_;
				GtkLabel* _tmp14_;
				gchar* _tmp15_ = NULL;
				gchar** _tmp16_;
				gint _tmp16__length1;
				GtkLabel* _tmp23_;
				GtkLabel* _tmp24_;
				GtkBox* _tmp25_;
				GtkLabel* _tmp26_;
				GtkBox* _tmp27_;
#line 216 "../lib/Widgets/AboutWindow.vala"
				if (!_tmp10_) {
#line 902 "AboutWindow.c"
					gint _tmp11_;
#line 216 "../lib/Widgets/AboutWindow.vala"
					_tmp11_ = i;
#line 216 "../lib/Widgets/AboutWindow.vala"
					i = _tmp11_ + 1;
#line 908 "AboutWindow.c"
				}
#line 216 "../lib/Widgets/AboutWindow.vala"
				_tmp10_ = FALSE;
#line 216 "../lib/Widgets/AboutWindow.vala"
				_tmp12_ = self->priv->translators;
#line 216 "../lib/Widgets/AboutWindow.vala"
				_tmp12__length1 = self->priv->translators_length1;
#line 216 "../lib/Widgets/AboutWindow.vala"
				if (!(i < _tmp12__length1)) {
#line 216 "../lib/Widgets/AboutWindow.vala"
					break;
#line 920 "AboutWindow.c"
				}
#line 217 "../lib/Widgets/AboutWindow.vala"
				_tmp13_ = (GtkLabel*) gtk_label_new ("");
#line 217 "../lib/Widgets/AboutWindow.vala"
				g_object_ref_sink (_tmp13_);
#line 217 "../lib/Widgets/AboutWindow.vala"
				translator_label = _tmp13_;
#line 218 "../lib/Widgets/AboutWindow.vala"
				_tmp14_ = translator_label;
#line 218 "../lib/Widgets/AboutWindow.vala"
				gtk_label_set_xalign (_tmp14_, (gfloat) 0);
#line 219 "../lib/Widgets/AboutWindow.vala"
				_tmp16_ = self->priv->translators;
#line 219 "../lib/Widgets/AboutWindow.vala"
				_tmp16__length1 = self->priv->translators_length1;
#line 219 "../lib/Widgets/AboutWindow.vala"
				if (i < (_tmp16__length1 - 1)) {
#line 938 "AboutWindow.c"
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp17_ = self->priv->translators;
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp17__length1 = self->priv->translators_length1;
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp18_ = _tmp17_[i];
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp19_ = g_strdup_printf ("%s", _tmp18_);
#line 219 "../lib/Widgets/AboutWindow.vala"
					_g_free0 (_tmp15_);
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp15_ = _tmp19_;
#line 955 "AboutWindow.c"
				} else {
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar* _tmp22_;
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp20_ = self->priv->translators;
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp20__length1 = self->priv->translators_length1;
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp21_ = _tmp20_[i];
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 219 "../lib/Widgets/AboutWindow.vala"
					_g_free0 (_tmp15_);
#line 219 "../lib/Widgets/AboutWindow.vala"
					_tmp15_ = _tmp22_;
#line 973 "AboutWindow.c"
				}
#line 219 "../lib/Widgets/AboutWindow.vala"
				_tmp23_ = translator_label;
#line 219 "../lib/Widgets/AboutWindow.vala"
				gtk_label_set_text (_tmp23_, _tmp15_);
#line 220 "../lib/Widgets/AboutWindow.vala"
				_tmp24_ = translator_label;
#line 220 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp24_, TRUE);
#line 221 "../lib/Widgets/AboutWindow.vala"
				_tmp25_ = self->priv->translators_box;
#line 221 "../lib/Widgets/AboutWindow.vala"
				_tmp26_ = translator_label;
#line 221 "../lib/Widgets/AboutWindow.vala"
				gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 222 "../lib/Widgets/AboutWindow.vala"
				_tmp27_ = self->priv->translators_box;
#line 222 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp27_, TRUE);
#line 216 "../lib/Widgets/AboutWindow.vala"
				_g_free0 (_tmp15_);
#line 216 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (translator_label);
#line 997 "AboutWindow.c"
			}
		}
	}
#line 225 "../lib/Widgets/AboutWindow.vala"
	_tmp28_ = self->priv->translators_box;
#line 225 "../lib/Widgets/AboutWindow.vala"
	_tmp29_ = gtk_widget_get_visible ((GtkWidget*) _tmp28_);
#line 225 "../lib/Widgets/AboutWindow.vala"
	_tmp30_ = _tmp29_;
#line 225 "../lib/Widgets/AboutWindow.vala"
	if (_tmp30_ == FALSE) {
#line 1009 "AboutWindow.c"
		GtkScrolledWindow* _tmp31_;
#line 226 "../lib/Widgets/AboutWindow.vala"
		_tmp31_ = self->priv->translators_box_scroller;
#line 226 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
#line 1015 "AboutWindow.c"
	} else {
		GtkScrolledWindow* _tmp32_;
#line 228 "../lib/Widgets/AboutWindow.vala"
		_tmp32_ = self->priv->translators_box_scroller;
#line 228 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp32_, TRUE);
#line 1022 "AboutWindow.c"
	}
#line 207 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (first_child);
#line 207 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY]);
#line 1028 "AboutWindow.c"
}

static void
he_about_window_update_copyright (HeAboutWindow* self,
                                  gint year,
                                  gchar** developers,
                                  gint developers_length1)
{
	GtkWidget* first_child = NULL;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkBox* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
#line 233 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 234 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers_box;
#line 234 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 234 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 234 "../lib/Widgets/AboutWindow.vala"
	first_child = _tmp2_;
#line 235 "../lib/Widgets/AboutWindow.vala"
	while (TRUE) {
#line 1056 "AboutWindow.c"
		GtkWidget* _tmp3_;
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
#line 235 "../lib/Widgets/AboutWindow.vala"
		_tmp3_ = first_child;
#line 235 "../lib/Widgets/AboutWindow.vala"
		if (!(_tmp3_ != NULL)) {
#line 235 "../lib/Widgets/AboutWindow.vala"
			break;
#line 1069 "AboutWindow.c"
		}
#line 236 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = self->priv->developers_box;
#line 236 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = first_child;
#line 236 "../lib/Widgets/AboutWindow.vala"
		gtk_box_remove (_tmp4_, _tmp5_);
#line 237 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = self->priv->developers_box;
#line 237 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = gtk_widget_get_first_child ((GtkWidget*) _tmp6_);
#line 237 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 237 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (first_child);
#line 237 "../lib/Widgets/AboutWindow.vala"
		first_child = _tmp8_;
#line 1087 "AboutWindow.c"
	}
	{
		gint i = 0;
#line 240 "../lib/Widgets/AboutWindow.vala"
		i = 0;
#line 1093 "AboutWindow.c"
		{
			gboolean _tmp9_ = FALSE;
#line 240 "../lib/Widgets/AboutWindow.vala"
			_tmp9_ = TRUE;
#line 240 "../lib/Widgets/AboutWindow.vala"
			while (TRUE) {
#line 1100 "AboutWindow.c"
				GtkLabel* developer_label = NULL;
				GtkLabel* _tmp11_;
				GtkLabel* _tmp12_;
				GtkLabel* _tmp21_;
				GtkBox* _tmp22_;
				GtkLabel* _tmp23_;
				GtkBox* _tmp24_;
#line 240 "../lib/Widgets/AboutWindow.vala"
				if (!_tmp9_) {
#line 1110 "AboutWindow.c"
					gint _tmp10_;
#line 240 "../lib/Widgets/AboutWindow.vala"
					_tmp10_ = i;
#line 240 "../lib/Widgets/AboutWindow.vala"
					i = _tmp10_ + 1;
#line 1116 "AboutWindow.c"
				}
#line 240 "../lib/Widgets/AboutWindow.vala"
				_tmp9_ = FALSE;
#line 240 "../lib/Widgets/AboutWindow.vala"
				if (!(i < developers_length1)) {
#line 240 "../lib/Widgets/AboutWindow.vala"
					break;
#line 1124 "AboutWindow.c"
				}
#line 241 "../lib/Widgets/AboutWindow.vala"
				_tmp11_ = (GtkLabel*) gtk_label_new ("");
#line 241 "../lib/Widgets/AboutWindow.vala"
				g_object_ref_sink (_tmp11_);
#line 241 "../lib/Widgets/AboutWindow.vala"
				developer_label = _tmp11_;
#line 242 "../lib/Widgets/AboutWindow.vala"
				_tmp12_ = developer_label;
#line 242 "../lib/Widgets/AboutWindow.vala"
				gtk_label_set_xalign (_tmp12_, (gfloat) 0);
#line 243 "../lib/Widgets/AboutWindow.vala"
				if (i == 0) {
#line 1138 "AboutWindow.c"
					gchar* _tmp13_ = NULL;
					GtkLabel* _tmp18_;
#line 244 "../lib/Widgets/AboutWindow.vala"
					if (year > 0) {
#line 1143 "AboutWindow.c"
						const gchar* _tmp14_;
						gchar* _tmp15_;
#line 245 "../lib/Widgets/AboutWindow.vala"
						_tmp14_ = developers[i];
#line 245 "../lib/Widgets/AboutWindow.vala"
						_tmp15_ = g_strdup_printf (_ ("Copyright © %i %s"), year, _tmp14_);
#line 245 "../lib/Widgets/AboutWindow.vala"
						_g_free0 (_tmp13_);
#line 245 "../lib/Widgets/AboutWindow.vala"
						_tmp13_ = _tmp15_;
#line 1154 "AboutWindow.c"
					} else {
						const gchar* _tmp16_;
						gchar* _tmp17_;
#line 246 "../lib/Widgets/AboutWindow.vala"
						_tmp16_ = developers[i];
#line 246 "../lib/Widgets/AboutWindow.vala"
						_tmp17_ = g_strdup_printf (_ ("Copyright © %s"), _tmp16_);
#line 246 "../lib/Widgets/AboutWindow.vala"
						_g_free0 (_tmp13_);
#line 246 "../lib/Widgets/AboutWindow.vala"
						_tmp13_ = _tmp17_;
#line 1166 "AboutWindow.c"
					}
#line 244 "../lib/Widgets/AboutWindow.vala"
					_tmp18_ = developer_label;
#line 244 "../lib/Widgets/AboutWindow.vala"
					gtk_label_set_text (_tmp18_, _tmp13_);
#line 243 "../lib/Widgets/AboutWindow.vala"
					_g_free0 (_tmp13_);
#line 1174 "AboutWindow.c"
				} else {
					GtkLabel* _tmp19_;
					const gchar* _tmp20_;
#line 248 "../lib/Widgets/AboutWindow.vala"
					_tmp19_ = developer_label;
#line 248 "../lib/Widgets/AboutWindow.vala"
					_tmp20_ = developers[i];
#line 248 "../lib/Widgets/AboutWindow.vala"
					gtk_label_set_text (_tmp19_, _tmp20_);
#line 1184 "AboutWindow.c"
				}
#line 250 "../lib/Widgets/AboutWindow.vala"
				_tmp21_ = developer_label;
#line 250 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
#line 251 "../lib/Widgets/AboutWindow.vala"
				_tmp22_ = self->priv->developers_box;
#line 251 "../lib/Widgets/AboutWindow.vala"
				_tmp23_ = developer_label;
#line 251 "../lib/Widgets/AboutWindow.vala"
				gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 252 "../lib/Widgets/AboutWindow.vala"
				_tmp24_ = self->priv->developers_box;
#line 252 "../lib/Widgets/AboutWindow.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp24_, TRUE);
#line 240 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (developer_label);
#line 1202 "AboutWindow.c"
			}
		}
	}
#line 255 "../lib/Widgets/AboutWindow.vala"
	_tmp25_ = self->priv->developers_box;
#line 255 "../lib/Widgets/AboutWindow.vala"
	_tmp26_ = gtk_widget_get_visible ((GtkWidget*) _tmp25_);
#line 255 "../lib/Widgets/AboutWindow.vala"
	_tmp27_ = _tmp26_;
#line 255 "../lib/Widgets/AboutWindow.vala"
	if (_tmp27_ == FALSE) {
#line 1214 "AboutWindow.c"
		GtkScrolledWindow* _tmp28_;
#line 256 "../lib/Widgets/AboutWindow.vala"
		_tmp28_ = self->priv->developers_box_scroller;
#line 256 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
#line 1220 "AboutWindow.c"
	} else {
		GtkScrolledWindow* _tmp29_;
#line 258 "../lib/Widgets/AboutWindow.vala"
		_tmp29_ = self->priv->developers_box_scroller;
#line 258 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp29_, TRUE);
#line 1227 "AboutWindow.c"
	}
#line 233 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (first_child);
#line 1231 "AboutWindow.c"
}

gchar**
he_about_window_get_developer_names (HeAboutWindow* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 267 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 267 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 267 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 267 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 267 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 267 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 1257 "AboutWindow.c"
	}
#line 267 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 267 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1263 "AboutWindow.c"
}

static gchar**
_vala_array_dup14 (gchar** self,
                   gssize length)
{
#line 269 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 1272 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 269 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 269 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 1279 "AboutWindow.c"
			gchar* _tmp0_;
#line 269 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 269 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 1285 "AboutWindow.c"
		}
#line 269 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 1289 "AboutWindow.c"
	}
#line 269 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 1293 "AboutWindow.c"
}

void
he_about_window_set_developer_names (HeAboutWindow* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
#line 268 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 269 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup14 (value, value_length1) : value;
#line 269 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 269 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 269 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp0_;
#line 269 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = _tmp0__length1;
#line 269 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 270 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_copyright_year (self);
#line 270 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 270 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, _tmp2_, value, (gint) value_length1);
#line 268 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY]);
#line 1327 "AboutWindow.c"
}

gint
he_about_window_get_copyright_year (HeAboutWindow* self)
{
	gint result;
#line 279 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 279 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_copyright_year;
#line 279 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1340 "AboutWindow.c"
}

void
he_about_window_set_copyright_year (HeAboutWindow* self,
                                    gint value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 280 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 281 "../lib/Widgets/AboutWindow.vala"
	self->priv->_copyright_year = value;
#line 282 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 282 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 282 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, value, _tmp0_, (gint) _tmp0__length1);
#line 280 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY]);
#line 1361 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_id (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 293 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_app_id;
#line 293 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 293 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1377 "AboutWindow.c"
}

void
he_about_window_set_app_id (HeAboutWindow* self,
                            const gchar* value)
{
	gchar* old_value;
#line 293 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 293 "../lib/Widgets/AboutWindow.vala"
	old_value = he_about_window_get_app_id (self);
#line 293 "../lib/Widgets/AboutWindow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1391 "AboutWindow.c"
		gchar* _tmp0_;
#line 293 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = g_strdup (value);
#line 293 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (self->priv->_app_id);
#line 293 "../lib/Widgets/AboutWindow.vala"
		self->priv->_app_id = _tmp0_;
#line 293 "../lib/Widgets/AboutWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY]);
#line 1401 "AboutWindow.c"
	}
}

const gchar*
he_about_window_get_translate_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 298 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 298 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_translate_url;
#line 298 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 298 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1418 "AboutWindow.c"
}

void
he_about_window_set_translate_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 299 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 300 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 300 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 300 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translate_url = _tmp0_;
#line 301 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1436 "AboutWindow.c"
		HeButton* _tmp1_;
#line 302 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->translate_app_button;
#line 302 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1442 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 304 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->translate_app_button;
#line 304 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1449 "AboutWindow.c"
	}
#line 299 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY]);
#line 1453 "AboutWindow.c"
}

const gchar*
he_about_window_get_issue_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 312 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 312 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_issue_url;
#line 312 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 312 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1469 "AboutWindow.c"
}

void
he_about_window_set_issue_url (HeAboutWindow* self,
                               const gchar* value)
{
	gchar* _tmp0_;
#line 313 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 314 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 314 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 314 "../lib/Widgets/AboutWindow.vala"
	self->priv->_issue_url = _tmp0_;
#line 315 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1487 "AboutWindow.c"
		HeButton* _tmp1_;
#line 316 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->report_button;
#line 316 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1493 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 318 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->report_button;
#line 318 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1500 "AboutWindow.c"
	}
#line 313 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY]);
#line 1504 "AboutWindow.c"
}

const gchar*
he_about_window_get_more_info_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 326 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_more_info_url;
#line 326 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 326 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1520 "AboutWindow.c"
}

void
he_about_window_set_more_info_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 327 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 328 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 328 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 328 "../lib/Widgets/AboutWindow.vala"
	self->priv->_more_info_url = _tmp0_;
#line 329 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1538 "AboutWindow.c"
		HeButton* _tmp1_;
#line 330 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->more_info_button;
#line 330 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1544 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 332 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->more_info_button;
#line 332 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1551 "AboutWindow.c"
	}
#line 327 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY]);
#line 1555 "AboutWindow.c"
}

/**
     * Shows the about window by overlaying it on the parent window.
     */
void
he_about_window_present (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
#line 340 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 341 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->parent_window;
#line 341 "../lib/Widgets/AboutWindow.vala"
	if (_tmp0_ != NULL) {
#line 343 "../lib/Widgets/AboutWindow.vala"
		he_about_window_find_and_overlay_on_parent (self);
#line 1573 "AboutWindow.c"
	}
#line 345 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_visible (self, TRUE);
#line 1577 "AboutWindow.c"
}

/**
     * Hides the about window.
     */
void
he_about_window_hide_about (HeAboutWindow* self)
{
	GtkWidget* _tmp0_;
#line 351 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 352 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_visible (self, FALSE);
#line 354 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 354 "../lib/Widgets/AboutWindow.vala"
	if (_tmp0_ != NULL) {
#line 1595 "AboutWindow.c"
		GtkWidget* _tmp1_;
#line 355 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 355 "../lib/Widgets/AboutWindow.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_overlay_get_type ())) {
#line 1601 "AboutWindow.c"
			GtkWidget* _tmp2_;
#line 356 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 356 "../lib/Widgets/AboutWindow.vala"
			gtk_overlay_remove_overlay (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_overlay_get_type (), GtkOverlay), (GtkWidget*) self);
#line 1607 "AboutWindow.c"
		} else {
#line 358 "../lib/Widgets/AboutWindow.vala"
			gtk_widget_unparent ((GtkWidget*) self);
#line 1611 "AboutWindow.c"
		}
	}
}

static void
he_about_window_find_and_overlay_on_parent (HeAboutWindow* self)
{
	GtkWidget* content = NULL;
	GtkWindow* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* overlay_target = NULL;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkWidget* _tmp7_;
#line 363 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 364 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->parent_window;
#line 364 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_window_get_child (_tmp0_);
#line 364 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 364 "../lib/Widgets/AboutWindow.vala"
	content = _tmp2_;
#line 365 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = content;
#line 365 "../lib/Widgets/AboutWindow.vala"
	if (_tmp3_ == NULL) {
#line 366 "../lib/Widgets/AboutWindow.vala"
		g_warning ("AboutWindow.vala:366: AboutWindow: Parent window has no content widget");
#line 367 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (content);
#line 367 "../lib/Widgets/AboutWindow.vala"
		return;
#line 1649 "AboutWindow.c"
	}
#line 371 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = content;
#line 371 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = he_about_window_find_overlay_target (self, _tmp4_);
#line 371 "../lib/Widgets/AboutWindow.vala"
	overlay_target = _tmp5_;
#line 373 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = overlay_target;
#line 373 "../lib/Widgets/AboutWindow.vala"
	if (_tmp7_ != NULL) {
#line 1661 "AboutWindow.c"
		GtkWidget* _tmp8_;
#line 373 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = overlay_target;
#line 373 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_overlay_get_type ());
#line 1667 "AboutWindow.c"
	} else {
#line 373 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = FALSE;
#line 1671 "AboutWindow.c"
	}
#line 373 "../lib/Widgets/AboutWindow.vala"
	if (_tmp6_) {
#line 1675 "AboutWindow.c"
		GtkWidget* _tmp9_;
#line 374 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = overlay_target;
#line 374 "../lib/Widgets/AboutWindow.vala"
		gtk_overlay_add_overlay (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_overlay_get_type (), GtkOverlay), (GtkWidget*) self);
#line 1681 "AboutWindow.c"
	} else {
#line 376 "../lib/Widgets/AboutWindow.vala"
		g_warning ("AboutWindow.vala:376: AboutWindow: No Gtk.Overlay found in parent wind" \
"ow. Modal dialogs require a Gtk.Overlay container.");
#line 378 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_visible (self, FALSE);
#line 1687 "AboutWindow.c"
	}
#line 363 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (overlay_target);
#line 363 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (content);
#line 1693 "AboutWindow.c"
}

static GtkWidget*
he_about_window_find_overlay_target (HeAboutWindow* self,
                                     GtkWidget* widget)
{
	GtkWidget* result;
#line 382 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 382 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 384 "../lib/Widgets/AboutWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_overlay_get_type ())) {
#line 1707 "AboutWindow.c"
		GtkWidget* _tmp0_;
#line 385 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = _g_object_ref0 (widget);
#line 385 "../lib/Widgets/AboutWindow.vala"
		result = _tmp0_;
#line 385 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 1715 "AboutWindow.c"
	}
#line 389 "../lib/Widgets/AboutWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_box_get_type ())) {
#line 1719 "AboutWindow.c"
		GtkWidget* child = NULL;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 390 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_box_get_type (), GtkBox));
#line 390 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 390 "../lib/Widgets/AboutWindow.vala"
		child = _tmp2_;
#line 391 "../lib/Widgets/AboutWindow.vala"
		while (TRUE) {
#line 1731 "AboutWindow.c"
			GtkWidget* _tmp3_;
			GtkWidget* _result_ = NULL;
			GtkWidget* _tmp4_;
			GtkWidget* _tmp5_;
			GtkWidget* _tmp6_;
			GtkWidget* _tmp7_;
			GtkWidget* _tmp8_;
			GtkWidget* _tmp9_;
#line 391 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = child;
#line 391 "../lib/Widgets/AboutWindow.vala"
			if (!(_tmp3_ != NULL)) {
#line 391 "../lib/Widgets/AboutWindow.vala"
				break;
#line 1746 "AboutWindow.c"
			}
#line 392 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = child;
#line 392 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = he_about_window_find_overlay_target (self, _tmp4_);
#line 392 "../lib/Widgets/AboutWindow.vala"
			_result_ = _tmp5_;
#line 393 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = _result_;
#line 393 "../lib/Widgets/AboutWindow.vala"
			if (_tmp6_ != NULL) {
#line 393 "../lib/Widgets/AboutWindow.vala"
				result = _result_;
#line 393 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (child);
#line 393 "../lib/Widgets/AboutWindow.vala"
				return result;
#line 1764 "AboutWindow.c"
			}
#line 394 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = child;
#line 394 "../lib/Widgets/AboutWindow.vala"
			_tmp8_ = gtk_widget_get_next_sibling (_tmp7_);
#line 394 "../lib/Widgets/AboutWindow.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 394 "../lib/Widgets/AboutWindow.vala"
			_g_object_unref0 (child);
#line 394 "../lib/Widgets/AboutWindow.vala"
			child = _tmp9_;
#line 391 "../lib/Widgets/AboutWindow.vala"
			_g_object_unref0 (_result_);
#line 1778 "AboutWindow.c"
		}
#line 389 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (child);
#line 1782 "AboutWindow.c"
	} else {
#line 396 "../lib/Widgets/AboutWindow.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_grid_get_type ())) {
#line 1786 "AboutWindow.c"
			GtkWidget* child = NULL;
			GtkWidget* _tmp10_;
			GtkWidget* _tmp11_;
#line 397 "../lib/Widgets/AboutWindow.vala"
			_tmp10_ = gtk_widget_get_first_child ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_grid_get_type (), GtkGrid));
#line 397 "../lib/Widgets/AboutWindow.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 397 "../lib/Widgets/AboutWindow.vala"
			child = _tmp11_;
#line 398 "../lib/Widgets/AboutWindow.vala"
			while (TRUE) {
#line 1798 "AboutWindow.c"
				GtkWidget* _tmp12_;
				GtkWidget* _result_ = NULL;
				GtkWidget* _tmp13_;
				GtkWidget* _tmp14_;
				GtkWidget* _tmp15_;
				GtkWidget* _tmp16_;
				GtkWidget* _tmp17_;
				GtkWidget* _tmp18_;
#line 398 "../lib/Widgets/AboutWindow.vala"
				_tmp12_ = child;
#line 398 "../lib/Widgets/AboutWindow.vala"
				if (!(_tmp12_ != NULL)) {
#line 398 "../lib/Widgets/AboutWindow.vala"
					break;
#line 1813 "AboutWindow.c"
				}
#line 399 "../lib/Widgets/AboutWindow.vala"
				_tmp13_ = child;
#line 399 "../lib/Widgets/AboutWindow.vala"
				_tmp14_ = he_about_window_find_overlay_target (self, _tmp13_);
#line 399 "../lib/Widgets/AboutWindow.vala"
				_result_ = _tmp14_;
#line 400 "../lib/Widgets/AboutWindow.vala"
				_tmp15_ = _result_;
#line 400 "../lib/Widgets/AboutWindow.vala"
				if (_tmp15_ != NULL) {
#line 400 "../lib/Widgets/AboutWindow.vala"
					result = _result_;
#line 400 "../lib/Widgets/AboutWindow.vala"
					_g_object_unref0 (child);
#line 400 "../lib/Widgets/AboutWindow.vala"
					return result;
#line 1831 "AboutWindow.c"
				}
#line 401 "../lib/Widgets/AboutWindow.vala"
				_tmp16_ = child;
#line 401 "../lib/Widgets/AboutWindow.vala"
				_tmp17_ = gtk_widget_get_next_sibling (_tmp16_);
#line 401 "../lib/Widgets/AboutWindow.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 401 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (child);
#line 401 "../lib/Widgets/AboutWindow.vala"
				child = _tmp18_;
#line 398 "../lib/Widgets/AboutWindow.vala"
				_g_object_unref0 (_result_);
#line 1845 "AboutWindow.c"
			}
#line 396 "../lib/Widgets/AboutWindow.vala"
			_g_object_unref0 (child);
#line 1849 "AboutWindow.c"
		}
	}
#line 405 "../lib/Widgets/AboutWindow.vala"
	result = NULL;
#line 405 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1856 "AboutWindow.c"
}

static void
he_about_window_real_dispose (GObject* base)
{
	HeAboutWindow * self;
	GtkWidget* _tmp0_;
	GtkBox* _tmp2_;
#line 510 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) base;
#line 511 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->dimming;
#line 511 "../lib/Widgets/AboutWindow.vala"
	if (_tmp0_ != NULL) {
#line 1871 "AboutWindow.c"
		GtkWidget* _tmp1_;
#line 512 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->dimming;
#line 512 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_unparent (_tmp1_);
#line 513 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (self->priv->dimming);
#line 513 "../lib/Widgets/AboutWindow.vala"
		self->priv->dimming = NULL;
#line 1881 "AboutWindow.c"
	}
#line 516 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->about_bin;
#line 516 "../lib/Widgets/AboutWindow.vala"
	if (_tmp2_ != NULL) {
#line 1887 "AboutWindow.c"
		GtkBox* _tmp3_;
#line 517 "../lib/Widgets/AboutWindow.vala"
		_tmp3_ = self->priv->about_bin;
#line 517 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 518 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (self->priv->about_bin);
#line 518 "../lib/Widgets/AboutWindow.vala"
		self->priv->about_bin = NULL;
#line 1897 "AboutWindow.c"
	}
#line 521 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (he_about_window_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1901 "AboutWindow.c"
}

static gboolean
he_about_window_real_contains (GtkWidget* base,
                               gdouble x,
                               gdouble y)
{
	HeAboutWindow * self;
	gboolean result;
#line 524 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) base;
#line 525 "../lib/Widgets/AboutWindow.vala"
	result = FALSE;
#line 525 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1917 "AboutWindow.c"
}

static void
he_about_window_real_measure (GtkWidget* base,
                              GtkOrientation orientation,
                              gint for_size,
                              gint* min,
                              gint* nat,
                              gint* min_baseline,
                              gint* nat_baseline)
{
	HeAboutWindow * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gint _vala_min_baseline = 0;
	gint _vala_nat_baseline = 0;
	gint about_min = 0;
	gint about_nat = 0;
	gint dimming_min = 0;
	gint dimming_nat = 0;
	GtkBox* _tmp0_;
#line 528 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) base;
#line 536 "../lib/Widgets/AboutWindow.vala"
	_vala_nat = 0;
#line 536 "../lib/Widgets/AboutWindow.vala"
	_vala_min = _vala_nat;
#line 538 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->about_bin;
#line 538 "../lib/Widgets/AboutWindow.vala"
	if (gtk_widget_get_child_visible ((GtkWidget*) _tmp0_)) {
#line 1949 "AboutWindow.c"
		GtkBox* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GtkWidget* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 539 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->about_bin;
#line 539 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_measure ((GtkWidget*) _tmp1_, orientation, for_size, &_tmp2_, &_tmp3_, NULL, NULL);
#line 539 "../lib/Widgets/AboutWindow.vala"
		about_min = _tmp2_;
#line 539 "../lib/Widgets/AboutWindow.vala"
		about_nat = _tmp3_;
#line 540 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = self->priv->dimming;
#line 540 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_measure (_tmp4_, orientation, for_size, &_tmp5_, &_tmp6_, NULL, NULL);
#line 540 "../lib/Widgets/AboutWindow.vala"
		dimming_min = _tmp5_;
#line 540 "../lib/Widgets/AboutWindow.vala"
		dimming_nat = _tmp6_;
#line 542 "../lib/Widgets/AboutWindow.vala"
		if (orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 543 "../lib/Widgets/AboutWindow.vala"
			_vala_min = MAX (dimming_min, about_min);
#line 544 "../lib/Widgets/AboutWindow.vala"
			_vala_nat = MAX (dimming_nat, about_nat);
#line 1978 "AboutWindow.c"
		} else {
#line 546 "../lib/Widgets/AboutWindow.vala"
			_vala_min = MAX (dimming_min, about_min + HE_ABOUT_WINDOW_TOP_MARGIN);
#line 547 "../lib/Widgets/AboutWindow.vala"
			_vala_nat = MAX (dimming_nat, about_nat + HE_ABOUT_WINDOW_TOP_MARGIN);
#line 1984 "AboutWindow.c"
		}
	}
#line 550 "../lib/Widgets/AboutWindow.vala"
	_vala_nat_baseline = -1;
#line 550 "../lib/Widgets/AboutWindow.vala"
	_vala_min_baseline = _vala_nat_baseline;
#line 528 "../lib/Widgets/AboutWindow.vala"
	if (min) {
#line 528 "../lib/Widgets/AboutWindow.vala"
		*min = _vala_min;
#line 1995 "AboutWindow.c"
	}
#line 528 "../lib/Widgets/AboutWindow.vala"
	if (nat) {
#line 528 "../lib/Widgets/AboutWindow.vala"
		*nat = _vala_nat;
#line 2001 "AboutWindow.c"
	}
#line 528 "../lib/Widgets/AboutWindow.vala"
	if (min_baseline) {
#line 528 "../lib/Widgets/AboutWindow.vala"
		*min_baseline = _vala_min_baseline;
#line 2007 "AboutWindow.c"
	}
#line 528 "../lib/Widgets/AboutWindow.vala"
	if (nat_baseline) {
#line 528 "../lib/Widgets/AboutWindow.vala"
		*nat_baseline = _vala_nat_baseline;
#line 2013 "AboutWindow.c"
	}
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 567 "../lib/Widgets/AboutWindow.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 2022 "AboutWindow.c"
}

static void
he_about_window_real_size_allocate (GtkWidget* base,
                                    gint width,
                                    gint height,
                                    gint baseline)
{
	HeAboutWindow * self;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	gint about_width = 0;
	gint about_height = 0;
	GtkBox* _tmp2_;
	gint _tmp3_ = 0;
	GtkBox* _tmp4_;
	gint _tmp5_ = 0;
	GskTransform* t = NULL;
	GskTransform* _tmp6_;
#line 553 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) base;
#line 554 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->about_bin;
#line 554 "../lib/Widgets/AboutWindow.vala"
	if (!gtk_widget_get_child_visible ((GtkWidget*) _tmp0_)) {
#line 555 "../lib/Widgets/AboutWindow.vala"
		return;
#line 2050 "AboutWindow.c"
	}
#line 557 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->dimming;
#line 557 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_allocate (_tmp1_, width, height, baseline, NULL);
#line 560 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->about_bin;
#line 560 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_measure ((GtkWidget*) _tmp2_, GTK_ORIENTATION_HORIZONTAL, -1, &_tmp3_, NULL, NULL, NULL);
#line 560 "../lib/Widgets/AboutWindow.vala"
	about_width = _tmp3_;
#line 561 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = self->priv->about_bin;
#line 561 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_measure ((GtkWidget*) _tmp4_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp5_, NULL, NULL);
#line 561 "../lib/Widgets/AboutWindow.vala"
	about_height = _tmp5_;
#line 563 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = gsk_transform_new ();
#line 563 "../lib/Widgets/AboutWindow.vala"
	t = _tmp6_;
#line 565 "../lib/Widgets/AboutWindow.vala"
	if (width <= 600) {
#line 2074 "AboutWindow.c"
		GskTransform* _tmp7_;
		graphene_point_t _tmp8_ = {0};
		GskTransform* _tmp9_;
		GtkBox* _tmp10_;
		GskTransform* _tmp11_;
		GskTransform* _tmp12_;
		GtkBox* _tmp13_;
		GtkBox* _tmp14_;
		HeButton* _tmp15_;
		GtkImage* _tmp16_;
		GtkBox* _tmp17_;
		GtkBox* _tmp18_;
#line 566 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = t;
#line 566 "../lib/Widgets/AboutWindow.vala"
		t = NULL;
#line 566 "../lib/Widgets/AboutWindow.vala"
		_tmp8_.x = (gfloat) 0;
#line 566 "../lib/Widgets/AboutWindow.vala"
		_tmp8_.y = (gfloat) (height - about_height);
#line 566 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = gsk_transform_translate (_tmp7_, &_tmp8_);
#line 566 "../lib/Widgets/AboutWindow.vala"
		_gsk_transform_unref0 (t);
#line 566 "../lib/Widgets/AboutWindow.vala"
		t = _tmp9_;
#line 567 "../lib/Widgets/AboutWindow.vala"
		_tmp10_ = self->priv->about_bin;
#line 567 "../lib/Widgets/AboutWindow.vala"
		_tmp11_ = t;
#line 567 "../lib/Widgets/AboutWindow.vala"
		_tmp12_ = _gsk_transform_ref0 (_tmp11_);
#line 567 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp10_, width, about_height, baseline, _tmp12_);
#line 568 "../lib/Widgets/AboutWindow.vala"
		_tmp13_ = self->priv->about_bin;
#line 568 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp13_, "bottom-sheet");
#line 569 "../lib/Widgets/AboutWindow.vala"
		_tmp14_ = self->priv->about_bin;
#line 569 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp14_, "dialog-sheet");
#line 570 "../lib/Widgets/AboutWindow.vala"
		_tmp15_ = self->priv->close_button;
#line 570 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp15_, 24);
#line 571 "../lib/Widgets/AboutWindow.vala"
		_tmp16_ = self->priv->icon_image;
#line 571 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp16_, 24);
#line 572 "../lib/Widgets/AboutWindow.vala"
		_tmp17_ = self->priv->button_box;
#line 572 "../lib/Widgets/AboutWindow.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp17_, GTK_ORIENTATION_VERTICAL);
#line 573 "../lib/Widgets/AboutWindow.vala"
		_tmp18_ = self->priv->content_box;
#line 573 "../lib/Widgets/AboutWindow.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_VERTICAL);
#line 2133 "AboutWindow.c"
	} else {
		gint effective_margin_h = 0;
		gint effective_margin_v = 0;
		gint available_width = 0;
		gint available_height = 0;
		gint available_space_h = 0;
		gint x_pos = 0;
		gint y_pos = 0;
		GskTransform* _tmp19_;
		graphene_point_t _tmp20_ = {0};
		GskTransform* _tmp21_;
		GtkBox* _tmp22_;
		GskTransform* _tmp23_;
		GskTransform* _tmp24_;
		GtkBox* _tmp25_;
		GtkBox* _tmp26_;
		HeButton* _tmp27_;
		GtkImage* _tmp28_;
		GtkBox* _tmp29_;
		GtkBox* _tmp30_;
#line 576 "../lib/Widgets/AboutWindow.vala"
		effective_margin_h = MAX (HE_ABOUT_WINDOW_MIN_EDGE_MARGIN, HE_ABOUT_WINDOW_DESKTOP_EDGE_MARGIN);
#line 577 "../lib/Widgets/AboutWindow.vala"
		effective_margin_v = MAX (HE_ABOUT_WINDOW_MIN_EDGE_MARGIN, HE_ABOUT_WINDOW_DESKTOP_EDGE_MARGIN);
#line 580 "../lib/Widgets/AboutWindow.vala"
		available_width = width - (2 * effective_margin_h);
#line 581 "../lib/Widgets/AboutWindow.vala"
		if (about_width > available_width) {
#line 582 "../lib/Widgets/AboutWindow.vala"
			effective_margin_h = MAX (HE_ABOUT_WINDOW_MIN_EDGE_MARGIN, (width - about_width) / 2);
#line 2164 "AboutWindow.c"
		}
#line 586 "../lib/Widgets/AboutWindow.vala"
		available_height = height - (2 * effective_margin_v);
#line 587 "../lib/Widgets/AboutWindow.vala"
		if (about_height > available_height) {
#line 588 "../lib/Widgets/AboutWindow.vala"
			effective_margin_v = MAX (HE_ABOUT_WINDOW_MIN_EDGE_MARGIN, (height - about_height) / 2);
#line 589 "../lib/Widgets/AboutWindow.vala"
			about_height = height - (2 * effective_margin_v);
#line 2174 "AboutWindow.c"
		}
#line 593 "../lib/Widgets/AboutWindow.vala"
		available_space_h = (width - (2 * effective_margin_h)) - about_width;
#line 595 "../lib/Widgets/AboutWindow.vala"
		if (gtk_widget_get_direction ((GtkWidget*) self) == GTK_TEXT_DIR_RTL) {
#line 597 "../lib/Widgets/AboutWindow.vala"
			x_pos = effective_margin_h + (available_space_h / 4);
#line 2182 "AboutWindow.c"
		} else {
#line 600 "../lib/Widgets/AboutWindow.vala"
			x_pos = effective_margin_h + ((available_space_h * 3) / 4);
#line 2186 "AboutWindow.c"
		}
#line 604 "../lib/Widgets/AboutWindow.vala"
		y_pos = (height - about_height) / 2;
#line 606 "../lib/Widgets/AboutWindow.vala"
		_tmp19_ = t;
#line 606 "../lib/Widgets/AboutWindow.vala"
		t = NULL;
#line 606 "../lib/Widgets/AboutWindow.vala"
		_tmp20_.x = (gfloat) x_pos;
#line 606 "../lib/Widgets/AboutWindow.vala"
		_tmp20_.y = (gfloat) y_pos;
#line 606 "../lib/Widgets/AboutWindow.vala"
		_tmp21_ = gsk_transform_translate (_tmp19_, &_tmp20_);
#line 606 "../lib/Widgets/AboutWindow.vala"
		_gsk_transform_unref0 (t);
#line 606 "../lib/Widgets/AboutWindow.vala"
		t = _tmp21_;
#line 607 "../lib/Widgets/AboutWindow.vala"
		_tmp22_ = self->priv->about_bin;
#line 607 "../lib/Widgets/AboutWindow.vala"
		_tmp23_ = t;
#line 607 "../lib/Widgets/AboutWindow.vala"
		_tmp24_ = _gsk_transform_ref0 (_tmp23_);
#line 607 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp22_, about_width, about_height, baseline, _tmp24_);
#line 608 "../lib/Widgets/AboutWindow.vala"
		_tmp25_ = self->priv->about_bin;
#line 608 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp25_, "dialog-sheet");
#line 609 "../lib/Widgets/AboutWindow.vala"
		_tmp26_ = self->priv->about_bin;
#line 609 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp26_, "bottom-sheet");
#line 610 "../lib/Widgets/AboutWindow.vala"
		_tmp27_ = self->priv->close_button;
#line 610 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp27_, 0);
#line 611 "../lib/Widgets/AboutWindow.vala"
		_tmp28_ = self->priv->icon_image;
#line 611 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp28_, 0);
#line 612 "../lib/Widgets/AboutWindow.vala"
		_tmp29_ = self->priv->button_box;
#line 612 "../lib/Widgets/AboutWindow.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp29_, GTK_ORIENTATION_HORIZONTAL);
#line 613 "../lib/Widgets/AboutWindow.vala"
		_tmp30_ = self->priv->content_box;
#line 613 "../lib/Widgets/AboutWindow.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp30_, GTK_ORIENTATION_HORIZONTAL);
#line 2236 "AboutWindow.c"
	}
#line 553 "../lib/Widgets/AboutWindow.vala"
	_gsk_transform_unref0 (t);
#line 2240 "AboutWindow.c"
}

/**
     * Creates a new AboutWindow.
     * @param parent The parent window. The window must contain
     *               a Gtk.Overlay somewhere in its widget hierarchy for modal
     *               overlay behavior to work correctly.
     * @param app_name Your application's name.
     * @param app_id Your application's reverse-domain name.
     * @param version Your application's version.
     * @param icon Your application's icon.
     * @param translate_url A URL where contributors can help translate the application.
     * @param issue_url A URL where users can report a problem with the application.
     * @param more_info_url A URL where users can get more information about the application.
     * @param translators Your application's translators.
     * @param developers Your application's developers.
     * @param copyright_year Your application's copyright year.
     * @param license Your application's license.
     * @param color The color of the AboutWindow.
     *
     * @since 1.0
     */
HeAboutWindow*
he_about_window_construct (GType object_type,
                           GtkWindow* parent,
                           const gchar* app_name,
                           const gchar* app_id,
                           const gchar* version,
                           const gchar* icon,
                           const gchar* translate_url,
                           const gchar* issue_url,
                           const gchar* more_info_url,
                           gchar** translators,
                           gint translators_length1,
                           gchar** developers,
                           gint developers_length1,
                           gint copyright_year,
                           HeAboutWindowLicenses license,
                           HeColors color)
{
	HeAboutWindow * self = NULL;
	GtkWindow* _tmp0_;
	gint _tmp1_ = 0;
#line 637 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 637 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 637 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_id != NULL, NULL);
#line 637 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) g_object_new (object_type, NULL);
#line 650 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 650 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 650 "../lib/Widgets/AboutWindow.vala"
	self->priv->parent_window = _tmp0_;
#line 651 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_name (self, app_name);
#line 652 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_id (self, app_id);
#line 653 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_version (self, version);
#line 654 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_icon (self, icon);
#line 655 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translate_url (self, translate_url);
#line 656 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_issue_url (self, issue_url);
#line 657 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_more_info_url (self, more_info_url);
#line 658 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translator_names (self, translators, translators_length1);
#line 659 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_developer_names (self, developers, developers_length1);
#line 660 "../lib/Widgets/AboutWindow.vala"
	if (copyright_year != 0) {
#line 660 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = copyright_year;
#line 2320 "AboutWindow.c"
	} else {
#line 660 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = 69;
#line 2324 "AboutWindow.c"
	}
#line 660 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_copyright_year (self, _tmp1_);
#line 661 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_license (self, license);
#line 662 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_color (self, color);
#line 637 "../lib/Widgets/AboutWindow.vala"
	return self;
#line 2334 "AboutWindow.c"
}

HeAboutWindow*
he_about_window_new (GtkWindow* parent,
                     const gchar* app_name,
                     const gchar* app_id,
                     const gchar* version,
                     const gchar* icon,
                     const gchar* translate_url,
                     const gchar* issue_url,
                     const gchar* more_info_url,
                     gchar** translators,
                     gint translators_length1,
                     gchar** developers,
                     gint developers_length1,
                     gint copyright_year,
                     HeAboutWindowLicenses license,
                     HeColors color)
{
#line 637 "../lib/Widgets/AboutWindow.vala"
	return he_about_window_construct (HE_TYPE_ABOUT_WINDOW, parent, app_name, app_id, version, icon, translate_url, issue_url, more_info_url, translators, translators_length1, developers, developers_length1, copyright_year, license, color);
#line 2356 "AboutWindow.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 408 "../lib/Widgets/AboutWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 408 "../lib/Widgets/AboutWindow.vala"
	return _data4_;
#line 2366 "AboutWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 408 "../lib/Widgets/AboutWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2376 "AboutWindow.c"
		HeAboutWindow* self;
#line 408 "../lib/Widgets/AboutWindow.vala"
		self = _data4_->self;
#line 408 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (_data4_->uri_launcher);
#line 408 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (self);
#line 408 "../lib/Widgets/AboutWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 2386 "AboutWindow.c"
	}
}

static void
_he_about_window___lambda101_ (Block4Data* _data4_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
#line 482 "../lib/Widgets/AboutWindow.vala"
	self = _data4_->self;
#line 483 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data4_->uri_launcher;
#line 483 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_translate_url (self);
#line 483 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 483 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 484 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data4_->uri_launcher;
#line 484 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, NULL, NULL, NULL, NULL);
#line 2412 "AboutWindow.c"
}

static void
__he_about_window___lambda101__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 482 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda101_ (self);
#line 2421 "AboutWindow.c"
}

static void
_he_about_window___lambda102_ (Block4Data* _data4_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
#line 487 "../lib/Widgets/AboutWindow.vala"
	self = _data4_->self;
#line 488 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data4_->uri_launcher;
#line 488 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_issue_url (self);
#line 488 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 488 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 489 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data4_->uri_launcher;
#line 489 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, NULL, NULL, NULL, NULL);
#line 2446 "AboutWindow.c"
}

static void
__he_about_window___lambda102__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 487 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda102_ (self);
#line 2455 "AboutWindow.c"
}

static void
_he_about_window___lambda103_ (Block4Data* _data4_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
#line 492 "../lib/Widgets/AboutWindow.vala"
	self = _data4_->self;
#line 493 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data4_->uri_launcher;
#line 493 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_more_info_url (self);
#line 493 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 493 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 494 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data4_->uri_launcher;
#line 494 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, NULL, NULL, NULL, NULL);
#line 2480 "AboutWindow.c"
}

static void
__he_about_window___lambda103__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 492 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda103_ (self);
#line 2489 "AboutWindow.c"
}

static void
_he_about_window___lambda104_ (HeAboutWindow* self)
{
#line 497 "../lib/Widgets/AboutWindow.vala"
	he_about_window_hide_about (self);
#line 2497 "AboutWindow.c"
}

static void
__he_about_window___lambda104__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 497 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda104_ ((HeAboutWindow*) self);
#line 2506 "AboutWindow.c"
}

static void
_he_about_window___lambda105_ (HeAboutWindow* self)
{
#line 506 "../lib/Widgets/AboutWindow.vala"
	he_about_window_hide_about (self);
#line 2514 "AboutWindow.c"
}

static void
__he_about_window___lambda105__gtk_gesture_end (GtkGesture* _sender,
                                                GdkEventSequence* sequence,
                                                gpointer self)
{
#line 506 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda105_ ((HeAboutWindow*) self);
#line 2524 "AboutWindow.c"
}

static GObject *
he_about_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAboutWindow * self;
	Block4Data* _data4_;
	HeBin* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	HeButton* _tmp8_;
	HeButton* _tmp9_;
	HeButton* _tmp10_;
	HeButton* _tmp11_;
	HeButton* _tmp12_;
	GtkOverlay* window_overlay = NULL;
	GtkOverlay* _tmp13_;
	GtkOverlay* _tmp14_;
	HeButton* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkImage* _tmp22_;
	GtkImage* _tmp23_;
	GtkImage* _tmp24_;
	GtkBox* _tmp25_;
	GtkImage* _tmp26_;
	GtkBox* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	HeModifierBadge* _tmp33_;
	HeModifierBadge* _tmp34_;
	GtkLabel* _tmp35_;
	GtkBox* _tmp36_;
	GtkLabel* _tmp37_;
	GtkBox* _tmp38_;
	HeModifierBadge* _tmp39_;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	GtkBox* _tmp42_;
	GtkScrolledWindow* _tmp43_;
	GtkBox* _tmp44_;
	GtkScrolledWindow* _tmp45_;
	GtkScrolledWindow* _tmp46_;
	GtkBox* _tmp47_;
	GtkScrolledWindow* _tmp48_;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkScrolledWindow* _tmp52_;
	GtkBox* _tmp53_;
	GtkScrolledWindow* _tmp54_;
	GtkScrolledWindow* _tmp55_;
	GtkBox* _tmp56_;
	GtkScrolledWindow* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkBox* _tmp60_;
	GtkLabel* _tmp61_;
	HeButton* _tmp62_;
	HeButton* _tmp63_;
	HeButton* _tmp64_;
	GtkBox* _tmp65_;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	HeButton* _tmp68_;
	GtkBox* _tmp69_;
	HeButton* _tmp70_;
	GtkBox* _tmp71_;
	HeButton* _tmp72_;
	GtkUriLauncher* _tmp73_;
	HeButton* _tmp74_;
	HeButton* _tmp75_;
	HeButton* _tmp76_;
	HeButton* _tmp77_;
	GtkWindowHandle* window_handle = NULL;
	GtkWindowHandle* _tmp78_;
	GtkWindowHandle* _tmp79_;
	GtkOverlay* _tmp80_;
	GtkBox* _tmp81_;
	GtkWindowHandle* _tmp82_;
	GtkGestureClick* click_gesture = NULL;
	GtkGestureClick* _tmp83_;
	GtkGestureClick* _tmp84_;
	GtkWidget* _tmp85_;
	GtkGestureClick* _tmp86_;
	GtkEventController* _tmp87_;
#line 408 "../lib/Widgets/AboutWindow.vala"
	parent_class = G_OBJECT_CLASS (he_about_window_parent_class);
#line 408 "../lib/Widgets/AboutWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 408 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 408 "../lib/Widgets/AboutWindow.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 408 "../lib/Widgets/AboutWindow.vala"
	_data4_->_ref_count_ = 1;
#line 408 "../lib/Widgets/AboutWindow.vala"
	_data4_->self = g_object_ref (self);
#line 410 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_bin_new ();
#line 410 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 410 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->dimming);
#line 410 "../lib/Widgets/AboutWindow.vala"
	self->priv->dimming = (GtkWidget*) _tmp0_;
#line 411 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->dimming;
#line 411 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class (_tmp1_, "dimming");
#line 412 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->dimming;
#line 412 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_child_visible (_tmp2_, FALSE);
#line 413 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = self->priv->dimming;
#line 413 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_parent (_tmp3_, (GtkWidget*) self);
#line 416 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 416 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 416 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->about_bin);
#line 416 "../lib/Widgets/AboutWindow.vala"
	self->priv->about_bin = _tmp4_;
#line 417 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = self->priv->about_bin;
#line 417 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_CENTER);
#line 418 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = self->priv->about_bin;
#line 418 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_child_visible ((GtkWidget*) _tmp6_, FALSE);
#line 419 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = self->priv->about_bin;
#line 419 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp7_, (GtkWidget*) self);
#line 421 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = he_button_new ("window-close-symbolic", "");
#line 421 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp8_);
#line 421 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 421 "../lib/Widgets/AboutWindow.vala"
	self->priv->close_button = _tmp8_;
#line 422 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = self->priv->close_button;
#line 422 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_disclosure (_tmp9_, TRUE);
#line 423 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = self->priv->close_button;
#line 423 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
#line 424 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = self->priv->close_button;
#line 424 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
#line 425 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = self->priv->close_button;
#line 425 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _ ("Close"));
#line 427 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = (GtkOverlay*) gtk_overlay_new ();
#line 427 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 427 "../lib/Widgets/AboutWindow.vala"
	window_overlay = _tmp13_;
#line 428 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = window_overlay;
#line 428 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = self->priv->close_button;
#line 428 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_add_overlay (_tmp14_, (GtkWidget*) _tmp15_);
#line 429 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = window_overlay;
#line 429 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = self->priv->about_box;
#line 429 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_set_child (_tmp16_, (GtkWidget*) _tmp17_);
#line 431 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = self->priv->about_box;
#line 431 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = self->priv->content_box;
#line 431 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 432 "../lib/Widgets/AboutWindow.vala"
	_tmp20_ = self->priv->about_box;
#line 432 "../lib/Widgets/AboutWindow.vala"
	_tmp21_ = self->priv->button_box;
#line 432 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 434 "../lib/Widgets/AboutWindow.vala"
	_tmp22_ = self->priv->icon_image;
#line 434 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
#line 435 "../lib/Widgets/AboutWindow.vala"
	_tmp23_ = self->priv->icon_image;
#line 435 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_pixel_size (_tmp23_, 128);
#line 436 "../lib/Widgets/AboutWindow.vala"
	_tmp24_ = self->priv->icon_image;
#line 436 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp24_, "icon-dropshadow");
#line 438 "../lib/Widgets/AboutWindow.vala"
	_tmp25_ = self->priv->content_box;
#line 438 "../lib/Widgets/AboutWindow.vala"
	_tmp26_ = self->priv->icon_image;
#line 438 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 439 "../lib/Widgets/AboutWindow.vala"
	_tmp27_ = self->priv->content_box;
#line 439 "../lib/Widgets/AboutWindow.vala"
	_tmp28_ = self->priv->info_box;
#line 439 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 441 "../lib/Widgets/AboutWindow.vala"
	_tmp29_ = self->priv->info_box;
#line 441 "../lib/Widgets/AboutWindow.vala"
	_tmp30_ = self->priv->title_box;
#line 441 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
#line 442 "../lib/Widgets/AboutWindow.vala"
	_tmp31_ = self->priv->info_box;
#line 442 "../lib/Widgets/AboutWindow.vala"
	_tmp32_ = self->priv->text_box;
#line 442 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 444 "../lib/Widgets/AboutWindow.vala"
	_tmp33_ = self->priv->version_badge;
#line 444 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_tinted (_tmp33_, TRUE);
#line 445 "../lib/Widgets/AboutWindow.vala"
	_tmp34_ = self->priv->version_badge;
#line 445 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp34_, 24);
#line 446 "../lib/Widgets/AboutWindow.vala"
	_tmp35_ = self->priv->title_label;
#line 446 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp35_, "display");
#line 447 "../lib/Widgets/AboutWindow.vala"
	_tmp36_ = self->priv->title_box;
#line 447 "../lib/Widgets/AboutWindow.vala"
	_tmp37_ = self->priv->title_label;
#line 447 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp36_, (GtkWidget*) _tmp37_);
#line 448 "../lib/Widgets/AboutWindow.vala"
	_tmp38_ = self->priv->title_box;
#line 448 "../lib/Widgets/AboutWindow.vala"
	_tmp39_ = self->priv->version_badge;
#line 448 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp38_, (GtkWidget*) _tmp39_);
#line 450 "../lib/Widgets/AboutWindow.vala"
	_tmp40_ = self->priv->developers_box;
#line 450 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, FALSE);
#line 451 "../lib/Widgets/AboutWindow.vala"
	_tmp41_ = self->priv->developers_box;
#line 451 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp41_, GTK_ALIGN_START);
#line 452 "../lib/Widgets/AboutWindow.vala"
	_tmp42_ = self->priv->developers_box;
#line 452 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_vexpand_set ((GtkWidget*) _tmp42_, TRUE);
#line 453 "../lib/Widgets/AboutWindow.vala"
	_tmp43_ = self->priv->developers_box_scroller;
#line 453 "../lib/Widgets/AboutWindow.vala"
	_tmp44_ = self->priv->developers_box;
#line 453 "../lib/Widgets/AboutWindow.vala"
	gtk_scrolled_window_set_child (_tmp43_, (GtkWidget*) _tmp44_);
#line 454 "../lib/Widgets/AboutWindow.vala"
	_tmp45_ = self->priv->developers_box_scroller;
#line 454 "../lib/Widgets/AboutWindow.vala"
	g_object_set (_tmp45_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 455 "../lib/Widgets/AboutWindow.vala"
	_tmp46_ = self->priv->developers_box_scroller;
#line 455 "../lib/Widgets/AboutWindow.vala"
	g_object_set (_tmp46_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 456 "../lib/Widgets/AboutWindow.vala"
	_tmp47_ = self->priv->text_box;
#line 456 "../lib/Widgets/AboutWindow.vala"
	_tmp48_ = self->priv->developers_box_scroller;
#line 456 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp47_, (GtkWidget*) _tmp48_);
#line 458 "../lib/Widgets/AboutWindow.vala"
	_tmp49_ = self->priv->translators_box;
#line 458 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp49_, FALSE);
#line 459 "../lib/Widgets/AboutWindow.vala"
	_tmp50_ = self->priv->translators_box;
#line 459 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_START);
#line 460 "../lib/Widgets/AboutWindow.vala"
	_tmp51_ = self->priv->translators_box;
#line 460 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_vexpand_set ((GtkWidget*) _tmp51_, TRUE);
#line 461 "../lib/Widgets/AboutWindow.vala"
	_tmp52_ = self->priv->translators_box_scroller;
#line 461 "../lib/Widgets/AboutWindow.vala"
	_tmp53_ = self->priv->translators_box;
#line 461 "../lib/Widgets/AboutWindow.vala"
	gtk_scrolled_window_set_child (_tmp52_, (GtkWidget*) _tmp53_);
#line 462 "../lib/Widgets/AboutWindow.vala"
	_tmp54_ = self->priv->translators_box_scroller;
#line 462 "../lib/Widgets/AboutWindow.vala"
	g_object_set (_tmp54_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 463 "../lib/Widgets/AboutWindow.vala"
	_tmp55_ = self->priv->translators_box_scroller;
#line 463 "../lib/Widgets/AboutWindow.vala"
	g_object_set (_tmp55_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 464 "../lib/Widgets/AboutWindow.vala"
	_tmp56_ = self->priv->text_box;
#line 464 "../lib/Widgets/AboutWindow.vala"
	_tmp57_ = self->priv->translators_box_scroller;
#line 464 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp56_, (GtkWidget*) _tmp57_);
#line 466 "../lib/Widgets/AboutWindow.vala"
	_tmp58_ = self->priv->license_label;
#line 466 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp58_, (gfloat) 0);
#line 467 "../lib/Widgets/AboutWindow.vala"
	_tmp59_ = self->priv->license_label;
#line 467 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp59_, TRUE);
#line 468 "../lib/Widgets/AboutWindow.vala"
	_tmp60_ = self->priv->text_box;
#line 468 "../lib/Widgets/AboutWindow.vala"
	_tmp61_ = self->priv->license_label;
#line 468 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp60_, (GtkWidget*) _tmp61_);
#line 470 "../lib/Widgets/AboutWindow.vala"
	_tmp62_ = self->priv->translate_app_button;
#line 470 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_textual (_tmp62_, TRUE);
#line 471 "../lib/Widgets/AboutWindow.vala"
	_tmp63_ = self->priv->report_button;
#line 471 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_tint (_tmp63_, TRUE);
#line 472 "../lib/Widgets/AboutWindow.vala"
	_tmp64_ = self->priv->more_info_button;
#line 472 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_fill (_tmp64_, TRUE);
#line 474 "../lib/Widgets/AboutWindow.vala"
	_tmp65_ = self->priv->button_box;
#line 474 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp65_, GTK_ALIGN_CENTER);
#line 475 "../lib/Widgets/AboutWindow.vala"
	_tmp66_ = self->priv->button_box;
#line 475 "../lib/Widgets/AboutWindow.vala"
	gtk_box_set_homogeneous (_tmp66_, TRUE);
#line 476 "../lib/Widgets/AboutWindow.vala"
	_tmp67_ = self->priv->button_box;
#line 476 "../lib/Widgets/AboutWindow.vala"
	_tmp68_ = self->priv->translate_app_button;
#line 476 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp67_, (GtkWidget*) _tmp68_);
#line 477 "../lib/Widgets/AboutWindow.vala"
	_tmp69_ = self->priv->button_box;
#line 477 "../lib/Widgets/AboutWindow.vala"
	_tmp70_ = self->priv->report_button;
#line 477 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp69_, (GtkWidget*) _tmp70_);
#line 478 "../lib/Widgets/AboutWindow.vala"
	_tmp71_ = self->priv->button_box;
#line 478 "../lib/Widgets/AboutWindow.vala"
	_tmp72_ = self->priv->more_info_button;
#line 478 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp71_, (GtkWidget*) _tmp72_);
#line 480 "../lib/Widgets/AboutWindow.vala"
	_tmp73_ = gtk_uri_launcher_new ("");
#line 480 "../lib/Widgets/AboutWindow.vala"
	_data4_->uri_launcher = _tmp73_;
#line 482 "../lib/Widgets/AboutWindow.vala"
	_tmp74_ = self->priv->translate_app_button;
#line 482 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp74_, "clicked", (GCallback) __he_about_window___lambda101__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 487 "../lib/Widgets/AboutWindow.vala"
	_tmp75_ = self->priv->report_button;
#line 487 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp75_, "clicked", (GCallback) __he_about_window___lambda102__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 492 "../lib/Widgets/AboutWindow.vala"
	_tmp76_ = self->priv->more_info_button;
#line 492 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp76_, "clicked", (GCallback) __he_about_window___lambda103__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 497 "../lib/Widgets/AboutWindow.vala"
	_tmp77_ = self->priv->close_button;
#line 497 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp77_, "clicked", (GCallback) __he_about_window___lambda104__gtk_button_clicked, self, 0);
#line 499 "../lib/Widgets/AboutWindow.vala"
	_tmp78_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 499 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp78_);
#line 499 "../lib/Widgets/AboutWindow.vala"
	window_handle = _tmp78_;
#line 500 "../lib/Widgets/AboutWindow.vala"
	_tmp79_ = window_handle;
#line 500 "../lib/Widgets/AboutWindow.vala"
	_tmp80_ = window_overlay;
#line 500 "../lib/Widgets/AboutWindow.vala"
	gtk_window_handle_set_child (_tmp79_, (GtkWidget*) _tmp80_);
#line 502 "../lib/Widgets/AboutWindow.vala"
	_tmp81_ = self->priv->about_bin;
#line 502 "../lib/Widgets/AboutWindow.vala"
	_tmp82_ = window_handle;
#line 502 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp81_, (GtkWidget*) _tmp82_);
#line 505 "../lib/Widgets/AboutWindow.vala"
	_tmp83_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 505 "../lib/Widgets/AboutWindow.vala"
	click_gesture = _tmp83_;
#line 506 "../lib/Widgets/AboutWindow.vala"
	_tmp84_ = click_gesture;
#line 506 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkGesture*) _tmp84_, "end", (GCallback) __he_about_window___lambda105__gtk_gesture_end, self, 0);
#line 507 "../lib/Widgets/AboutWindow.vala"
	_tmp85_ = self->priv->dimming;
#line 507 "../lib/Widgets/AboutWindow.vala"
	_tmp86_ = click_gesture;
#line 507 "../lib/Widgets/AboutWindow.vala"
	_tmp87_ = _g_object_ref0 ((GtkEventController*) _tmp86_);
#line 507 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_controller (_tmp85_, _tmp87_);
#line 408 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (click_gesture);
#line 408 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (window_handle);
#line 408 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (window_overlay);
#line 408 "../lib/Widgets/AboutWindow.vala"
	block4_data_unref (_data4_);
#line 408 "../lib/Widgets/AboutWindow.vala"
	_data4_ = NULL;
#line 408 "../lib/Widgets/AboutWindow.vala"
	return obj;
#line 2975 "AboutWindow.c"
}

static void
he_about_window_class_init (HeAboutWindowClass * klass,
                            gpointer klass_data)
{
#line 23 "../lib/Widgets/AboutWindow.vala"
	he_about_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_type_class_adjust_private_offset (klass, &HeAboutWindow_private_offset);
#line 23 "../lib/Widgets/AboutWindow.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) he_about_window_real_dispose;
#line 23 "../lib/Widgets/AboutWindow.vala"
	((GtkWidgetClass *) klass)->contains = (gboolean (*) (GtkWidget*, gdouble, gdouble)) he_about_window_real_contains;
#line 23 "../lib/Widgets/AboutWindow.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) he_about_window_real_measure;
#line 23 "../lib/Widgets/AboutWindow.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) he_about_window_real_size_allocate;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_about_window_get_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_about_window_set_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = he_about_window_constructor;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = he_about_window_finalize;
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_VISIBLE_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3004 "AboutWindow.c"
	/**
	     * The theme color of the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COLOR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3010 "AboutWindow.c"
	/**
	     * The license shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_LICENSE_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY] = g_param_spec_enum ("license", "license", "license", HE_ABOUT_WINDOW_TYPE_LICENSES, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3016 "AboutWindow.c"
	/**
	     * The version shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_VERSION_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3022 "AboutWindow.c"
	/**
	     * The name of the application shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_NAME_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3028 "AboutWindow.c"
	/**
	     *  The icon shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ICON_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3034 "AboutWindow.c"
	/**
	     * The translators shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY] = g_param_spec_boxed ("translator-names", "translator-names", "translator-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3040 "AboutWindow.c"
	/**
	     * The developers shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY] = g_param_spec_boxed ("developer-names", "developer-names", "developer-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3046 "AboutWindow.c"
	/**
	     * The copyright year shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY] = g_param_spec_int ("copyright-year", "copyright-year", "copyright-year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3052 "AboutWindow.c"
	/**
	     * Your application's reverse-domain name.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_ID_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3058 "AboutWindow.c"
	/**
	     * A URL where contributors can help translate the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY] = g_param_spec_string ("translate-url", "translate-url", "translate-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3064 "AboutWindow.c"
	/**
	     * A URL where users can report a problem with the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY] = g_param_spec_string ("issue-url", "issue-url", "issue-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3070 "AboutWindow.c"
	/**
	     * A URL where users can get more information about the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY] = g_param_spec_string ("more-info-url", "more-info-url", "more-info-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3076 "AboutWindow.c"
	/**
	     * The hidden signal fires when the about window is hidden.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	he_about_window_signals[HE_ABOUT_WINDOW_HIDDEN_SIGNAL] = g_signal_new ("hidden", HE_TYPE_ABOUT_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3082 "AboutWindow.c"
}

static void
he_about_window_instance_init (HeAboutWindow * self,
                               gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkImage* _tmp10_;
	GtkScrolledWindow* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	HeButton* _tmp13_;
	HeButton* _tmp14_;
	HeButton* _tmp15_;
	HeModifierBadge* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gchar* _tmp19_;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self->priv = he_about_window_get_instance_private (self);
#line 37 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 37 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 37 "../lib/Widgets/AboutWindow.vala"
	self->priv->about_box = _tmp0_;
#line 38 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 30);
#line 38 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 38 "../lib/Widgets/AboutWindow.vala"
	self->priv->content_box = _tmp1_;
#line 39 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 39 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 39 "../lib/Widgets/AboutWindow.vala"
	self->priv->button_box = _tmp2_;
#line 40 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 40 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 40 "../lib/Widgets/AboutWindow.vala"
	self->priv->info_box = _tmp3_;
#line 41 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 41 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 41 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_box = _tmp4_;
#line 42 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 42 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 42 "../lib/Widgets/AboutWindow.vala"
	self->priv->text_box = _tmp5_;
#line 43 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 43 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 43 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_box = _tmp6_;
#line 44 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 44 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 44 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_box = _tmp7_;
#line 46 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (NULL);
#line 46 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp8_);
#line 46 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_label = _tmp8_;
#line 47 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 47 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 47 "../lib/Widgets/AboutWindow.vala"
	self->priv->license_label = _tmp9_;
#line 49 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = (GtkImage*) gtk_image_new ();
#line 49 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 49 "../lib/Widgets/AboutWindow.vala"
	self->priv->icon_image = _tmp10_;
#line 51 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 51 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 51 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_box_scroller = _tmp11_;
#line 52 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 52 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 52 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_box_scroller = _tmp12_;
#line 54 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = he_button_new (NULL, _ ("Translate App"));
#line 54 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 54 "../lib/Widgets/AboutWindow.vala"
	self->priv->translate_app_button = _tmp13_;
#line 55 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = he_button_new (NULL, _ ("Report a Problem"));
#line 55 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 55 "../lib/Widgets/AboutWindow.vala"
	self->priv->report_button = _tmp14_;
#line 56 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = he_button_new (NULL, _ ("More Info…"));
#line 56 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 56 "../lib/Widgets/AboutWindow.vala"
	self->priv->more_info_button = _tmp15_;
#line 59 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = he_modifier_badge_new ("");
#line 59 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 59 "../lib/Widgets/AboutWindow.vala"
	self->priv->version_badge = _tmp16_;
#line 64 "../lib/Widgets/AboutWindow.vala"
	self->priv->_visible = FALSE;
#line 146 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = HE_COLORS_PURPLE;
#line 165 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = HE_ABOUT_WINDOW_LICENSES_GPLV3;
#line 201 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = g_new0 (gchar*, 0 + 1);
#line 201 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp17_;
#line 201 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = 0;
#line 201 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 262 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 262 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp18_;
#line 262 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = 0;
#line 262 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 293 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = g_strdup ("");
#line 293 "../lib/Widgets/AboutWindow.vala"
	self->priv->_app_id = _tmp19_;
#line 3239 "AboutWindow.c"
}

static void
he_about_window_finalize (GObject * obj)
{
	HeAboutWindow * self;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 33 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->dimming);
#line 34 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->about_bin);
#line 35 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 37 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->about_box);
#line 38 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->content_box);
#line 39 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->button_box);
#line 40 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->info_box);
#line 41 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_box);
#line 42 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->text_box);
#line 43 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->developers_box);
#line 44 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translators_box);
#line 46 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_label);
#line 47 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->license_label);
#line 49 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->icon_image);
#line 51 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->developers_box_scroller);
#line 52 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translators_box_scroller);
#line 54 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translate_app_button);
#line 55 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->report_button);
#line 56 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->more_info_button);
#line 57 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 59 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->version_badge);
#line 201 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 262 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 286 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 287 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 288 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 293 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_app_id);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (he_about_window_parent_class)->finalize (obj);
#line 3304 "AboutWindow.c"
}

/**
 * An AboutWindow is a modal widget that displays information about the application.
 */
static GType
he_about_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAboutWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_about_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAboutWindow), 0, (GInstanceInitFunc) he_about_window_instance_init, NULL };
	GType he_about_window_type_id;
	he_about_window_type_id = g_type_register_static (gtk_widget_get_type (), "HeAboutWindow", &g_define_type_info, 0);
	HeAboutWindow_private_offset = g_type_add_instance_private (he_about_window_type_id, sizeof (HeAboutWindowPrivate));
	return he_about_window_type_id;
}

GType
he_about_window_get_type (void)
{
	static volatile gsize he_about_window_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_type_id__once)) {
		GType he_about_window_type_id;
		he_about_window_type_id = he_about_window_get_type_once ();
		g_once_init_leave (&he_about_window_type_id__once, he_about_window_type_id);
	}
	return he_about_window_type_id__once;
}

static void
_vala_he_about_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VISIBLE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_boolean (value, he_about_window_get_visible (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_color (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_license (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_version (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_name (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_icon (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 3380 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_translator_names (self, &length));
#line 3385 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 3391 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_developer_names (self, &length));
#line 3396 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_int (value, he_about_window_get_copyright_year (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_id (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_translate_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_issue_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_more_info_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 3430 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 3436 "AboutWindow.c"
	}
}

static void
_vala_he_about_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VISIBLE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_visible (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_color (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_license (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_version (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_name (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_icon (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 3488 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_translator_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 3495 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 3501 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_developer_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 3508 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_copyright_year (self, g_value_get_int (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_id (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_translate_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_issue_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_more_info_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 3542 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 3548 "AboutWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

