/* BottomBar.c generated by valac 0.56.18, the Vala compiler
 * generated from BottomBar.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_BOTTOM_BAR_0_PROPERTY,
	HE_BOTTOM_BAR_TITLE_PROPERTY,
	HE_BOTTOM_BAR_OVERLAY_BUTTON_PROPERTY,
	HE_BOTTOM_BAR_DESCRIPTION_PROPERTY,
	HE_BOTTOM_BAR_MODE_PROPERTY,
	HE_BOTTOM_BAR_STYLE_PROPERTY,
	HE_BOTTOM_BAR_FLOATING_POSITION_PROPERTY,
	HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY,
	HE_BOTTOM_BAR_NUM_PROPERTIES
};
static GParamSpec* he_bottom_bar_properties[HE_BOTTOM_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))

struct _HeBottomBarPrivate {
	GtkBox* main_box;
	GtkBox* left_box;
	GtkBox* center_box;
	GtkBox* right_box;
	GtkLabel* title_label;
	GtkLabel* description_label;
	GtkOverlay* overlay_parent;
	HeOverlayButton* _overlay_button;
	HeBottomBarMode _mode;
	HeBottomBarStyle _style;
	HeBottomBarFloatingPosition _floating_position;
};

static gint HeBottomBar_private_offset;
static gpointer he_bottom_bar_parent_class = NULL;
static GtkBuildableIface * he_bottom_bar_gtk_buildable_parent_iface = NULL;

static void he_bottom_bar_remove_from_overlay (HeBottomBar* self);
static void he_bottom_bar_remove_overlay_button (HeBottomBar* self);
static void he_bottom_bar_setup_overlay_button (HeBottomBar* self);
static void he_bottom_bar_update_mode_styling (HeBottomBar* self);
static void he_bottom_bar_setup_overlay (HeBottomBar* self,
                                  GtkWidget* target_widget);
static void he_bottom_bar_update_style_classes (HeBottomBar* self);
static void he_bottom_bar_update_layout_orientation (HeBottomBar* self);
static void he_bottom_bar_real_add_child (GtkBuildable* base,
                                   GtkBuilder* builder,
                                   GObject* child,
                                   const gchar* type);
static void he_bottom_bar_setup_styling (HeBottomBar* self);
static void he_bottom_bar_setup_layout (HeBottomBar* self);
static void he_bottom_bar_apply_floating_position_settings (HeBottomBar* self);
static void he_bottom_bar_reparent_overlay_to_container (HeBottomBar* self,
                                                  GtkOverlay* overlay,
                                                  GtkWidget* container);
static void he_bottom_bar_apply_overlay_button_positioning (HeBottomBar* self);
static GObject * he_bottom_bar_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void he_bottom_bar_finalize (GObject * obj);
static GType he_bottom_bar_get_type_once (void);
static void _vala_he_bottom_bar_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_he_bottom_bar_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_bottom_bar_get_instance_private (HeBottomBar* self)
{
	return G_STRUCT_MEMBER_P (self, HeBottomBar_private_offset);
}

/**
     * Display modes for the BottomBar widget.
     *
     * The mode determines how the bottom bar is positioned and styled:
     *
     * - **DOCKED**: Traditional bottom app bar attached to the window edge.
     * Spans the full width and has a flat appearance with subtle elevation.
     *
     * - **FLOATING**: Overlay bar that hovers over content with rounded corners.
     * Requires an `overlay_widget` to be specified for positioning.
     * Has higher elevation and appears above other content.
     */
static GType
he_bottom_bar_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_MODE_DOCKED, "HE_BOTTOM_BAR_MODE_DOCKED", "docked"}, {HE_BOTTOM_BAR_MODE_FLOATING, "HE_BOTTOM_BAR_MODE_FLOATING", "floating"}, {0, NULL, NULL}};
	GType he_bottom_bar_mode_type_id;
	he_bottom_bar_mode_type_id = g_enum_register_static ("HeBottomBarMode", values);
	return he_bottom_bar_mode_type_id;
}

GType
he_bottom_bar_mode_get_type (void)
{
	static volatile gsize he_bottom_bar_mode_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_mode_type_id__once)) {
		GType he_bottom_bar_mode_type_id;
		he_bottom_bar_mode_type_id = he_bottom_bar_mode_get_type_once ();
		g_once_init_leave (&he_bottom_bar_mode_type_id__once, he_bottom_bar_mode_type_id);
	}
	return he_bottom_bar_mode_type_id__once;
}

/**
     * Visual styles for the BottomBar widget.
     *
     * The style determines the visual appearance and theming:
     *
     * - **DEFAULT**: Standard appearance with system colors and styling.
     * Uses the default theme colors and contrast levels.
     *
     * - **VIBRANT**: Enhanced appearance with more vivid colors and effects.
     * Provides higher visual impact and modern styling. Applies "vibrant" CSS class.
     */
static GType
he_bottom_bar_style_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_STYLE_DEFAULT, "HE_BOTTOM_BAR_STYLE_DEFAULT", "default"}, {HE_BOTTOM_BAR_STYLE_VIBRANT, "HE_BOTTOM_BAR_STYLE_VIBRANT", "vibrant"}, {0, NULL, NULL}};
	GType he_bottom_bar_style_type_id;
	he_bottom_bar_style_type_id = g_enum_register_static ("HeBottomBarStyle", values);
	return he_bottom_bar_style_type_id;
}

GType
he_bottom_bar_style_get_type (void)
{
	static volatile gsize he_bottom_bar_style_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_style_type_id__once)) {
		GType he_bottom_bar_style_type_id;
		he_bottom_bar_style_type_id = he_bottom_bar_style_get_type_once ();
		g_once_init_leave (&he_bottom_bar_style_type_id__once, he_bottom_bar_style_type_id);
	}
	return he_bottom_bar_style_type_id__once;
}

/**
     * Positioning options for floating BottomBar.
     *
     * When in floating mode, the bottom bar can be positioned at different edges:
     *
     * - **BOTTOM**: Default positioning at the bottom edge of the overlay widget.
     * - **LEFT**: Positioned at the left edge with vertical orientation.
     * - **RIGHT**: Positioned at the right edge with vertical orientation.
     */
static GType
he_bottom_bar_floating_position_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_FLOATING_POSITION_BOTTOM, "HE_BOTTOM_BAR_FLOATING_POSITION_BOTTOM", "bottom"}, {HE_BOTTOM_BAR_FLOATING_POSITION_LEFT, "HE_BOTTOM_BAR_FLOATING_POSITION_LEFT", "left"}, {HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT, "HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT", "right"}, {0, NULL, NULL}};
	GType he_bottom_bar_floating_position_type_id;
	he_bottom_bar_floating_position_type_id = g_enum_register_static ("HeBottomBarFloatingPosition", values);
	return he_bottom_bar_floating_position_type_id;
}

GType
he_bottom_bar_floating_position_get_type (void)
{
	static volatile gsize he_bottom_bar_floating_position_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_floating_position_type_id__once)) {
		GType he_bottom_bar_floating_position_type_id;
		he_bottom_bar_floating_position_type_id = he_bottom_bar_floating_position_get_type_once ();
		g_once_init_leave (&he_bottom_bar_floating_position_type_id__once, he_bottom_bar_floating_position_type_id);
	}
	return he_bottom_bar_floating_position_type_id__once;
}

/**
     * Positioning options for buttons within the BottomBar.
     *
     * Buttons can be placed on either side of the center content area,
     * allowing for a balanced layout of actions.
     */
static GType
he_bottom_bar_position_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_POSITION_LEFT, "HE_BOTTOM_BAR_POSITION_LEFT", "left"}, {HE_BOTTOM_BAR_POSITION_RIGHT, "HE_BOTTOM_BAR_POSITION_RIGHT", "right"}, {0, NULL, NULL}};
	GType he_bottom_bar_position_type_id;
	he_bottom_bar_position_type_id = g_enum_register_static ("HeBottomBarPosition", values);
	return he_bottom_bar_position_type_id;
}

GType
he_bottom_bar_position_get_type (void)
{
	static volatile gsize he_bottom_bar_position_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_position_type_id__once)) {
		GType he_bottom_bar_position_type_id;
		he_bottom_bar_position_type_id = he_bottom_bar_position_get_type_once ();
		g_once_init_leave (&he_bottom_bar_position_type_id__once, he_bottom_bar_position_type_id);
	}
	return he_bottom_bar_position_type_id__once;
}

const gchar*
he_bottom_bar_get_title (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 64 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 64 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 64 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 64 "../lib/Widgets/BottomBar.vala"
	return result;
#line 252 "BottomBar.c"
}

void
he_bottom_bar_set_title (HeBottomBar* self,
                         const gchar* value)
{
	GtkLabel* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean is_vertical = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkLabel* _tmp5_;
#line 65 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 66 "../lib/Widgets/BottomBar.vala"
	gtk_label_set_text (_tmp0_, value);
#line 68 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_floating_position == HE_BOTTOM_BAR_FLOATING_POSITION_LEFT) {
#line 68 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = TRUE;
#line 274 "BottomBar.c"
	} else {
#line 68 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->_floating_position == HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT;
#line 278 "BottomBar.c"
	}
#line 68 "../lib/Widgets/BottomBar.vala"
	is_vertical = _tmp1_;
#line 69 "../lib/Widgets/BottomBar.vala"
	if (!is_vertical) {
#line 284 "BottomBar.c"
		gint _tmp3_;
		gint _tmp4_;
#line 69 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = strlen (value);
#line 69 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp3_;
#line 69 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _tmp4_ > 0;
#line 293 "BottomBar.c"
	} else {
#line 69 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = FALSE;
#line 297 "BottomBar.c"
	}
#line 69 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = self->priv->title_label;
#line 69 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, _tmp2_);
#line 65 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY]);
#line 305 "BottomBar.c"
}

HeOverlayButton*
he_bottom_bar_get_overlay_button (HeBottomBar* self)
{
	HeOverlayButton* result;
	HeOverlayButton* _tmp0_;
#line 86 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->_overlay_button;
#line 86 "../lib/Widgets/BottomBar.vala"
	result = _tmp0_;
#line 86 "../lib/Widgets/BottomBar.vala"
	return result;
#line 321 "BottomBar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "../lib/Widgets/BottomBar.vala"
	return self ? g_object_ref (self) : NULL;
#line 329 "BottomBar.c"
}

void
he_bottom_bar_set_overlay_button (HeBottomBar* self,
                                  HeOverlayButton* value)
{
	HeOverlayButton* _tmp0_;
	HeOverlayButton* _tmp1_;
	HeOverlayButton* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	HeOverlayButton* _tmp5_;
#line 87 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 88 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->_overlay_button;
#line 88 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_ == value) {
#line 88 "../lib/Widgets/BottomBar.vala"
		return;
#line 350 "BottomBar.c"
	}
#line 91 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->_overlay_button;
#line 91 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_ != NULL) {
#line 92 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_remove_overlay_button (self);
#line 358 "BottomBar.c"
	}
#line 95 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 95 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->_overlay_button);
#line 95 "../lib/Widgets/BottomBar.vala"
	self->priv->_overlay_button = _tmp2_;
#line 98 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = self->priv->_overlay_button;
#line 98 "../lib/Widgets/BottomBar.vala"
	if (_tmp5_ != NULL) {
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->_mode == HE_BOTTOM_BAR_MODE_FLOATING;
#line 372 "BottomBar.c"
	} else {
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = FALSE;
#line 376 "BottomBar.c"
	}
#line 98 "../lib/Widgets/BottomBar.vala"
	if (_tmp4_) {
#line 380 "BottomBar.c"
		GtkOverlay* _tmp6_;
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->overlay_parent;
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = _tmp6_ != NULL;
#line 386 "BottomBar.c"
	} else {
#line 98 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = FALSE;
#line 390 "BottomBar.c"
	}
#line 98 "../lib/Widgets/BottomBar.vala"
	if (_tmp3_) {
#line 99 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_setup_overlay_button (self);
#line 396 "BottomBar.c"
	}
#line 87 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_OVERLAY_BUTTON_PROPERTY]);
#line 400 "BottomBar.c"
}

const gchar*
he_bottom_bar_get_description (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 112 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->description_label;
#line 112 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 112 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 112 "../lib/Widgets/BottomBar.vala"
	return result;
#line 419 "BottomBar.c"
}

void
he_bottom_bar_set_description (HeBottomBar* self,
                               const gchar* value)
{
	GtkLabel* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean is_vertical = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkLabel* _tmp5_;
#line 113 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 114 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->description_label;
#line 114 "../lib/Widgets/BottomBar.vala"
	gtk_label_set_text (_tmp0_, value);
#line 116 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_floating_position == HE_BOTTOM_BAR_FLOATING_POSITION_LEFT) {
#line 116 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = TRUE;
#line 441 "BottomBar.c"
	} else {
#line 116 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->_floating_position == HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT;
#line 445 "BottomBar.c"
	}
#line 116 "../lib/Widgets/BottomBar.vala"
	is_vertical = _tmp1_;
#line 117 "../lib/Widgets/BottomBar.vala"
	if (!is_vertical) {
#line 451 "BottomBar.c"
		gint _tmp3_;
		gint _tmp4_;
#line 117 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = strlen (value);
#line 117 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp3_;
#line 117 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _tmp4_ > 0;
#line 460 "BottomBar.c"
	} else {
#line 117 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = FALSE;
#line 464 "BottomBar.c"
	}
#line 117 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = self->priv->description_label;
#line 117 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, _tmp2_);
#line 113 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY]);
#line 472 "BottomBar.c"
}

HeBottomBarMode
he_bottom_bar_get_mode (HeBottomBar* self)
{
	HeBottomBarMode result;
#line 182 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 182 "../lib/Widgets/BottomBar.vala"
	result = self->priv->_mode;
#line 182 "../lib/Widgets/BottomBar.vala"
	return result;
#line 485 "BottomBar.c"
}

void
he_bottom_bar_set_mode (HeBottomBar* self,
                        HeBottomBarMode value)
{
	gboolean _tmp0_ = FALSE;
#line 183 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 184 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_mode == value) {
#line 184 "../lib/Widgets/BottomBar.vala"
		return;
#line 499 "BottomBar.c"
	}
#line 186 "../lib/Widgets/BottomBar.vala"
	self->priv->_mode = value;
#line 187 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_mode_styling (self);
#line 190 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_mode == HE_BOTTOM_BAR_MODE_FLOATING) {
#line 507 "BottomBar.c"
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 190 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = he_bottom_bar_get_overlay_widget (self);
#line 190 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _tmp1_;
#line 190 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 516 "BottomBar.c"
	} else {
#line 190 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = FALSE;
#line 520 "BottomBar.c"
	}
#line 190 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 524 "BottomBar.c"
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 191 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = he_bottom_bar_get_overlay_widget (self);
#line 191 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp3_;
#line 191 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_setup_overlay (self, _tmp4_);
#line 533 "BottomBar.c"
	} else {
#line 192 "../lib/Widgets/BottomBar.vala"
		if (self->priv->_mode == HE_BOTTOM_BAR_MODE_DOCKED) {
#line 193 "../lib/Widgets/BottomBar.vala"
			he_bottom_bar_remove_from_overlay (self);
#line 539 "BottomBar.c"
		}
	}
#line 183 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_MODE_PROPERTY]);
#line 544 "BottomBar.c"
}

HeBottomBarStyle
he_bottom_bar_get_style (HeBottomBar* self)
{
	HeBottomBarStyle result;
#line 210 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 210 "../lib/Widgets/BottomBar.vala"
	result = self->priv->_style;
#line 210 "../lib/Widgets/BottomBar.vala"
	return result;
#line 557 "BottomBar.c"
}

void
he_bottom_bar_set_style (HeBottomBar* self,
                         HeBottomBarStyle value)
{
#line 211 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 212 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_style == value) {
#line 212 "../lib/Widgets/BottomBar.vala"
		return;
#line 570 "BottomBar.c"
	}
#line 214 "../lib/Widgets/BottomBar.vala"
	self->priv->_style = value;
#line 215 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_style_classes (self);
#line 211 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_STYLE_PROPERTY]);
#line 578 "BottomBar.c"
}

HeBottomBarFloatingPosition
he_bottom_bar_get_floating_position (HeBottomBar* self)
{
	HeBottomBarFloatingPosition result;
#line 233 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 233 "../lib/Widgets/BottomBar.vala"
	result = self->priv->_floating_position;
#line 233 "../lib/Widgets/BottomBar.vala"
	return result;
#line 591 "BottomBar.c"
}

void
he_bottom_bar_set_floating_position (HeBottomBar* self,
                                     HeBottomBarFloatingPosition value)
{
	gboolean _tmp0_ = FALSE;
#line 234 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_floating_position == value) {
#line 235 "../lib/Widgets/BottomBar.vala"
		return;
#line 605 "BottomBar.c"
	}
#line 237 "../lib/Widgets/BottomBar.vala"
	self->priv->_floating_position = value;
#line 240 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_layout_orientation (self);
#line 243 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_mode == HE_BOTTOM_BAR_MODE_FLOATING) {
#line 613 "BottomBar.c"
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 243 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = he_bottom_bar_get_overlay_widget (self);
#line 243 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _tmp1_;
#line 243 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 622 "BottomBar.c"
	} else {
#line 243 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = FALSE;
#line 626 "BottomBar.c"
	}
#line 243 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 630 "BottomBar.c"
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 244 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = he_bottom_bar_get_overlay_widget (self);
#line 244 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _tmp3_;
#line 244 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_setup_overlay (self, _tmp4_);
#line 639 "BottomBar.c"
	}
#line 234 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_FLOATING_POSITION_PROPERTY]);
#line 643 "BottomBar.c"
}

GtkWidget*
he_bottom_bar_get_overlay_widget (HeBottomBar* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_ = NULL;
	GtkOverlay* _tmp1_;
#line 261 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 261 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->overlay_parent;
#line 261 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_ != NULL) {
#line 658 "BottomBar.c"
		GtkOverlay* _tmp2_;
		GtkWidget* _tmp3_;
#line 261 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->overlay_parent;
#line 261 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = gtk_overlay_get_child (_tmp2_);
#line 261 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp3_;
#line 667 "BottomBar.c"
	} else {
#line 261 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = NULL;
#line 671 "BottomBar.c"
	}
#line 261 "../lib/Widgets/BottomBar.vala"
	result = _tmp0_;
#line 261 "../lib/Widgets/BottomBar.vala"
	return result;
#line 677 "BottomBar.c"
}

void
he_bottom_bar_set_overlay_widget (HeBottomBar* self,
                                  GtkWidget* value)
{
	gboolean _tmp0_ = FALSE;
	HeBottomBarMode _tmp1_;
	HeBottomBarMode _tmp2_;
#line 262 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 263 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = he_bottom_bar_get_mode (self);
#line 263 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = _tmp1_;
#line 263 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_ == HE_BOTTOM_BAR_MODE_FLOATING) {
#line 263 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = value == NULL;
#line 697 "BottomBar.c"
	} else {
#line 263 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = FALSE;
#line 701 "BottomBar.c"
	}
#line 263 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 264 "../lib/Widgets/BottomBar.vala"
		g_warning ("BottomBar.vala:264: overlay_widget must be set when using FLOATING mod" \
"e");
#line 265 "../lib/Widgets/BottomBar.vala"
		return;
#line 709 "BottomBar.c"
	}
#line 268 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_setup_overlay (self, value);
#line 262 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY]);
#line 715 "BottomBar.c"
}

/**
     * Add a child widget for Gtk.Builder support.
     *
     * This method is called automatically when using UI files or Blueprint.
     * It only accepts He.Button widgets as children.
     *
     * @param builder The Gtk.Builder instance (unused)
     * @param child The child widget to add (must be He.Button)
     * @param type Positioning hint: "left", "right", or null (defaults to left)
     */
static void
he_bottom_bar_real_add_child (GtkBuildable* base,
                              GtkBuilder* builder,
                              GObject* child,
                              const gchar* type)
{
	HeBottomBar * self;
	HeBottomBarPosition _tmp0_ = 0;
	HeBottomBarPosition position = 0;
#line 293 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) base;
#line 293 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (builder != NULL);
#line 293 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (child != NULL);
#line 294 "../lib/Widgets/BottomBar.vala"
	if (!HE_IS_BUTTON (child)) {
#line 295 "../lib/Widgets/BottomBar.vala"
		g_warning ("BottomBar.vala:295: BottomBar only accepts He.Button children");
#line 296 "../lib/Widgets/BottomBar.vala"
		return;
#line 749 "BottomBar.c"
	}
#line 299 "../lib/Widgets/BottomBar.vala"
	if (g_strcmp0 (type, "right") == 0) {
#line 299 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = HE_BOTTOM_BAR_POSITION_RIGHT;
#line 755 "BottomBar.c"
	} else {
#line 299 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = HE_BOTTOM_BAR_POSITION_LEFT;
#line 759 "BottomBar.c"
	}
#line 299 "../lib/Widgets/BottomBar.vala"
	position = _tmp0_;
#line 300 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_BUTTON, HeButton), position);
#line 765 "BottomBar.c"
}

/**
     * Create a new BottomBar in docked mode.
     *
     * The bottom bar will be created without title or description text.
     * Use the `title` and `description` properties to set content after creation.
     */
HeBottomBar*
he_bottom_bar_construct (GType object_type)
{
	HeBottomBar * self = NULL;
#line 310 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 309 "../lib/Widgets/BottomBar.vala"
	return self;
#line 782 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new (void)
{
#line 309 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct (HE_TYPE_BOTTOM_BAR);
#line 790 "BottomBar.c"
}

/**
     * Create a new BottomBar with title and description text.
     *
     * This is a convenience constructor that sets both the title and description
     * in a single call. The bottom bar will be in docked mode by default.
     *
     * @param title The main title text to display
     * @param description The secondary description text to display
     */
HeBottomBar*
he_bottom_bar_construct_with_details (GType object_type,
                                      const gchar* title,
                                      const gchar* description)
{
	HeBottomBar * self = NULL;
#line 322 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 322 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 323 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 324 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_title (self, title);
#line 325 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_description (self, description);
#line 322 "../lib/Widgets/BottomBar.vala"
	return self;
#line 820 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new_with_details (const gchar* title,
                                const gchar* description)
{
#line 322 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct_with_details (HE_TYPE_BOTTOM_BAR, title, description);
#line 829 "BottomBar.c"
}

/**
     * Create a new BottomBar in floating mode.
     *
     * This convenience constructor automatically sets the mode to FLOATING
     * and configures the overlay widget. The bottom bar will hover over
     * the specified widget with elevated styling.
     *
     * @param overlay_widget The widget to overlay the bottom bar on top of
     */
HeBottomBar*
he_bottom_bar_construct_floating (GType object_type,
                                  GtkWidget* overlay_widget)
{
	HeBottomBar * self = NULL;
#line 337 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (overlay_widget != NULL, NULL);
#line 338 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 339 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_mode (self, HE_BOTTOM_BAR_MODE_FLOATING);
#line 340 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_overlay_widget (self, overlay_widget);
#line 337 "../lib/Widgets/BottomBar.vala"
	return self;
#line 856 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new_floating (GtkWidget* overlay_widget)
{
#line 337 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct_floating (HE_TYPE_BOTTOM_BAR, overlay_widget);
#line 864 "BottomBar.c"
}

/**
     * Initialize CSS classes and styling properties.
     *
     * Sets up the base styling for title, description, and layout components.
     * Called once during widget construction.
     */
static void
he_bottom_bar_setup_styling (HeBottomBar* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
#line 361 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 362 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 362 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "title");
#line 363 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->description_label;
#line 363 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "dim-label");
#line 364 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "bottom-bar");
#line 366 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->center_box;
#line 366 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 367 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = self->priv->center_box;
#line 367 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 900 "BottomBar.c"
}

/**
     * Arrange the internal widget hierarchy.
     *
     * Creates the horizontal layout with left, center, and right sections.
     * Called once during widget construction.
     */
static void
he_bottom_bar_setup_layout (HeBottomBar* self)
{
	GtkBox* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkLabel* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
#line 376 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 377 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->center_box;
#line 377 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->title_label;
#line 377 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp0_, (GtkWidget*) _tmp1_);
#line 378 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->center_box;
#line 378 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = self->priv->description_label;
#line 378 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp2_, (GtkWidget*) _tmp3_);
#line 380 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = self->priv->main_box;
#line 380 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = self->priv->left_box;
#line 380 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp4_, (GtkWidget*) _tmp5_);
#line 381 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = self->priv->main_box;
#line 381 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = self->priv->center_box;
#line 381 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
#line 382 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = self->priv->main_box;
#line 382 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = self->priv->right_box;
#line 382 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
#line 384 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->main_box;
#line 384 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp10_, (GtkWidget*) self);
#line 959 "BottomBar.c"
}

/**
     * Update CSS classes based on current mode.
     *
     * Removes previous mode classes and applies the current mode class.
     * This triggers CSS transitions and styling changes.
     */
static void
he_bottom_bar_update_mode_styling (HeBottomBar* self)
{
#line 393 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 394 "../lib/Widgets/BottomBar.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "docked");
#line 395 "../lib/Widgets/BottomBar.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "floating");
#line 397 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_mode == HE_BOTTOM_BAR_MODE_DOCKED) {
#line 398 "../lib/Widgets/BottomBar.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "docked");
#line 981 "BottomBar.c"
	} else {
#line 400 "../lib/Widgets/BottomBar.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "floating");
#line 985 "BottomBar.c"
	}
}

/**
     * Update CSS classes based on current style.
     *
     * Removes previous style classes and applies the current style class.
     * Only applies "vibrant" class when style is VIBRANT.
     */
static void
he_bottom_bar_update_style_classes (HeBottomBar* self)
{
#line 410 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 411 "../lib/Widgets/BottomBar.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "vibrant");
#line 413 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_style == HE_BOTTOM_BAR_STYLE_VIBRANT) {
#line 414 "../lib/Widgets/BottomBar.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "vibrant");
#line 1006 "BottomBar.c"
	}
}

/**
     * Update layout orientation based on floating position.
     *
     * Changes the main box orientation and alignment based on whether
     * the floating bar is positioned horizontally or vertically.
     * Also hides title and description in vertical mode and adjusts
     * internal box orientations and alignments.
     */
static void
he_bottom_bar_update_layout_orientation (HeBottomBar* self)
{
	gboolean _tmp0_ = FALSE;
#line 426 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 427 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_floating_position == HE_BOTTOM_BAR_FLOATING_POSITION_LEFT) {
#line 427 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = TRUE;
#line 1028 "BottomBar.c"
	} else {
#line 427 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = self->priv->_floating_position == HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT;
#line 1032 "BottomBar.c"
	}
#line 427 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 1036 "BottomBar.c"
		GtkBox* _tmp1_;
		GtkBox* _tmp2_;
		GtkBox* _tmp3_;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		GtkBox* _tmp6_;
		GtkBox* _tmp7_;
		GtkBox* _tmp8_;
		GtkBox* _tmp9_;
		GtkBox* _tmp10_;
		GtkBox* _tmp11_;
		GtkLabel* _tmp12_;
		GtkLabel* _tmp13_;
#line 429 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->main_box;
#line 429 "../lib/Widgets/BottomBar.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp1_, GTK_ORIENTATION_VERTICAL);
#line 430 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->main_box;
#line 430 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 431 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = self->priv->main_box;
#line 431 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
#line 433 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_apply_floating_position_settings (self);
#line 436 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->left_box;
#line 436 "../lib/Widgets/BottomBar.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp4_, GTK_ORIENTATION_VERTICAL);
#line 437 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = self->priv->right_box;
#line 437 "../lib/Widgets/BottomBar.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp5_, GTK_ORIENTATION_VERTICAL);
#line 440 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->left_box;
#line 440 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 441 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = self->priv->right_box;
#line 441 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 442 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = self->priv->left_box;
#line 442 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
#line 443 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = self->priv->right_box;
#line 443 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
#line 446 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = self->priv->center_box;
#line 446 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 447 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = self->priv->center_box;
#line 447 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 450 "../lib/Widgets/BottomBar.vala"
		_tmp12_ = self->priv->title_label;
#line 450 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
#line 451 "../lib/Widgets/BottomBar.vala"
		_tmp13_ = self->priv->description_label;
#line 451 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 1104 "BottomBar.c"
	} else {
		GtkBox* _tmp14_;
		GtkBox* _tmp15_;
		GtkBox* _tmp16_;
		GtkBox* _tmp17_;
		GtkBox* _tmp18_;
		GtkBox* _tmp19_;
		GtkBox* _tmp20_;
		GtkBox* _tmp21_;
		GtkBox* _tmp22_;
		GtkBox* _tmp23_;
		GtkBox* _tmp24_;
		GtkLabel* _tmp25_;
		GtkLabel* _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		GtkLabel* _tmp30_;
		GtkLabel* _tmp31_;
		const gchar* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
#line 454 "../lib/Widgets/BottomBar.vala"
		_tmp14_ = self->priv->main_box;
#line 454 "../lib/Widgets/BottomBar.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp14_, GTK_ORIENTATION_HORIZONTAL);
#line 455 "../lib/Widgets/BottomBar.vala"
		_tmp15_ = self->priv->main_box;
#line 455 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_FILL);
#line 456 "../lib/Widgets/BottomBar.vala"
		_tmp16_ = self->priv->main_box;
#line 456 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_FILL);
#line 458 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_apply_floating_position_settings (self);
#line 461 "../lib/Widgets/BottomBar.vala"
		_tmp17_ = self->priv->left_box;
#line 461 "../lib/Widgets/BottomBar.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp17_, GTK_ORIENTATION_HORIZONTAL);
#line 462 "../lib/Widgets/BottomBar.vala"
		_tmp18_ = self->priv->right_box;
#line 462 "../lib/Widgets/BottomBar.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_HORIZONTAL);
#line 465 "../lib/Widgets/BottomBar.vala"
		_tmp19_ = self->priv->left_box;
#line 465 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
#line 466 "../lib/Widgets/BottomBar.vala"
		_tmp20_ = self->priv->right_box;
#line 466 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_END);
#line 467 "../lib/Widgets/BottomBar.vala"
		_tmp21_ = self->priv->left_box;
#line 467 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_CENTER);
#line 468 "../lib/Widgets/BottomBar.vala"
		_tmp22_ = self->priv->right_box;
#line 468 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_CENTER);
#line 471 "../lib/Widgets/BottomBar.vala"
		_tmp23_ = self->priv->center_box;
#line 471 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
#line 472 "../lib/Widgets/BottomBar.vala"
		_tmp24_ = self->priv->center_box;
#line 472 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_FILL);
#line 475 "../lib/Widgets/BottomBar.vala"
		_tmp25_ = self->priv->title_label;
#line 475 "../lib/Widgets/BottomBar.vala"
		_tmp26_ = self->priv->title_label;
#line 475 "../lib/Widgets/BottomBar.vala"
		_tmp27_ = gtk_label_get_text (_tmp26_);
#line 475 "../lib/Widgets/BottomBar.vala"
		_tmp28_ = strlen (_tmp27_);
#line 475 "../lib/Widgets/BottomBar.vala"
		_tmp29_ = _tmp28_;
#line 475 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp25_, _tmp29_ > 0);
#line 476 "../lib/Widgets/BottomBar.vala"
		_tmp30_ = self->priv->description_label;
#line 476 "../lib/Widgets/BottomBar.vala"
		_tmp31_ = self->priv->description_label;
#line 476 "../lib/Widgets/BottomBar.vala"
		_tmp32_ = gtk_label_get_text (_tmp31_);
#line 476 "../lib/Widgets/BottomBar.vala"
		_tmp33_ = strlen (_tmp32_);
#line 476 "../lib/Widgets/BottomBar.vala"
		_tmp34_ = _tmp33_;
#line 476 "../lib/Widgets/BottomBar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp30_, _tmp34_ > 0);
#line 1197 "BottomBar.c"
	}
}

/**
     * Configure overlay positioning for floating mode.
     *
     * Creates or uses an existing Gtk.Overlay to position the bottom bar
     * over the target widget. Handles widget reparenting automatically.
     *
     * @param target_widget The widget to overlay, or null to clear overlay
     */
static void
he_bottom_bar_setup_overlay (HeBottomBar* self,
                             GtkWidget* target_widget)
{
	HeBottomBarMode _tmp0_;
	HeBottomBarMode _tmp1_;
	GtkWidget* _tmp2_;
	GtkOverlay* _tmp11_;
#line 488 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 489 "../lib/Widgets/BottomBar.vala"
	if (target_widget == NULL) {
#line 489 "../lib/Widgets/BottomBar.vala"
		return;
#line 1223 "BottomBar.c"
	}
#line 492 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = he_bottom_bar_get_mode (self);
#line 492 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = _tmp0_;
#line 492 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_ != HE_BOTTOM_BAR_MODE_FLOATING) {
#line 492 "../lib/Widgets/BottomBar.vala"
		return;
#line 1233 "BottomBar.c"
	}
#line 495 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_remove_from_overlay (self);
#line 498 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 498 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_ != NULL) {
#line 499 "../lib/Widgets/BottomBar.vala"
		gtk_widget_unparent ((GtkWidget*) self);
#line 1243 "BottomBar.c"
	}
#line 503 "../lib/Widgets/BottomBar.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (target_widget, gtk_overlay_get_type ())) {
#line 1247 "BottomBar.c"
		GtkWidget* parent = NULL;
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
#line 504 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = gtk_widget_get_parent (target_widget);
#line 504 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 504 "../lib/Widgets/BottomBar.vala"
		parent = _tmp4_;
#line 505 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = parent;
#line 505 "../lib/Widgets/BottomBar.vala"
		if (_tmp5_ != NULL) {
#line 1262 "BottomBar.c"
			GtkOverlay* _tmp6_;
			GtkOverlay* _tmp7_;
			GtkOverlay* _tmp8_;
			GtkWidget* _tmp9_;
#line 506 "../lib/Widgets/BottomBar.vala"
			_tmp6_ = (GtkOverlay*) gtk_overlay_new ();
#line 506 "../lib/Widgets/BottomBar.vala"
			g_object_ref_sink (_tmp6_);
#line 506 "../lib/Widgets/BottomBar.vala"
			_g_object_unref0 (self->priv->overlay_parent);
#line 506 "../lib/Widgets/BottomBar.vala"
			self->priv->overlay_parent = _tmp6_;
#line 507 "../lib/Widgets/BottomBar.vala"
			gtk_widget_unparent (target_widget);
#line 508 "../lib/Widgets/BottomBar.vala"
			_tmp7_ = self->priv->overlay_parent;
#line 508 "../lib/Widgets/BottomBar.vala"
			gtk_overlay_set_child (_tmp7_, target_widget);
#line 511 "../lib/Widgets/BottomBar.vala"
			_tmp8_ = self->priv->overlay_parent;
#line 511 "../lib/Widgets/BottomBar.vala"
			_tmp9_ = parent;
#line 511 "../lib/Widgets/BottomBar.vala"
			he_bottom_bar_reparent_overlay_to_container (self, _tmp8_, _tmp9_);
#line 1287 "BottomBar.c"
		}
#line 503 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (parent);
#line 1291 "BottomBar.c"
	} else {
		GtkOverlay* _tmp10_;
#line 515 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (target_widget, gtk_overlay_get_type (), GtkOverlay));
#line 515 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (self->priv->overlay_parent);
#line 515 "../lib/Widgets/BottomBar.vala"
		self->priv->overlay_parent = _tmp10_;
#line 1300 "BottomBar.c"
	}
#line 518 "../lib/Widgets/BottomBar.vala"
	_tmp11_ = self->priv->overlay_parent;
#line 518 "../lib/Widgets/BottomBar.vala"
	if (_tmp11_ != NULL) {
#line 1306 "BottomBar.c"
		GtkOverlay* _tmp12_;
#line 519 "../lib/Widgets/BottomBar.vala"
		_tmp12_ = self->priv->overlay_parent;
#line 519 "../lib/Widgets/BottomBar.vala"
		gtk_overlay_add_overlay (_tmp12_, (GtkWidget*) self);
#line 520 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_apply_floating_position_settings (self);
#line 1314 "BottomBar.c"
	}
}

/**
     * Apply alignment and margin settings based on floating position.
     *
     * Configures the widget alignment and margins to position the floating
     * bottom bar at the specified edge of the overlay.
     */
static void
he_bottom_bar_apply_floating_position_settings (HeBottomBar* self)
{
	HeOverlayButton* _tmp0_;
#line 530 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 532 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 0);
#line 533 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 0);
#line 534 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 0);
#line 535 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 0);
#line 537 "../lib/Widgets/BottomBar.vala"
	switch (self->priv->_floating_position) {
#line 537 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_BOTTOM:
#line 1342 "BottomBar.c"
		{
#line 539 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 540 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
#line 541 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_start ((GtkWidget*) self, 12);
#line 542 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_end ((GtkWidget*) self, 12);
#line 543 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) self, 12);
#line 544 "../lib/Widgets/BottomBar.vala"
			break;
#line 1356 "BottomBar.c"
		}
#line 537 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_LEFT:
#line 1360 "BottomBar.c"
		{
#line 547 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_START);
#line 548 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 549 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_start ((GtkWidget*) self, 12);
#line 550 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_top ((GtkWidget*) self, 12);
#line 551 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) self, 12);
#line 552 "../lib/Widgets/BottomBar.vala"
			break;
#line 1374 "BottomBar.c"
		}
#line 537 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT:
#line 1378 "BottomBar.c"
		{
#line 555 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_END);
#line 556 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 557 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_end ((GtkWidget*) self, 12);
#line 558 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_top ((GtkWidget*) self, 12);
#line 559 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) self, 12);
#line 560 "../lib/Widgets/BottomBar.vala"
			break;
#line 1392 "BottomBar.c"
		}
		default:
#line 537 "../lib/Widgets/BottomBar.vala"
		break;
#line 1397 "BottomBar.c"
	}
#line 564 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->_overlay_button;
#line 564 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_ != NULL) {
#line 565 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_setup_overlay_button (self);
#line 1405 "BottomBar.c"
	}
}

/**
     * Setup the overlay button positioning when in floating mode.
     *
     * Positions the overlay button 18px away from the bottom bar based on
     * the current floating_position setting.
     */
static void
he_bottom_bar_setup_overlay_button (HeBottomBar* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HeOverlayButton* _tmp2_;
	HeOverlayButton* _tmp4_;
	GtkWidget* _tmp5_;
	GtkOverlay* _tmp6_;
	GtkOverlay* _tmp9_;
	HeOverlayButton* _tmp10_;
#line 575 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 576 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->_overlay_button;
#line 576 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_ == NULL) {
#line 576 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = TRUE;
#line 1434 "BottomBar.c"
	} else {
		GtkOverlay* _tmp3_;
#line 576 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = self->priv->overlay_parent;
#line 576 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1441 "BottomBar.c"
	}
#line 576 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_) {
#line 576 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = TRUE;
#line 1447 "BottomBar.c"
	} else {
#line 576 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = self->priv->_mode != HE_BOTTOM_BAR_MODE_FLOATING;
#line 1451 "BottomBar.c"
	}
#line 576 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 577 "../lib/Widgets/BottomBar.vala"
		return;
#line 1457 "BottomBar.c"
	}
#line 581 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = self->priv->_overlay_button;
#line 581 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
#line 581 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = self->priv->overlay_parent;
#line 581 "../lib/Widgets/BottomBar.vala"
	if (_tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
#line 1467 "BottomBar.c"
		GtkOverlay* _tmp7_;
		HeOverlayButton* _tmp8_;
#line 582 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = self->priv->overlay_parent;
#line 582 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = self->priv->_overlay_button;
#line 582 "../lib/Widgets/BottomBar.vala"
		gtk_overlay_remove_overlay (_tmp7_, (GtkWidget*) _tmp8_);
#line 1476 "BottomBar.c"
	}
#line 586 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = self->priv->overlay_parent;
#line 586 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->_overlay_button;
#line 586 "../lib/Widgets/BottomBar.vala"
	gtk_overlay_add_overlay (_tmp9_, (GtkWidget*) _tmp10_);
#line 587 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_apply_overlay_button_positioning (self);
#line 1486 "BottomBar.c"
}

/**
     * Apply positioning settings to the overlay button based on floating position.
     *
     * Positions the button 18px away from the bottom bar in the appropriate direction.
     */
static void
he_bottom_bar_apply_overlay_button_positioning (HeBottomBar* self)
{
	HeOverlayButton* _tmp0_;
	HeOverlayButton* _tmp1_;
	HeOverlayButton* _tmp2_;
	HeOverlayButton* _tmp3_;
	HeOverlayButton* _tmp4_;
#line 595 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 596 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->_overlay_button;
#line 596 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_ == NULL) {
#line 596 "../lib/Widgets/BottomBar.vala"
		return;
#line 1510 "BottomBar.c"
	}
#line 599 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->_overlay_button;
#line 599 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp1_, 0);
#line 600 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->_overlay_button;
#line 600 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 0);
#line 601 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = self->priv->_overlay_button;
#line 601 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp3_, 0);
#line 602 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = self->priv->_overlay_button;
#line 602 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 0);
#line 604 "../lib/Widgets/BottomBar.vala"
	switch (self->priv->_floating_position) {
#line 604 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_BOTTOM:
#line 1532 "BottomBar.c"
		{
			HeOverlayButton* _tmp5_;
			HeOverlayButton* _tmp6_;
			HeOverlayButton* _tmp7_;
			HeOverlayButton* _tmp8_;
#line 607 "../lib/Widgets/BottomBar.vala"
			_tmp5_ = self->priv->_overlay_button;
#line 607 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 608 "../lib/Widgets/BottomBar.vala"
			_tmp6_ = self->priv->_overlay_button;
#line 608 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
#line 609 "../lib/Widgets/BottomBar.vala"
			_tmp7_ = self->priv->_overlay_button;
#line 609 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_end ((GtkWidget*) _tmp7_, 12 - 18);
#line 610 "../lib/Widgets/BottomBar.vala"
			_tmp8_ = self->priv->_overlay_button;
#line 610 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp8_, 12);
#line 611 "../lib/Widgets/BottomBar.vala"
			break;
#line 1556 "BottomBar.c"
		}
#line 604 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_LEFT:
#line 1560 "BottomBar.c"
		{
			HeOverlayButton* _tmp9_;
			HeOverlayButton* _tmp10_;
			HeOverlayButton* _tmp11_;
			HeOverlayButton* _tmp12_;
#line 615 "../lib/Widgets/BottomBar.vala"
			_tmp9_ = self->priv->_overlay_button;
#line 615 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_START);
#line 616 "../lib/Widgets/BottomBar.vala"
			_tmp10_ = self->priv->_overlay_button;
#line 616 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
#line 617 "../lib/Widgets/BottomBar.vala"
			_tmp11_ = self->priv->_overlay_button;
#line 617 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 12);
#line 618 "../lib/Widgets/BottomBar.vala"
			_tmp12_ = self->priv->_overlay_button;
#line 618 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp12_, (12 + gtk_widget_get_allocated_height ((GtkWidget*) self)) + 18);
#line 619 "../lib/Widgets/BottomBar.vala"
			break;
#line 1584 "BottomBar.c"
		}
#line 604 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_RIGHT:
#line 1588 "BottomBar.c"
		{
			HeOverlayButton* _tmp13_;
			HeOverlayButton* _tmp14_;
			HeOverlayButton* _tmp15_;
			HeOverlayButton* _tmp16_;
#line 623 "../lib/Widgets/BottomBar.vala"
			_tmp13_ = self->priv->_overlay_button;
#line 623 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_END);
#line 624 "../lib/Widgets/BottomBar.vala"
			_tmp14_ = self->priv->_overlay_button;
#line 624 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_END);
#line 625 "../lib/Widgets/BottomBar.vala"
			_tmp15_ = self->priv->_overlay_button;
#line 625 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_end ((GtkWidget*) _tmp15_, 12);
#line 626 "../lib/Widgets/BottomBar.vala"
			_tmp16_ = self->priv->_overlay_button;
#line 626 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp16_, (12 + gtk_widget_get_allocated_height ((GtkWidget*) self)) + 18);
#line 627 "../lib/Widgets/BottomBar.vala"
			break;
#line 1612 "BottomBar.c"
		}
		default:
#line 604 "../lib/Widgets/BottomBar.vala"
		break;
#line 1617 "BottomBar.c"
	}
}

/**
     * Remove the overlay button from the overlay parent.
     */
static void
he_bottom_bar_remove_overlay_button (HeBottomBar* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HeOverlayButton* _tmp2_;
#line 634 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 635 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->_overlay_button;
#line 635 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_ != NULL) {
#line 1636 "BottomBar.c"
		GtkOverlay* _tmp3_;
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = self->priv->overlay_parent;
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 1642 "BottomBar.c"
	} else {
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = FALSE;
#line 1646 "BottomBar.c"
	}
#line 635 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_) {
#line 1650 "BottomBar.c"
		HeOverlayButton* _tmp4_;
		GtkWidget* _tmp5_;
		GtkOverlay* _tmp6_;
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->_overlay_button;
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->overlay_parent;
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget);
#line 1662 "BottomBar.c"
	} else {
#line 635 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = FALSE;
#line 1666 "BottomBar.c"
	}
#line 635 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 1670 "BottomBar.c"
		GtkOverlay* _tmp7_;
		HeOverlayButton* _tmp8_;
#line 636 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = self->priv->overlay_parent;
#line 636 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = self->priv->_overlay_button;
#line 636 "../lib/Widgets/BottomBar.vala"
		gtk_overlay_remove_overlay (_tmp7_, (GtkWidget*) _tmp8_);
#line 1679 "BottomBar.c"
	}
}

/**
     * Simple method to reparent the overlay to various container types.
     *
     * @param overlay The overlay widget to reparent
     * @param container The parent container
     */
static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 652 "../lib/Widgets/BottomBar.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 1694 "BottomBar.c"
}

static void
he_bottom_bar_reparent_overlay_to_container (HeBottomBar* self,
                                             GtkOverlay* overlay,
                                             GtkWidget* container)
{
#line 646 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 646 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (overlay != NULL);
#line 646 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (container != NULL);
#line 648 "../lib/Widgets/BottomBar.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (container, gtk_box_get_type ())) {
#line 649 "../lib/Widgets/BottomBar.vala"
		gtk_box_append (G_TYPE_CHECK_INSTANCE_CAST (container, gtk_box_get_type (), GtkBox), (GtkWidget*) overlay);
#line 1712 "BottomBar.c"
	} else {
		GParamSpec* child_prop = NULL;
		GObjectClass* _tmp0_;
		GParamSpec* _tmp1_;
		GParamSpec* _tmp2_;
		GParamSpec* _tmp3_;
#line 652 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) container);
#line 652 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = g_object_class_find_property (_tmp0_, "child");
#line 652 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _g_param_spec_ref0 (_tmp1_);
#line 652 "../lib/Widgets/BottomBar.vala"
		child_prop = _tmp2_;
#line 653 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = child_prop;
#line 653 "../lib/Widgets/BottomBar.vala"
		if (_tmp3_ != NULL) {
#line 1731 "BottomBar.c"
			GValue _tmp4_ = {0};
#line 654 "../lib/Widgets/BottomBar.vala"
			g_value_init (&_tmp4_, gtk_overlay_get_type ());
#line 654 "../lib/Widgets/BottomBar.vala"
			g_value_set_object (&_tmp4_, overlay);
#line 654 "../lib/Widgets/BottomBar.vala"
			g_object_set_property ((GObject*) container, "child", &_tmp4_);
#line 654 "../lib/Widgets/BottomBar.vala"
			G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 1741 "BottomBar.c"
		} else {
			const gchar* _tmp5_;
#line 656 "../lib/Widgets/BottomBar.vala"
			_tmp5_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) container));
#line 656 "../lib/Widgets/BottomBar.vala"
			g_warning ("BottomBar.vala:656: Container type %s does not support floating Bottom" \
"Bar", _tmp5_);
#line 1748 "BottomBar.c"
		}
#line 648 "../lib/Widgets/BottomBar.vala"
		_g_param_spec_unref0 (child_prop);
#line 1752 "BottomBar.c"
	}
}

/**
     * Remove the bottom bar from any overlay parent.
     */
static void
he_bottom_bar_remove_from_overlay (HeBottomBar* self)
{
	gboolean _tmp0_ = FALSE;
	GtkOverlay* _tmp1_;
#line 665 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 667 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_remove_overlay_button (self);
#line 669 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->overlay_parent;
#line 669 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_ != NULL) {
#line 1772 "BottomBar.c"
		GtkWidget* _tmp2_;
		GtkOverlay* _tmp3_;
#line 669 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 669 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = self->priv->overlay_parent;
#line 669 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget);
#line 1781 "BottomBar.c"
	} else {
#line 669 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = FALSE;
#line 1785 "BottomBar.c"
	}
#line 669 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 1789 "BottomBar.c"
		GtkOverlay* _tmp4_;
#line 670 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->overlay_parent;
#line 670 "../lib/Widgets/BottomBar.vala"
		gtk_overlay_remove_overlay (_tmp4_, (GtkWidget*) self);
#line 1795 "BottomBar.c"
	}
#line 674 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 0);
#line 675 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 0);
#line 676 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 0);
#line 677 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 0);
#line 1805 "BottomBar.c"
}

/**
     * Add a button to the end of the bottom bar.
     *
     * The button is added to the specified position (left or right side)
     * after any existing buttons in that position.
     *
     * @param button The He.Button to add to the bottom bar
     * @param position Which side of the bar to add the button to
     *
     */
void
he_bottom_bar_append_button (HeBottomBar* self,
                             HeButton* button,
                             HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
#line 697 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 697 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 698 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 1832 "BottomBar.c"
		GtkBox* _tmp1_;
#line 698 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 698 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 1838 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 698 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 698 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 1845 "BottomBar.c"
	}
#line 698 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 698 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 699 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (target_box, (GtkWidget*) button);
#line 697 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 1855 "BottomBar.c"
}

/**
     * Add a button to the beginning of the bottom bar.
     *
     * The button is added to the specified position (left or right side)
     * before any existing buttons in that position.
     *
     * @param button The He.Button to add to the bottom bar
     * @param position Which side of the bar to add the button to
     *
     */
void
he_bottom_bar_prepend_button (HeBottomBar* self,
                              HeButton* button,
                              HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
#line 712 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 712 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 713 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 1882 "BottomBar.c"
		GtkBox* _tmp1_;
#line 713 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 713 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 1888 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 713 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 713 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 1895 "BottomBar.c"
	}
#line 713 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 713 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 714 "../lib/Widgets/BottomBar.vala"
	gtk_box_prepend (target_box, (GtkWidget*) button);
#line 712 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 1905 "BottomBar.c"
}

/**
     * Remove a button from the bottom bar.
     *
     * The button is removed from whichever position it's currently in.
     * If the button is not a child of this bottom bar, no action is taken.
     *
     * @param button The He.Button to remove from the bottom bar
     *
     */
void
he_bottom_bar_remove_button (HeBottomBar* self,
                             HeButton* button)
{
	GtkWidget* parent = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_;
#line 726 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 726 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 727 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) button);
#line 727 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 727 "../lib/Widgets/BottomBar.vala"
	parent = _tmp1_;
#line 728 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = parent;
#line 728 "../lib/Widgets/BottomBar.vala"
	if (_tmp3_ != NULL) {
#line 1940 "BottomBar.c"
		gboolean _tmp4_ = FALSE;
		GtkWidget* _tmp5_;
		GtkBox* _tmp6_;
#line 728 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = parent;
#line 728 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->left_box;
#line 728 "../lib/Widgets/BottomBar.vala"
		if (_tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
#line 728 "../lib/Widgets/BottomBar.vala"
			_tmp4_ = TRUE;
#line 1952 "BottomBar.c"
		} else {
			GtkWidget* _tmp7_;
			GtkBox* _tmp8_;
#line 728 "../lib/Widgets/BottomBar.vala"
			_tmp7_ = parent;
#line 728 "../lib/Widgets/BottomBar.vala"
			_tmp8_ = self->priv->right_box;
#line 728 "../lib/Widgets/BottomBar.vala"
			_tmp4_ = _tmp7_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget);
#line 1962 "BottomBar.c"
		}
#line 728 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _tmp4_;
#line 1966 "BottomBar.c"
	} else {
#line 728 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = FALSE;
#line 1970 "BottomBar.c"
	}
#line 728 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_) {
#line 1974 "BottomBar.c"
		GtkWidget* _tmp9_;
#line 729 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = parent;
#line 729 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_box_get_type (), GtkBox), (GtkWidget*) button);
#line 1980 "BottomBar.c"
	}
#line 726 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (parent);
#line 1984 "BottomBar.c"
}

/**
     * Insert a button after another button.
     *
     * The new button is inserted immediately after the reference button
     * in the specified position. Both buttons must be in the same position.
     *
     * @param button The He.Button to insert
     * @param after The existing He.Button to insert after
     * @param position Which side of the bar to insert the button into
     *
     */
void
he_bottom_bar_insert_button_after (HeBottomBar* self,
                                   HeButton* button,
                                   HeButton* after,
                                   HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
#line 744 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 744 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 744 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (after != NULL);
#line 745 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 2015 "BottomBar.c"
		GtkBox* _tmp1_;
#line 745 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 745 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 2021 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 745 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 745 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 2028 "BottomBar.c"
	}
#line 745 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 745 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 746 "../lib/Widgets/BottomBar.vala"
	gtk_box_insert_child_after (target_box, (GtkWidget*) button, (GtkWidget*) after);
#line 744 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 2038 "BottomBar.c"
}

/**
     * Remove all buttons from the bottom bar.
     *
     * This removes all buttons from both the left and right sides of the bar.
     * The buttons are unparented but not destroyed, so they can be reused.
     *
     */
void
he_bottom_bar_clear_buttons (HeBottomBar* self)
{
	GtkWidget* child = NULL;
#line 756 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 759 "../lib/Widgets/BottomBar.vala"
	while (TRUE) {
#line 2056 "BottomBar.c"
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
#line 759 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = self->priv->left_box;
#line 759 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 759 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 759 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (child);
#line 759 "../lib/Widgets/BottomBar.vala"
		child = _tmp2_;
#line 759 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = child;
#line 759 "../lib/Widgets/BottomBar.vala"
		if (!(_tmp3_ != NULL)) {
#line 759 "../lib/Widgets/BottomBar.vala"
			break;
#line 2079 "BottomBar.c"
		}
#line 760 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->left_box;
#line 760 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = child;
#line 760 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp4_, _tmp5_);
#line 2087 "BottomBar.c"
	}
#line 763 "../lib/Widgets/BottomBar.vala"
	while (TRUE) {
#line 2091 "BottomBar.c"
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
		GtkBox* _tmp10_;
		GtkWidget* _tmp11_;
#line 763 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->right_box;
#line 763 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = gtk_widget_get_first_child ((GtkWidget*) _tmp6_);
#line 763 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 763 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (child);
#line 763 "../lib/Widgets/BottomBar.vala"
		child = _tmp8_;
#line 763 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = child;
#line 763 "../lib/Widgets/BottomBar.vala"
		if (!(_tmp9_ != NULL)) {
#line 763 "../lib/Widgets/BottomBar.vala"
			break;
#line 2114 "BottomBar.c"
		}
#line 764 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = self->priv->right_box;
#line 764 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = child;
#line 764 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp10_, _tmp11_);
#line 2122 "BottomBar.c"
	}
#line 756 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (child);
#line 2126 "BottomBar.c"
}

/**
     * Get the number of buttons in a specific position.
     *
     * This counts all He.Button widgets currently added to the specified
     * side of the bottom bar.
     *
     * @param position Which side of the bar to count buttons for
     * @return The number of buttons in the specified position
     *
     */
gint
he_bottom_bar_get_button_count (HeBottomBar* self,
                                HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
	gint count = 0;
	GtkWidget* child = NULL;
	GtkBox* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	gint result;
#line 778 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 779 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 2156 "BottomBar.c"
		GtkBox* _tmp1_;
#line 779 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 779 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 2162 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 779 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 779 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 2169 "BottomBar.c"
	}
#line 779 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 779 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 780 "../lib/Widgets/BottomBar.vala"
	count = 0;
#line 782 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = target_box;
#line 782 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = gtk_widget_get_first_child ((GtkWidget*) _tmp4_);
#line 782 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 782 "../lib/Widgets/BottomBar.vala"
	child = _tmp6_;
#line 783 "../lib/Widgets/BottomBar.vala"
	while (TRUE) {
#line 2187 "BottomBar.c"
		GtkWidget* _tmp7_;
		gint _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
#line 783 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = child;
#line 783 "../lib/Widgets/BottomBar.vala"
		if (!(_tmp7_ != NULL)) {
#line 783 "../lib/Widgets/BottomBar.vala"
			break;
#line 2199 "BottomBar.c"
		}
#line 784 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = count;
#line 784 "../lib/Widgets/BottomBar.vala"
		count = _tmp8_ + 1;
#line 785 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = child;
#line 785 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = gtk_widget_get_next_sibling (_tmp9_);
#line 785 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 785 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (child);
#line 785 "../lib/Widgets/BottomBar.vala"
		child = _tmp11_;
#line 2215 "BottomBar.c"
	}
#line 788 "../lib/Widgets/BottomBar.vala"
	result = count;
#line 788 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (child);
#line 788 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 788 "../lib/Widgets/BottomBar.vala"
	return result;
#line 2225 "BottomBar.c"
}

static GObject *
he_bottom_bar_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeBottomBar * self;
#line 347 "../lib/Widgets/BottomBar.vala"
	parent_class = G_OBJECT_CLASS (he_bottom_bar_parent_class);
#line 347 "../lib/Widgets/BottomBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 347 "../lib/Widgets/BottomBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 348 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_setup_styling (self);
#line 349 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_setup_layout (self);
#line 350 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_mode_styling (self);
#line 351 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_style_classes (self);
#line 352 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_layout_orientation (self);
#line 347 "../lib/Widgets/BottomBar.vala"
	return obj;
#line 2254 "BottomBar.c"
}

static void
he_bottom_bar_class_init (HeBottomBarClass * klass,
                          gpointer klass_data)
{
#line 44 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_parent_class = g_type_class_peek_parent (klass);
#line 44 "../lib/Widgets/BottomBar.vala"
	g_type_class_adjust_private_offset (klass, &HeBottomBar_private_offset);
#line 44 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_bottom_bar_get_property;
#line 44 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_bottom_bar_set_property;
#line 44 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->constructor = he_bottom_bar_constructor;
#line 44 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->finalize = he_bottom_bar_finalize;
#line 2273 "BottomBar.c"
	/**
	     * The main title text displayed in the center of the bottom bar.
	     * This is ideal for showing the current context or selection state,
	     * such as "Photos" or "3 items selected".
	     *
	     * Note: Title is hidden when in vertical mode (LEFT/RIGHT positioning).
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_TITLE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2283 "BottomBar.c"
	/**
	     * An optional overlay button that appears near the bottom bar when in floating mode.
	     *
	     * When set, this button will be positioned 18px away from the floating bottom bar.
	     * The positioning depends on the floating_position:
	     * - BOTTOM: Button appears 18px to the right of the bar
	     * - LEFT: Button appears 18px above the bar
	     * - RIGHT: Button appears 18px above the bar
	     *
	     * The overlay button is only visible when the BottomBar is in FLOATING mode.
	     * Setting this to null removes the overlay button.
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_OVERLAY_BUTTON_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_OVERLAY_BUTTON_PROPERTY] = g_param_spec_object ("overlay-button", "overlay-button", "overlay-button", HE_TYPE_OVERLAY_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2298 "BottomBar.c"
	/**
	     * The secondary description text displayed below the title.
	     * This is ideal for showing additional context or action hints,
	     * such as "Tap to select items" or "Ready to share".
	     *
	     * Note: Description is hidden when in vertical mode (LEFT/RIGHT positioning).
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_DESCRIPTION_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2308 "BottomBar.c"
	/**
	     * The current display mode of the bottom bar.
	     *
	     * Changing this property automatically updates the CSS classes and positioning.
	     * When switching to FLOATING mode, ensure `overlay_widget` is set.
	     * The overlay_button is only shown in FLOATING mode.
	     *
	     * CSS Classes
	     * - `docked` class is applied when mode is DOCKED
	     * - `floating` class is applied when mode is FLOATING
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_MODE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", HE_BOTTOM_BAR_TYPE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2322 "BottomBar.c"
	/**
	     * The current visual style of the bottom bar.
	     *
	     * Changing this property automatically updates the CSS classes to apply
	     * the appropriate theming and visual effects.
	     *
	     * CSS Classes
	     * - No additional class is applied when style is DEFAULT
	     * - `vibrant` class is applied when style is VIBRANT
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_STYLE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_STYLE_PROPERTY] = g_param_spec_enum ("style", "style", "style", HE_BOTTOM_BAR_TYPE_STYLE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2335 "BottomBar.c"
	/**
	     * The position of the bottom bar when in floating mode.
	     *
	     * This property determines where the floating bottom bar is positioned
	     * relative to the overlay widget. Only affects appearance in FLOATING mode.
	     * Also repositions the overlay_button if present.
	     *
	     * Position Behavior
	     * - BOTTOM: Positioned at bottom with horizontal layout (default)
	     * - LEFT: Positioned at left edge with vertical layout
	     * - RIGHT: Positioned at right edge with vertical layout
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_FLOATING_POSITION_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_FLOATING_POSITION_PROPERTY] = g_param_spec_enum ("floating-position", "floating-position", "floating-position", HE_BOTTOM_BAR_TYPE_FLOATING_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2350 "BottomBar.c"
	/**
	     * The widget to overlay when in floating mode.
	     *
	     * This property is **required** when using FLOATING mode. The bottom bar
	     * will be positioned as an overlay on top of this widget.
	     *
	     * Behavior
	     * - If the target widget is not already in a Gtk.Overlay, one will be created automatically
	     * - The overlay is inserted into the widget hierarchy, preserving the original structure
	     * - Setting this to `null` while in FLOATING mode will show a warning
	     */
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY] = g_param_spec_object ("overlay-widget", "overlay-widget", "overlay-widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 344 "../lib/Widgets/BottomBar.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 2366 "BottomBar.c"
}

static void
he_bottom_bar_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                            gpointer iface_data)
{
#line 44 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 44 "../lib/Widgets/BottomBar.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_bottom_bar_real_add_child;
#line 2377 "BottomBar.c"
}

static void
he_bottom_bar_instance_init (HeBottomBar * self,
                             gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
#line 44 "../lib/Widgets/BottomBar.vala"
	self->priv = he_bottom_bar_get_instance_private (self);
#line 45 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 45 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp0_);
#line 45 "../lib/Widgets/BottomBar.vala"
	self->priv->main_box = _tmp0_;
#line 46 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 4);
#line 46 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp1_);
#line 46 "../lib/Widgets/BottomBar.vala"
	self->priv->left_box = _tmp1_;
#line 47 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 47 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp2_);
#line 47 "../lib/Widgets/BottomBar.vala"
	self->priv->center_box = _tmp2_;
#line 48 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 4);
#line 48 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp3_);
#line 48 "../lib/Widgets/BottomBar.vala"
	self->priv->right_box = _tmp3_;
#line 50 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 50 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp4_);
#line 50 "../lib/Widgets/BottomBar.vala"
	self->priv->title_label = _tmp4_;
#line 51 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new ("");
#line 51 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp5_);
#line 51 "../lib/Widgets/BottomBar.vala"
	self->priv->description_label = _tmp5_;
#line 53 "../lib/Widgets/BottomBar.vala"
	self->priv->overlay_parent = NULL;
#line 54 "../lib/Widgets/BottomBar.vala"
	self->priv->_overlay_button = NULL;
#line 169 "../lib/Widgets/BottomBar.vala"
	self->priv->_mode = HE_BOTTOM_BAR_MODE_DOCKED;
#line 198 "../lib/Widgets/BottomBar.vala"
	self->priv->_style = HE_BOTTOM_BAR_STYLE_DEFAULT;
#line 219 "../lib/Widgets/BottomBar.vala"
	self->priv->_floating_position = HE_BOTTOM_BAR_FLOATING_POSITION_BOTTOM;
#line 2438 "BottomBar.c"
}

static void
he_bottom_bar_finalize (GObject * obj)
{
	HeBottomBar * self;
#line 44 "../lib/Widgets/BottomBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 684 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_remove_from_overlay (self);
#line 45 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->main_box);
#line 46 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->left_box);
#line 47 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->center_box);
#line 48 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->right_box);
#line 50 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->title_label);
#line 51 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->description_label);
#line 53 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->overlay_parent);
#line 54 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->_overlay_button);
#line 44 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (he_bottom_bar_parent_class)->finalize (obj);
#line 2467 "BottomBar.c"
}

/**
 * A BottomBar is a bottom toolbar that displays actions and content labels.
 *
 * The BottomBar can operate in two distinct modes:
 * - **Docked Mode**: Acts as a traditional bottom app bar, attached to the window edge
 * - **Floating Mode**: Hovers over content as an overlay with rounded corners and elevation
 *
 * Important Notes
 *
 * - **Button Limitation**: Only accepts `He.Button` widgets as children
 * - **Floating Mode Requirements**: Must set `overlay_widget` when using `Mode.FLOATING`
 * - **Automatic Overlay Creation**: If the target widget isn't in a `Gtk.Overlay`, one is created automatically
 *
 * CSS Classes
 *
 * The BottomBar automatically applies CSS classes for styling:
 * - `bottom-bar`: Always applied to the root element
 * - `docked`: Applied when in docked mode
 * - `floating`: Applied when in floating mode
 * - `default`: Applied when using default style
 * - `vibrant`: Applied when using vibrant style
 *
 * @since 1.0
 */
static GType
he_bottom_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeBottomBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_bottom_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeBottomBar), 0, (GInstanceInitFunc) he_bottom_bar_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_bottom_bar_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_bottom_bar_type_id;
	he_bottom_bar_type_id = g_type_register_static (HE_TYPE_BIN, "HeBottomBar", &g_define_type_info, 0);
	g_type_add_interface_static (he_bottom_bar_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeBottomBar_private_offset = g_type_add_instance_private (he_bottom_bar_type_id, sizeof (HeBottomBarPrivate));
	return he_bottom_bar_type_id;
}

GType
he_bottom_bar_get_type (void)
{
	static volatile gsize he_bottom_bar_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_type_id__once)) {
		GType he_bottom_bar_type_id;
		he_bottom_bar_type_id = he_bottom_bar_get_type_once ();
		g_once_init_leave (&he_bottom_bar_type_id__once, he_bottom_bar_type_id);
	}
	return he_bottom_bar_type_id__once;
}

static void
_vala_he_bottom_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 44 "../lib/Widgets/BottomBar.vala"
	switch (property_id) {
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_string (value, he_bottom_bar_get_title (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_OVERLAY_BUTTON_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_object (value, he_bottom_bar_get_overlay_button (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_string (value, he_bottom_bar_get_description (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_MODE_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_enum (value, he_bottom_bar_get_mode (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_STYLE_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_enum (value, he_bottom_bar_get_style (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_enum (value, he_bottom_bar_get_floating_position (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		g_value_set_object (value, he_bottom_bar_get_overlay_widget (self));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 2570 "BottomBar.c"
		default:
#line 44 "../lib/Widgets/BottomBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 2576 "BottomBar.c"
	}
}

static void
_vala_he_bottom_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 44 "../lib/Widgets/BottomBar.vala"
	switch (property_id) {
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_title (self, g_value_get_string (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_OVERLAY_BUTTON_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_overlay_button (self, g_value_get_object (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_description (self, g_value_get_string (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_MODE_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_mode (self, g_value_get_enum (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_STYLE_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_style (self, g_value_get_enum (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_FLOATING_POSITION_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_floating_position (self, g_value_get_enum (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 44 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY:
#line 44 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_overlay_widget (self, g_value_get_object (value));
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 2632 "BottomBar.c"
		default:
#line 44 "../lib/Widgets/BottomBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "../lib/Widgets/BottomBar.vala"
		break;
#line 2638 "BottomBar.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

