/* Card.c generated by valac 0.56.18, the Vala compiler
 * generated from Card.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_CARD_0_PROPERTY,
	HE_CARD_CARD_TYPE_PROPERTY,
	HE_CARD_LAYOUT_PROPERTY,
	HE_CARD_TITLE_PROPERTY,
	HE_CARD_SUBTITLE_PROPERTY,
	HE_CARD_ICON_PROPERTY,
	HE_CARD_GICON_PROPERTY,
	HE_CARD_PAINTABLE_PROPERTY,
	HE_CARD_WIDGET_PROPERTY,
	HE_CARD_SECONDARY_BUTTON_PROPERTY,
	HE_CARD_PRIMARY_BUTTON_PROPERTY,
	HE_CARD_NUM_PROPERTIES
};
static GParamSpec* he_card_properties[HE_CARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	HE_CONTENT_BLOCK_0_PROPERTY,
	HE_CONTENT_BLOCK_TITLE_PROPERTY,
	HE_CONTENT_BLOCK_SUBTITLE_PROPERTY,
	HE_CONTENT_BLOCK_ICON_PROPERTY,
	HE_CONTENT_BLOCK_GICON_PROPERTY,
	HE_CONTENT_BLOCK_SECONDARY_BUTTON_PROPERTY,
	HE_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY,
	HE_CONTENT_BLOCK_NUM_PROPERTIES
};
static GParamSpec* he_content_block_properties[HE_CONTENT_BLOCK_NUM_PROPERTIES];
enum  {
	HE_MINI_CONTENT_BLOCK_0_PROPERTY,
	HE_MINI_CONTENT_BLOCK_WIDGET_PROPERTY,
	HE_MINI_CONTENT_BLOCK_TITLE_PROPERTY,
	HE_MINI_CONTENT_BLOCK_SUBTITLE_PROPERTY,
	HE_MINI_CONTENT_BLOCK_ICON_PROPERTY,
	HE_MINI_CONTENT_BLOCK_GICON_PROPERTY,
	HE_MINI_CONTENT_BLOCK_PAINTABLE_PROPERTY,
	HE_MINI_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY,
	HE_MINI_CONTENT_BLOCK_NUM_PROPERTIES
};
static GParamSpec* he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_NUM_PROPERTIES];

struct _HeCardPrivate {
	GtkLabel* title_label;
	GtkLabel* subtitle_label;
	GtkImage* image;
	GtkBox* info_box;
	GtkBox* button_box;
	GtkBox* main_box;
	HeButton* _secondary_button;
	HeButton* _primary_button;
	GtkWidget* _widget;
	gchar* _title_text;
	gchar* _subtitle_text;
	HeCardType _card_type;
	HeCardLayout _layout;
};

static gint HeCard_private_offset;
static gpointer he_card_parent_class = NULL;
static GtkBuildableIface * he_card_gtk_buildable_parent_iface = NULL;
static gpointer he_content_block_parent_class = NULL;
static gpointer he_mini_content_block_parent_class = NULL;

static void he_card_rebuild_layout (HeCard* self);
static void he_card_setup_components (HeCard* self);
static void he_card_real_add_child (GtkBuildable* base,
                             GtkBuilder* builder,
                             GObject* child,
                             const gchar* type);
static void he_card_create_labels (HeCard* self);
static GObject * he_card_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties);
static void he_card_finalize (GObject * obj);
static GType he_card_get_type_once (void);
static void _vala_he_card_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_he_card_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);
static GType he_content_block_get_type_once (void);
static void _vala_he_content_block_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_he_content_block_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static GType he_mini_content_block_get_type_once (void);
static void _vala_he_mini_content_block_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_he_mini_content_block_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * Type of card appearance
 */
static GType
he_card_type_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_CARD_TYPE_DEFAULT, "HE_CARD_TYPE_DEFAULT", "default"}, {HE_CARD_TYPE_OUTLINE, "HE_CARD_TYPE_OUTLINE", "outline"}, {HE_CARD_TYPE_FILLED, "HE_CARD_TYPE_FILLED", "filled"}, {HE_CARD_TYPE_ELEVATED, "HE_CARD_TYPE_ELEVATED", "elevated"}, {0, NULL, NULL}};
	GType he_card_type_type_id;
	he_card_type_type_id = g_enum_register_static ("HeCardType", values);
	return he_card_type_type_id;
}

GType
he_card_type_get_type (void)
{
	static volatile gsize he_card_type_type_id__once = 0;
	if (g_once_init_enter (&he_card_type_type_id__once)) {
		GType he_card_type_type_id;
		he_card_type_type_id = he_card_type_get_type_once ();
		g_once_init_leave (&he_card_type_type_id__once, he_card_type_type_id);
	}
	return he_card_type_type_id__once;
}

/**
 * Layout style of the card
 */
static GType
he_card_layout_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_CARD_LAYOUT_VERTICAL, "HE_CARD_LAYOUT_VERTICAL", "vertical"}, {HE_CARD_LAYOUT_HORIZONTAL, "HE_CARD_LAYOUT_HORIZONTAL", "horizontal"}, {0, NULL, NULL}};
	GType he_card_layout_type_id;
	he_card_layout_type_id = g_enum_register_static ("HeCardLayout", values);
	return he_card_layout_type_id;
}

GType
he_card_layout_get_type (void)
{
	static volatile gsize he_card_layout_type_id__once = 0;
	if (g_once_init_enter (&he_card_layout_type_id__once)) {
		GType he_card_layout_type_id;
		he_card_layout_type_id = he_card_layout_get_type_once ();
		g_once_init_leave (&he_card_layout_type_id__once, he_card_layout_type_id);
	}
	return he_card_layout_type_id__once;
}

static inline gpointer
he_card_get_instance_private (HeCard* self)
{
	return G_STRUCT_MEMBER_P (self, HeCard_private_offset);
}

HeCardType
he_card_get_card_type (HeCard* self)
{
	HeCardType result;
#line 64 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../lib/Widgets/Card.vala"
	result = self->priv->_card_type;
#line 65 "../lib/Widgets/Card.vala"
	return result;
#line 213 "Card.c"
}

void
he_card_set_card_type (HeCard* self,
                       HeCardType value)
{
#line 67 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 68 "../lib/Widgets/Card.vala"
	if (self->priv->_card_type == value) {
#line 68 "../lib/Widgets/Card.vala"
		return;
#line 226 "Card.c"
	}
#line 71 "../lib/Widgets/Card.vala"
	switch (self->priv->_card_type) {
#line 71 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_OUTLINE:
#line 232 "Card.c"
		{
#line 73 "../lib/Widgets/Card.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "outline");
#line 74 "../lib/Widgets/Card.vala"
			break;
#line 238 "Card.c"
		}
#line 71 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_FILLED:
#line 242 "Card.c"
		{
#line 76 "../lib/Widgets/Card.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "filled");
#line 77 "../lib/Widgets/Card.vala"
			break;
#line 248 "Card.c"
		}
#line 71 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_ELEVATED:
#line 252 "Card.c"
		{
#line 79 "../lib/Widgets/Card.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "elevated");
#line 80 "../lib/Widgets/Card.vala"
			break;
#line 258 "Card.c"
		}
		default:
#line 71 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_DEFAULT:
#line 263 "Card.c"
		{
#line 83 "../lib/Widgets/Card.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "outline");
#line 84 "../lib/Widgets/Card.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "elevated");
#line 85 "../lib/Widgets/Card.vala"
			break;
#line 271 "Card.c"
		}
	}
#line 88 "../lib/Widgets/Card.vala"
	self->priv->_card_type = value;
#line 91 "../lib/Widgets/Card.vala"
	switch (self->priv->_card_type) {
#line 91 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_OUTLINE:
#line 280 "Card.c"
		{
#line 93 "../lib/Widgets/Card.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "outline");
#line 94 "../lib/Widgets/Card.vala"
			break;
#line 286 "Card.c"
		}
#line 91 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_FILLED:
#line 290 "Card.c"
		{
#line 96 "../lib/Widgets/Card.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "filled");
#line 97 "../lib/Widgets/Card.vala"
			break;
#line 296 "Card.c"
		}
#line 91 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_ELEVATED:
#line 300 "Card.c"
		{
#line 99 "../lib/Widgets/Card.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "elevated");
#line 100 "../lib/Widgets/Card.vala"
			break;
#line 306 "Card.c"
		}
		default:
#line 91 "../lib/Widgets/Card.vala"
		case HE_CARD_TYPE_DEFAULT:
#line 311 "Card.c"
		{
#line 103 "../lib/Widgets/Card.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "filled");
#line 104 "../lib/Widgets/Card.vala"
			break;
#line 317 "Card.c"
		}
	}
#line 67 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_CARD_TYPE_PROPERTY]);
#line 322 "Card.c"
}

HeCardLayout
he_card_get_layout (HeCard* self)
{
	HeCardLayout result;
#line 113 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 114 "../lib/Widgets/Card.vala"
	result = self->priv->_layout;
#line 114 "../lib/Widgets/Card.vala"
	return result;
#line 335 "Card.c"
}

void
he_card_set_layout (HeCard* self,
                    HeCardLayout value)
{
#line 116 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 117 "../lib/Widgets/Card.vala"
	if (self->priv->_layout == value) {
#line 117 "../lib/Widgets/Card.vala"
		return;
#line 348 "Card.c"
	}
#line 118 "../lib/Widgets/Card.vala"
	self->priv->_layout = value;
#line 119 "../lib/Widgets/Card.vala"
	he_card_rebuild_layout (self);
#line 116 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_LAYOUT_PROPERTY]);
#line 356 "Card.c"
}

const gchar*
he_card_get_title (HeCard* self)
{
	HeCardClass* _klass_;
#line 127 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 127 "../lib/Widgets/Card.vala"
	if (_klass_->get_title) {
#line 127 "../lib/Widgets/Card.vala"
		return _klass_->get_title (self);
#line 371 "Card.c"
	}
#line 127 "../lib/Widgets/Card.vala"
	return NULL;
#line 375 "Card.c"
}

static const gchar*
he_card_real_get_title (HeCard* base)
{
	const gchar* result;
	HeCard* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 127 "../lib/Widgets/Card.vala"
	self = base;
#line 128 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->_title_text;
#line 128 "../lib/Widgets/Card.vala"
	_tmp0_ = _tmp1_;
#line 128 "../lib/Widgets/Card.vala"
	if (_tmp0_ == NULL) {
#line 128 "../lib/Widgets/Card.vala"
		_tmp0_ = "";
#line 395 "Card.c"
	}
#line 128 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 128 "../lib/Widgets/Card.vala"
	return result;
#line 401 "Card.c"
}

void
he_card_set_title (HeCard* self,
                   const gchar* value)
{
	HeCardClass* _klass_;
#line 130 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 130 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 130 "../lib/Widgets/Card.vala"
	if (_klass_->set_title) {
#line 130 "../lib/Widgets/Card.vala"
		_klass_->set_title (self, value);
#line 417 "Card.c"
	}
}

static void
he_card_real_set_title (HeCard* base,
                        const gchar* value)
{
	HeCard* self;
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 130 "../lib/Widgets/Card.vala"
	self = base;
#line 131 "../lib/Widgets/Card.vala"
	_tmp0_ = g_strdup (value);
#line 131 "../lib/Widgets/Card.vala"
	_g_free0 (self->priv->_title_text);
#line 131 "../lib/Widgets/Card.vala"
	self->priv->_title_text = _tmp0_;
#line 132 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->title_label;
#line 132 "../lib/Widgets/Card.vala"
	if (_tmp1_ != NULL) {
#line 440 "Card.c"
		gboolean _tmp2_ = FALSE;
#line 133 "../lib/Widgets/Card.vala"
		if (value != NULL) {
#line 133 "../lib/Widgets/Card.vala"
			_tmp2_ = g_strcmp0 (value, "") != 0;
#line 446 "Card.c"
		} else {
#line 133 "../lib/Widgets/Card.vala"
			_tmp2_ = FALSE;
#line 450 "Card.c"
		}
#line 133 "../lib/Widgets/Card.vala"
		if (_tmp2_) {
#line 454 "Card.c"
			GtkLabel* _tmp3_;
			GtkLabel* _tmp4_;
#line 134 "../lib/Widgets/Card.vala"
			_tmp3_ = self->priv->title_label;
#line 134 "../lib/Widgets/Card.vala"
			gtk_label_set_text (_tmp3_, value);
#line 135 "../lib/Widgets/Card.vala"
			_tmp4_ = self->priv->title_label;
#line 135 "../lib/Widgets/Card.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 465 "Card.c"
		} else {
			GtkLabel* _tmp5_;
#line 137 "../lib/Widgets/Card.vala"
			_tmp5_ = self->priv->title_label;
#line 137 "../lib/Widgets/Card.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 472 "Card.c"
		}
	}
#line 130 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_TITLE_PROPERTY]);
#line 477 "Card.c"
}

const gchar*
he_card_get_subtitle (HeCard* self)
{
	HeCardClass* _klass_;
#line 147 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 147 "../lib/Widgets/Card.vala"
	if (_klass_->get_subtitle) {
#line 147 "../lib/Widgets/Card.vala"
		return _klass_->get_subtitle (self);
#line 492 "Card.c"
	}
#line 147 "../lib/Widgets/Card.vala"
	return NULL;
#line 496 "Card.c"
}

static const gchar*
he_card_real_get_subtitle (HeCard* base)
{
	const gchar* result;
	HeCard* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 147 "../lib/Widgets/Card.vala"
	self = base;
#line 148 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->_subtitle_text;
#line 148 "../lib/Widgets/Card.vala"
	_tmp0_ = _tmp1_;
#line 148 "../lib/Widgets/Card.vala"
	if (_tmp0_ == NULL) {
#line 148 "../lib/Widgets/Card.vala"
		_tmp0_ = "";
#line 516 "Card.c"
	}
#line 148 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 148 "../lib/Widgets/Card.vala"
	return result;
#line 522 "Card.c"
}

void
he_card_set_subtitle (HeCard* self,
                      const gchar* value)
{
	HeCardClass* _klass_;
#line 150 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 150 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 150 "../lib/Widgets/Card.vala"
	if (_klass_->set_subtitle) {
#line 150 "../lib/Widgets/Card.vala"
		_klass_->set_subtitle (self, value);
#line 538 "Card.c"
	}
}

static void
he_card_real_set_subtitle (HeCard* base,
                           const gchar* value)
{
	HeCard* self;
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 150 "../lib/Widgets/Card.vala"
	self = base;
#line 151 "../lib/Widgets/Card.vala"
	_tmp0_ = g_strdup (value);
#line 151 "../lib/Widgets/Card.vala"
	_g_free0 (self->priv->_subtitle_text);
#line 151 "../lib/Widgets/Card.vala"
	self->priv->_subtitle_text = _tmp0_;
#line 152 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->subtitle_label;
#line 152 "../lib/Widgets/Card.vala"
	if (_tmp1_ != NULL) {
#line 561 "Card.c"
		gboolean _tmp2_ = FALSE;
#line 153 "../lib/Widgets/Card.vala"
		if (value != NULL) {
#line 153 "../lib/Widgets/Card.vala"
			_tmp2_ = g_strcmp0 (value, "") != 0;
#line 567 "Card.c"
		} else {
#line 153 "../lib/Widgets/Card.vala"
			_tmp2_ = FALSE;
#line 571 "Card.c"
		}
#line 153 "../lib/Widgets/Card.vala"
		if (_tmp2_) {
#line 575 "Card.c"
			GtkLabel* _tmp3_;
			GtkLabel* _tmp4_;
#line 154 "../lib/Widgets/Card.vala"
			_tmp3_ = self->priv->subtitle_label;
#line 154 "../lib/Widgets/Card.vala"
			gtk_label_set_text (_tmp3_, value);
#line 155 "../lib/Widgets/Card.vala"
			_tmp4_ = self->priv->subtitle_label;
#line 155 "../lib/Widgets/Card.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 586 "Card.c"
		} else {
			GtkLabel* _tmp5_;
#line 157 "../lib/Widgets/Card.vala"
			_tmp5_ = self->priv->subtitle_label;
#line 157 "../lib/Widgets/Card.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 593 "Card.c"
		}
	}
#line 150 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_SUBTITLE_PROPERTY]);
#line 598 "Card.c"
}

const gchar*
he_card_get_icon (HeCard* self)
{
	HeCardClass* _klass_;
#line 167 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 167 "../lib/Widgets/Card.vala"
	if (_klass_->get_icon) {
#line 167 "../lib/Widgets/Card.vala"
		return _klass_->get_icon (self);
#line 613 "Card.c"
	}
#line 167 "../lib/Widgets/Card.vala"
	return NULL;
#line 617 "Card.c"
}

static const gchar*
he_card_real_get_icon (HeCard* base)
{
	const gchar* result;
	HeCard* self;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
#line 167 "../lib/Widgets/Card.vala"
	self = base;
#line 168 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->image;
#line 168 "../lib/Widgets/Card.vala"
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
#line 168 "../lib/Widgets/Card.vala"
	result = _tmp1_;
#line 168 "../lib/Widgets/Card.vala"
	return result;
#line 637 "Card.c"
}

void
he_card_set_icon (HeCard* self,
                  const gchar* value)
{
	HeCardClass* _klass_;
#line 170 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 170 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 170 "../lib/Widgets/Card.vala"
	if (_klass_->set_icon) {
#line 170 "../lib/Widgets/Card.vala"
		_klass_->set_icon (self, value);
#line 653 "Card.c"
	}
}

static void
he_card_real_set_icon (HeCard* base,
                       const gchar* value)
{
	HeCard* self;
#line 170 "../lib/Widgets/Card.vala"
	self = base;
#line 171 "../lib/Widgets/Card.vala"
	if (value == NULL) {
#line 666 "Card.c"
		GtkImage* _tmp0_;
#line 172 "../lib/Widgets/Card.vala"
		_tmp0_ = self->priv->image;
#line 172 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 672 "Card.c"
	} else {
		GtkImage* _tmp1_;
		GtkImage* _tmp2_;
#line 174 "../lib/Widgets/Card.vala"
		_tmp1_ = self->priv->image;
#line 174 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 175 "../lib/Widgets/Card.vala"
		_tmp2_ = self->priv->image;
#line 175 "../lib/Widgets/Card.vala"
		gtk_image_set_from_icon_name (_tmp2_, value);
#line 684 "Card.c"
	}
#line 170 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_ICON_PROPERTY]);
#line 688 "Card.c"
}

void
he_card_set_gicon (HeCard* self,
                   GIcon* value)
{
	HeCardClass* _klass_;
#line 184 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 184 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 184 "../lib/Widgets/Card.vala"
	if (_klass_->set_gicon) {
#line 184 "../lib/Widgets/Card.vala"
		_klass_->set_gicon (self, value);
#line 704 "Card.c"
	}
}

static void
he_card_real_set_gicon (HeCard* base,
                        GIcon* value)
{
	HeCard* self;
#line 184 "../lib/Widgets/Card.vala"
	self = base;
#line 185 "../lib/Widgets/Card.vala"
	if (value == NULL) {
#line 717 "Card.c"
		GtkImage* _tmp0_;
#line 186 "../lib/Widgets/Card.vala"
		_tmp0_ = self->priv->image;
#line 186 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 723 "Card.c"
	} else {
		GtkImage* _tmp1_;
		GtkImage* _tmp2_;
#line 188 "../lib/Widgets/Card.vala"
		_tmp1_ = self->priv->image;
#line 188 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 189 "../lib/Widgets/Card.vala"
		_tmp2_ = self->priv->image;
#line 189 "../lib/Widgets/Card.vala"
		gtk_image_set_from_gicon (_tmp2_, value);
#line 735 "Card.c"
	}
#line 184 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_GICON_PROPERTY]);
#line 739 "Card.c"
}

void
he_card_set_paintable (HeCard* self,
                       GdkPaintable* value)
{
	HeCardClass* _klass_;
#line 198 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 198 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 198 "../lib/Widgets/Card.vala"
	if (_klass_->set_paintable) {
#line 198 "../lib/Widgets/Card.vala"
		_klass_->set_paintable (self, value);
#line 755 "Card.c"
	}
}

static void
he_card_real_set_paintable (HeCard* base,
                            GdkPaintable* value)
{
	HeCard* self;
#line 198 "../lib/Widgets/Card.vala"
	self = base;
#line 199 "../lib/Widgets/Card.vala"
	if (value == NULL) {
#line 768 "Card.c"
		GtkImage* _tmp0_;
#line 200 "../lib/Widgets/Card.vala"
		_tmp0_ = self->priv->image;
#line 200 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 774 "Card.c"
	} else {
		GtkImage* _tmp1_;
		GtkImage* _tmp2_;
#line 202 "../lib/Widgets/Card.vala"
		_tmp1_ = self->priv->image;
#line 202 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 203 "../lib/Widgets/Card.vala"
		_tmp2_ = self->priv->image;
#line 203 "../lib/Widgets/Card.vala"
		gtk_image_set_from_paintable (_tmp2_, value);
#line 786 "Card.c"
	}
#line 198 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_PAINTABLE_PROPERTY]);
#line 790 "Card.c"
}

GtkWidget*
he_card_get_widget (HeCard* self)
{
	HeCardClass* _klass_;
#line 212 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 212 "../lib/Widgets/Card.vala"
	if (_klass_->get_widget) {
#line 212 "../lib/Widgets/Card.vala"
		return _klass_->get_widget (self);
#line 805 "Card.c"
	}
#line 212 "../lib/Widgets/Card.vala"
	return NULL;
#line 809 "Card.c"
}

static GtkWidget*
he_card_real_get_widget (HeCard* base)
{
	GtkWidget* result;
	HeCard* self;
	GtkWidget* _tmp0_;
#line 212 "../lib/Widgets/Card.vala"
	self = base;
#line 213 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->_widget;
#line 213 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 213 "../lib/Widgets/Card.vala"
	return result;
#line 826 "Card.c"
}

void
he_card_set_widget (HeCard* self,
                    GtkWidget* value)
{
	HeCardClass* _klass_;
#line 215 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 215 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 215 "../lib/Widgets/Card.vala"
	if (_klass_->set_widget) {
#line 215 "../lib/Widgets/Card.vala"
		_klass_->set_widget (self, value);
#line 842 "Card.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 222 "../lib/Widgets/Card.vala"
	return self ? g_object_ref (self) : NULL;
#line 851 "Card.c"
}

static void
he_card_real_set_widget (HeCard* base,
                         GtkWidget* value)
{
	HeCard* self;
	GtkWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_ = FALSE;
#line 215 "../lib/Widgets/Card.vala"
	self = base;
#line 216 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->_widget;
#line 216 "../lib/Widgets/Card.vala"
	if (value == _tmp0_) {
#line 216 "../lib/Widgets/Card.vala"
		return;
#line 872 "Card.c"
	}
#line 218 "../lib/Widgets/Card.vala"
	_tmp2_ = self->priv->_widget;
#line 218 "../lib/Widgets/Card.vala"
	if (_tmp2_ != NULL) {
#line 878 "Card.c"
		GtkBox* _tmp3_;
#line 218 "../lib/Widgets/Card.vala"
		_tmp3_ = self->priv->button_box;
#line 218 "../lib/Widgets/Card.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 884 "Card.c"
	} else {
#line 218 "../lib/Widgets/Card.vala"
		_tmp1_ = FALSE;
#line 888 "Card.c"
	}
#line 218 "../lib/Widgets/Card.vala"
	if (_tmp1_) {
#line 892 "Card.c"
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
#line 219 "../lib/Widgets/Card.vala"
		_tmp4_ = self->priv->button_box;
#line 219 "../lib/Widgets/Card.vala"
		_tmp5_ = self->priv->_widget;
#line 219 "../lib/Widgets/Card.vala"
		gtk_box_remove (_tmp4_, _tmp5_);
#line 901 "Card.c"
	}
#line 222 "../lib/Widgets/Card.vala"
	_tmp6_ = _g_object_ref0 (value);
#line 222 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_widget);
#line 222 "../lib/Widgets/Card.vala"
	self->priv->_widget = _tmp6_;
#line 224 "../lib/Widgets/Card.vala"
	if (value != NULL) {
#line 911 "Card.c"
		GtkBox* _tmp8_;
#line 224 "../lib/Widgets/Card.vala"
		_tmp8_ = self->priv->button_box;
#line 224 "../lib/Widgets/Card.vala"
		_tmp7_ = _tmp8_ != NULL;
#line 917 "Card.c"
	} else {
#line 224 "../lib/Widgets/Card.vala"
		_tmp7_ = FALSE;
#line 921 "Card.c"
	}
#line 224 "../lib/Widgets/Card.vala"
	if (_tmp7_) {
#line 925 "Card.c"
		GtkBox* _tmp9_;
#line 225 "../lib/Widgets/Card.vala"
		_tmp9_ = self->priv->button_box;
#line 225 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp9_, value);
#line 931 "Card.c"
	}
#line 215 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_WIDGET_PROPERTY]);
#line 935 "Card.c"
}

HeButton*
he_card_get_secondary_button (HeCard* self)
{
	HeCardClass* _klass_;
#line 247 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 247 "../lib/Widgets/Card.vala"
	if (_klass_->get_secondary_button) {
#line 247 "../lib/Widgets/Card.vala"
		return _klass_->get_secondary_button (self);
#line 950 "Card.c"
	}
#line 247 "../lib/Widgets/Card.vala"
	return NULL;
#line 954 "Card.c"
}

static HeButton*
he_card_real_get_secondary_button (HeCard* base)
{
	HeButton* result;
	HeCard* self;
	HeButton* _tmp0_;
#line 247 "../lib/Widgets/Card.vala"
	self = base;
#line 248 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->_secondary_button;
#line 248 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 248 "../lib/Widgets/Card.vala"
	return result;
#line 971 "Card.c"
}

void
he_card_set_secondary_button (HeCard* self,
                              HeButton* value)
{
	HeCardClass* _klass_;
#line 234 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 234 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 234 "../lib/Widgets/Card.vala"
	if (_klass_->set_secondary_button) {
#line 234 "../lib/Widgets/Card.vala"
		_klass_->set_secondary_button (self, value);
#line 987 "Card.c"
	}
}

static void
he_card_real_set_secondary_button (HeCard* base,
                                   HeButton* value)
{
	HeCard* self;
	gboolean _tmp0_ = FALSE;
	HeButton* _tmp1_;
#line 234 "../lib/Widgets/Card.vala"
	self = base;
#line 235 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->_secondary_button;
#line 235 "../lib/Widgets/Card.vala"
	if (_tmp1_ != NULL) {
#line 1004 "Card.c"
		GtkBox* _tmp2_;
#line 235 "../lib/Widgets/Card.vala"
		_tmp2_ = self->priv->button_box;
#line 235 "../lib/Widgets/Card.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1010 "Card.c"
	} else {
#line 235 "../lib/Widgets/Card.vala"
		_tmp0_ = FALSE;
#line 1014 "Card.c"
	}
#line 235 "../lib/Widgets/Card.vala"
	if (_tmp0_) {
#line 1018 "Card.c"
		GtkBox* _tmp3_;
		HeButton* _tmp4_;
#line 236 "../lib/Widgets/Card.vala"
		_tmp3_ = self->priv->button_box;
#line 236 "../lib/Widgets/Card.vala"
		_tmp4_ = self->priv->_secondary_button;
#line 236 "../lib/Widgets/Card.vala"
		gtk_box_remove (_tmp3_, (GtkWidget*) _tmp4_);
#line 1027 "Card.c"
	}
#line 239 "../lib/Widgets/Card.vala"
	if (value != NULL) {
#line 1031 "Card.c"
		HeButton* _tmp5_;
		GtkBox* _tmp6_;
#line 240 "../lib/Widgets/Card.vala"
		he_button_set_is_tint (value, TRUE);
#line 241 "../lib/Widgets/Card.vala"
		_tmp5_ = _g_object_ref0 (value);
#line 241 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->_secondary_button);
#line 241 "../lib/Widgets/Card.vala"
		self->priv->_secondary_button = _tmp5_;
#line 242 "../lib/Widgets/Card.vala"
		_tmp6_ = self->priv->button_box;
#line 242 "../lib/Widgets/Card.vala"
		if (_tmp6_ != NULL) {
#line 1046 "Card.c"
			GtkBox* _tmp7_;
			HeButton* _tmp8_;
#line 243 "../lib/Widgets/Card.vala"
			_tmp7_ = self->priv->button_box;
#line 243 "../lib/Widgets/Card.vala"
			_tmp8_ = self->priv->_secondary_button;
#line 243 "../lib/Widgets/Card.vala"
			gtk_box_prepend (_tmp7_, (GtkWidget*) _tmp8_);
#line 1055 "Card.c"
		}
	}
#line 234 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_SECONDARY_BUTTON_PROPERTY]);
#line 1060 "Card.c"
}

HeButton*
he_card_get_primary_button (HeCard* self)
{
	HeCardClass* _klass_;
#line 256 "../lib/Widgets/Card.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 256 "../lib/Widgets/Card.vala"
	if (_klass_->get_primary_button) {
#line 256 "../lib/Widgets/Card.vala"
		return _klass_->get_primary_button (self);
#line 1075 "Card.c"
	}
#line 256 "../lib/Widgets/Card.vala"
	return NULL;
#line 1079 "Card.c"
}

static HeButton*
he_card_real_get_primary_button (HeCard* base)
{
	HeButton* result;
	HeCard* self;
	HeButton* _tmp0_;
#line 256 "../lib/Widgets/Card.vala"
	self = base;
#line 257 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->_primary_button;
#line 257 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 257 "../lib/Widgets/Card.vala"
	return result;
#line 1096 "Card.c"
}

void
he_card_set_primary_button (HeCard* self,
                            HeButton* value)
{
	HeCardClass* _klass_;
#line 259 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 259 "../lib/Widgets/Card.vala"
	_klass_ = HE_CARD_GET_CLASS (self);
#line 259 "../lib/Widgets/Card.vala"
	if (_klass_->set_primary_button) {
#line 259 "../lib/Widgets/Card.vala"
		_klass_->set_primary_button (self, value);
#line 1112 "Card.c"
	}
}

static void
he_card_real_set_primary_button (HeCard* base,
                                 HeButton* value)
{
	HeCard* self;
	gboolean _tmp0_ = FALSE;
	HeButton* _tmp1_;
#line 259 "../lib/Widgets/Card.vala"
	self = base;
#line 260 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->_primary_button;
#line 260 "../lib/Widgets/Card.vala"
	if (_tmp1_ != NULL) {
#line 1129 "Card.c"
		GtkBox* _tmp2_;
#line 260 "../lib/Widgets/Card.vala"
		_tmp2_ = self->priv->button_box;
#line 260 "../lib/Widgets/Card.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1135 "Card.c"
	} else {
#line 260 "../lib/Widgets/Card.vala"
		_tmp0_ = FALSE;
#line 1139 "Card.c"
	}
#line 260 "../lib/Widgets/Card.vala"
	if (_tmp0_) {
#line 1143 "Card.c"
		GtkBox* _tmp3_;
		HeButton* _tmp4_;
#line 261 "../lib/Widgets/Card.vala"
		_tmp3_ = self->priv->button_box;
#line 261 "../lib/Widgets/Card.vala"
		_tmp4_ = self->priv->_primary_button;
#line 261 "../lib/Widgets/Card.vala"
		gtk_box_remove (_tmp3_, (GtkWidget*) _tmp4_);
#line 1152 "Card.c"
	}
#line 264 "../lib/Widgets/Card.vala"
	if (value != NULL) {
#line 1156 "Card.c"
		HeButton* _tmp5_;
		GtkBox* _tmp6_;
#line 265 "../lib/Widgets/Card.vala"
		_tmp5_ = _g_object_ref0 (value);
#line 265 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->_primary_button);
#line 265 "../lib/Widgets/Card.vala"
		self->priv->_primary_button = _tmp5_;
#line 266 "../lib/Widgets/Card.vala"
		he_button_set_is_fill (value, TRUE);
#line 268 "../lib/Widgets/Card.vala"
		if (self->priv->_layout == HE_CARD_LAYOUT_HORIZONTAL) {
#line 269 "../lib/Widgets/Card.vala"
			gtk_widget_set_hexpand ((GtkWidget*) value, TRUE);
#line 270 "../lib/Widgets/Card.vala"
			gtk_widget_set_halign ((GtkWidget*) value, GTK_ALIGN_END);
#line 1173 "Card.c"
		}
#line 273 "../lib/Widgets/Card.vala"
		_tmp6_ = self->priv->button_box;
#line 273 "../lib/Widgets/Card.vala"
		if (_tmp6_ != NULL) {
#line 1179 "Card.c"
			GtkBox* _tmp7_;
			HeButton* _tmp8_;
#line 274 "../lib/Widgets/Card.vala"
			_tmp7_ = self->priv->button_box;
#line 274 "../lib/Widgets/Card.vala"
			_tmp8_ = self->priv->_primary_button;
#line 274 "../lib/Widgets/Card.vala"
			gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 1188 "Card.c"
		}
	}
#line 259 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_card_properties[HE_CARD_PRIMARY_BUTTON_PROPERTY]);
#line 1193 "Card.c"
}

/**
     * Constructs a new Card with vertical layout (ContentBlock style).
     */
HeCard*
he_card_construct (GType object_type,
                   const gchar* title,
                   const gchar* subtitle,
                   const gchar* icon,
                   HeButton* primary_button,
                   HeButton* secondary_button)
{
	HeCard * self = NULL;
#line 288 "../lib/Widgets/Card.vala"
	self = (HeCard*) he_bin_construct (object_type);
#line 289 "../lib/Widgets/Card.vala"
	self->priv->_layout = HE_CARD_LAYOUT_VERTICAL;
#line 290 "../lib/Widgets/Card.vala"
	he_card_setup_components (self);
#line 292 "../lib/Widgets/Card.vala"
	he_card_set_title (self, title);
#line 293 "../lib/Widgets/Card.vala"
	he_card_set_subtitle (self, subtitle);
#line 294 "../lib/Widgets/Card.vala"
	he_card_set_icon (self, icon);
#line 295 "../lib/Widgets/Card.vala"
	he_card_set_primary_button (self, primary_button);
#line 296 "../lib/Widgets/Card.vala"
	he_card_set_secondary_button (self, secondary_button);
#line 283 "../lib/Widgets/Card.vala"
	return self;
#line 1226 "Card.c"
}

HeCard*
he_card_new (const gchar* title,
             const gchar* subtitle,
             const gchar* icon,
             HeButton* primary_button,
             HeButton* secondary_button)
{
#line 283 "../lib/Widgets/Card.vala"
	return he_card_construct (HE_TYPE_CARD, title, subtitle, icon, primary_button, secondary_button);
#line 1238 "Card.c"
}

/**
     * Constructs a new Card with horizontal layout (MiniContentBlock style).
     */
HeCard*
he_card_construct_horizontal (GType object_type,
                              const gchar* title,
                              const gchar* subtitle,
                              const gchar* icon,
                              HeButton* primary_button,
                              GtkWidget* widget)
{
	HeCard * self = NULL;
#line 307 "../lib/Widgets/Card.vala"
	self = (HeCard*) he_bin_construct (object_type);
#line 308 "../lib/Widgets/Card.vala"
	self->priv->_layout = HE_CARD_LAYOUT_HORIZONTAL;
#line 309 "../lib/Widgets/Card.vala"
	he_card_setup_components (self);
#line 311 "../lib/Widgets/Card.vala"
	he_card_set_title (self, title);
#line 312 "../lib/Widgets/Card.vala"
	he_card_set_subtitle (self, subtitle);
#line 313 "../lib/Widgets/Card.vala"
	he_card_set_icon (self, icon);
#line 314 "../lib/Widgets/Card.vala"
	he_card_set_primary_button (self, primary_button);
#line 315 "../lib/Widgets/Card.vala"
	he_card_set_widget (self, widget);
#line 302 "../lib/Widgets/Card.vala"
	return self;
#line 1271 "Card.c"
}

HeCard*
he_card_new_horizontal (const gchar* title,
                        const gchar* subtitle,
                        const gchar* icon,
                        HeButton* primary_button,
                        GtkWidget* widget)
{
#line 302 "../lib/Widgets/Card.vala"
	return he_card_construct_horizontal (HE_TYPE_CARD, title, subtitle, icon, primary_button, widget);
#line 1283 "Card.c"
}

/**
     * Add a child to the Card, should only be used in the context of a UI or Blueprint file.
     */
static void
he_card_real_add_child (GtkBuildable* base,
                        GtkBuilder* builder,
                        GObject* child,
                        const gchar* type)
{
	HeCard * self;
	GtkBox* _tmp0_;
#line 321 "../lib/Widgets/Card.vala"
	self = (HeCard*) base;
#line 321 "../lib/Widgets/Card.vala"
	g_return_if_fail (builder != NULL);
#line 321 "../lib/Widgets/Card.vala"
	g_return_if_fail (child != NULL);
#line 322 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->button_box;
#line 322 "../lib/Widgets/Card.vala"
	if (_tmp0_ != NULL) {
#line 1307 "Card.c"
		GtkBox* _tmp1_;
#line 323 "../lib/Widgets/Card.vala"
		_tmp1_ = self->priv->button_box;
#line 323 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
#line 1313 "Card.c"
	}
}

static void
he_card_setup_components (HeCard* self)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
#line 327 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 329 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->image;
#line 329 "../lib/Widgets/Card.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_CENTER);
#line 330 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->image;
#line 330 "../lib/Widgets/Card.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
#line 331 "../lib/Widgets/Card.vala"
	_tmp2_ = self->priv->image;
#line 331 "../lib/Widgets/Card.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 333 "../lib/Widgets/Card.vala"
	he_card_rebuild_layout (self);
#line 1339 "Card.c"
}

static void
he_card_create_labels (HeCard* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_;
#line 336 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 338 "../lib/Widgets/Card.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 338 "../lib/Widgets/Card.vala"
	g_object_ref_sink (_tmp0_);
#line 338 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->title_label);
#line 338 "../lib/Widgets/Card.vala"
	self->priv->title_label = _tmp0_;
#line 339 "../lib/Widgets/Card.vala"
	_tmp1_ = self->priv->title_label;
#line 339 "../lib/Widgets/Card.vala"
	gtk_label_set_xalign (_tmp1_, (gfloat) 0);
#line 340 "../lib/Widgets/Card.vala"
	_tmp2_ = self->priv->title_label;
#line 340 "../lib/Widgets/Card.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp2_, "cb-title");
#line 341 "../lib/Widgets/Card.vala"
	_tmp3_ = self->priv->title_label;
#line 341 "../lib/Widgets/Card.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 343 "../lib/Widgets/Card.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
#line 343 "../lib/Widgets/Card.vala"
	g_object_ref_sink (_tmp4_);
#line 343 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->subtitle_label);
#line 343 "../lib/Widgets/Card.vala"
	self->priv->subtitle_label = _tmp4_;
#line 344 "../lib/Widgets/Card.vala"
	_tmp5_ = self->priv->subtitle_label;
#line 344 "../lib/Widgets/Card.vala"
	gtk_label_set_xalign (_tmp5_, (gfloat) 0);
#line 345 "../lib/Widgets/Card.vala"
	_tmp6_ = self->priv->subtitle_label;
#line 345 "../lib/Widgets/Card.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "cb-subtitle");
#line 346 "../lib/Widgets/Card.vala"
	_tmp7_ = self->priv->subtitle_label;
#line 346 "../lib/Widgets/Card.vala"
	gtk_label_set_wrap (_tmp7_, TRUE);
#line 347 "../lib/Widgets/Card.vala"
	_tmp8_ = self->priv->subtitle_label;
#line 347 "../lib/Widgets/Card.vala"
	gtk_label_set_ellipsize (_tmp8_, PANGO_ELLIPSIZE_END);
#line 348 "../lib/Widgets/Card.vala"
	_tmp9_ = self->priv->subtitle_label;
#line 348 "../lib/Widgets/Card.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 351 "../lib/Widgets/Card.vala"
	_tmp11_ = self->priv->_title_text;
#line 351 "../lib/Widgets/Card.vala"
	if (_tmp11_ != NULL) {
#line 1413 "Card.c"
		const gchar* _tmp12_;
#line 351 "../lib/Widgets/Card.vala"
		_tmp12_ = self->priv->_title_text;
#line 351 "../lib/Widgets/Card.vala"
		_tmp10_ = g_strcmp0 (_tmp12_, "") != 0;
#line 1419 "Card.c"
	} else {
#line 351 "../lib/Widgets/Card.vala"
		_tmp10_ = FALSE;
#line 1423 "Card.c"
	}
#line 351 "../lib/Widgets/Card.vala"
	if (_tmp10_) {
#line 1427 "Card.c"
		GtkLabel* _tmp13_;
		const gchar* _tmp14_;
		GtkLabel* _tmp15_;
#line 352 "../lib/Widgets/Card.vala"
		_tmp13_ = self->priv->title_label;
#line 352 "../lib/Widgets/Card.vala"
		_tmp14_ = self->priv->_title_text;
#line 352 "../lib/Widgets/Card.vala"
		gtk_label_set_text (_tmp13_, _tmp14_);
#line 353 "../lib/Widgets/Card.vala"
		_tmp15_ = self->priv->title_label;
#line 353 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp15_, TRUE);
#line 1441 "Card.c"
	}
#line 356 "../lib/Widgets/Card.vala"
	_tmp17_ = self->priv->_subtitle_text;
#line 356 "../lib/Widgets/Card.vala"
	if (_tmp17_ != NULL) {
#line 1447 "Card.c"
		const gchar* _tmp18_;
#line 356 "../lib/Widgets/Card.vala"
		_tmp18_ = self->priv->_subtitle_text;
#line 356 "../lib/Widgets/Card.vala"
		_tmp16_ = g_strcmp0 (_tmp18_, "") != 0;
#line 1453 "Card.c"
	} else {
#line 356 "../lib/Widgets/Card.vala"
		_tmp16_ = FALSE;
#line 1457 "Card.c"
	}
#line 356 "../lib/Widgets/Card.vala"
	if (_tmp16_) {
#line 1461 "Card.c"
		GtkLabel* _tmp19_;
		const gchar* _tmp20_;
		GtkLabel* _tmp21_;
#line 357 "../lib/Widgets/Card.vala"
		_tmp19_ = self->priv->subtitle_label;
#line 357 "../lib/Widgets/Card.vala"
		_tmp20_ = self->priv->_subtitle_text;
#line 357 "../lib/Widgets/Card.vala"
		gtk_label_set_text (_tmp19_, _tmp20_);
#line 358 "../lib/Widgets/Card.vala"
		_tmp21_ = self->priv->subtitle_label;
#line 358 "../lib/Widgets/Card.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
#line 1475 "Card.c"
	}
}

static void
he_card_rebuild_layout (HeCard* self)
{
	HeButton* temp_primary = NULL;
	HeButton* _tmp0_;
	HeButton* _tmp1_;
	HeButton* temp_secondary = NULL;
	HeButton* _tmp2_;
	HeButton* _tmp3_;
	GtkWidget* temp_widget = NULL;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp46_;
	HeButton* _tmp47_;
	HeButton* _tmp49_;
	GtkWidget* _tmp51_;
#line 362 "../lib/Widgets/Card.vala"
	g_return_if_fail (self != NULL);
#line 364 "../lib/Widgets/Card.vala"
	_tmp0_ = self->priv->_primary_button;
#line 364 "../lib/Widgets/Card.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 364 "../lib/Widgets/Card.vala"
	temp_primary = _tmp1_;
#line 365 "../lib/Widgets/Card.vala"
	_tmp2_ = self->priv->_secondary_button;
#line 365 "../lib/Widgets/Card.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 365 "../lib/Widgets/Card.vala"
	temp_secondary = _tmp3_;
#line 366 "../lib/Widgets/Card.vala"
	_tmp4_ = self->priv->_widget;
#line 366 "../lib/Widgets/Card.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 366 "../lib/Widgets/Card.vala"
	temp_widget = _tmp5_;
#line 369 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_primary_button);
#line 369 "../lib/Widgets/Card.vala"
	self->priv->_primary_button = NULL;
#line 370 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_secondary_button);
#line 370 "../lib/Widgets/Card.vala"
	self->priv->_secondary_button = NULL;
#line 371 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_widget);
#line 371 "../lib/Widgets/Card.vala"
	self->priv->_widget = NULL;
#line 374 "../lib/Widgets/Card.vala"
	_tmp6_ = self->priv->main_box;
#line 374 "../lib/Widgets/Card.vala"
	if (_tmp6_ != NULL) {
#line 1532 "Card.c"
		GtkBox* _tmp7_;
#line 375 "../lib/Widgets/Card.vala"
		_tmp7_ = self->priv->main_box;
#line 375 "../lib/Widgets/Card.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp7_);
#line 1538 "Card.c"
	}
#line 379 "../lib/Widgets/Card.vala"
	he_card_create_labels (self);
#line 381 "../lib/Widgets/Card.vala"
	if (self->priv->_layout == HE_CARD_LAYOUT_VERTICAL) {
#line 1544 "Card.c"
		GtkImage* _tmp8_;
		GtkImage* _tmp9_;
		GtkImage* _tmp10_;
		GtkLabel* _tmp11_;
		GtkBox* _tmp12_;
		GtkBox* _tmp13_;
		GtkImage* _tmp14_;
		GtkBox* _tmp15_;
		GtkLabel* _tmp16_;
		GtkBox* _tmp17_;
		GtkLabel* _tmp18_;
		GtkBox* _tmp19_;
		GtkBox* _tmp20_;
		GtkBox* _tmp21_;
		GtkBox* _tmp22_;
		GtkBox* _tmp23_;
		GtkBox* _tmp24_;
		GtkBox* _tmp25_;
		GtkBox* _tmp26_;
#line 383 "../lib/Widgets/Card.vala"
		_tmp8_ = self->priv->image;
#line 383 "../lib/Widgets/Card.vala"
		gtk_image_set_pixel_size (_tmp8_, 48);
#line 384 "../lib/Widgets/Card.vala"
		_tmp9_ = self->priv->image;
#line 384 "../lib/Widgets/Card.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_START);
#line 385 "../lib/Widgets/Card.vala"
		_tmp10_ = self->priv->image;
#line 385 "../lib/Widgets/Card.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 387 "../lib/Widgets/Card.vala"
		_tmp11_ = self->priv->subtitle_label;
#line 387 "../lib/Widgets/Card.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 389 "../lib/Widgets/Card.vala"
		_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 389 "../lib/Widgets/Card.vala"
		g_object_ref_sink (_tmp12_);
#line 389 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->info_box);
#line 389 "../lib/Widgets/Card.vala"
		self->priv->info_box = _tmp12_;
#line 390 "../lib/Widgets/Card.vala"
		_tmp13_ = self->priv->info_box;
#line 390 "../lib/Widgets/Card.vala"
		_tmp14_ = self->priv->image;
#line 390 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp13_, (GtkWidget*) _tmp14_);
#line 391 "../lib/Widgets/Card.vala"
		_tmp15_ = self->priv->info_box;
#line 391 "../lib/Widgets/Card.vala"
		_tmp16_ = self->priv->title_label;
#line 391 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp15_, (GtkWidget*) _tmp16_);
#line 392 "../lib/Widgets/Card.vala"
		_tmp17_ = self->priv->info_box;
#line 392 "../lib/Widgets/Card.vala"
		_tmp18_ = self->priv->subtitle_label;
#line 392 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp17_, (GtkWidget*) _tmp18_);
#line 394 "../lib/Widgets/Card.vala"
		_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 394 "../lib/Widgets/Card.vala"
		g_object_ref_sink (_tmp19_);
#line 394 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->button_box);
#line 394 "../lib/Widgets/Card.vala"
		self->priv->button_box = _tmp19_;
#line 395 "../lib/Widgets/Card.vala"
		_tmp20_ = self->priv->button_box;
#line 395 "../lib/Widgets/Card.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_END);
#line 396 "../lib/Widgets/Card.vala"
		_tmp21_ = self->priv->button_box;
#line 396 "../lib/Widgets/Card.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
#line 398 "../lib/Widgets/Card.vala"
		_tmp22_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 398 "../lib/Widgets/Card.vala"
		g_object_ref_sink (_tmp22_);
#line 398 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->main_box);
#line 398 "../lib/Widgets/Card.vala"
		self->priv->main_box = _tmp22_;
#line 399 "../lib/Widgets/Card.vala"
		_tmp23_ = self->priv->main_box;
#line 399 "../lib/Widgets/Card.vala"
		_tmp24_ = self->priv->info_box;
#line 399 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp23_, (GtkWidget*) _tmp24_);
#line 400 "../lib/Widgets/Card.vala"
		_tmp25_ = self->priv->main_box;
#line 400 "../lib/Widgets/Card.vala"
		_tmp26_ = self->priv->button_box;
#line 400 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 402 "../lib/Widgets/Card.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "content-block");
#line 403 "../lib/Widgets/Card.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "mini-content-block");
#line 1646 "Card.c"
	} else {
		GtkImage* _tmp27_;
		GtkBox* _tmp28_;
		GtkBox* _tmp29_;
		GtkBox* _tmp30_;
		GtkBox* _tmp31_;
		GtkLabel* _tmp32_;
		GtkBox* _tmp33_;
		GtkLabel* _tmp34_;
		GtkBox* _tmp35_;
		GtkBox* _tmp36_;
		GtkBox* _tmp37_;
		GtkBox* _tmp38_;
		GtkBox* _tmp39_;
		GtkBox* _tmp40_;
		GtkImage* _tmp41_;
		GtkBox* _tmp42_;
		GtkBox* _tmp43_;
		GtkBox* _tmp44_;
		GtkBox* _tmp45_;
#line 406 "../lib/Widgets/Card.vala"
		_tmp27_ = self->priv->image;
#line 406 "../lib/Widgets/Card.vala"
		gtk_image_set_pixel_size (_tmp27_, 24);
#line 408 "../lib/Widgets/Card.vala"
		_tmp28_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 408 "../lib/Widgets/Card.vala"
		g_object_ref_sink (_tmp28_);
#line 408 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->info_box);
#line 408 "../lib/Widgets/Card.vala"
		self->priv->info_box = _tmp28_;
#line 409 "../lib/Widgets/Card.vala"
		_tmp29_ = self->priv->info_box;
#line 409 "../lib/Widgets/Card.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp29_, TRUE);
#line 410 "../lib/Widgets/Card.vala"
		_tmp30_ = self->priv->info_box;
#line 410 "../lib/Widgets/Card.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
#line 411 "../lib/Widgets/Card.vala"
		_tmp31_ = self->priv->info_box;
#line 411 "../lib/Widgets/Card.vala"
		_tmp32_ = self->priv->title_label;
#line 411 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 412 "../lib/Widgets/Card.vala"
		_tmp33_ = self->priv->info_box;
#line 412 "../lib/Widgets/Card.vala"
		_tmp34_ = self->priv->subtitle_label;
#line 412 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 414 "../lib/Widgets/Card.vala"
		_tmp35_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 414 "../lib/Widgets/Card.vala"
		g_object_ref_sink (_tmp35_);
#line 414 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->button_box);
#line 414 "../lib/Widgets/Card.vala"
		self->priv->button_box = _tmp35_;
#line 415 "../lib/Widgets/Card.vala"
		_tmp36_ = self->priv->button_box;
#line 415 "../lib/Widgets/Card.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp36_, TRUE);
#line 416 "../lib/Widgets/Card.vala"
		_tmp37_ = self->priv->button_box;
#line 416 "../lib/Widgets/Card.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
#line 418 "../lib/Widgets/Card.vala"
		_tmp38_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 418 "../lib/Widgets/Card.vala"
		g_object_ref_sink (_tmp38_);
#line 418 "../lib/Widgets/Card.vala"
		_g_object_unref0 (self->priv->main_box);
#line 418 "../lib/Widgets/Card.vala"
		self->priv->main_box = _tmp38_;
#line 419 "../lib/Widgets/Card.vala"
		_tmp39_ = self->priv->main_box;
#line 419 "../lib/Widgets/Card.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp39_, TRUE);
#line 420 "../lib/Widgets/Card.vala"
		_tmp40_ = self->priv->main_box;
#line 420 "../lib/Widgets/Card.vala"
		_tmp41_ = self->priv->image;
#line 420 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp40_, (GtkWidget*) _tmp41_);
#line 421 "../lib/Widgets/Card.vala"
		_tmp42_ = self->priv->main_box;
#line 421 "../lib/Widgets/Card.vala"
		_tmp43_ = self->priv->info_box;
#line 421 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp42_, (GtkWidget*) _tmp43_);
#line 422 "../lib/Widgets/Card.vala"
		_tmp44_ = self->priv->main_box;
#line 422 "../lib/Widgets/Card.vala"
		_tmp45_ = self->priv->button_box;
#line 422 "../lib/Widgets/Card.vala"
		gtk_box_append (_tmp44_, (GtkWidget*) _tmp45_);
#line 424 "../lib/Widgets/Card.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "mini-content-block");
#line 425 "../lib/Widgets/Card.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "content-block");
#line 1749 "Card.c"
	}
#line 428 "../lib/Widgets/Card.vala"
	_tmp46_ = self->priv->main_box;
#line 428 "../lib/Widgets/Card.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp46_, (GtkWidget*) self);
#line 431 "../lib/Widgets/Card.vala"
	_tmp47_ = temp_primary;
#line 431 "../lib/Widgets/Card.vala"
	if (_tmp47_ != NULL) {
#line 1759 "Card.c"
		HeButton* _tmp48_;
#line 432 "../lib/Widgets/Card.vala"
		_tmp48_ = temp_primary;
#line 432 "../lib/Widgets/Card.vala"
		he_card_set_primary_button (self, _tmp48_);
#line 1765 "Card.c"
	}
#line 435 "../lib/Widgets/Card.vala"
	_tmp49_ = temp_secondary;
#line 435 "../lib/Widgets/Card.vala"
	if (_tmp49_ != NULL) {
#line 1771 "Card.c"
		HeButton* _tmp50_;
#line 436 "../lib/Widgets/Card.vala"
		_tmp50_ = temp_secondary;
#line 436 "../lib/Widgets/Card.vala"
		he_card_set_secondary_button (self, _tmp50_);
#line 1777 "Card.c"
	}
#line 439 "../lib/Widgets/Card.vala"
	_tmp51_ = temp_widget;
#line 439 "../lib/Widgets/Card.vala"
	if (_tmp51_ != NULL) {
#line 1783 "Card.c"
		GtkWidget* _tmp52_;
#line 440 "../lib/Widgets/Card.vala"
		_tmp52_ = temp_widget;
#line 440 "../lib/Widgets/Card.vala"
		he_card_set_widget (self, _tmp52_);
#line 1789 "Card.c"
	}
#line 362 "../lib/Widgets/Card.vala"
	_g_object_unref0 (temp_widget);
#line 362 "../lib/Widgets/Card.vala"
	_g_object_unref0 (temp_secondary);
#line 362 "../lib/Widgets/Card.vala"
	_g_object_unref0 (temp_primary);
#line 1797 "Card.c"
}

static GObject *
he_card_constructor (GType type,
                     guint n_construct_properties,
                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeCard * self;
#line 448 "../lib/Widgets/Card.vala"
	parent_class = G_OBJECT_CLASS (he_card_parent_class);
#line 448 "../lib/Widgets/Card.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 448 "../lib/Widgets/Card.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CARD, HeCard);
#line 449 "../lib/Widgets/Card.vala"
	_g_free0 (self->priv->_title_text);
#line 449 "../lib/Widgets/Card.vala"
	self->priv->_title_text = NULL;
#line 450 "../lib/Widgets/Card.vala"
	_g_free0 (self->priv->_subtitle_text);
#line 450 "../lib/Widgets/Card.vala"
	self->priv->_subtitle_text = NULL;
#line 451 "../lib/Widgets/Card.vala"
	he_card_setup_components (self);
#line 448 "../lib/Widgets/Card.vala"
	return obj;
#line 1826 "Card.c"
}

static void
he_card_class_init (HeCardClass * klass,
                    gpointer klass_data)
{
#line 42 "../lib/Widgets/Card.vala"
	he_card_parent_class = g_type_class_peek_parent (klass);
#line 42 "../lib/Widgets/Card.vala"
	g_type_class_adjust_private_offset (klass, &HeCard_private_offset);
#line 42 "../lib/Widgets/Card.vala"
	((HeBinClass *) klass)->add_child = (void (*) (HeBin*, GtkBuilder*, GObject*, const gchar*)) he_card_real_add_child;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_title = (const gchar* (*) (HeCard*)) he_card_real_get_title;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_title = (void (*) (HeCard*, const gchar*)) he_card_real_set_title;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_subtitle = (const gchar* (*) (HeCard*)) he_card_real_get_subtitle;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_subtitle = (void (*) (HeCard*, const gchar*)) he_card_real_set_subtitle;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_icon = (const gchar* (*) (HeCard*)) he_card_real_get_icon;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_icon = (void (*) (HeCard*, const gchar*)) he_card_real_set_icon;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_gicon = (void (*) (HeCard*, GIcon*)) he_card_real_set_gicon;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_paintable = (void (*) (HeCard*, GdkPaintable*)) he_card_real_set_paintable;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_widget = (GtkWidget* (*) (HeCard*)) he_card_real_get_widget;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_widget = (void (*) (HeCard*, GtkWidget*)) he_card_real_set_widget;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_secondary_button = (HeButton* (*) (HeCard*)) he_card_real_get_secondary_button;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_secondary_button = (void (*) (HeCard*, HeButton*)) he_card_real_set_secondary_button;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_primary_button = (HeButton* (*) (HeCard*)) he_card_real_get_primary_button;
#line 42 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_primary_button = (void (*) (HeCard*, HeButton*)) he_card_real_set_primary_button;
#line 42 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_card_get_property;
#line 42 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_card_set_property;
#line 42 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->constructor = he_card_constructor;
#line 42 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->finalize = he_card_finalize;
#line 1875 "Card.c"
	/**
	     * Sets the type of the card for styling.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_CARD_TYPE_PROPERTY, he_card_properties[HE_CARD_CARD_TYPE_PROPERTY] = g_param_spec_enum ("card-type", "card-type", "card-type", HE_TYPE_CARD_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1881 "Card.c"
	/**
	     * Sets the layout of the card.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_LAYOUT_PROPERTY, he_card_properties[HE_CARD_LAYOUT_PROPERTY] = g_param_spec_enum ("layout", "layout", "layout", HE_TYPE_CARD_LAYOUT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1887 "Card.c"
	/**
	     * Sets the title of the card.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_TITLE_PROPERTY, he_card_properties[HE_CARD_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1893 "Card.c"
	/**
	     * Sets the subtitle of the card.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_SUBTITLE_PROPERTY, he_card_properties[HE_CARD_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1899 "Card.c"
	/**
	     * Sets the icon of the card.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_ICON_PROPERTY, he_card_properties[HE_CARD_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1905 "Card.c"
	/**
	     * Sets the icon of the card, as a GLib.Icon.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_GICON_PROPERTY, he_card_properties[HE_CARD_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 1911 "Card.c"
	/**
	     * Sets the icon of the card as a Gdk.Paintable.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_PAINTABLE_PROPERTY, he_card_properties[HE_CARD_PAINTABLE_PROPERTY] = g_param_spec_object ("paintable", "paintable", "paintable", gdk_paintable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 1917 "Card.c"
	/**
	     * Sets the widget of the card (for horizontal layout).
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_WIDGET_PROPERTY, he_card_properties[HE_CARD_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1923 "Card.c"
	/**
	     * Sets the secondary button of the card.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_SECONDARY_BUTTON_PROPERTY, he_card_properties[HE_CARD_SECONDARY_BUTTON_PROPERTY] = g_param_spec_object ("secondary-button", "secondary-button", "secondary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1929 "Card.c"
	/**
	     * Sets the primary button of the card.
	     */
#line 42 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CARD_PRIMARY_BUTTON_PROPERTY, he_card_properties[HE_CARD_PRIMARY_BUTTON_PROPERTY] = g_param_spec_object ("primary-button", "primary-button", "primary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 445 "../lib/Widgets/Card.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 1937 "Card.c"
}

static void
he_card_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                      gpointer iface_data)
{
#line 42 "../lib/Widgets/Card.vala"
	he_card_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 42 "../lib/Widgets/Card.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_card_real_add_child;
#line 1948 "Card.c"
}

static void
he_card_instance_init (HeCard * self,
                       gpointer klass)
{
	GtkImage* _tmp0_;
#line 42 "../lib/Widgets/Card.vala"
	self->priv = he_card_get_instance_private (self);
#line 45 "../lib/Widgets/Card.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 45 "../lib/Widgets/Card.vala"
	g_object_ref_sink (_tmp0_);
#line 45 "../lib/Widgets/Card.vala"
	self->priv->image = _tmp0_;
#line 57 "../lib/Widgets/Card.vala"
	self->priv->_card_type = HE_CARD_TYPE_DEFAULT;
#line 58 "../lib/Widgets/Card.vala"
	self->priv->_layout = HE_CARD_LAYOUT_VERTICAL;
#line 1968 "Card.c"
}

static void
he_card_finalize (GObject * obj)
{
	HeCard * self;
#line 42 "../lib/Widgets/Card.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CARD, HeCard);
#line 43 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->title_label);
#line 44 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->subtitle_label);
#line 45 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->image);
#line 46 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->info_box);
#line 47 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->button_box);
#line 48 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->main_box);
#line 49 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_secondary_button);
#line 50 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_primary_button);
#line 51 "../lib/Widgets/Card.vala"
	_g_object_unref0 (self->priv->_widget);
#line 54 "../lib/Widgets/Card.vala"
	_g_free0 (self->priv->_title_text);
#line 55 "../lib/Widgets/Card.vala"
	_g_free0 (self->priv->_subtitle_text);
#line 42 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (he_card_parent_class)->finalize (obj);
#line 2001 "Card.c"
}

/**
 * A Card displays content with an icon, text and optional buttons.
 * Combines functionality of ContentBlock and MiniContentBlock.
 */
static GType
he_card_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeCardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_card_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeCard), 0, (GInstanceInitFunc) he_card_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_card_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_card_type_id;
	he_card_type_id = g_type_register_static (HE_TYPE_BIN, "HeCard", &g_define_type_info, 0);
	g_type_add_interface_static (he_card_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeCard_private_offset = g_type_add_instance_private (he_card_type_id, sizeof (HeCardPrivate));
	return he_card_type_id;
}

GType
he_card_get_type (void)
{
	static volatile gsize he_card_type_id__once = 0;
	if (g_once_init_enter (&he_card_type_id__once)) {
		GType he_card_type_id;
		he_card_type_id = he_card_get_type_once ();
		g_once_init_leave (&he_card_type_id__once, he_card_type_id);
	}
	return he_card_type_id__once;
}

static void
_vala_he_card_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	HeCard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CARD, HeCard);
#line 42 "../lib/Widgets/Card.vala"
	switch (property_id) {
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_CARD_TYPE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_enum (value, he_card_get_card_type (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_LAYOUT_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_enum (value, he_card_get_layout (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_TITLE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_title (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_SUBTITLE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_subtitle (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_ICON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_icon (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_WIDGET_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_widget (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_SECONDARY_BUTTON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_secondary_button (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_PRIMARY_BUTTON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_primary_button (self));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 2090 "Card.c"
		default:
#line 42 "../lib/Widgets/Card.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 2096 "Card.c"
	}
}

static void
_vala_he_card_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	HeCard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CARD, HeCard);
#line 42 "../lib/Widgets/Card.vala"
	switch (property_id) {
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_CARD_TYPE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_card_type (self, g_value_get_enum (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_LAYOUT_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_layout (self, g_value_get_enum (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_TITLE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_title (self, g_value_get_string (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_SUBTITLE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_subtitle (self, g_value_get_string (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_ICON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_icon (self, g_value_get_string (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_GICON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_gicon (self, g_value_get_object (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_PAINTABLE_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_paintable (self, g_value_get_object (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_WIDGET_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_widget (self, g_value_get_object (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_SECONDARY_BUTTON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_secondary_button (self, g_value_get_object (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 42 "../lib/Widgets/Card.vala"
		case HE_CARD_PRIMARY_BUTTON_PROPERTY:
#line 42 "../lib/Widgets/Card.vala"
		he_card_set_primary_button (self, g_value_get_object (value));
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 2170 "Card.c"
		default:
#line 42 "../lib/Widgets/Card.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../lib/Widgets/Card.vala"
		break;
#line 2176 "Card.c"
	}
}

static const gchar*
he_content_block_real_get_title (HeCard* base)
{
	const gchar* result;
	HeContentBlock* self;
	const gchar* _tmp0_;
#line 458 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 458 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_content_block_parent_class)->get_title (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 458 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 458 "../lib/Widgets/Card.vala"
	return result;
#line 2194 "Card.c"
}

static void
he_content_block_real_set_title (HeCard* base,
                                 const gchar* value)
{
	HeContentBlock* self;
#line 459 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 459 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_content_block_parent_class)->set_title (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 459 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_content_block_properties[HE_CONTENT_BLOCK_TITLE_PROPERTY]);
#line 2208 "Card.c"
}

static const gchar*
he_content_block_real_get_subtitle (HeCard* base)
{
	const gchar* result;
	HeContentBlock* self;
	const gchar* _tmp0_;
#line 463 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 463 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_content_block_parent_class)->get_subtitle (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 463 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 463 "../lib/Widgets/Card.vala"
	return result;
#line 2225 "Card.c"
}

static void
he_content_block_real_set_subtitle (HeCard* base,
                                    const gchar* value)
{
	HeContentBlock* self;
#line 464 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 464 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_content_block_parent_class)->set_subtitle (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 464 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_content_block_properties[HE_CONTENT_BLOCK_SUBTITLE_PROPERTY]);
#line 2239 "Card.c"
}

static const gchar*
he_content_block_real_get_icon (HeCard* base)
{
	const gchar* result;
	HeContentBlock* self;
	const gchar* _tmp0_;
#line 468 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 468 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_content_block_parent_class)->get_icon (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 468 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 468 "../lib/Widgets/Card.vala"
	return result;
#line 2256 "Card.c"
}

static void
he_content_block_real_set_icon (HeCard* base,
                                const gchar* value)
{
	HeContentBlock* self;
#line 469 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 469 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_content_block_parent_class)->set_icon (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 469 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_content_block_properties[HE_CONTENT_BLOCK_ICON_PROPERTY]);
#line 2270 "Card.c"
}

static void
he_content_block_real_set_gicon (HeCard* base,
                                 GIcon* value)
{
	HeContentBlock* self;
#line 473 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 473 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_content_block_parent_class)->set_gicon (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 473 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_content_block_properties[HE_CONTENT_BLOCK_GICON_PROPERTY]);
#line 2284 "Card.c"
}

static HeButton*
he_content_block_real_get_secondary_button (HeCard* base)
{
	HeButton* result;
	HeContentBlock* self;
	HeButton* _tmp0_;
#line 477 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 477 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_content_block_parent_class)->get_secondary_button (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 477 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 477 "../lib/Widgets/Card.vala"
	return result;
#line 2301 "Card.c"
}

static void
he_content_block_real_set_secondary_button (HeCard* base,
                                            HeButton* value)
{
	HeContentBlock* self;
#line 478 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 478 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_content_block_parent_class)->set_secondary_button (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 478 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_content_block_properties[HE_CONTENT_BLOCK_SECONDARY_BUTTON_PROPERTY]);
#line 2315 "Card.c"
}

static HeButton*
he_content_block_real_get_primary_button (HeCard* base)
{
	HeButton* result;
	HeContentBlock* self;
	HeButton* _tmp0_;
#line 482 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 482 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_content_block_parent_class)->get_primary_button (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 482 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 482 "../lib/Widgets/Card.vala"
	return result;
#line 2332 "Card.c"
}

static void
he_content_block_real_set_primary_button (HeCard* base,
                                          HeButton* value)
{
	HeContentBlock* self;
#line 483 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) base;
#line 483 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_content_block_parent_class)->set_primary_button (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 483 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_content_block_properties[HE_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY]);
#line 2346 "Card.c"
}

HeContentBlock*
he_content_block_construct (GType object_type,
                            const gchar* title,
                            const gchar* subtitle,
                            const gchar* icon,
                            HeButton* primary_button,
                            HeButton* secondary_button)
{
	HeContentBlock * self = NULL;
#line 491 "../lib/Widgets/Card.vala"
	self = (HeContentBlock*) he_card_construct (object_type, title, subtitle, icon, primary_button, secondary_button);
#line 486 "../lib/Widgets/Card.vala"
	return self;
#line 2362 "Card.c"
}

HeContentBlock*
he_content_block_new (const gchar* title,
                      const gchar* subtitle,
                      const gchar* icon,
                      HeButton* primary_button,
                      HeButton* secondary_button)
{
#line 486 "../lib/Widgets/Card.vala"
	return he_content_block_construct (HE_TYPE_CONTENT_BLOCK, title, subtitle, icon, primary_button, secondary_button);
#line 2374 "Card.c"
}

static void
he_content_block_class_init (HeContentBlockClass * klass,
                             gpointer klass_data)
{
#line 456 "../lib/Widgets/Card.vala"
	he_content_block_parent_class = g_type_class_peek_parent (klass);
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_title = (const gchar* (*) (HeCard*)) he_content_block_real_get_title;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_title = (void (*) (HeCard*, const gchar*)) he_content_block_real_set_title;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_subtitle = (const gchar* (*) (HeCard*)) he_content_block_real_get_subtitle;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_subtitle = (void (*) (HeCard*, const gchar*)) he_content_block_real_set_subtitle;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_icon = (const gchar* (*) (HeCard*)) he_content_block_real_get_icon;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_icon = (void (*) (HeCard*, const gchar*)) he_content_block_real_set_icon;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_gicon = (void (*) (HeCard*, GIcon*)) he_content_block_real_set_gicon;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_secondary_button = (HeButton* (*) (HeCard*)) he_content_block_real_get_secondary_button;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_secondary_button = (void (*) (HeCard*, HeButton*)) he_content_block_real_set_secondary_button;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_primary_button = (HeButton* (*) (HeCard*)) he_content_block_real_get_primary_button;
#line 456 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_primary_button = (void (*) (HeCard*, HeButton*)) he_content_block_real_set_primary_button;
#line 456 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_content_block_get_property;
#line 456 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_content_block_set_property;
#line 456 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CONTENT_BLOCK_TITLE_PROPERTY, he_content_block_properties[HE_CONTENT_BLOCK_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 456 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CONTENT_BLOCK_SUBTITLE_PROPERTY, he_content_block_properties[HE_CONTENT_BLOCK_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 456 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CONTENT_BLOCK_ICON_PROPERTY, he_content_block_properties[HE_CONTENT_BLOCK_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 456 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CONTENT_BLOCK_GICON_PROPERTY, he_content_block_properties[HE_CONTENT_BLOCK_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 456 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CONTENT_BLOCK_SECONDARY_BUTTON_PROPERTY, he_content_block_properties[HE_CONTENT_BLOCK_SECONDARY_BUTTON_PROPERTY] = g_param_spec_object ("secondary-button", "secondary-button", "secondary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 456 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY, he_content_block_properties[HE_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY] = g_param_spec_object ("primary-button", "primary-button", "primary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2421 "Card.c"
}

static void
he_content_block_instance_init (HeContentBlock * self,
                                gpointer klass)
{
}

static GType
he_content_block_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeContentBlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_content_block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeContentBlock), 0, (GInstanceInitFunc) he_content_block_instance_init, NULL };
	GType he_content_block_type_id;
	he_content_block_type_id = g_type_register_static (HE_TYPE_CARD, "HeContentBlock", &g_define_type_info, 0);
	return he_content_block_type_id;
}

GType
he_content_block_get_type (void)
{
	static volatile gsize he_content_block_type_id__once = 0;
	if (g_once_init_enter (&he_content_block_type_id__once)) {
		GType he_content_block_type_id;
		he_content_block_type_id = he_content_block_get_type_once ();
		g_once_init_leave (&he_content_block_type_id__once, he_content_block_type_id);
	}
	return he_content_block_type_id__once;
}

static void
_vala_he_content_block_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	HeContentBlock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CONTENT_BLOCK, HeContentBlock);
#line 456 "../lib/Widgets/Card.vala"
	switch (property_id) {
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_TITLE_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_title ((HeCard*) self));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_SUBTITLE_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_subtitle ((HeCard*) self));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_ICON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_icon ((HeCard*) self));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_SECONDARY_BUTTON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_secondary_button ((HeCard*) self));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_primary_button ((HeCard*) self));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 2491 "Card.c"
		default:
#line 456 "../lib/Widgets/Card.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 2497 "Card.c"
	}
}

static void
_vala_he_content_block_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	HeContentBlock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CONTENT_BLOCK, HeContentBlock);
#line 456 "../lib/Widgets/Card.vala"
	switch (property_id) {
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_TITLE_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		he_card_set_title ((HeCard*) self, g_value_get_string (value));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_SUBTITLE_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		he_card_set_subtitle ((HeCard*) self, g_value_get_string (value));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_ICON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		he_card_set_icon ((HeCard*) self, g_value_get_string (value));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_GICON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		he_card_set_gicon ((HeCard*) self, g_value_get_object (value));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_SECONDARY_BUTTON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		he_card_set_secondary_button ((HeCard*) self, g_value_get_object (value));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 456 "../lib/Widgets/Card.vala"
		case HE_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY:
#line 456 "../lib/Widgets/Card.vala"
		he_card_set_primary_button ((HeCard*) self, g_value_get_object (value));
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 2547 "Card.c"
		default:
#line 456 "../lib/Widgets/Card.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 456 "../lib/Widgets/Card.vala"
		break;
#line 2553 "Card.c"
	}
}

static GtkWidget*
he_mini_content_block_real_get_widget (HeCard* base)
{
	GtkWidget* result;
	HeMiniContentBlock* self;
	GtkWidget* _tmp0_;
#line 497 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 497 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_mini_content_block_parent_class)->get_widget (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 497 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 497 "../lib/Widgets/Card.vala"
	return result;
#line 2571 "Card.c"
}

static void
he_mini_content_block_real_set_widget (HeCard* base,
                                       GtkWidget* value)
{
	HeMiniContentBlock* self;
#line 498 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 498 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_widget (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 498 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_WIDGET_PROPERTY]);
#line 2585 "Card.c"
}

static const gchar*
he_mini_content_block_real_get_title (HeCard* base)
{
	const gchar* result;
	HeMiniContentBlock* self;
	const gchar* _tmp0_;
#line 502 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 502 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_mini_content_block_parent_class)->get_title (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 502 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 502 "../lib/Widgets/Card.vala"
	return result;
#line 2602 "Card.c"
}

static void
he_mini_content_block_real_set_title (HeCard* base,
                                      const gchar* value)
{
	HeMiniContentBlock* self;
#line 503 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 503 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_title (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 503 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_TITLE_PROPERTY]);
#line 2616 "Card.c"
}

static const gchar*
he_mini_content_block_real_get_subtitle (HeCard* base)
{
	const gchar* result;
	HeMiniContentBlock* self;
	const gchar* _tmp0_;
#line 507 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 507 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_mini_content_block_parent_class)->get_subtitle (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 507 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 507 "../lib/Widgets/Card.vala"
	return result;
#line 2633 "Card.c"
}

static void
he_mini_content_block_real_set_subtitle (HeCard* base,
                                         const gchar* value)
{
	HeMiniContentBlock* self;
#line 508 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 508 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_subtitle (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 508 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_SUBTITLE_PROPERTY]);
#line 2647 "Card.c"
}

static const gchar*
he_mini_content_block_real_get_icon (HeCard* base)
{
	const gchar* result;
	HeMiniContentBlock* self;
	const gchar* _tmp0_;
#line 512 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 512 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_mini_content_block_parent_class)->get_icon (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 512 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 512 "../lib/Widgets/Card.vala"
	return result;
#line 2664 "Card.c"
}

static void
he_mini_content_block_real_set_icon (HeCard* base,
                                     const gchar* value)
{
	HeMiniContentBlock* self;
#line 513 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 513 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_icon (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 513 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_ICON_PROPERTY]);
#line 2678 "Card.c"
}

static void
he_mini_content_block_real_set_gicon (HeCard* base,
                                      GIcon* value)
{
	HeMiniContentBlock* self;
#line 517 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 517 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_gicon (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 517 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_GICON_PROPERTY]);
#line 2692 "Card.c"
}

static void
he_mini_content_block_real_set_paintable (HeCard* base,
                                          GdkPaintable* value)
{
	HeMiniContentBlock* self;
#line 521 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 521 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_paintable (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 521 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_PAINTABLE_PROPERTY]);
#line 2706 "Card.c"
}

static HeButton*
he_mini_content_block_real_get_primary_button (HeCard* base)
{
	HeButton* result;
	HeMiniContentBlock* self;
	HeButton* _tmp0_;
#line 525 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 525 "../lib/Widgets/Card.vala"
	_tmp0_ = HE_CARD_CLASS (he_mini_content_block_parent_class)->get_primary_button (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard));
#line 525 "../lib/Widgets/Card.vala"
	result = _tmp0_;
#line 525 "../lib/Widgets/Card.vala"
	return result;
#line 2723 "Card.c"
}

static void
he_mini_content_block_real_set_primary_button (HeCard* base,
                                               HeButton* value)
{
	HeMiniContentBlock* self;
#line 526 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) base;
#line 526 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (he_mini_content_block_parent_class)->set_primary_button (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_CARD, HeCard), value);
#line 526 "../lib/Widgets/Card.vala"
	g_object_notify_by_pspec ((GObject *) self, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY]);
#line 2737 "Card.c"
}

HeMiniContentBlock*
he_mini_content_block_construct (GType object_type)
{
	HeMiniContentBlock * self = NULL;
#line 530 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) he_card_construct_horizontal (object_type, NULL, NULL, NULL, NULL, NULL);
#line 529 "../lib/Widgets/Card.vala"
	return self;
#line 2748 "Card.c"
}

HeMiniContentBlock*
he_mini_content_block_new (void)
{
#line 529 "../lib/Widgets/Card.vala"
	return he_mini_content_block_construct (HE_TYPE_MINI_CONTENT_BLOCK);
#line 2756 "Card.c"
}

HeMiniContentBlock*
he_mini_content_block_construct_with_details (GType object_type,
                                              const gchar* title,
                                              const gchar* subtitle,
                                              HeButton* primary_button,
                                              GtkWidget* widget)
{
	HeMiniContentBlock * self = NULL;
#line 537 "../lib/Widgets/Card.vala"
	self = (HeMiniContentBlock*) he_card_construct_horizontal (object_type, title, subtitle, NULL, primary_button, widget);
#line 538 "../lib/Widgets/Card.vala"
	he_card_set_widget ((HeCard*) self, widget);
#line 533 "../lib/Widgets/Card.vala"
	return self;
#line 2773 "Card.c"
}

HeMiniContentBlock*
he_mini_content_block_new_with_details (const gchar* title,
                                        const gchar* subtitle,
                                        HeButton* primary_button,
                                        GtkWidget* widget)
{
#line 533 "../lib/Widgets/Card.vala"
	return he_mini_content_block_construct_with_details (HE_TYPE_MINI_CONTENT_BLOCK, title, subtitle, primary_button, widget);
#line 2784 "Card.c"
}

static void
he_mini_content_block_class_init (HeMiniContentBlockClass * klass,
                                  gpointer klass_data)
{
#line 495 "../lib/Widgets/Card.vala"
	he_mini_content_block_parent_class = g_type_class_peek_parent (klass);
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_widget = (GtkWidget* (*) (HeCard*)) he_mini_content_block_real_get_widget;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_widget = (void (*) (HeCard*, GtkWidget*)) he_mini_content_block_real_set_widget;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_title = (const gchar* (*) (HeCard*)) he_mini_content_block_real_get_title;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_title = (void (*) (HeCard*, const gchar*)) he_mini_content_block_real_set_title;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_subtitle = (const gchar* (*) (HeCard*)) he_mini_content_block_real_get_subtitle;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_subtitle = (void (*) (HeCard*, const gchar*)) he_mini_content_block_real_set_subtitle;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_icon = (const gchar* (*) (HeCard*)) he_mini_content_block_real_get_icon;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_icon = (void (*) (HeCard*, const gchar*)) he_mini_content_block_real_set_icon;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_gicon = (void (*) (HeCard*, GIcon*)) he_mini_content_block_real_set_gicon;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_paintable = (void (*) (HeCard*, GdkPaintable*)) he_mini_content_block_real_set_paintable;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->get_primary_button = (HeButton* (*) (HeCard*)) he_mini_content_block_real_get_primary_button;
#line 495 "../lib/Widgets/Card.vala"
	HE_CARD_CLASS (klass)->set_primary_button = (void (*) (HeCard*, HeButton*)) he_mini_content_block_real_set_primary_button;
#line 495 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_mini_content_block_get_property;
#line 495 "../lib/Widgets/Card.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_mini_content_block_set_property;
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_WIDGET_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_TITLE_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_SUBTITLE_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_ICON_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_GICON_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_PAINTABLE_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_PAINTABLE_PROPERTY] = g_param_spec_object ("paintable", "paintable", "paintable", gdk_paintable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 495 "../lib/Widgets/Card.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_MINI_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY, he_mini_content_block_properties[HE_MINI_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY] = g_param_spec_object ("primary-button", "primary-button", "primary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2835 "Card.c"
}

static void
he_mini_content_block_instance_init (HeMiniContentBlock * self,
                                     gpointer klass)
{
}

static GType
he_mini_content_block_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeMiniContentBlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_mini_content_block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeMiniContentBlock), 0, (GInstanceInitFunc) he_mini_content_block_instance_init, NULL };
	GType he_mini_content_block_type_id;
	he_mini_content_block_type_id = g_type_register_static (HE_TYPE_CARD, "HeMiniContentBlock", &g_define_type_info, 0);
	return he_mini_content_block_type_id;
}

GType
he_mini_content_block_get_type (void)
{
	static volatile gsize he_mini_content_block_type_id__once = 0;
	if (g_once_init_enter (&he_mini_content_block_type_id__once)) {
		GType he_mini_content_block_type_id;
		he_mini_content_block_type_id = he_mini_content_block_get_type_once ();
		g_once_init_leave (&he_mini_content_block_type_id__once, he_mini_content_block_type_id);
	}
	return he_mini_content_block_type_id__once;
}

static void
_vala_he_mini_content_block_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	HeMiniContentBlock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_MINI_CONTENT_BLOCK, HeMiniContentBlock);
#line 495 "../lib/Widgets/Card.vala"
	switch (property_id) {
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_WIDGET_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_widget ((HeCard*) self));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_TITLE_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_title ((HeCard*) self));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_SUBTITLE_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_subtitle ((HeCard*) self));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_ICON_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		g_value_set_string (value, he_card_get_icon ((HeCard*) self));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		g_value_set_object (value, he_card_get_primary_button ((HeCard*) self));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 2905 "Card.c"
		default:
#line 495 "../lib/Widgets/Card.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 2911 "Card.c"
	}
}

static void
_vala_he_mini_content_block_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	HeMiniContentBlock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_MINI_CONTENT_BLOCK, HeMiniContentBlock);
#line 495 "../lib/Widgets/Card.vala"
	switch (property_id) {
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_WIDGET_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_widget ((HeCard*) self, g_value_get_object (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_TITLE_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_title ((HeCard*) self, g_value_get_string (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_SUBTITLE_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_subtitle ((HeCard*) self, g_value_get_string (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_ICON_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_icon ((HeCard*) self, g_value_get_string (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_GICON_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_gicon ((HeCard*) self, g_value_get_object (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_PAINTABLE_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_paintable ((HeCard*) self, g_value_get_object (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 495 "../lib/Widgets/Card.vala"
		case HE_MINI_CONTENT_BLOCK_PRIMARY_BUTTON_PROPERTY:
#line 495 "../lib/Widgets/Card.vala"
		he_card_set_primary_button ((HeCard*) self, g_value_get_object (value));
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 2967 "Card.c"
		default:
#line 495 "../lib/Widgets/Card.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 495 "../lib/Widgets/Card.vala"
		break;
#line 2973 "Card.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

