/* ChipGroup.c generated by valac 0.56.18, the Vala compiler
 * generated from ChipGroup.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_CHIP_GROUP_0_PROPERTY,
	HE_CHIP_GROUP_SELECTION_MODEL_PROPERTY,
	HE_CHIP_GROUP_SINGLE_LINE_PROPERTY,
	HE_CHIP_GROUP_MODE_PROPERTY,
	HE_CHIP_GROUP_SHOW_CLOSE_BUTTONS_PROPERTY,
	HE_CHIP_GROUP_NUM_PROPERTIES
};
static GParamSpec* he_chip_group_properties[HE_CHIP_GROUP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
enum  {
	HE_CHIP_GROUP_FILTERS_CHANGED_SIGNAL,
	HE_CHIP_GROUP_CHIP_REMOVED_SIGNAL,
	HE_CHIP_GROUP_NUM_SIGNALS
};
static guint he_chip_group_signals[HE_CHIP_GROUP_NUM_SIGNALS] = {0};

struct _HeChipGroupPrivate {
	GtkSingleSelection* _selection_model;
	GList* _buttons;
	GtkFlowBox* flowbox;
	GtkScrolledWindow* sw;
	gboolean _single_line;
	HeChipGroupMode _mode;
	gboolean _show_close_buttons;
};

struct _Block6Data {
	int _ref_count_;
	HeChipGroup* self;
	HeChip* button;
};

static gint HeChipGroup_private_offset;
static gpointer he_chip_group_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void he_chip_group_on_selection_changed (HeChipGroup* self,
                                         guint position,
                                         guint n_items);
static void _he_chip_group_on_selection_changed_gtk_selection_model_selection_changed (GtkSelectionModel* _sender,
                                                                                guint position,
                                                                                guint n_items,
                                                                                gpointer self);
static void he_chip_group_on_selection_items_changed (HeChipGroup* self,
                                               guint position,
                                               guint removed,
                                               guint added);
static void _he_chip_group_on_selection_items_changed_g_list_model_items_changed (GListModel* _sender,
                                                                           guint position,
                                                                           guint removed,
                                                                           guint added,
                                                                           gpointer self);
static void he_chip_group_remove_chip (HeChipGroup* self,
                                guint position);
static void he_chip_group_update_close_buttons (HeChipGroup* self);
static void he_chip_group_update_chip_groups (HeChipGroup* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _____lambda117_ (Block6Data* _data6_);
static void he_chip_group_on_button_toggled (HeChipGroup* self,
                                      HeChip* button);
static void ______lambda117__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                 gpointer self);
static void _____lambda118_ (Block6Data* _data6_);
static void ______lambda118__he_chip_close_clicked (HeChip* _sender,
                                             gpointer self);
static void _vala_array_add29 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
static GObject * he_chip_group_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void he_chip_group_finalize (GObject * obj);
static GType he_chip_group_get_type_once (void);
static void _vala_he_chip_group_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_he_chip_group_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * Modes for ChipGroup behavior.
 * Selection mode - chips behave as radio buttons, only one can be active.
 * Filtering mode - multiple chips can be active simultaneously.
 *
 * @since 1.0
 */
static GType
he_chip_group_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_CHIP_GROUP_MODE_SELECTION, "HE_CHIP_GROUP_MODE_SELECTION", "selection"}, {HE_CHIP_GROUP_MODE_FILTERING, "HE_CHIP_GROUP_MODE_FILTERING", "filtering"}, {0, NULL, NULL}};
	GType he_chip_group_mode_type_id;
	he_chip_group_mode_type_id = g_enum_register_static ("HeChipGroupMode", values);
	return he_chip_group_mode_type_id;
}

GType
he_chip_group_mode_get_type (void)
{
	static volatile gsize he_chip_group_mode_type_id__once = 0;
	if (g_once_init_enter (&he_chip_group_mode_type_id__once)) {
		GType he_chip_group_mode_type_id;
		he_chip_group_mode_type_id = he_chip_group_mode_get_type_once ();
		g_once_init_leave (&he_chip_group_mode_type_id__once, he_chip_group_mode_type_id);
	}
	return he_chip_group_mode_type_id__once;
}

static inline gpointer
he_chip_group_get_instance_private (HeChipGroup* self)
{
	return G_STRUCT_MEMBER_P (self, HeChipGroup_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../lib/Widgets/ChipGroup.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 168 "ChipGroup.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 37 "../lib/Widgets/ChipGroup.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 176 "ChipGroup.c"
}

GtkSingleSelection*
he_chip_group_get_selection_model (HeChipGroup* self)
{
	GtkSingleSelection* result;
	GtkSingleSelection* _tmp0_;
#line 47 "../lib/Widgets/ChipGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = self->priv->_selection_model;
#line 47 "../lib/Widgets/ChipGroup.vala"
	result = _tmp0_;
#line 47 "../lib/Widgets/ChipGroup.vala"
	return result;
#line 192 "ChipGroup.c"
}

static void
_he_chip_group_on_selection_changed_gtk_selection_model_selection_changed (GtkSelectionModel* _sender,
                                                                           guint position,
                                                                           guint n_items,
                                                                           gpointer self)
{
#line 52 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_on_selection_changed ((HeChipGroup*) self, position, n_items);
#line 203 "ChipGroup.c"
}

static void
_he_chip_group_on_selection_items_changed_g_list_model_items_changed (GListModel* _sender,
                                                                      guint position,
                                                                      guint removed,
                                                                      guint added,
                                                                      gpointer self)
{
#line 53 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_on_selection_items_changed ((HeChipGroup*) self, position, removed, added);
#line 215 "ChipGroup.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../lib/Widgets/ChipGroup.vala"
	return self ? g_object_ref (self) : NULL;
#line 223 "ChipGroup.c"
}

void
he_chip_group_set_selection_model (HeChipGroup* self,
                                   GtkSingleSelection* value)
{
	GtkSingleSelection* _tmp0_;
	GtkSingleSelection* _tmp1_;
	GtkSingleSelection* _tmp6_;
	GtkSingleSelection* _tmp7_;
	GtkSingleSelection* _tmp8_;
	GtkSingleSelection* _tmp9_;
#line 48 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 49 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = self->priv->_selection_model;
#line 49 "../lib/Widgets/ChipGroup.vala"
	if (_tmp0_ == value) {
#line 49 "../lib/Widgets/ChipGroup.vala"
		return;
#line 244 "ChipGroup.c"
	}
#line 51 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = self->priv->_selection_model;
#line 51 "../lib/Widgets/ChipGroup.vala"
	if (_tmp1_ != NULL) {
#line 250 "ChipGroup.c"
		GtkSingleSelection* _tmp2_;
		guint _tmp3_;
		GtkSingleSelection* _tmp4_;
		guint _tmp5_;
#line 52 "../lib/Widgets/ChipGroup.vala"
		_tmp2_ = self->priv->_selection_model;
#line 52 "../lib/Widgets/ChipGroup.vala"
		g_signal_parse_name ("selection-changed", gtk_selection_model_get_type (), &_tmp3_, NULL, FALSE);
#line 52 "../lib/Widgets/ChipGroup.vala"
		g_signal_handlers_disconnect_matched ((GtkSelectionModel*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _he_chip_group_on_selection_changed_gtk_selection_model_selection_changed, self);
#line 53 "../lib/Widgets/ChipGroup.vala"
		_tmp4_ = self->priv->_selection_model;
#line 53 "../lib/Widgets/ChipGroup.vala"
		g_signal_parse_name ("items-changed", g_list_model_get_type (), &_tmp5_, NULL, FALSE);
#line 53 "../lib/Widgets/ChipGroup.vala"
		g_signal_handlers_disconnect_matched ((GListModel*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _he_chip_group_on_selection_items_changed_g_list_model_items_changed, self);
#line 267 "ChipGroup.c"
	}
#line 56 "../lib/Widgets/ChipGroup.vala"
	_tmp6_ = _g_object_ref0 (value);
#line 56 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (self->priv->_selection_model);
#line 56 "../lib/Widgets/ChipGroup.vala"
	self->priv->_selection_model = _tmp6_;
#line 58 "../lib/Widgets/ChipGroup.vala"
	_tmp7_ = self->priv->_selection_model;
#line 58 "../lib/Widgets/ChipGroup.vala"
	g_signal_connect_object ((GtkSelectionModel*) _tmp7_, "selection-changed", (GCallback) _he_chip_group_on_selection_changed_gtk_selection_model_selection_changed, self, 0);
#line 59 "../lib/Widgets/ChipGroup.vala"
	_tmp8_ = self->priv->_selection_model;
#line 59 "../lib/Widgets/ChipGroup.vala"
	g_signal_connect_object ((GListModel*) _tmp8_, "items-changed", (GCallback) _he_chip_group_on_selection_items_changed_g_list_model_items_changed, self, 0);
#line 61 "../lib/Widgets/ChipGroup.vala"
	_tmp9_ = self->priv->_selection_model;
#line 61 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_on_selection_items_changed (self, (guint) 0, (guint) 0, g_list_model_get_n_items ((GListModel*) _tmp9_));
#line 48 "../lib/Widgets/ChipGroup.vala"
	g_object_notify_by_pspec ((GObject *) self, he_chip_group_properties[HE_CHIP_GROUP_SELECTION_MODEL_PROPERTY]);
#line 289 "ChipGroup.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5234 "glib-2.0.vapi"
	l = self;
#line 5235 "glib-2.0.vapi"
	while (TRUE) {
#line 303 "ChipGroup.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5235 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5235 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5235 "glib-2.0.vapi"
			break;
#line 313 "ChipGroup.c"
		}
#line 5236 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5236 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5236 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 321 "ChipGroup.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5237 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5237 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5237 "glib-2.0.vapi"
			l = _tmp4_;
#line 330 "ChipGroup.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5239 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5239 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5239 "glib-2.0.vapi"
			func (_tmp6_);
#line 5240 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5240 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5241 "glib-2.0.vapi"
			break;
#line 347 "ChipGroup.c"
		}
	}
#line 5244 "glib-2.0.vapi"
	result = self;
#line 5244 "glib-2.0.vapi"
	return result;
#line 354 "ChipGroup.c"
}

static void
he_chip_group_remove_chip (HeChipGroup* self,
                           guint position)
{
	GList* _tmp0_;
	HeChip* chip = NULL;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	HeChip* _tmp3_;
	HeChip* _tmp4_;
#line 65 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = self->priv->_buttons;
#line 66 "../lib/Widgets/ChipGroup.vala"
	if (position >= g_list_length (_tmp0_)) {
#line 66 "../lib/Widgets/ChipGroup.vala"
		return;
#line 375 "ChipGroup.c"
	}
#line 68 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = self->priv->_buttons;
#line 68 "../lib/Widgets/ChipGroup.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, position);
#line 68 "../lib/Widgets/ChipGroup.vala"
	_tmp3_ = _g_object_ref0 ((HeChip*) _tmp2_);
#line 68 "../lib/Widgets/ChipGroup.vala"
	chip = _tmp3_;
#line 69 "../lib/Widgets/ChipGroup.vala"
	_tmp4_ = chip;
#line 69 "../lib/Widgets/ChipGroup.vala"
	if (_tmp4_ != NULL) {
#line 389 "ChipGroup.c"
		HeChip* _tmp5_;
		HeChip* _tmp6_;
#line 71 "../lib/Widgets/ChipGroup.vala"
		_tmp5_ = chip;
#line 71 "../lib/Widgets/ChipGroup.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp5_);
#line 72 "../lib/Widgets/ChipGroup.vala"
		_tmp6_ = chip;
#line 72 "../lib/Widgets/ChipGroup.vala"
		self->priv->_buttons = vala_g_list_remove_full (self->priv->_buttons, _tmp6_, _g_object_unref0_);
#line 75 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_update_close_buttons (self);
#line 78 "../lib/Widgets/ChipGroup.vala"
		g_signal_emit (self, he_chip_group_signals[HE_CHIP_GROUP_CHIP_REMOVED_SIGNAL], 0, position);
#line 404 "ChipGroup.c"
	}
#line 65 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (chip);
#line 408 "ChipGroup.c"
}

gboolean
he_chip_group_get_single_line (HeChipGroup* self)
{
	gboolean result;
#line 87 "../lib/Widgets/ChipGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../lib/Widgets/ChipGroup.vala"
	result = self->priv->_single_line;
#line 87 "../lib/Widgets/ChipGroup.vala"
	return result;
#line 421 "ChipGroup.c"
}

void
he_chip_group_set_single_line (HeChipGroup* self,
                               gboolean value)
{
#line 88 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 89 "../lib/Widgets/ChipGroup.vala"
	self->priv->_single_line = value;
#line 90 "../lib/Widgets/ChipGroup.vala"
	if (value) {
#line 434 "ChipGroup.c"
		GtkFlowBox* _tmp0_;
		GtkScrolledWindow* _tmp1_;
#line 91 "../lib/Widgets/ChipGroup.vala"
		_tmp0_ = self->priv->flowbox;
#line 91 "../lib/Widgets/ChipGroup.vala"
		gtk_flow_box_set_min_children_per_line (_tmp0_, (guint) 999);
#line 92 "../lib/Widgets/ChipGroup.vala"
		_tmp1_ = self->priv->sw;
#line 92 "../lib/Widgets/ChipGroup.vala"
		g_object_set (_tmp1_, "hscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 445 "ChipGroup.c"
	} else {
		GtkFlowBox* _tmp2_;
		GtkScrolledWindow* _tmp3_;
#line 94 "../lib/Widgets/ChipGroup.vala"
		_tmp2_ = self->priv->flowbox;
#line 94 "../lib/Widgets/ChipGroup.vala"
		gtk_flow_box_set_min_children_per_line (_tmp2_, (guint) 3);
#line 95 "../lib/Widgets/ChipGroup.vala"
		_tmp3_ = self->priv->sw;
#line 95 "../lib/Widgets/ChipGroup.vala"
		g_object_set (_tmp3_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 457 "ChipGroup.c"
	}
#line 88 "../lib/Widgets/ChipGroup.vala"
	g_object_notify_by_pspec ((GObject *) self, he_chip_group_properties[HE_CHIP_GROUP_SINGLE_LINE_PROPERTY]);
#line 461 "ChipGroup.c"
}

HeChipGroupMode
he_chip_group_get_mode (HeChipGroup* self)
{
	HeChipGroupMode result;
#line 109 "../lib/Widgets/ChipGroup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 109 "../lib/Widgets/ChipGroup.vala"
	result = self->priv->_mode;
#line 109 "../lib/Widgets/ChipGroup.vala"
	return result;
#line 474 "ChipGroup.c"
}

void
he_chip_group_set_mode (HeChipGroup* self,
                        HeChipGroupMode value)
{
#line 110 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 111 "../lib/Widgets/ChipGroup.vala"
	self->priv->_mode = value;
#line 112 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_update_chip_groups (self);
#line 110 "../lib/Widgets/ChipGroup.vala"
	g_object_notify_by_pspec ((GObject *) self, he_chip_group_properties[HE_CHIP_GROUP_MODE_PROPERTY]);
#line 489 "ChipGroup.c"
}

gboolean
he_chip_group_get_show_close_buttons (HeChipGroup* self)
{
	gboolean result;
#line 125 "../lib/Widgets/ChipGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "../lib/Widgets/ChipGroup.vala"
	result = self->priv->_show_close_buttons;
#line 125 "../lib/Widgets/ChipGroup.vala"
	return result;
#line 502 "ChipGroup.c"
}

void
he_chip_group_set_show_close_buttons (HeChipGroup* self,
                                      gboolean value)
{
#line 126 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 127 "../lib/Widgets/ChipGroup.vala"
	self->priv->_show_close_buttons = value;
#line 128 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_update_close_buttons (self);
#line 126 "../lib/Widgets/ChipGroup.vala"
	g_object_notify_by_pspec ((GObject *) self, he_chip_group_properties[HE_CHIP_GROUP_SHOW_CLOSE_BUTTONS_PROPERTY]);
#line 517 "ChipGroup.c"
}

/**
     * Creates a new ChipGroup.
     */
HeChipGroup*
he_chip_group_construct (GType object_type)
{
	HeChipGroup * self = NULL;
#line 153 "../lib/Widgets/ChipGroup.vala"
	self = (HeChipGroup*) he_bin_construct (object_type);
#line 152 "../lib/Widgets/ChipGroup.vala"
	return self;
#line 531 "ChipGroup.c"
}

HeChipGroup*
he_chip_group_new (void)
{
#line 152 "../lib/Widgets/ChipGroup.vala"
	return he_chip_group_construct (HE_TYPE_CHIP_GROUP);
#line 539 "ChipGroup.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5301 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5301 "glib-2.0.vapi"
	return result;
#line 550 "ChipGroup.c"
}

static void
he_chip_group_update_chip_groups (HeChipGroup* self)
{
	GList* _tmp0_;
	HeChipGroupMode _tmp1_;
	HeChipGroupMode _tmp2_;
#line 173 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 174 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = self->priv->_buttons;
#line 174 "../lib/Widgets/ChipGroup.vala"
	if (vala_g_list_is_empty (_tmp0_)) {
#line 174 "../lib/Widgets/ChipGroup.vala"
		return;
#line 567 "ChipGroup.c"
	}
#line 176 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = he_chip_group_get_mode (self);
#line 176 "../lib/Widgets/ChipGroup.vala"
	_tmp2_ = _tmp1_;
#line 176 "../lib/Widgets/ChipGroup.vala"
	if (_tmp2_ == HE_CHIP_GROUP_MODE_SELECTION) {
#line 575 "ChipGroup.c"
		HeChip* first_chip = NULL;
		GList* _tmp3_;
		gconstpointer _tmp4_;
		HeChip* _tmp5_;
#line 178 "../lib/Widgets/ChipGroup.vala"
		_tmp3_ = self->priv->_buttons;
#line 178 "../lib/Widgets/ChipGroup.vala"
		_tmp4_ = g_list_nth_data (_tmp3_, (guint) 0);
#line 178 "../lib/Widgets/ChipGroup.vala"
		_tmp5_ = _g_object_ref0 ((HeChip*) _tmp4_);
#line 178 "../lib/Widgets/ChipGroup.vala"
		first_chip = _tmp5_;
#line 588 "ChipGroup.c"
		{
			guint i = 0U;
#line 179 "../lib/Widgets/ChipGroup.vala"
			i = (guint) 1;
#line 593 "ChipGroup.c"
			{
				gboolean _tmp6_ = FALSE;
#line 179 "../lib/Widgets/ChipGroup.vala"
				_tmp6_ = TRUE;
#line 179 "../lib/Widgets/ChipGroup.vala"
				while (TRUE) {
#line 600 "ChipGroup.c"
					GList* _tmp8_;
					HeChip* chip = NULL;
					GList* _tmp9_;
					gconstpointer _tmp10_;
					HeChip* _tmp11_;
					gboolean _tmp12_ = FALSE;
					HeChip* _tmp13_;
#line 179 "../lib/Widgets/ChipGroup.vala"
					if (!_tmp6_) {
#line 610 "ChipGroup.c"
						guint _tmp7_;
#line 179 "../lib/Widgets/ChipGroup.vala"
						_tmp7_ = i;
#line 179 "../lib/Widgets/ChipGroup.vala"
						i = _tmp7_ + 1;
#line 616 "ChipGroup.c"
					}
#line 179 "../lib/Widgets/ChipGroup.vala"
					_tmp6_ = FALSE;
#line 179 "../lib/Widgets/ChipGroup.vala"
					_tmp8_ = self->priv->_buttons;
#line 179 "../lib/Widgets/ChipGroup.vala"
					if (!(i < g_list_length (_tmp8_))) {
#line 179 "../lib/Widgets/ChipGroup.vala"
						break;
#line 626 "ChipGroup.c"
					}
#line 180 "../lib/Widgets/ChipGroup.vala"
					_tmp9_ = self->priv->_buttons;
#line 180 "../lib/Widgets/ChipGroup.vala"
					_tmp10_ = g_list_nth_data (_tmp9_, i);
#line 180 "../lib/Widgets/ChipGroup.vala"
					_tmp11_ = _g_object_ref0 ((HeChip*) _tmp10_);
#line 180 "../lib/Widgets/ChipGroup.vala"
					chip = _tmp11_;
#line 181 "../lib/Widgets/ChipGroup.vala"
					_tmp13_ = chip;
#line 181 "../lib/Widgets/ChipGroup.vala"
					if (_tmp13_ != NULL) {
#line 640 "ChipGroup.c"
						HeChip* _tmp14_;
#line 181 "../lib/Widgets/ChipGroup.vala"
						_tmp14_ = first_chip;
#line 181 "../lib/Widgets/ChipGroup.vala"
						_tmp12_ = _tmp14_ != NULL;
#line 646 "ChipGroup.c"
					} else {
#line 181 "../lib/Widgets/ChipGroup.vala"
						_tmp12_ = FALSE;
#line 650 "ChipGroup.c"
					}
#line 181 "../lib/Widgets/ChipGroup.vala"
					if (_tmp12_) {
#line 654 "ChipGroup.c"
						HeChip* _tmp15_;
						HeChip* _tmp16_;
#line 182 "../lib/Widgets/ChipGroup.vala"
						_tmp15_ = chip;
#line 182 "../lib/Widgets/ChipGroup.vala"
						_tmp16_ = first_chip;
#line 182 "../lib/Widgets/ChipGroup.vala"
						gtk_toggle_button_set_group ((GtkToggleButton*) _tmp15_, (GtkToggleButton*) _tmp16_);
#line 663 "ChipGroup.c"
					}
#line 179 "../lib/Widgets/ChipGroup.vala"
					_g_object_unref0 (chip);
#line 667 "ChipGroup.c"
				}
			}
		}
#line 176 "../lib/Widgets/ChipGroup.vala"
		_g_object_unref0 (first_chip);
#line 673 "ChipGroup.c"
	} else {
		{
			guint i = 0U;
#line 187 "../lib/Widgets/ChipGroup.vala"
			i = (guint) 0;
#line 679 "ChipGroup.c"
			{
				gboolean _tmp17_ = FALSE;
#line 187 "../lib/Widgets/ChipGroup.vala"
				_tmp17_ = TRUE;
#line 187 "../lib/Widgets/ChipGroup.vala"
				while (TRUE) {
#line 686 "ChipGroup.c"
					GList* _tmp19_;
					HeChip* chip = NULL;
					GList* _tmp20_;
					gconstpointer _tmp21_;
					HeChip* _tmp22_;
					HeChip* _tmp23_;
#line 187 "../lib/Widgets/ChipGroup.vala"
					if (!_tmp17_) {
#line 695 "ChipGroup.c"
						guint _tmp18_;
#line 187 "../lib/Widgets/ChipGroup.vala"
						_tmp18_ = i;
#line 187 "../lib/Widgets/ChipGroup.vala"
						i = _tmp18_ + 1;
#line 701 "ChipGroup.c"
					}
#line 187 "../lib/Widgets/ChipGroup.vala"
					_tmp17_ = FALSE;
#line 187 "../lib/Widgets/ChipGroup.vala"
					_tmp19_ = self->priv->_buttons;
#line 187 "../lib/Widgets/ChipGroup.vala"
					if (!(i < g_list_length (_tmp19_))) {
#line 187 "../lib/Widgets/ChipGroup.vala"
						break;
#line 711 "ChipGroup.c"
					}
#line 188 "../lib/Widgets/ChipGroup.vala"
					_tmp20_ = self->priv->_buttons;
#line 188 "../lib/Widgets/ChipGroup.vala"
					_tmp21_ = g_list_nth_data (_tmp20_, i);
#line 188 "../lib/Widgets/ChipGroup.vala"
					_tmp22_ = _g_object_ref0 ((HeChip*) _tmp21_);
#line 188 "../lib/Widgets/ChipGroup.vala"
					chip = _tmp22_;
#line 189 "../lib/Widgets/ChipGroup.vala"
					_tmp23_ = chip;
#line 189 "../lib/Widgets/ChipGroup.vala"
					if (_tmp23_ != NULL) {
#line 725 "ChipGroup.c"
						HeChip* _tmp24_;
#line 190 "../lib/Widgets/ChipGroup.vala"
						_tmp24_ = chip;
#line 190 "../lib/Widgets/ChipGroup.vala"
						gtk_toggle_button_set_group ((GtkToggleButton*) _tmp24_, NULL);
#line 731 "ChipGroup.c"
					}
#line 187 "../lib/Widgets/ChipGroup.vala"
					_g_object_unref0 (chip);
#line 735 "ChipGroup.c"
				}
			}
		}
	}
#line 195 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_update_close_buttons (self);
#line 742 "ChipGroup.c"
}

static void
he_chip_group_update_close_buttons (HeChipGroup* self)
{
#line 198 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 750 "ChipGroup.c"
	{
		guint i = 0U;
#line 199 "../lib/Widgets/ChipGroup.vala"
		i = (guint) 0;
#line 755 "ChipGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 199 "../lib/Widgets/ChipGroup.vala"
			_tmp0_ = TRUE;
#line 199 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 762 "ChipGroup.c"
				GList* _tmp2_;
				HeChip* chip = NULL;
				GList* _tmp3_;
				gconstpointer _tmp4_;
				HeChip* _tmp5_;
				HeChip* _tmp6_;
#line 199 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp0_) {
#line 771 "ChipGroup.c"
					guint _tmp1_;
#line 199 "../lib/Widgets/ChipGroup.vala"
					_tmp1_ = i;
#line 199 "../lib/Widgets/ChipGroup.vala"
					i = _tmp1_ + 1;
#line 777 "ChipGroup.c"
				}
#line 199 "../lib/Widgets/ChipGroup.vala"
				_tmp0_ = FALSE;
#line 199 "../lib/Widgets/ChipGroup.vala"
				_tmp2_ = self->priv->_buttons;
#line 199 "../lib/Widgets/ChipGroup.vala"
				if (!(i < g_list_length (_tmp2_))) {
#line 199 "../lib/Widgets/ChipGroup.vala"
					break;
#line 787 "ChipGroup.c"
				}
#line 200 "../lib/Widgets/ChipGroup.vala"
				_tmp3_ = self->priv->_buttons;
#line 200 "../lib/Widgets/ChipGroup.vala"
				_tmp4_ = g_list_nth_data (_tmp3_, i);
#line 200 "../lib/Widgets/ChipGroup.vala"
				_tmp5_ = _g_object_ref0 ((HeChip*) _tmp4_);
#line 200 "../lib/Widgets/ChipGroup.vala"
				chip = _tmp5_;
#line 201 "../lib/Widgets/ChipGroup.vala"
				_tmp6_ = chip;
#line 201 "../lib/Widgets/ChipGroup.vala"
				if (_tmp6_ != NULL) {
#line 801 "ChipGroup.c"
					gboolean _tmp7_ = FALSE;
					HeChipGroupMode _tmp8_;
					HeChipGroupMode _tmp9_;
					HeChip* _tmp12_;
#line 202 "../lib/Widgets/ChipGroup.vala"
					_tmp8_ = he_chip_group_get_mode (self);
#line 202 "../lib/Widgets/ChipGroup.vala"
					_tmp9_ = _tmp8_;
#line 202 "../lib/Widgets/ChipGroup.vala"
					if (_tmp9_ == HE_CHIP_GROUP_MODE_FILTERING) {
#line 812 "ChipGroup.c"
						gboolean _tmp10_;
						gboolean _tmp11_;
#line 202 "../lib/Widgets/ChipGroup.vala"
						_tmp10_ = he_chip_group_get_show_close_buttons (self);
#line 202 "../lib/Widgets/ChipGroup.vala"
						_tmp11_ = _tmp10_;
#line 202 "../lib/Widgets/ChipGroup.vala"
						_tmp7_ = _tmp11_;
#line 821 "ChipGroup.c"
					} else {
#line 202 "../lib/Widgets/ChipGroup.vala"
						_tmp7_ = FALSE;
#line 825 "ChipGroup.c"
					}
#line 202 "../lib/Widgets/ChipGroup.vala"
					_tmp12_ = chip;
#line 202 "../lib/Widgets/ChipGroup.vala"
					he_chip_set_show_close_button (_tmp12_, _tmp7_);
#line 831 "ChipGroup.c"
				}
#line 199 "../lib/Widgets/ChipGroup.vala"
				_g_object_unref0 (chip);
#line 835 "ChipGroup.c"
			}
		}
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 218 "../lib/Widgets/ChipGroup.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 218 "../lib/Widgets/ChipGroup.vala"
	return _data6_;
#line 848 "ChipGroup.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 218 "../lib/Widgets/ChipGroup.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 858 "ChipGroup.c"
		HeChipGroup* self;
#line 218 "../lib/Widgets/ChipGroup.vala"
		self = _data6_->self;
#line 218 "../lib/Widgets/ChipGroup.vala"
		_g_object_unref0 (_data6_->button);
#line 218 "../lib/Widgets/ChipGroup.vala"
		_g_object_unref0 (self);
#line 218 "../lib/Widgets/ChipGroup.vala"
		g_slice_free (Block6Data, _data6_);
#line 868 "ChipGroup.c"
	}
}

static void
_____lambda117_ (Block6Data* _data6_)
{
	HeChipGroup* self;
	HeChip* _tmp0_;
#line 228 "../lib/Widgets/ChipGroup.vala"
	self = _data6_->self;
#line 228 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = _data6_->button;
#line 228 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_on_button_toggled (self, _tmp0_);
#line 883 "ChipGroup.c"
}

static void
______lambda117__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self)
{
#line 228 "../lib/Widgets/ChipGroup.vala"
	_____lambda117_ (self);
#line 892 "ChipGroup.c"
}

static void
_____lambda118_ (Block6Data* _data6_)
{
	HeChipGroup* self;
	gint button_pos = 0;
	GList* _tmp0_;
	HeChip* _tmp1_;
#line 231 "../lib/Widgets/ChipGroup.vala"
	self = _data6_->self;
#line 232 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = self->priv->_buttons;
#line 232 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = _data6_->button;
#line 232 "../lib/Widgets/ChipGroup.vala"
	button_pos = g_list_index (_tmp0_, _tmp1_);
#line 233 "../lib/Widgets/ChipGroup.vala"
	if (button_pos >= 0) {
#line 234 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_remove_chip (self, (guint) button_pos);
#line 914 "ChipGroup.c"
	}
}

static void
______lambda118__he_chip_close_clicked (HeChip* _sender,
                                        gpointer self)
{
#line 231 "../lib/Widgets/ChipGroup.vala"
	_____lambda118_ (self);
#line 924 "ChipGroup.c"
}

static void
he_chip_group_on_selection_items_changed (HeChipGroup* self,
                                          guint position,
                                          guint removed,
                                          guint added)
{
#line 207 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 935 "ChipGroup.c"
	{
		guint i = 0U;
#line 209 "../lib/Widgets/ChipGroup.vala"
		i = (guint) 0;
#line 940 "ChipGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 209 "../lib/Widgets/ChipGroup.vala"
			_tmp0_ = TRUE;
#line 209 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 947 "ChipGroup.c"
				GList* button_link = NULL;
				GList* _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
#line 209 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp0_) {
#line 954 "ChipGroup.c"
					guint _tmp1_;
#line 209 "../lib/Widgets/ChipGroup.vala"
					_tmp1_ = i;
#line 209 "../lib/Widgets/ChipGroup.vala"
					i = _tmp1_ + 1;
#line 960 "ChipGroup.c"
				}
#line 209 "../lib/Widgets/ChipGroup.vala"
				_tmp0_ = FALSE;
#line 209 "../lib/Widgets/ChipGroup.vala"
				if (!(i < removed)) {
#line 209 "../lib/Widgets/ChipGroup.vala"
					break;
#line 968 "ChipGroup.c"
				}
#line 210 "../lib/Widgets/ChipGroup.vala"
				_tmp2_ = self->priv->_buttons;
#line 210 "../lib/Widgets/ChipGroup.vala"
				_tmp3_ = g_list_nth (_tmp2_, position);
#line 210 "../lib/Widgets/ChipGroup.vala"
				button_link = _tmp3_;
#line 211 "../lib/Widgets/ChipGroup.vala"
				_tmp4_ = button_link;
#line 211 "../lib/Widgets/ChipGroup.vala"
				if (_tmp4_ != NULL) {
#line 980 "ChipGroup.c"
					GList* _tmp5_;
					gconstpointer _tmp6_;
					GList* _tmp7_;
#line 212 "../lib/Widgets/ChipGroup.vala"
					_tmp5_ = button_link;
#line 212 "../lib/Widgets/ChipGroup.vala"
					_tmp6_ = _tmp5_->data;
#line 212 "../lib/Widgets/ChipGroup.vala"
					gtk_widget_unparent ((GtkWidget*) ((HeChip*) _tmp6_));
#line 213 "../lib/Widgets/ChipGroup.vala"
					_tmp7_ = button_link;
#line 213 "../lib/Widgets/ChipGroup.vala"
					self->priv->_buttons = g_list_delete_link (self->priv->_buttons, _tmp7_);
#line 994 "ChipGroup.c"
				}
			}
		}
	}
	{
		guint i = 0U;
#line 218 "../lib/Widgets/ChipGroup.vala"
		i = (guint) 0;
#line 1003 "ChipGroup.c"
		{
			gboolean _tmp8_ = FALSE;
#line 218 "../lib/Widgets/ChipGroup.vala"
			_tmp8_ = TRUE;
#line 218 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 1010 "ChipGroup.c"
				Block6Data* _data6_;
				guint current_pos = 0U;
				GList* button_link = NULL;
				GList* _tmp10_;
				GList* _tmp11_;
				GtkSingleSelection* _tmp12_;
				HeChip* _tmp13_ = NULL;
				GtkSingleSelection* _tmp14_;
				GObject* _tmp15_;
				GObject* _tmp16_;
				HeChip* _tmp17_;
				HeChip* _tmp18_;
				HeChip* _tmp19_;
				GtkFlowBox* _tmp20_;
				HeChip* _tmp21_;
				GList* _tmp22_;
				HeChip* _tmp23_;
				HeChip* _tmp24_;
#line 218 "../lib/Widgets/ChipGroup.vala"
				_data6_ = g_slice_new0 (Block6Data);
#line 218 "../lib/Widgets/ChipGroup.vala"
				_data6_->_ref_count_ = 1;
#line 218 "../lib/Widgets/ChipGroup.vala"
				_data6_->self = g_object_ref (self);
#line 218 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp8_) {
#line 1037 "ChipGroup.c"
					guint _tmp9_;
#line 218 "../lib/Widgets/ChipGroup.vala"
					_tmp9_ = i;
#line 218 "../lib/Widgets/ChipGroup.vala"
					i = _tmp9_ + 1;
#line 1043 "ChipGroup.c"
				}
#line 218 "../lib/Widgets/ChipGroup.vala"
				_tmp8_ = FALSE;
#line 218 "../lib/Widgets/ChipGroup.vala"
				if (!(i < added)) {
#line 218 "../lib/Widgets/ChipGroup.vala"
					block6_data_unref (_data6_);
#line 218 "../lib/Widgets/ChipGroup.vala"
					_data6_ = NULL;
#line 218 "../lib/Widgets/ChipGroup.vala"
					break;
#line 1055 "ChipGroup.c"
				}
#line 219 "../lib/Widgets/ChipGroup.vala"
				current_pos = position + i;
#line 220 "../lib/Widgets/ChipGroup.vala"
				_tmp10_ = self->priv->_buttons;
#line 220 "../lib/Widgets/ChipGroup.vala"
				_tmp11_ = g_list_nth (_tmp10_, current_pos);
#line 220 "../lib/Widgets/ChipGroup.vala"
				button_link = _tmp11_;
#line 222 "../lib/Widgets/ChipGroup.vala"
				_tmp12_ = self->priv->_selection_model;
#line 222 "../lib/Widgets/ChipGroup.vala"
				_tmp13_ = he_chip_new ("");
#line 222 "../lib/Widgets/ChipGroup.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp13_, gtk_single_selection_get_selected (_tmp12_) == current_pos);
#line 222 "../lib/Widgets/ChipGroup.vala"
				g_object_ref_sink (_tmp13_);
#line 222 "../lib/Widgets/ChipGroup.vala"
				_data6_->button = _tmp13_;
#line 226 "../lib/Widgets/ChipGroup.vala"
				_tmp14_ = self->priv->_selection_model;
#line 226 "../lib/Widgets/ChipGroup.vala"
				_tmp15_ = g_list_model_get_item ((GListModel*) _tmp14_, current_pos);
#line 226 "../lib/Widgets/ChipGroup.vala"
				_tmp16_ = _tmp15_;
#line 226 "../lib/Widgets/ChipGroup.vala"
				_tmp17_ = _data6_->button;
#line 226 "../lib/Widgets/ChipGroup.vala"
				g_object_bind_property_with_closures (_tmp16_, "title", (GObject*) _tmp17_, "chip-label", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 226 "../lib/Widgets/ChipGroup.vala"
				_g_object_unref0 (_tmp16_);
#line 228 "../lib/Widgets/ChipGroup.vala"
				_tmp18_ = _data6_->button;
#line 228 "../lib/Widgets/ChipGroup.vala"
				g_signal_connect_data ((GtkToggleButton*) _tmp18_, "toggled", (GCallback) ______lambda117__gtk_toggle_button_toggled, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 231 "../lib/Widgets/ChipGroup.vala"
				_tmp19_ = _data6_->button;
#line 231 "../lib/Widgets/ChipGroup.vala"
				g_signal_connect_data (_tmp19_, "close-clicked", (GCallback) ______lambda118__he_chip_close_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 238 "../lib/Widgets/ChipGroup.vala"
				_tmp20_ = self->priv->flowbox;
#line 238 "../lib/Widgets/ChipGroup.vala"
				_tmp21_ = _data6_->button;
#line 238 "../lib/Widgets/ChipGroup.vala"
				gtk_flow_box_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 240 "../lib/Widgets/ChipGroup.vala"
				_tmp22_ = button_link;
#line 240 "../lib/Widgets/ChipGroup.vala"
				_tmp23_ = _data6_->button;
#line 240 "../lib/Widgets/ChipGroup.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 240 "../lib/Widgets/ChipGroup.vala"
				self->priv->_buttons = g_list_insert_before (self->priv->_buttons, _tmp22_, _tmp24_);
#line 218 "../lib/Widgets/ChipGroup.vala"
				block6_data_unref (_data6_);
#line 218 "../lib/Widgets/ChipGroup.vala"
				_data6_ = NULL;
#line 1113 "ChipGroup.c"
			}
		}
	}
#line 243 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_update_chip_groups (self);
#line 1119 "ChipGroup.c"
}

static void
he_chip_group_on_selection_changed (HeChipGroup* self,
                                    guint position,
                                    guint n_items)
{
	HeChipGroupMode _tmp0_;
	HeChipGroupMode _tmp1_;
	guint selected = 0U;
	GtkSingleSelection* _tmp2_;
#line 246 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 247 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = he_chip_group_get_mode (self);
#line 247 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = _tmp0_;
#line 247 "../lib/Widgets/ChipGroup.vala"
	if (_tmp1_ != HE_CHIP_GROUP_MODE_SELECTION) {
#line 247 "../lib/Widgets/ChipGroup.vala"
		return;
#line 1141 "ChipGroup.c"
	}
#line 250 "../lib/Widgets/ChipGroup.vala"
	_tmp2_ = self->priv->_selection_model;
#line 250 "../lib/Widgets/ChipGroup.vala"
	selected = gtk_single_selection_get_selected (_tmp2_);
#line 1147 "ChipGroup.c"
	{
		guint i = 0U;
#line 251 "../lib/Widgets/ChipGroup.vala"
		i = position;
#line 1152 "ChipGroup.c"
		{
			gboolean _tmp3_ = FALSE;
#line 251 "../lib/Widgets/ChipGroup.vala"
			_tmp3_ = TRUE;
#line 251 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 1159 "ChipGroup.c"
				gboolean _tmp5_ = FALSE;
				HeChip* button = NULL;
				GList* _tmp7_;
				gconstpointer _tmp8_;
				HeChip* _tmp9_;
				HeChip* _tmp10_;
#line 251 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp3_) {
#line 1168 "ChipGroup.c"
					guint _tmp4_;
#line 251 "../lib/Widgets/ChipGroup.vala"
					_tmp4_ = i;
#line 251 "../lib/Widgets/ChipGroup.vala"
					i = _tmp4_ + 1;
#line 1174 "ChipGroup.c"
				}
#line 251 "../lib/Widgets/ChipGroup.vala"
				_tmp3_ = FALSE;
#line 251 "../lib/Widgets/ChipGroup.vala"
				if (i < (position + n_items)) {
#line 1180 "ChipGroup.c"
					GList* _tmp6_;
#line 251 "../lib/Widgets/ChipGroup.vala"
					_tmp6_ = self->priv->_buttons;
#line 251 "../lib/Widgets/ChipGroup.vala"
					_tmp5_ = i < g_list_length (_tmp6_);
#line 1186 "ChipGroup.c"
				} else {
#line 251 "../lib/Widgets/ChipGroup.vala"
					_tmp5_ = FALSE;
#line 1190 "ChipGroup.c"
				}
#line 251 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp5_) {
#line 251 "../lib/Widgets/ChipGroup.vala"
					break;
#line 1196 "ChipGroup.c"
				}
#line 252 "../lib/Widgets/ChipGroup.vala"
				_tmp7_ = self->priv->_buttons;
#line 252 "../lib/Widgets/ChipGroup.vala"
				_tmp8_ = g_list_nth_data (_tmp7_, i);
#line 252 "../lib/Widgets/ChipGroup.vala"
				_tmp9_ = _g_object_ref0 ((HeChip*) _tmp8_);
#line 252 "../lib/Widgets/ChipGroup.vala"
				button = _tmp9_;
#line 253 "../lib/Widgets/ChipGroup.vala"
				_tmp10_ = button;
#line 253 "../lib/Widgets/ChipGroup.vala"
				if (_tmp10_ != NULL) {
#line 1210 "ChipGroup.c"
					HeChip* _tmp11_;
#line 254 "../lib/Widgets/ChipGroup.vala"
					_tmp11_ = button;
#line 254 "../lib/Widgets/ChipGroup.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp11_, i == selected);
#line 1216 "ChipGroup.c"
				}
#line 251 "../lib/Widgets/ChipGroup.vala"
				_g_object_unref0 (button);
#line 1220 "ChipGroup.c"
			}
		}
	}
}

static void
he_chip_group_on_button_toggled (HeChipGroup* self,
                                 HeChip* button)
{
	HeChipGroupMode _tmp0_;
	HeChipGroupMode _tmp1_;
#line 259 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 259 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (button != NULL);
#line 260 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = he_chip_group_get_mode (self);
#line 260 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = _tmp0_;
#line 260 "../lib/Widgets/ChipGroup.vala"
	if (_tmp1_ == HE_CHIP_GROUP_MODE_SELECTION) {
#line 1242 "ChipGroup.c"
		GtkSingleSelection* _tmp2_;
		gint button_pos = 0;
		GList* _tmp3_;
		guint position = 0U;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 261 "../lib/Widgets/ChipGroup.vala"
		_tmp2_ = self->priv->_selection_model;
#line 261 "../lib/Widgets/ChipGroup.vala"
		if (g_list_model_get_n_items ((GListModel*) _tmp2_) <= ((guint) 1)) {
#line 262 "../lib/Widgets/ChipGroup.vala"
			return;
#line 1255 "ChipGroup.c"
		}
#line 265 "../lib/Widgets/ChipGroup.vala"
		_tmp3_ = self->priv->_buttons;
#line 265 "../lib/Widgets/ChipGroup.vala"
		button_pos = g_list_index (_tmp3_, button);
#line 266 "../lib/Widgets/ChipGroup.vala"
		if (button_pos < 0) {
#line 266 "../lib/Widgets/ChipGroup.vala"
			return;
#line 1265 "ChipGroup.c"
		}
#line 268 "../lib/Widgets/ChipGroup.vala"
		position = (guint) button_pos;
#line 269 "../lib/Widgets/ChipGroup.vala"
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) button);
#line 269 "../lib/Widgets/ChipGroup.vala"
		_tmp5_ = _tmp4_;
#line 269 "../lib/Widgets/ChipGroup.vala"
		if (_tmp5_) {
#line 1275 "ChipGroup.c"
			GtkSingleSelection* _tmp6_;
#line 270 "../lib/Widgets/ChipGroup.vala"
			_tmp6_ = self->priv->_selection_model;
#line 270 "../lib/Widgets/ChipGroup.vala"
			gtk_selection_model_select_item ((GtkSelectionModel*) _tmp6_, position, TRUE);
#line 1281 "ChipGroup.c"
		} else {
			GtkSingleSelection* _tmp7_;
#line 272 "../lib/Widgets/ChipGroup.vala"
			_tmp7_ = self->priv->_selection_model;
#line 272 "../lib/Widgets/ChipGroup.vala"
			gtk_selection_model_unselect_item ((GtkSelectionModel*) _tmp7_, position);
#line 1288 "ChipGroup.c"
		}
	} else {
#line 276 "../lib/Widgets/ChipGroup.vala"
		g_signal_emit (self, he_chip_group_signals[HE_CHIP_GROUP_FILTERS_CHANGED_SIGNAL], 0);
#line 1293 "ChipGroup.c"
	}
}

/**
     * Get the indices of all active chips.
     * Primarily useful in filtering mode to determine which filters are currently applied.
     * @return Array of indices representing active chips
     *
     * @since 1.0
     */
static void
_vala_array_add29 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
#line 293 "../lib/Widgets/ChipGroup.vala"
	if ((*length) == (*size)) {
#line 293 "../lib/Widgets/ChipGroup.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 293 "../lib/Widgets/ChipGroup.vala"
		*array = g_renew (guint, *array, *size);
#line 1316 "ChipGroup.c"
	}
#line 293 "../lib/Widgets/ChipGroup.vala"
	(*array)[(*length)++] = value;
#line 1320 "ChipGroup.c"
}

guint*
he_chip_group_get_active_filters (HeChipGroup* self,
                                  gint* result_length1)
{
	guint* active_indices = NULL;
	guint* _tmp0_;
	gint active_indices_length1;
	gint _active_indices_size_;
	guint* _tmp12_;
	gint _tmp12__length1;
	guint* result;
#line 287 "../lib/Widgets/ChipGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 288 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = g_new0 (guint, 0);
#line 288 "../lib/Widgets/ChipGroup.vala"
	active_indices = _tmp0_;
#line 288 "../lib/Widgets/ChipGroup.vala"
	active_indices_length1 = 0;
#line 288 "../lib/Widgets/ChipGroup.vala"
	_active_indices_size_ = active_indices_length1;
#line 1344 "ChipGroup.c"
	{
		guint i = 0U;
#line 290 "../lib/Widgets/ChipGroup.vala"
		i = (guint) 0;
#line 1349 "ChipGroup.c"
		{
			gboolean _tmp1_ = FALSE;
#line 290 "../lib/Widgets/ChipGroup.vala"
			_tmp1_ = TRUE;
#line 290 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 1356 "ChipGroup.c"
				GList* _tmp3_;
				HeChip* chip = NULL;
				GList* _tmp4_;
				gconstpointer _tmp5_;
				HeChip* _tmp6_;
				gboolean _tmp7_ = FALSE;
				HeChip* _tmp8_;
#line 290 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp1_) {
#line 1366 "ChipGroup.c"
					guint _tmp2_;
#line 290 "../lib/Widgets/ChipGroup.vala"
					_tmp2_ = i;
#line 290 "../lib/Widgets/ChipGroup.vala"
					i = _tmp2_ + 1;
#line 1372 "ChipGroup.c"
				}
#line 290 "../lib/Widgets/ChipGroup.vala"
				_tmp1_ = FALSE;
#line 290 "../lib/Widgets/ChipGroup.vala"
				_tmp3_ = self->priv->_buttons;
#line 290 "../lib/Widgets/ChipGroup.vala"
				if (!(i < g_list_length (_tmp3_))) {
#line 290 "../lib/Widgets/ChipGroup.vala"
					break;
#line 1382 "ChipGroup.c"
				}
#line 291 "../lib/Widgets/ChipGroup.vala"
				_tmp4_ = self->priv->_buttons;
#line 291 "../lib/Widgets/ChipGroup.vala"
				_tmp5_ = g_list_nth_data (_tmp4_, i);
#line 291 "../lib/Widgets/ChipGroup.vala"
				_tmp6_ = _g_object_ref0 ((HeChip*) _tmp5_);
#line 291 "../lib/Widgets/ChipGroup.vala"
				chip = _tmp6_;
#line 292 "../lib/Widgets/ChipGroup.vala"
				_tmp8_ = chip;
#line 292 "../lib/Widgets/ChipGroup.vala"
				if (_tmp8_ != NULL) {
#line 1396 "ChipGroup.c"
					HeChip* _tmp9_;
					gboolean _tmp10_;
					gboolean _tmp11_;
#line 292 "../lib/Widgets/ChipGroup.vala"
					_tmp9_ = chip;
#line 292 "../lib/Widgets/ChipGroup.vala"
					_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
#line 292 "../lib/Widgets/ChipGroup.vala"
					_tmp11_ = _tmp10_;
#line 292 "../lib/Widgets/ChipGroup.vala"
					_tmp7_ = _tmp11_;
#line 1408 "ChipGroup.c"
				} else {
#line 292 "../lib/Widgets/ChipGroup.vala"
					_tmp7_ = FALSE;
#line 1412 "ChipGroup.c"
				}
#line 292 "../lib/Widgets/ChipGroup.vala"
				if (_tmp7_) {
#line 293 "../lib/Widgets/ChipGroup.vala"
					_vala_array_add29 (&active_indices, &active_indices_length1, &_active_indices_size_, i);
#line 1418 "ChipGroup.c"
				}
#line 290 "../lib/Widgets/ChipGroup.vala"
				_g_object_unref0 (chip);
#line 1422 "ChipGroup.c"
			}
		}
	}
#line 297 "../lib/Widgets/ChipGroup.vala"
	_tmp12_ = active_indices;
#line 297 "../lib/Widgets/ChipGroup.vala"
	_tmp12__length1 = active_indices_length1;
#line 297 "../lib/Widgets/ChipGroup.vala"
	if (result_length1) {
#line 297 "../lib/Widgets/ChipGroup.vala"
		*result_length1 = _tmp12__length1;
#line 1434 "ChipGroup.c"
	}
#line 297 "../lib/Widgets/ChipGroup.vala"
	result = _tmp12_;
#line 297 "../lib/Widgets/ChipGroup.vala"
	return result;
#line 1440 "ChipGroup.c"
}

/**
     * Set which chips should be active by their indices.
     * Useful for programmatically setting filter states or restoring previous selections.
     * @param indices Array of chip indices to activate
     *
     * @since 1.0
     */
void
he_chip_group_set_active_filters (HeChipGroup* self,
                                  guint* indices,
                                  gint indices_length1)
{
#line 307 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 1457 "ChipGroup.c"
	{
		guint i = 0U;
#line 308 "../lib/Widgets/ChipGroup.vala"
		i = (guint) 0;
#line 1462 "ChipGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 308 "../lib/Widgets/ChipGroup.vala"
			_tmp0_ = TRUE;
#line 308 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 1469 "ChipGroup.c"
				GList* _tmp2_;
				HeChip* chip = NULL;
				GList* _tmp3_;
				gconstpointer _tmp4_;
				HeChip* _tmp5_;
				HeChip* _tmp6_;
#line 308 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp0_) {
#line 1478 "ChipGroup.c"
					guint _tmp1_;
#line 308 "../lib/Widgets/ChipGroup.vala"
					_tmp1_ = i;
#line 308 "../lib/Widgets/ChipGroup.vala"
					i = _tmp1_ + 1;
#line 1484 "ChipGroup.c"
				}
#line 308 "../lib/Widgets/ChipGroup.vala"
				_tmp0_ = FALSE;
#line 308 "../lib/Widgets/ChipGroup.vala"
				_tmp2_ = self->priv->_buttons;
#line 308 "../lib/Widgets/ChipGroup.vala"
				if (!(i < g_list_length (_tmp2_))) {
#line 308 "../lib/Widgets/ChipGroup.vala"
					break;
#line 1494 "ChipGroup.c"
				}
#line 309 "../lib/Widgets/ChipGroup.vala"
				_tmp3_ = self->priv->_buttons;
#line 309 "../lib/Widgets/ChipGroup.vala"
				_tmp4_ = g_list_nth_data (_tmp3_, i);
#line 309 "../lib/Widgets/ChipGroup.vala"
				_tmp5_ = _g_object_ref0 ((HeChip*) _tmp4_);
#line 309 "../lib/Widgets/ChipGroup.vala"
				chip = _tmp5_;
#line 310 "../lib/Widgets/ChipGroup.vala"
				_tmp6_ = chip;
#line 310 "../lib/Widgets/ChipGroup.vala"
				if (_tmp6_ != NULL) {
#line 1508 "ChipGroup.c"
					HeChip* _tmp7_;
#line 311 "../lib/Widgets/ChipGroup.vala"
					_tmp7_ = chip;
#line 311 "../lib/Widgets/ChipGroup.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, FALSE);
#line 1514 "ChipGroup.c"
				}
#line 308 "../lib/Widgets/ChipGroup.vala"
				_g_object_unref0 (chip);
#line 1518 "ChipGroup.c"
			}
		}
	}
	{
		guint* index_collection = NULL;
		gint index_collection_length1 = 0;
		gint _index_collection_size_ = 0;
		gint index_it = 0;
#line 315 "../lib/Widgets/ChipGroup.vala"
		index_collection = indices;
#line 315 "../lib/Widgets/ChipGroup.vala"
		index_collection_length1 = indices_length1;
#line 315 "../lib/Widgets/ChipGroup.vala"
		for (index_it = 0; index_it < index_collection_length1; index_it = index_it + 1) {
#line 1533 "ChipGroup.c"
			guint index = 0U;
#line 315 "../lib/Widgets/ChipGroup.vala"
			index = index_collection[index_it];
#line 1537 "ChipGroup.c"
			{
				GList* _tmp8_;
#line 316 "../lib/Widgets/ChipGroup.vala"
				_tmp8_ = self->priv->_buttons;
#line 316 "../lib/Widgets/ChipGroup.vala"
				if (index < g_list_length (_tmp8_)) {
#line 1544 "ChipGroup.c"
					HeChip* chip = NULL;
					GList* _tmp9_;
					gconstpointer _tmp10_;
					HeChip* _tmp11_;
					HeChip* _tmp12_;
#line 317 "../lib/Widgets/ChipGroup.vala"
					_tmp9_ = self->priv->_buttons;
#line 317 "../lib/Widgets/ChipGroup.vala"
					_tmp10_ = g_list_nth_data (_tmp9_, index);
#line 317 "../lib/Widgets/ChipGroup.vala"
					_tmp11_ = _g_object_ref0 ((HeChip*) _tmp10_);
#line 317 "../lib/Widgets/ChipGroup.vala"
					chip = _tmp11_;
#line 318 "../lib/Widgets/ChipGroup.vala"
					_tmp12_ = chip;
#line 318 "../lib/Widgets/ChipGroup.vala"
					if (_tmp12_ != NULL) {
#line 1562 "ChipGroup.c"
						HeChip* _tmp13_;
#line 319 "../lib/Widgets/ChipGroup.vala"
						_tmp13_ = chip;
#line 319 "../lib/Widgets/ChipGroup.vala"
						gtk_toggle_button_set_active ((GtkToggleButton*) _tmp13_, TRUE);
#line 1568 "ChipGroup.c"
					}
#line 316 "../lib/Widgets/ChipGroup.vala"
					_g_object_unref0 (chip);
#line 1572 "ChipGroup.c"
				}
			}
		}
	}
}

/**
     * Deactivate all chips, clearing any active filters or selections.
     * Useful for providing a "clear all" functionality to users.
     *
     * @since 1.0
     */
void
he_chip_group_clear_filters (HeChipGroup* self)
{
#line 331 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 1590 "ChipGroup.c"
	{
		guint i = 0U;
#line 332 "../lib/Widgets/ChipGroup.vala"
		i = (guint) 0;
#line 1595 "ChipGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 332 "../lib/Widgets/ChipGroup.vala"
			_tmp0_ = TRUE;
#line 332 "../lib/Widgets/ChipGroup.vala"
			while (TRUE) {
#line 1602 "ChipGroup.c"
				GList* _tmp2_;
				HeChip* chip = NULL;
				GList* _tmp3_;
				gconstpointer _tmp4_;
				HeChip* _tmp5_;
				HeChip* _tmp6_;
#line 332 "../lib/Widgets/ChipGroup.vala"
				if (!_tmp0_) {
#line 1611 "ChipGroup.c"
					guint _tmp1_;
#line 332 "../lib/Widgets/ChipGroup.vala"
					_tmp1_ = i;
#line 332 "../lib/Widgets/ChipGroup.vala"
					i = _tmp1_ + 1;
#line 1617 "ChipGroup.c"
				}
#line 332 "../lib/Widgets/ChipGroup.vala"
				_tmp0_ = FALSE;
#line 332 "../lib/Widgets/ChipGroup.vala"
				_tmp2_ = self->priv->_buttons;
#line 332 "../lib/Widgets/ChipGroup.vala"
				if (!(i < g_list_length (_tmp2_))) {
#line 332 "../lib/Widgets/ChipGroup.vala"
					break;
#line 1627 "ChipGroup.c"
				}
#line 333 "../lib/Widgets/ChipGroup.vala"
				_tmp3_ = self->priv->_buttons;
#line 333 "../lib/Widgets/ChipGroup.vala"
				_tmp4_ = g_list_nth_data (_tmp3_, i);
#line 333 "../lib/Widgets/ChipGroup.vala"
				_tmp5_ = _g_object_ref0 ((HeChip*) _tmp4_);
#line 333 "../lib/Widgets/ChipGroup.vala"
				chip = _tmp5_;
#line 334 "../lib/Widgets/ChipGroup.vala"
				_tmp6_ = chip;
#line 334 "../lib/Widgets/ChipGroup.vala"
				if (_tmp6_ != NULL) {
#line 1641 "ChipGroup.c"
					HeChip* _tmp7_;
#line 335 "../lib/Widgets/ChipGroup.vala"
					_tmp7_ = chip;
#line 335 "../lib/Widgets/ChipGroup.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, FALSE);
#line 1647 "ChipGroup.c"
				}
#line 332 "../lib/Widgets/ChipGroup.vala"
				_g_object_unref0 (chip);
#line 1651 "ChipGroup.c"
			}
		}
	}
}

/**
     * Remove a chip from the group at the specified position.
     * This will also remove the corresponding item from the selection model.
     * Only effective in filtering mode.
     * @param position Index of the chip to remove
     *
     * @since 1.0
     */
void
he_chip_group_remove_chip_at (HeChipGroup* self,
                              guint position)
{
	HeChipGroupMode _tmp0_;
	HeChipGroupMode _tmp1_;
#line 348 "../lib/Widgets/ChipGroup.vala"
	g_return_if_fail (self != NULL);
#line 349 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = he_chip_group_get_mode (self);
#line 349 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = _tmp0_;
#line 349 "../lib/Widgets/ChipGroup.vala"
	if (_tmp1_ == HE_CHIP_GROUP_MODE_FILTERING) {
#line 350 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_remove_chip (self, position);
#line 1681 "ChipGroup.c"
	}
}

static GObject *
he_chip_group_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeChipGroup * self;
	GtkFlowBox* _tmp0_;
	GtkScrolledWindow* _tmp1_;
	GtkScrolledWindow* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkScrolledWindow* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkScrolledWindow* _tmp6_;
	GtkFlowBox* _tmp7_;
	GtkScrolledWindow* _tmp8_;
#line 156 "../lib/Widgets/ChipGroup.vala"
	parent_class = G_OBJECT_CLASS (he_chip_group_parent_class);
#line 156 "../lib/Widgets/ChipGroup.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 156 "../lib/Widgets/ChipGroup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CHIP_GROUP, HeChipGroup);
#line 157 "../lib/Widgets/ChipGroup.vala"
	_tmp0_ = (GtkFlowBox*) gtk_flow_box_new ();
#line 157 "../lib/Widgets/ChipGroup.vala"
	g_object_ref_sink (_tmp0_);
#line 157 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (self->priv->flowbox);
#line 157 "../lib/Widgets/ChipGroup.vala"
	self->priv->flowbox = _tmp0_;
#line 159 "../lib/Widgets/ChipGroup.vala"
	_tmp1_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 159 "../lib/Widgets/ChipGroup.vala"
	g_object_ref_sink (_tmp1_);
#line 159 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (self->priv->sw);
#line 159 "../lib/Widgets/ChipGroup.vala"
	self->priv->sw = _tmp1_;
#line 160 "../lib/Widgets/ChipGroup.vala"
	_tmp2_ = self->priv->sw;
#line 160 "../lib/Widgets/ChipGroup.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 161 "../lib/Widgets/ChipGroup.vala"
	_tmp3_ = self->priv->sw;
#line 161 "../lib/Widgets/ChipGroup.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 162 "../lib/Widgets/ChipGroup.vala"
	_tmp4_ = self->priv->sw;
#line 162 "../lib/Widgets/ChipGroup.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 163 "../lib/Widgets/ChipGroup.vala"
	_tmp5_ = self->priv->sw;
#line 163 "../lib/Widgets/ChipGroup.vala"
	g_object_set (_tmp5_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 164 "../lib/Widgets/ChipGroup.vala"
	_tmp6_ = self->priv->sw;
#line 164 "../lib/Widgets/ChipGroup.vala"
	_tmp7_ = self->priv->flowbox;
#line 164 "../lib/Widgets/ChipGroup.vala"
	gtk_scrolled_window_set_child (_tmp6_, (GtkWidget*) _tmp7_);
#line 166 "../lib/Widgets/ChipGroup.vala"
	_tmp8_ = self->priv->sw;
#line 166 "../lib/Widgets/ChipGroup.vala"
	he_bin_set_child ((HeBin*) self, (GtkWidget*) _tmp8_);
#line 168 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_set_single_line (self, FALSE);
#line 169 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_set_mode (self, HE_CHIP_GROUP_MODE_SELECTION);
#line 170 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_set_show_close_buttons (self, FALSE);
#line 156 "../lib/Widgets/ChipGroup.vala"
	return obj;
#line 1758 "ChipGroup.c"
}

static void
he_chip_group_class_init (HeChipGroupClass * klass,
                          gpointer klass_data)
{
#line 35 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_parent_class = g_type_class_peek_parent (klass);
#line 35 "../lib/Widgets/ChipGroup.vala"
	g_type_class_adjust_private_offset (klass, &HeChipGroup_private_offset);
#line 35 "../lib/Widgets/ChipGroup.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_chip_group_get_property;
#line 35 "../lib/Widgets/ChipGroup.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_chip_group_set_property;
#line 35 "../lib/Widgets/ChipGroup.vala"
	G_OBJECT_CLASS (klass)->constructor = he_chip_group_constructor;
#line 35 "../lib/Widgets/ChipGroup.vala"
	G_OBJECT_CLASS (klass)->finalize = he_chip_group_finalize;
#line 1777 "ChipGroup.c"
	/**
	     * The SelectionModel that is controlled by this group.
	     *
	     * @since 1.0
	     */
#line 35 "../lib/Widgets/ChipGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CHIP_GROUP_SELECTION_MODEL_PROPERTY, he_chip_group_properties[HE_CHIP_GROUP_SELECTION_MODEL_PROPERTY] = g_param_spec_object ("selection-model", "selection-model", "selection-model", gtk_single_selection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../lib/Widgets/ChipGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CHIP_GROUP_SINGLE_LINE_PROPERTY, he_chip_group_properties[HE_CHIP_GROUP_SINGLE_LINE_PROPERTY] = g_param_spec_boolean ("single-line", "single-line", "single-line", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../lib/Widgets/ChipGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CHIP_GROUP_MODE_PROPERTY, he_chip_group_properties[HE_CHIP_GROUP_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", HE_TYPE_CHIP_GROUP_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../lib/Widgets/ChipGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_CHIP_GROUP_SHOW_CLOSE_BUTTONS_PROPERTY, he_chip_group_properties[HE_CHIP_GROUP_SHOW_CLOSE_BUTTONS_PROPERTY] = g_param_spec_boolean ("show-close-buttons", "show-close-buttons", "show-close-buttons", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1791 "ChipGroup.c"
	/**
	     * Signal emitted when filters change in filtering mode.
	     * Connect to this signal to respond to filter state changes.
	     *
	     * @since 1.0
	     */
#line 35 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_signals[HE_CHIP_GROUP_FILTERS_CHANGED_SIGNAL] = g_signal_new ("filters-changed", HE_TYPE_CHIP_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1800 "ChipGroup.c"
	/**
	     * Signal emitted when a chip is removed from the group.
	     * Only emitted in filtering mode when close buttons are enabled.
	     * @param position The index of the removed chip
	     *
	     * @since 1.0
	     */
#line 35 "../lib/Widgets/ChipGroup.vala"
	he_chip_group_signals[HE_CHIP_GROUP_CHIP_REMOVED_SIGNAL] = g_signal_new ("chip-removed", HE_TYPE_CHIP_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 1810 "ChipGroup.c"
}

static void
he_chip_group_instance_init (HeChipGroup * self,
                             gpointer klass)
{
#line 35 "../lib/Widgets/ChipGroup.vala"
	self->priv = he_chip_group_get_instance_private (self);
#line 1819 "ChipGroup.c"
}

static void
he_chip_group_finalize (GObject * obj)
{
	HeChipGroup * self;
#line 35 "../lib/Widgets/ChipGroup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_CHIP_GROUP, HeChipGroup);
#line 36 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (self->priv->_selection_model);
#line 37 "../lib/Widgets/ChipGroup.vala"
	(self->priv->_buttons == NULL) ? NULL : (self->priv->_buttons = (_g_list_free__g_object_unref0_ (self->priv->_buttons), NULL));
#line 38 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (self->priv->flowbox);
#line 39 "../lib/Widgets/ChipGroup.vala"
	_g_object_unref0 (self->priv->sw);
#line 35 "../lib/Widgets/ChipGroup.vala"
	G_OBJECT_CLASS (he_chip_group_parent_class)->finalize (obj);
#line 1838 "ChipGroup.c"
}

/**
 * A ChipGroup is a holder widget for Chips.
 */
static GType
he_chip_group_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeChipGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_chip_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeChipGroup), 0, (GInstanceInitFunc) he_chip_group_instance_init, NULL };
	GType he_chip_group_type_id;
	he_chip_group_type_id = g_type_register_static (HE_TYPE_BIN, "HeChipGroup", &g_define_type_info, 0);
	HeChipGroup_private_offset = g_type_add_instance_private (he_chip_group_type_id, sizeof (HeChipGroupPrivate));
	return he_chip_group_type_id;
}

GType
he_chip_group_get_type (void)
{
	static volatile gsize he_chip_group_type_id__once = 0;
	if (g_once_init_enter (&he_chip_group_type_id__once)) {
		GType he_chip_group_type_id;
		he_chip_group_type_id = he_chip_group_get_type_once ();
		g_once_init_leave (&he_chip_group_type_id__once, he_chip_group_type_id);
	}
	return he_chip_group_type_id__once;
}

static void
_vala_he_chip_group_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HeChipGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CHIP_GROUP, HeChipGroup);
#line 35 "../lib/Widgets/ChipGroup.vala"
	switch (property_id) {
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_SELECTION_MODEL_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		g_value_set_object (value, he_chip_group_get_selection_model (self));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_SINGLE_LINE_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		g_value_set_boolean (value, he_chip_group_get_single_line (self));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_MODE_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		g_value_set_enum (value, he_chip_group_get_mode (self));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_SHOW_CLOSE_BUTTONS_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		g_value_set_boolean (value, he_chip_group_get_show_close_buttons (self));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 1900 "ChipGroup.c"
		default:
#line 35 "../lib/Widgets/ChipGroup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 1906 "ChipGroup.c"
	}
}

static void
_vala_he_chip_group_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	HeChipGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_CHIP_GROUP, HeChipGroup);
#line 35 "../lib/Widgets/ChipGroup.vala"
	switch (property_id) {
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_SELECTION_MODEL_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_set_selection_model (self, g_value_get_object (value));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_SINGLE_LINE_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_set_single_line (self, g_value_get_boolean (value));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_MODE_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_set_mode (self, g_value_get_enum (value));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 35 "../lib/Widgets/ChipGroup.vala"
		case HE_CHIP_GROUP_SHOW_CLOSE_BUTTONS_PROPERTY:
#line 35 "../lib/Widgets/ChipGroup.vala"
		he_chip_group_set_show_close_buttons (self, g_value_get_boolean (value));
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 1944 "ChipGroup.c"
		default:
#line 35 "../lib/Widgets/ChipGroup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../lib/Widgets/ChipGroup.vala"
		break;
#line 1950 "ChipGroup.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

