/* Dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from Dialog.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define HE_DIALOG_TOP_MARGIN 56
#define HE_DIALOG_DESKTOP_EDGE_MARGIN 114
#define HE_DIALOG_MIN_EDGE_MARGIN 56
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_DIALOG_0_PROPERTY,
	HE_DIALOG_VISIBLE_PROPERTY,
	HE_DIALOG_TITLE_PROPERTY,
	HE_DIALOG_INFO_PROPERTY,
	HE_DIALOG_ICON_PROPERTY,
	HE_DIALOG_SECONDARY_BUTTON_PROPERTY,
	HE_DIALOG_PRIMARY_BUTTON_PROPERTY,
	HE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* he_dialog_properties[HE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
enum  {
	HE_DIALOG_HIDDEN_SIGNAL,
	HE_DIALOG_NUM_SIGNALS
};
static guint he_dialog_signals[HE_DIALOG_NUM_SIGNALS] = {0};

struct _HeDialogPrivate {
	GtkWidget* dimming;
	GtkBox* dialog_bin;
	GtkLabel* title_label;
	GtkLabel* info_label;
	GtkImage* image;
	GtkBox* info_box;
	GtkBox* child_box;
	GtkBox* button_box;
	GtkWindowHandle* dialog_handle;
	HeButton* _secondary_button;
	HeButton* _primary_button;
	GtkWindow* parent_window;
	gboolean _visible;
};

static gint HeDialog_private_offset;
static gpointer he_dialog_parent_class = NULL;

static void he_dialog_find_and_overlay_on_parent (HeDialog* self);
static GtkWidget* he_dialog_find_overlay_target (HeDialog* self,
                                          GtkWidget* widget);
static void he_dialog_real_dispose (GObject* base);
static gboolean he_dialog_real_contains (GtkWidget* base,
                                  gdouble x,
                                  gdouble y);
static void he_dialog_real_measure (GtkWidget* base,
                             GtkOrientation orientation,
                             gint for_size,
                             gint* min,
                             gint* nat,
                             gint* min_baseline,
                             gint* nat_baseline);
static void he_dialog_real_size_allocate (GtkWidget* base,
                                   gint width,
                                   gint height,
                                   gint baseline);
static GObject * he_dialog_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void _he_dialog___lambda128_ (HeDialog* self);
static void __he_dialog___lambda128__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self);
static void _he_dialog___lambda129_ (HeDialog* self);
static void __he_dialog___lambda129__gtk_gesture_end (GtkGesture* _sender,
                                               GdkEventSequence* sequence,
                                               gpointer self);
static void he_dialog_finalize (GObject * obj);
static GType he_dialog_get_type_once (void);
static void _vala_he_dialog_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_dialog_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_dialog_get_instance_private (HeDialog* self)
{
	return G_STRUCT_MEMBER_P (self, HeDialog_private_offset);
}

gboolean
he_dialog_get_visible (HeDialog* self)
{
	gboolean result;
#line 56 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../lib/Widgets/Dialog.vala"
	result = self->priv->_visible;
#line 56 "../lib/Widgets/Dialog.vala"
	return result;
#line 145 "Dialog.c"
}

void
he_dialog_set_visible (HeDialog* self,
                       gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 57 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 58 "../lib/Widgets/Dialog.vala"
	_tmp0_ = he_dialog_get_visible (self);
#line 58 "../lib/Widgets/Dialog.vala"
	_tmp1_ = _tmp0_;
#line 58 "../lib/Widgets/Dialog.vala"
	if (_tmp1_ == value) {
#line 59 "../lib/Widgets/Dialog.vala"
		return;
#line 164 "Dialog.c"
	}
#line 61 "../lib/Widgets/Dialog.vala"
	self->priv->_visible = value;
#line 63 "../lib/Widgets/Dialog.vala"
	if (value) {
#line 170 "Dialog.c"
		GtkWidget* _tmp2_;
		GtkBox* _tmp3_;
#line 64 "../lib/Widgets/Dialog.vala"
		_tmp2_ = self->priv->dimming;
#line 64 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_child_visible (_tmp2_, TRUE);
#line 65 "../lib/Widgets/Dialog.vala"
		_tmp3_ = self->priv->dialog_bin;
#line 65 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_child_visible ((GtkWidget*) _tmp3_, TRUE);
#line 181 "Dialog.c"
	} else {
		GtkWidget* _tmp4_;
		GtkBox* _tmp5_;
#line 67 "../lib/Widgets/Dialog.vala"
		_tmp4_ = self->priv->dimming;
#line 67 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_child_visible (_tmp4_, FALSE);
#line 68 "../lib/Widgets/Dialog.vala"
		_tmp5_ = self->priv->dialog_bin;
#line 68 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_child_visible ((GtkWidget*) _tmp5_, FALSE);
#line 69 "../lib/Widgets/Dialog.vala"
		g_signal_emit (self, he_dialog_signals[HE_DIALOG_HIDDEN_SIGNAL], 0);
#line 195 "Dialog.c"
	}
#line 71 "../lib/Widgets/Dialog.vala"
	gtk_widget_queue_allocate ((GtkWidget*) self);
#line 57 "../lib/Widgets/Dialog.vala"
	g_object_notify_by_pspec ((GObject *) self, he_dialog_properties[HE_DIALOG_VISIBLE_PROPERTY]);
#line 201 "Dialog.c"
}

const gchar*
he_dialog_get_title (HeDialog* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 79 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->title_label;
#line 80 "../lib/Widgets/Dialog.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 80 "../lib/Widgets/Dialog.vala"
	result = _tmp1_;
#line 80 "../lib/Widgets/Dialog.vala"
	return result;
#line 220 "Dialog.c"
}

void
he_dialog_set_title (HeDialog* self,
                     const gchar* value)
{
#line 82 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 83 "../lib/Widgets/Dialog.vala"
	if (value != NULL) {
#line 231 "Dialog.c"
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
#line 84 "../lib/Widgets/Dialog.vala"
		_tmp0_ = self->priv->title_label;
#line 84 "../lib/Widgets/Dialog.vala"
		gtk_label_set_markup (_tmp0_, value);
#line 85 "../lib/Widgets/Dialog.vala"
		_tmp1_ = self->priv->title_label;
#line 85 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 242 "Dialog.c"
	} else {
		GtkLabel* _tmp2_;
#line 87 "../lib/Widgets/Dialog.vala"
		_tmp2_ = self->priv->title_label;
#line 87 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 249 "Dialog.c"
	}
#line 82 "../lib/Widgets/Dialog.vala"
	g_object_notify_by_pspec ((GObject *) self, he_dialog_properties[HE_DIALOG_TITLE_PROPERTY]);
#line 253 "Dialog.c"
}

const gchar*
he_dialog_get_info (HeDialog* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 96 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->info_label;
#line 97 "../lib/Widgets/Dialog.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 97 "../lib/Widgets/Dialog.vala"
	result = _tmp1_;
#line 97 "../lib/Widgets/Dialog.vala"
	return result;
#line 272 "Dialog.c"
}

void
he_dialog_set_info (HeDialog* self,
                    const gchar* value)
{
#line 99 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 100 "../lib/Widgets/Dialog.vala"
	if (value != NULL) {
#line 283 "Dialog.c"
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
#line 101 "../lib/Widgets/Dialog.vala"
		_tmp0_ = self->priv->info_label;
#line 101 "../lib/Widgets/Dialog.vala"
		gtk_label_set_markup (_tmp0_, value);
#line 102 "../lib/Widgets/Dialog.vala"
		_tmp1_ = self->priv->info_label;
#line 102 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 294 "Dialog.c"
	} else {
		GtkLabel* _tmp2_;
#line 104 "../lib/Widgets/Dialog.vala"
		_tmp2_ = self->priv->info_label;
#line 104 "../lib/Widgets/Dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 301 "Dialog.c"
	}
#line 99 "../lib/Widgets/Dialog.vala"
	g_object_notify_by_pspec ((GObject *) self, he_dialog_properties[HE_DIALOG_INFO_PROPERTY]);
#line 305 "Dialog.c"
}

const gchar*
he_dialog_get_icon (HeDialog* self)
{
	const gchar* result;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
#line 113 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->image;
#line 114 "../lib/Widgets/Dialog.vala"
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
#line 114 "../lib/Widgets/Dialog.vala"
	result = _tmp1_;
#line 114 "../lib/Widgets/Dialog.vala"
	return result;
#line 324 "Dialog.c"
}

void
he_dialog_set_icon (HeDialog* self,
                    const gchar* value)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
#line 117 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 118 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->image;
#line 118 "../lib/Widgets/Dialog.vala"
	gtk_image_set_pixel_size (_tmp0_, (gint) ((GtkIconSize) 48));
#line 119 "../lib/Widgets/Dialog.vala"
	_tmp1_ = self->priv->image;
#line 119 "../lib/Widgets/Dialog.vala"
	gtk_image_set_from_icon_name (_tmp1_, value);
#line 117 "../lib/Widgets/Dialog.vala"
	g_object_notify_by_pspec ((GObject *) self, he_dialog_properties[HE_DIALOG_ICON_PROPERTY]);
#line 345 "Dialog.c"
}

HeButton*
he_dialog_get_secondary_button (HeDialog* self)
{
	HeButton* result;
	HeButton* _tmp0_;
#line 138 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->_secondary_button;
#line 139 "../lib/Widgets/Dialog.vala"
	result = _tmp0_;
#line 139 "../lib/Widgets/Dialog.vala"
	return result;
#line 361 "Dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../lib/Widgets/Dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 369 "Dialog.c"
}

void
he_dialog_set_secondary_button (HeDialog* self,
                                HeButton* value)
{
	HeButton* _tmp0_;
	HeButton* _tmp3_;
	GtkBox* _tmp4_;
	HeButton* _tmp5_;
	GtkBox* _tmp6_;
	HeButton* _tmp7_;
	HeButton* _tmp8_;
#line 127 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 128 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->_secondary_button;
#line 128 "../lib/Widgets/Dialog.vala"
	if (_tmp0_ != NULL) {
#line 389 "Dialog.c"
		GtkBox* _tmp1_;
		HeButton* _tmp2_;
#line 129 "../lib/Widgets/Dialog.vala"
		_tmp1_ = self->priv->button_box;
#line 129 "../lib/Widgets/Dialog.vala"
		_tmp2_ = self->priv->_secondary_button;
#line 129 "../lib/Widgets/Dialog.vala"
		gtk_box_remove (_tmp1_, (GtkWidget*) _tmp2_);
#line 398 "Dialog.c"
	}
#line 132 "../lib/Widgets/Dialog.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 132 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->_secondary_button);
#line 132 "../lib/Widgets/Dialog.vala"
	self->priv->_secondary_button = _tmp3_;
#line 133 "../lib/Widgets/Dialog.vala"
	he_button_set_is_tint (value, TRUE);
#line 134 "../lib/Widgets/Dialog.vala"
	_tmp4_ = self->priv->button_box;
#line 134 "../lib/Widgets/Dialog.vala"
	_tmp5_ = self->priv->_secondary_button;
#line 134 "../lib/Widgets/Dialog.vala"
	gtk_box_prepend (_tmp4_, (GtkWidget*) _tmp5_);
#line 135 "../lib/Widgets/Dialog.vala"
	_tmp6_ = self->priv->button_box;
#line 135 "../lib/Widgets/Dialog.vala"
	_tmp7_ = self->priv->_secondary_button;
#line 135 "../lib/Widgets/Dialog.vala"
	_tmp8_ = self->cancel_button;
#line 135 "../lib/Widgets/Dialog.vala"
	gtk_box_reorder_child_after (_tmp6_, (GtkWidget*) _tmp7_, (GtkWidget*) _tmp8_);
#line 127 "../lib/Widgets/Dialog.vala"
	g_object_notify_by_pspec ((GObject *) self, he_dialog_properties[HE_DIALOG_SECONDARY_BUTTON_PROPERTY]);
#line 424 "Dialog.c"
}

HeButton*
he_dialog_get_primary_button (HeDialog* self)
{
	HeButton* result;
	HeButton* _tmp0_;
#line 147 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->_primary_button;
#line 148 "../lib/Widgets/Dialog.vala"
	result = _tmp0_;
#line 148 "../lib/Widgets/Dialog.vala"
	return result;
#line 440 "Dialog.c"
}

void
he_dialog_set_primary_button (HeDialog* self,
                              HeButton* value)
{
	HeButton* _tmp0_;
	HeButton* _tmp3_;
	GtkBox* _tmp4_;
	HeButton* _tmp5_;
	HeButton* _tmp6_;
#line 151 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 152 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->_primary_button;
#line 152 "../lib/Widgets/Dialog.vala"
	if (_tmp0_ != NULL) {
#line 458 "Dialog.c"
		GtkBox* _tmp1_;
		HeButton* _tmp2_;
#line 153 "../lib/Widgets/Dialog.vala"
		_tmp1_ = self->priv->button_box;
#line 153 "../lib/Widgets/Dialog.vala"
		_tmp2_ = self->priv->_primary_button;
#line 153 "../lib/Widgets/Dialog.vala"
		gtk_box_remove (_tmp1_, (GtkWidget*) _tmp2_);
#line 467 "Dialog.c"
	}
#line 156 "../lib/Widgets/Dialog.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 156 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->_primary_button);
#line 156 "../lib/Widgets/Dialog.vala"
	self->priv->_primary_button = _tmp3_;
#line 157 "../lib/Widgets/Dialog.vala"
	he_button_set_is_fill (value, TRUE);
#line 158 "../lib/Widgets/Dialog.vala"
	_tmp4_ = self->priv->button_box;
#line 158 "../lib/Widgets/Dialog.vala"
	_tmp5_ = self->priv->_primary_button;
#line 158 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp4_, (GtkWidget*) _tmp5_);
#line 160 "../lib/Widgets/Dialog.vala"
	_tmp6_ = self->priv->_secondary_button;
#line 160 "../lib/Widgets/Dialog.vala"
	if (_tmp6_ != NULL) {
#line 487 "Dialog.c"
		GtkBox* _tmp7_;
		HeButton* _tmp8_;
		HeButton* _tmp9_;
#line 161 "../lib/Widgets/Dialog.vala"
		_tmp7_ = self->priv->button_box;
#line 161 "../lib/Widgets/Dialog.vala"
		_tmp8_ = self->priv->_primary_button;
#line 161 "../lib/Widgets/Dialog.vala"
		_tmp9_ = self->priv->_secondary_button;
#line 161 "../lib/Widgets/Dialog.vala"
		gtk_box_reorder_child_after (_tmp7_, (GtkWidget*) _tmp8_, (GtkWidget*) _tmp9_);
#line 499 "Dialog.c"
	}
#line 151 "../lib/Widgets/Dialog.vala"
	g_object_notify_by_pspec ((GObject *) self, he_dialog_properties[HE_DIALOG_PRIMARY_BUTTON_PROPERTY]);
#line 503 "Dialog.c"
}

/**
     * Add a child directly to the Dialog. Used only in code.
     *
     * @since 1.0
     */
void
he_dialog_add (HeDialog* self,
               GtkWidget* widget)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 171 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 171 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (widget != NULL);
#line 172 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->child_box;
#line 172 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp0_, widget);
#line 173 "../lib/Widgets/Dialog.vala"
	_tmp1_ = self->priv->child_box;
#line 173 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 529 "Dialog.c"
}

/**
     * Shows the dialog by overlaying it on the parent window.
     */
void
he_dialog_present (HeDialog* self)
{
	GtkWindow* _tmp0_;
#line 179 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 180 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->parent_window;
#line 180 "../lib/Widgets/Dialog.vala"
	if (_tmp0_ != NULL) {
#line 182 "../lib/Widgets/Dialog.vala"
		he_dialog_find_and_overlay_on_parent (self);
#line 547 "Dialog.c"
	}
#line 184 "../lib/Widgets/Dialog.vala"
	he_dialog_set_visible (self, TRUE);
#line 551 "Dialog.c"
}

/**
     * Hides the dialog.
     */
void
he_dialog_hide_dialog (HeDialog* self)
{
	GtkWidget* _tmp0_;
#line 190 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 191 "../lib/Widgets/Dialog.vala"
	he_dialog_set_visible (self, FALSE);
#line 193 "../lib/Widgets/Dialog.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 193 "../lib/Widgets/Dialog.vala"
	if (_tmp0_ != NULL) {
#line 569 "Dialog.c"
		GtkWidget* _tmp1_;
#line 194 "../lib/Widgets/Dialog.vala"
		_tmp1_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 194 "../lib/Widgets/Dialog.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_overlay_get_type ())) {
#line 575 "Dialog.c"
			GtkWidget* _tmp2_;
#line 195 "../lib/Widgets/Dialog.vala"
			_tmp2_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 195 "../lib/Widgets/Dialog.vala"
			gtk_overlay_remove_overlay (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_overlay_get_type (), GtkOverlay), (GtkWidget*) self);
#line 581 "Dialog.c"
		} else {
#line 197 "../lib/Widgets/Dialog.vala"
			gtk_widget_unparent ((GtkWidget*) self);
#line 585 "Dialog.c"
		}
	}
}

static void
he_dialog_find_and_overlay_on_parent (HeDialog* self)
{
	GtkWidget* content = NULL;
	GtkWindow* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* overlay_target = NULL;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkWidget* _tmp7_;
#line 202 "../lib/Widgets/Dialog.vala"
	g_return_if_fail (self != NULL);
#line 203 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->parent_window;
#line 203 "../lib/Widgets/Dialog.vala"
	_tmp1_ = gtk_window_get_child (_tmp0_);
#line 203 "../lib/Widgets/Dialog.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 203 "../lib/Widgets/Dialog.vala"
	content = _tmp2_;
#line 204 "../lib/Widgets/Dialog.vala"
	_tmp3_ = content;
#line 204 "../lib/Widgets/Dialog.vala"
	if (_tmp3_ == NULL) {
#line 205 "../lib/Widgets/Dialog.vala"
		g_warning ("Dialog.vala:205: Dialog: Parent window has no content widget");
#line 206 "../lib/Widgets/Dialog.vala"
		_g_object_unref0 (content);
#line 206 "../lib/Widgets/Dialog.vala"
		return;
#line 623 "Dialog.c"
	}
#line 210 "../lib/Widgets/Dialog.vala"
	_tmp4_ = content;
#line 210 "../lib/Widgets/Dialog.vala"
	_tmp5_ = he_dialog_find_overlay_target (self, _tmp4_);
#line 210 "../lib/Widgets/Dialog.vala"
	overlay_target = _tmp5_;
#line 212 "../lib/Widgets/Dialog.vala"
	_tmp7_ = overlay_target;
#line 212 "../lib/Widgets/Dialog.vala"
	if (_tmp7_ != NULL) {
#line 635 "Dialog.c"
		GtkWidget* _tmp8_;
#line 212 "../lib/Widgets/Dialog.vala"
		_tmp8_ = overlay_target;
#line 212 "../lib/Widgets/Dialog.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_overlay_get_type ());
#line 641 "Dialog.c"
	} else {
#line 212 "../lib/Widgets/Dialog.vala"
		_tmp6_ = FALSE;
#line 645 "Dialog.c"
	}
#line 212 "../lib/Widgets/Dialog.vala"
	if (_tmp6_) {
#line 649 "Dialog.c"
		GtkWidget* _tmp9_;
#line 213 "../lib/Widgets/Dialog.vala"
		_tmp9_ = overlay_target;
#line 213 "../lib/Widgets/Dialog.vala"
		gtk_overlay_add_overlay (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_overlay_get_type (), GtkOverlay), (GtkWidget*) self);
#line 655 "Dialog.c"
	} else {
#line 215 "../lib/Widgets/Dialog.vala"
		g_warning ("Dialog.vala:215: Dialog: No Gtk.Overlay found in parent window. Modal " \
"dialogs require a Gtk.Overlay container.");
#line 217 "../lib/Widgets/Dialog.vala"
		he_dialog_set_visible (self, FALSE);
#line 661 "Dialog.c"
	}
#line 202 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (overlay_target);
#line 202 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (content);
#line 667 "Dialog.c"
}

static GtkWidget*
he_dialog_find_overlay_target (HeDialog* self,
                               GtkWidget* widget)
{
	GtkWidget* result;
#line 221 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 221 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 223 "../lib/Widgets/Dialog.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_overlay_get_type ())) {
#line 681 "Dialog.c"
		GtkWidget* _tmp0_;
#line 224 "../lib/Widgets/Dialog.vala"
		_tmp0_ = _g_object_ref0 (widget);
#line 224 "../lib/Widgets/Dialog.vala"
		result = _tmp0_;
#line 224 "../lib/Widgets/Dialog.vala"
		return result;
#line 689 "Dialog.c"
	}
#line 228 "../lib/Widgets/Dialog.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_box_get_type ())) {
#line 693 "Dialog.c"
		GtkWidget* child = NULL;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 229 "../lib/Widgets/Dialog.vala"
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_box_get_type (), GtkBox));
#line 229 "../lib/Widgets/Dialog.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 229 "../lib/Widgets/Dialog.vala"
		child = _tmp2_;
#line 230 "../lib/Widgets/Dialog.vala"
		while (TRUE) {
#line 705 "Dialog.c"
			GtkWidget* _tmp3_;
			GtkWidget* _result_ = NULL;
			GtkWidget* _tmp4_;
			GtkWidget* _tmp5_;
			GtkWidget* _tmp6_;
			GtkWidget* _tmp7_;
			GtkWidget* _tmp8_;
			GtkWidget* _tmp9_;
#line 230 "../lib/Widgets/Dialog.vala"
			_tmp3_ = child;
#line 230 "../lib/Widgets/Dialog.vala"
			if (!(_tmp3_ != NULL)) {
#line 230 "../lib/Widgets/Dialog.vala"
				break;
#line 720 "Dialog.c"
			}
#line 231 "../lib/Widgets/Dialog.vala"
			_tmp4_ = child;
#line 231 "../lib/Widgets/Dialog.vala"
			_tmp5_ = he_dialog_find_overlay_target (self, _tmp4_);
#line 231 "../lib/Widgets/Dialog.vala"
			_result_ = _tmp5_;
#line 232 "../lib/Widgets/Dialog.vala"
			_tmp6_ = _result_;
#line 232 "../lib/Widgets/Dialog.vala"
			if (_tmp6_ != NULL) {
#line 232 "../lib/Widgets/Dialog.vala"
				result = _result_;
#line 232 "../lib/Widgets/Dialog.vala"
				_g_object_unref0 (child);
#line 232 "../lib/Widgets/Dialog.vala"
				return result;
#line 738 "Dialog.c"
			}
#line 233 "../lib/Widgets/Dialog.vala"
			_tmp7_ = child;
#line 233 "../lib/Widgets/Dialog.vala"
			_tmp8_ = gtk_widget_get_next_sibling (_tmp7_);
#line 233 "../lib/Widgets/Dialog.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 233 "../lib/Widgets/Dialog.vala"
			_g_object_unref0 (child);
#line 233 "../lib/Widgets/Dialog.vala"
			child = _tmp9_;
#line 230 "../lib/Widgets/Dialog.vala"
			_g_object_unref0 (_result_);
#line 752 "Dialog.c"
		}
#line 228 "../lib/Widgets/Dialog.vala"
		_g_object_unref0 (child);
#line 756 "Dialog.c"
	} else {
#line 235 "../lib/Widgets/Dialog.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_grid_get_type ())) {
#line 760 "Dialog.c"
			GtkWidget* child = NULL;
			GtkWidget* _tmp10_;
			GtkWidget* _tmp11_;
#line 236 "../lib/Widgets/Dialog.vala"
			_tmp10_ = gtk_widget_get_first_child ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_grid_get_type (), GtkGrid));
#line 236 "../lib/Widgets/Dialog.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 236 "../lib/Widgets/Dialog.vala"
			child = _tmp11_;
#line 237 "../lib/Widgets/Dialog.vala"
			while (TRUE) {
#line 772 "Dialog.c"
				GtkWidget* _tmp12_;
				GtkWidget* _result_ = NULL;
				GtkWidget* _tmp13_;
				GtkWidget* _tmp14_;
				GtkWidget* _tmp15_;
				GtkWidget* _tmp16_;
				GtkWidget* _tmp17_;
				GtkWidget* _tmp18_;
#line 237 "../lib/Widgets/Dialog.vala"
				_tmp12_ = child;
#line 237 "../lib/Widgets/Dialog.vala"
				if (!(_tmp12_ != NULL)) {
#line 237 "../lib/Widgets/Dialog.vala"
					break;
#line 787 "Dialog.c"
				}
#line 238 "../lib/Widgets/Dialog.vala"
				_tmp13_ = child;
#line 238 "../lib/Widgets/Dialog.vala"
				_tmp14_ = he_dialog_find_overlay_target (self, _tmp13_);
#line 238 "../lib/Widgets/Dialog.vala"
				_result_ = _tmp14_;
#line 239 "../lib/Widgets/Dialog.vala"
				_tmp15_ = _result_;
#line 239 "../lib/Widgets/Dialog.vala"
				if (_tmp15_ != NULL) {
#line 239 "../lib/Widgets/Dialog.vala"
					result = _result_;
#line 239 "../lib/Widgets/Dialog.vala"
					_g_object_unref0 (child);
#line 239 "../lib/Widgets/Dialog.vala"
					return result;
#line 805 "Dialog.c"
				}
#line 240 "../lib/Widgets/Dialog.vala"
				_tmp16_ = child;
#line 240 "../lib/Widgets/Dialog.vala"
				_tmp17_ = gtk_widget_get_next_sibling (_tmp16_);
#line 240 "../lib/Widgets/Dialog.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 240 "../lib/Widgets/Dialog.vala"
				_g_object_unref0 (child);
#line 240 "../lib/Widgets/Dialog.vala"
				child = _tmp18_;
#line 237 "../lib/Widgets/Dialog.vala"
				_g_object_unref0 (_result_);
#line 819 "Dialog.c"
			}
#line 235 "../lib/Widgets/Dialog.vala"
			_g_object_unref0 (child);
#line 823 "Dialog.c"
		}
	}
#line 244 "../lib/Widgets/Dialog.vala"
	result = NULL;
#line 244 "../lib/Widgets/Dialog.vala"
	return result;
#line 830 "Dialog.c"
}

/**
     * Creates a new dialog.
     * @param parent The parent window of the dialog. The window must contain
     *               a Gtk.Overlay somewhere in its widget hierarchy for modal
     *               overlay behavior to work correctly.
     * @param title The title of the dialog.
     * @param info The info text of the dialog.
     * @param icon The icon of the dialog.
     * @param primary_button The primary button of the dialog.
     * @param secondary_button The secondary button of the dialog.
     *
     * @since 1.0
     */
HeDialog*
he_dialog_construct (GType object_type,
                     GtkWindow* parent,
                     const gchar* title,
                     const gchar* info,
                     const gchar* icon,
                     HeButton* primary_button,
                     HeButton* secondary_button)
{
	HeDialog * self = NULL;
	GtkWindow* _tmp0_;
#line 260 "../lib/Widgets/Dialog.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 260 "../lib/Widgets/Dialog.vala"
	self = (HeDialog*) g_object_new (object_type, NULL);
#line 266 "../lib/Widgets/Dialog.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 266 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 266 "../lib/Widgets/Dialog.vala"
	self->priv->parent_window = _tmp0_;
#line 267 "../lib/Widgets/Dialog.vala"
	he_dialog_set_title (self, title);
#line 268 "../lib/Widgets/Dialog.vala"
	he_dialog_set_info (self, info);
#line 269 "../lib/Widgets/Dialog.vala"
	he_dialog_set_icon (self, icon);
#line 270 "../lib/Widgets/Dialog.vala"
	he_dialog_set_primary_button (self, primary_button);
#line 271 "../lib/Widgets/Dialog.vala"
	he_dialog_set_secondary_button (self, secondary_button);
#line 260 "../lib/Widgets/Dialog.vala"
	return self;
#line 879 "Dialog.c"
}

HeDialog*
he_dialog_new (GtkWindow* parent,
               const gchar* title,
               const gchar* info,
               const gchar* icon,
               HeButton* primary_button,
               HeButton* secondary_button)
{
#line 260 "../lib/Widgets/Dialog.vala"
	return he_dialog_construct (HE_TYPE_DIALOG, parent, title, info, icon, primary_button, secondary_button);
#line 892 "Dialog.c"
}

static void
he_dialog_real_dispose (GObject* base)
{
	HeDialog * self;
	GtkWidget* _tmp0_;
	GtkBox* _tmp2_;
#line 337 "../lib/Widgets/Dialog.vala"
	self = (HeDialog*) base;
#line 338 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->dimming;
#line 338 "../lib/Widgets/Dialog.vala"
	if (_tmp0_ != NULL) {
#line 907 "Dialog.c"
		GtkWidget* _tmp1_;
#line 339 "../lib/Widgets/Dialog.vala"
		_tmp1_ = self->priv->dimming;
#line 339 "../lib/Widgets/Dialog.vala"
		gtk_widget_unparent (_tmp1_);
#line 340 "../lib/Widgets/Dialog.vala"
		_g_object_unref0 (self->priv->dimming);
#line 340 "../lib/Widgets/Dialog.vala"
		self->priv->dimming = NULL;
#line 917 "Dialog.c"
	}
#line 343 "../lib/Widgets/Dialog.vala"
	_tmp2_ = self->priv->dialog_bin;
#line 343 "../lib/Widgets/Dialog.vala"
	if (_tmp2_ != NULL) {
#line 923 "Dialog.c"
		GtkBox* _tmp3_;
#line 344 "../lib/Widgets/Dialog.vala"
		_tmp3_ = self->priv->dialog_bin;
#line 344 "../lib/Widgets/Dialog.vala"
		gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 345 "../lib/Widgets/Dialog.vala"
		_g_object_unref0 (self->priv->dialog_bin);
#line 345 "../lib/Widgets/Dialog.vala"
		self->priv->dialog_bin = NULL;
#line 933 "Dialog.c"
	}
#line 348 "../lib/Widgets/Dialog.vala"
	G_OBJECT_CLASS (he_dialog_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 937 "Dialog.c"
}

static gboolean
he_dialog_real_contains (GtkWidget* base,
                         gdouble x,
                         gdouble y)
{
	HeDialog * self;
	gboolean result;
#line 351 "../lib/Widgets/Dialog.vala"
	self = (HeDialog*) base;
#line 352 "../lib/Widgets/Dialog.vala"
	result = FALSE;
#line 352 "../lib/Widgets/Dialog.vala"
	return result;
#line 953 "Dialog.c"
}

static void
he_dialog_real_measure (GtkWidget* base,
                        GtkOrientation orientation,
                        gint for_size,
                        gint* min,
                        gint* nat,
                        gint* min_baseline,
                        gint* nat_baseline)
{
	HeDialog * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gint _vala_min_baseline = 0;
	gint _vala_nat_baseline = 0;
	gint dialog_min = 0;
	gint dialog_nat = 0;
	gint dimming_min = 0;
	gint dimming_nat = 0;
	GtkBox* _tmp0_;
#line 355 "../lib/Widgets/Dialog.vala"
	self = (HeDialog*) base;
#line 363 "../lib/Widgets/Dialog.vala"
	_vala_nat = 0;
#line 363 "../lib/Widgets/Dialog.vala"
	_vala_min = _vala_nat;
#line 365 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->dialog_bin;
#line 365 "../lib/Widgets/Dialog.vala"
	if (gtk_widget_get_child_visible ((GtkWidget*) _tmp0_)) {
#line 985 "Dialog.c"
		GtkBox* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GtkWidget* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 366 "../lib/Widgets/Dialog.vala"
		_tmp1_ = self->priv->dialog_bin;
#line 366 "../lib/Widgets/Dialog.vala"
		gtk_widget_measure ((GtkWidget*) _tmp1_, orientation, for_size, &_tmp2_, &_tmp3_, NULL, NULL);
#line 366 "../lib/Widgets/Dialog.vala"
		dialog_min = _tmp2_;
#line 366 "../lib/Widgets/Dialog.vala"
		dialog_nat = _tmp3_;
#line 367 "../lib/Widgets/Dialog.vala"
		_tmp4_ = self->priv->dimming;
#line 367 "../lib/Widgets/Dialog.vala"
		gtk_widget_measure (_tmp4_, orientation, for_size, &_tmp5_, &_tmp6_, NULL, NULL);
#line 367 "../lib/Widgets/Dialog.vala"
		dimming_min = _tmp5_;
#line 367 "../lib/Widgets/Dialog.vala"
		dimming_nat = _tmp6_;
#line 369 "../lib/Widgets/Dialog.vala"
		if (orientation == GTK_ORIENTATION_HORIZONTAL) {
#line 370 "../lib/Widgets/Dialog.vala"
			_vala_min = MAX (dimming_min, dialog_min);
#line 371 "../lib/Widgets/Dialog.vala"
			_vala_nat = MAX (dimming_nat, dialog_nat);
#line 1014 "Dialog.c"
		} else {
#line 373 "../lib/Widgets/Dialog.vala"
			_vala_min = MAX (dimming_min, dialog_min + HE_DIALOG_TOP_MARGIN);
#line 374 "../lib/Widgets/Dialog.vala"
			_vala_nat = MAX (dimming_nat, dialog_nat + HE_DIALOG_TOP_MARGIN);
#line 1020 "Dialog.c"
		}
	}
#line 377 "../lib/Widgets/Dialog.vala"
	_vala_nat_baseline = -1;
#line 377 "../lib/Widgets/Dialog.vala"
	_vala_min_baseline = _vala_nat_baseline;
#line 355 "../lib/Widgets/Dialog.vala"
	if (min) {
#line 355 "../lib/Widgets/Dialog.vala"
		*min = _vala_min;
#line 1031 "Dialog.c"
	}
#line 355 "../lib/Widgets/Dialog.vala"
	if (nat) {
#line 355 "../lib/Widgets/Dialog.vala"
		*nat = _vala_nat;
#line 1037 "Dialog.c"
	}
#line 355 "../lib/Widgets/Dialog.vala"
	if (min_baseline) {
#line 355 "../lib/Widgets/Dialog.vala"
		*min_baseline = _vala_min_baseline;
#line 1043 "Dialog.c"
	}
#line 355 "../lib/Widgets/Dialog.vala"
	if (nat_baseline) {
#line 355 "../lib/Widgets/Dialog.vala"
		*nat_baseline = _vala_nat_baseline;
#line 1049 "Dialog.c"
	}
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 394 "../lib/Widgets/Dialog.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 1058 "Dialog.c"
}

static void
he_dialog_real_size_allocate (GtkWidget* base,
                              gint width,
                              gint height,
                              gint baseline)
{
	HeDialog * self;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	gint dialog_width = 0;
	gint dialog_height = 0;
	GtkBox* _tmp2_;
	gint _tmp3_ = 0;
	GtkBox* _tmp4_;
	gint _tmp5_ = 0;
	GskTransform* t = NULL;
	GskTransform* _tmp6_;
#line 380 "../lib/Widgets/Dialog.vala"
	self = (HeDialog*) base;
#line 381 "../lib/Widgets/Dialog.vala"
	_tmp0_ = self->priv->dialog_bin;
#line 381 "../lib/Widgets/Dialog.vala"
	if (!gtk_widget_get_child_visible ((GtkWidget*) _tmp0_)) {
#line 382 "../lib/Widgets/Dialog.vala"
		return;
#line 1086 "Dialog.c"
	}
#line 384 "../lib/Widgets/Dialog.vala"
	_tmp1_ = self->priv->dimming;
#line 384 "../lib/Widgets/Dialog.vala"
	gtk_widget_allocate (_tmp1_, width, height, baseline, NULL);
#line 387 "../lib/Widgets/Dialog.vala"
	_tmp2_ = self->priv->dialog_bin;
#line 387 "../lib/Widgets/Dialog.vala"
	gtk_widget_measure ((GtkWidget*) _tmp2_, GTK_ORIENTATION_HORIZONTAL, -1, &_tmp3_, NULL, NULL, NULL);
#line 387 "../lib/Widgets/Dialog.vala"
	dialog_width = _tmp3_;
#line 388 "../lib/Widgets/Dialog.vala"
	_tmp4_ = self->priv->dialog_bin;
#line 388 "../lib/Widgets/Dialog.vala"
	gtk_widget_measure ((GtkWidget*) _tmp4_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp5_, NULL, NULL);
#line 388 "../lib/Widgets/Dialog.vala"
	dialog_height = _tmp5_;
#line 390 "../lib/Widgets/Dialog.vala"
	_tmp6_ = gsk_transform_new ();
#line 390 "../lib/Widgets/Dialog.vala"
	t = _tmp6_;
#line 392 "../lib/Widgets/Dialog.vala"
	if (width <= 600) {
#line 1110 "Dialog.c"
		GskTransform* _tmp7_;
		graphene_point_t _tmp8_ = {0};
		GskTransform* _tmp9_;
		GtkBox* _tmp10_;
		GskTransform* _tmp11_;
		GskTransform* _tmp12_;
		GtkBox* _tmp13_;
		GtkBox* _tmp14_;
#line 393 "../lib/Widgets/Dialog.vala"
		_tmp7_ = t;
#line 393 "../lib/Widgets/Dialog.vala"
		t = NULL;
#line 393 "../lib/Widgets/Dialog.vala"
		_tmp8_.x = (gfloat) 0;
#line 393 "../lib/Widgets/Dialog.vala"
		_tmp8_.y = (gfloat) (height - dialog_height);
#line 393 "../lib/Widgets/Dialog.vala"
		_tmp9_ = gsk_transform_translate (_tmp7_, &_tmp8_);
#line 393 "../lib/Widgets/Dialog.vala"
		_gsk_transform_unref0 (t);
#line 393 "../lib/Widgets/Dialog.vala"
		t = _tmp9_;
#line 394 "../lib/Widgets/Dialog.vala"
		_tmp10_ = self->priv->dialog_bin;
#line 394 "../lib/Widgets/Dialog.vala"
		_tmp11_ = t;
#line 394 "../lib/Widgets/Dialog.vala"
		_tmp12_ = _gsk_transform_ref0 (_tmp11_);
#line 394 "../lib/Widgets/Dialog.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp10_, width, dialog_height, baseline, _tmp12_);
#line 395 "../lib/Widgets/Dialog.vala"
		_tmp13_ = self->priv->dialog_bin;
#line 395 "../lib/Widgets/Dialog.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp13_, "bottom-sheet");
#line 396 "../lib/Widgets/Dialog.vala"
		_tmp14_ = self->priv->dialog_bin;
#line 396 "../lib/Widgets/Dialog.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp14_, "dialog-sheet");
#line 1149 "Dialog.c"
	} else {
		gint effective_margin_h = 0;
		gint effective_margin_v = 0;
		gint available_width = 0;
		gint available_height = 0;
		gint available_space_h = 0;
		gint x_pos = 0;
		gint y_pos = 0;
		GskTransform* _tmp15_;
		graphene_point_t _tmp16_ = {0};
		GskTransform* _tmp17_;
		GtkBox* _tmp18_;
		GskTransform* _tmp19_;
		GskTransform* _tmp20_;
		GtkBox* _tmp21_;
		GtkBox* _tmp22_;
#line 399 "../lib/Widgets/Dialog.vala"
		effective_margin_h = MAX (HE_DIALOG_MIN_EDGE_MARGIN, HE_DIALOG_DESKTOP_EDGE_MARGIN);
#line 400 "../lib/Widgets/Dialog.vala"
		effective_margin_v = MAX (HE_DIALOG_MIN_EDGE_MARGIN, HE_DIALOG_DESKTOP_EDGE_MARGIN);
#line 403 "../lib/Widgets/Dialog.vala"
		available_width = width - (2 * effective_margin_h);
#line 404 "../lib/Widgets/Dialog.vala"
		if (dialog_width > available_width) {
#line 405 "../lib/Widgets/Dialog.vala"
			effective_margin_h = MAX (HE_DIALOG_MIN_EDGE_MARGIN, (width - dialog_width) / 2);
#line 1176 "Dialog.c"
		}
#line 409 "../lib/Widgets/Dialog.vala"
		available_height = height - (2 * effective_margin_v);
#line 410 "../lib/Widgets/Dialog.vala"
		if (dialog_height > available_height) {
#line 411 "../lib/Widgets/Dialog.vala"
			effective_margin_v = MAX (HE_DIALOG_MIN_EDGE_MARGIN, (height - dialog_height) / 2);
#line 412 "../lib/Widgets/Dialog.vala"
			dialog_height = height - (2 * effective_margin_v);
#line 1186 "Dialog.c"
		}
#line 416 "../lib/Widgets/Dialog.vala"
		available_space_h = (width - (2 * effective_margin_h)) - dialog_width;
#line 418 "../lib/Widgets/Dialog.vala"
		if (gtk_widget_get_direction ((GtkWidget*) self) == GTK_TEXT_DIR_RTL) {
#line 420 "../lib/Widgets/Dialog.vala"
			x_pos = effective_margin_h + (available_space_h / 4);
#line 1194 "Dialog.c"
		} else {
#line 423 "../lib/Widgets/Dialog.vala"
			x_pos = effective_margin_h + ((available_space_h * 3) / 4);
#line 1198 "Dialog.c"
		}
#line 427 "../lib/Widgets/Dialog.vala"
		y_pos = (height - dialog_height) / 2;
#line 429 "../lib/Widgets/Dialog.vala"
		_tmp15_ = t;
#line 429 "../lib/Widgets/Dialog.vala"
		t = NULL;
#line 429 "../lib/Widgets/Dialog.vala"
		_tmp16_.x = (gfloat) x_pos;
#line 429 "../lib/Widgets/Dialog.vala"
		_tmp16_.y = (gfloat) y_pos;
#line 429 "../lib/Widgets/Dialog.vala"
		_tmp17_ = gsk_transform_translate (_tmp15_, &_tmp16_);
#line 429 "../lib/Widgets/Dialog.vala"
		_gsk_transform_unref0 (t);
#line 429 "../lib/Widgets/Dialog.vala"
		t = _tmp17_;
#line 430 "../lib/Widgets/Dialog.vala"
		_tmp18_ = self->priv->dialog_bin;
#line 430 "../lib/Widgets/Dialog.vala"
		_tmp19_ = t;
#line 430 "../lib/Widgets/Dialog.vala"
		_tmp20_ = _gsk_transform_ref0 (_tmp19_);
#line 430 "../lib/Widgets/Dialog.vala"
		gtk_widget_allocate ((GtkWidget*) _tmp18_, dialog_width, dialog_height, baseline, _tmp20_);
#line 431 "../lib/Widgets/Dialog.vala"
		_tmp21_ = self->priv->dialog_bin;
#line 431 "../lib/Widgets/Dialog.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "dialog-sheet");
#line 432 "../lib/Widgets/Dialog.vala"
		_tmp22_ = self->priv->dialog_bin;
#line 432 "../lib/Widgets/Dialog.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp22_, "bottom-sheet");
#line 1232 "Dialog.c"
	}
#line 380 "../lib/Widgets/Dialog.vala"
	_gsk_transform_unref0 (t);
#line 1236 "Dialog.c"
}

static void
_he_dialog___lambda128_ (HeDialog* self)
{
#line 312 "../lib/Widgets/Dialog.vala"
	he_dialog_hide_dialog (self);
#line 1244 "Dialog.c"
}

static void
__he_dialog___lambda128__gtk_button_clicked (GtkButton* _sender,
                                             gpointer self)
{
#line 311 "../lib/Widgets/Dialog.vala"
	_he_dialog___lambda128_ ((HeDialog*) self);
#line 1253 "Dialog.c"
}

static void
_he_dialog___lambda129_ (HeDialog* self)
{
#line 333 "../lib/Widgets/Dialog.vala"
	he_dialog_hide_dialog (self);
#line 1261 "Dialog.c"
}

static void
__he_dialog___lambda129__gtk_gesture_end (GtkGesture* _sender,
                                          GdkEventSequence* sequence,
                                          gpointer self)
{
#line 333 "../lib/Widgets/Dialog.vala"
	_he_dialog___lambda129_ ((HeDialog*) self);
#line 1271 "Dialog.c"
}

static GObject *
he_dialog_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeDialog * self;
	HeBin* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkBox* _tmp25_;
	GtkImage* _tmp26_;
	GtkBox* _tmp27_;
	GtkLabel* _tmp28_;
	GtkBox* _tmp29_;
	GtkLabel* _tmp30_;
	HeButton* _tmp31_;
	HeButton* _tmp32_;
	HeButton* _tmp33_;
	GtkBox* _tmp34_;
	GtkBox* _tmp35_;
	GtkBox* _tmp36_;
	GtkBox* _tmp37_;
	HeButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	GtkBox* _tmp42_;
	GtkBox* _tmp43_;
	GtkBox* _tmp44_;
	GtkBox* _tmp45_;
	GtkBox* _tmp46_;
	GtkBox* _tmp47_;
	GtkWindowHandle* _tmp48_;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkWindowHandle* _tmp51_;
	GtkGestureClick* click_gesture = NULL;
	GtkGestureClick* _tmp52_;
	GtkGestureClick* _tmp53_;
	GtkWidget* _tmp54_;
	GtkGestureClick* _tmp55_;
	GtkEventController* _tmp56_;
#line 274 "../lib/Widgets/Dialog.vala"
	parent_class = G_OBJECT_CLASS (he_dialog_parent_class);
#line 274 "../lib/Widgets/Dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 274 "../lib/Widgets/Dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DIALOG, HeDialog);
#line 276 "../lib/Widgets/Dialog.vala"
	_tmp0_ = he_bin_new ();
#line 276 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 276 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->dimming);
#line 276 "../lib/Widgets/Dialog.vala"
	self->priv->dimming = (GtkWidget*) _tmp0_;
#line 277 "../lib/Widgets/Dialog.vala"
	_tmp1_ = self->priv->dimming;
#line 277 "../lib/Widgets/Dialog.vala"
	gtk_widget_add_css_class (_tmp1_, "dimming");
#line 278 "../lib/Widgets/Dialog.vala"
	_tmp2_ = self->priv->dimming;
#line 278 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_child_visible (_tmp2_, FALSE);
#line 279 "../lib/Widgets/Dialog.vala"
	_tmp3_ = self->priv->dimming;
#line 279 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_parent (_tmp3_, (GtkWidget*) self);
#line 282 "../lib/Widgets/Dialog.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 282 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp4_);
#line 282 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->dialog_bin);
#line 282 "../lib/Widgets/Dialog.vala"
	self->priv->dialog_bin = _tmp4_;
#line 283 "../lib/Widgets/Dialog.vala"
	_tmp5_ = self->priv->dialog_bin;
#line 283 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_CENTER);
#line 284 "../lib/Widgets/Dialog.vala"
	_tmp6_ = self->priv->dialog_bin;
#line 284 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_child_visible ((GtkWidget*) _tmp6_, FALSE);
#line 285 "../lib/Widgets/Dialog.vala"
	_tmp7_ = self->priv->dialog_bin;
#line 285 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp7_, 440, -1);
#line 286 "../lib/Widgets/Dialog.vala"
	_tmp8_ = self->priv->dialog_bin;
#line 286 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp8_, (GtkWidget*) self);
#line 288 "../lib/Widgets/Dialog.vala"
	_tmp9_ = self->priv->image;
#line 288 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 289 "../lib/Widgets/Dialog.vala"
	_tmp10_ = self->priv->image;
#line 289 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 290 "../lib/Widgets/Dialog.vala"
	_tmp11_ = self->priv->title_label;
#line 290 "../lib/Widgets/Dialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp11_, "view-title");
#line 291 "../lib/Widgets/Dialog.vala"
	_tmp12_ = self->priv->title_label;
#line 291 "../lib/Widgets/Dialog.vala"
	gtk_label_set_wrap (_tmp12_, TRUE);
#line 292 "../lib/Widgets/Dialog.vala"
	_tmp13_ = self->priv->title_label;
#line 292 "../lib/Widgets/Dialog.vala"
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
#line 293 "../lib/Widgets/Dialog.vala"
	_tmp14_ = self->priv->title_label;
#line 293 "../lib/Widgets/Dialog.vala"
	gtk_label_set_wrap_mode (_tmp14_, PANGO_WRAP_WORD);
#line 294 "../lib/Widgets/Dialog.vala"
	_tmp15_ = self->priv->title_label;
#line 294 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
#line 295 "../lib/Widgets/Dialog.vala"
	_tmp16_ = self->priv->title_label;
#line 295 "../lib/Widgets/Dialog.vala"
	gtk_label_set_width_chars (_tmp16_, 25);
#line 296 "../lib/Widgets/Dialog.vala"
	_tmp17_ = self->priv->info_label;
#line 296 "../lib/Widgets/Dialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp17_, "body");
#line 297 "../lib/Widgets/Dialog.vala"
	_tmp18_ = self->priv->info_label;
#line 297 "../lib/Widgets/Dialog.vala"
	gtk_label_set_xalign (_tmp18_, (gfloat) 0);
#line 298 "../lib/Widgets/Dialog.vala"
	_tmp19_ = self->priv->info_label;
#line 298 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp19_, TRUE);
#line 299 "../lib/Widgets/Dialog.vala"
	_tmp20_ = self->priv->info_label;
#line 299 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp20_, TRUE);
#line 300 "../lib/Widgets/Dialog.vala"
	_tmp21_ = self->priv->info_label;
#line 300 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_START);
#line 301 "../lib/Widgets/Dialog.vala"
	_tmp22_ = self->priv->info_label;
#line 301 "../lib/Widgets/Dialog.vala"
	gtk_label_set_wrap (_tmp22_, TRUE);
#line 302 "../lib/Widgets/Dialog.vala"
	_tmp23_ = self->priv->info_label;
#line 302 "../lib/Widgets/Dialog.vala"
	gtk_label_set_wrap_mode (_tmp23_, PANGO_WRAP_WORD);
#line 303 "../lib/Widgets/Dialog.vala"
	_tmp24_ = self->priv->info_label;
#line 303 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp24_, FALSE);
#line 305 "../lib/Widgets/Dialog.vala"
	_tmp25_ = self->priv->info_box;
#line 305 "../lib/Widgets/Dialog.vala"
	_tmp26_ = self->priv->image;
#line 305 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 306 "../lib/Widgets/Dialog.vala"
	_tmp27_ = self->priv->info_box;
#line 306 "../lib/Widgets/Dialog.vala"
	_tmp28_ = self->priv->title_label;
#line 306 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 307 "../lib/Widgets/Dialog.vala"
	_tmp29_ = self->priv->info_box;
#line 307 "../lib/Widgets/Dialog.vala"
	_tmp30_ = self->priv->info_label;
#line 307 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
#line 309 "../lib/Widgets/Dialog.vala"
	_tmp31_ = he_button_new (NULL, _ ("Cancel"));
#line 309 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp31_);
#line 309 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->cancel_button);
#line 309 "../lib/Widgets/Dialog.vala"
	self->cancel_button = _tmp31_;
#line 310 "../lib/Widgets/Dialog.vala"
	_tmp32_ = self->cancel_button;
#line 310 "../lib/Widgets/Dialog.vala"
	he_button_set_is_textual (_tmp32_, TRUE);
#line 311 "../lib/Widgets/Dialog.vala"
	_tmp33_ = self->cancel_button;
#line 311 "../lib/Widgets/Dialog.vala"
	g_signal_connect_object ((GtkButton*) _tmp33_, "clicked", (GCallback) __he_dialog___lambda128__gtk_button_clicked, self, 0);
#line 315 "../lib/Widgets/Dialog.vala"
	_tmp34_ = self->priv->button_box;
#line 315 "../lib/Widgets/Dialog.vala"
	gtk_box_set_homogeneous (_tmp34_, TRUE);
#line 316 "../lib/Widgets/Dialog.vala"
	_tmp35_ = self->priv->button_box;
#line 316 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp35_, GTK_ALIGN_CENTER);
#line 317 "../lib/Widgets/Dialog.vala"
	_tmp36_ = self->priv->button_box;
#line 317 "../lib/Widgets/Dialog.vala"
	gtk_box_set_homogeneous (_tmp36_, TRUE);
#line 318 "../lib/Widgets/Dialog.vala"
	_tmp37_ = self->priv->button_box;
#line 318 "../lib/Widgets/Dialog.vala"
	_tmp38_ = self->cancel_button;
#line 318 "../lib/Widgets/Dialog.vala"
	gtk_box_prepend (_tmp37_, (GtkWidget*) _tmp38_);
#line 320 "../lib/Widgets/Dialog.vala"
	_tmp39_ = self->priv->child_box;
#line 320 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
#line 322 "../lib/Widgets/Dialog.vala"
	_tmp40_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 322 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp40_);
#line 322 "../lib/Widgets/Dialog.vala"
	main_box = _tmp40_;
#line 323 "../lib/Widgets/Dialog.vala"
	_tmp41_ = main_box;
#line 323 "../lib/Widgets/Dialog.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp41_, TRUE);
#line 324 "../lib/Widgets/Dialog.vala"
	_tmp42_ = main_box;
#line 324 "../lib/Widgets/Dialog.vala"
	_tmp43_ = self->priv->info_box;
#line 324 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp42_, (GtkWidget*) _tmp43_);
#line 325 "../lib/Widgets/Dialog.vala"
	_tmp44_ = main_box;
#line 325 "../lib/Widgets/Dialog.vala"
	_tmp45_ = self->priv->child_box;
#line 325 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp44_, (GtkWidget*) _tmp45_);
#line 326 "../lib/Widgets/Dialog.vala"
	_tmp46_ = main_box;
#line 326 "../lib/Widgets/Dialog.vala"
	_tmp47_ = self->priv->button_box;
#line 326 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp46_, (GtkWidget*) _tmp47_);
#line 328 "../lib/Widgets/Dialog.vala"
	_tmp48_ = self->priv->dialog_handle;
#line 328 "../lib/Widgets/Dialog.vala"
	_tmp49_ = main_box;
#line 328 "../lib/Widgets/Dialog.vala"
	gtk_window_handle_set_child (_tmp48_, (GtkWidget*) _tmp49_);
#line 329 "../lib/Widgets/Dialog.vala"
	_tmp50_ = self->priv->dialog_bin;
#line 329 "../lib/Widgets/Dialog.vala"
	_tmp51_ = self->priv->dialog_handle;
#line 329 "../lib/Widgets/Dialog.vala"
	gtk_box_append (_tmp50_, (GtkWidget*) _tmp51_);
#line 332 "../lib/Widgets/Dialog.vala"
	_tmp52_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 332 "../lib/Widgets/Dialog.vala"
	click_gesture = _tmp52_;
#line 333 "../lib/Widgets/Dialog.vala"
	_tmp53_ = click_gesture;
#line 333 "../lib/Widgets/Dialog.vala"
	g_signal_connect_object ((GtkGesture*) _tmp53_, "end", (GCallback) __he_dialog___lambda129__gtk_gesture_end, self, 0);
#line 334 "../lib/Widgets/Dialog.vala"
	_tmp54_ = self->priv->dimming;
#line 334 "../lib/Widgets/Dialog.vala"
	_tmp55_ = click_gesture;
#line 334 "../lib/Widgets/Dialog.vala"
	_tmp56_ = _g_object_ref0 ((GtkEventController*) _tmp55_);
#line 334 "../lib/Widgets/Dialog.vala"
	gtk_widget_add_controller (_tmp54_, _tmp56_);
#line 274 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (click_gesture);
#line 274 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (main_box);
#line 274 "../lib/Widgets/Dialog.vala"
	return obj;
#line 1573 "Dialog.c"
}

static void
he_dialog_class_init (HeDialogClass * klass,
                      gpointer klass_data)
{
#line 23 "../lib/Widgets/Dialog.vala"
	he_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/Dialog.vala"
	g_type_class_adjust_private_offset (klass, &HeDialog_private_offset);
#line 23 "../lib/Widgets/Dialog.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) he_dialog_real_dispose;
#line 23 "../lib/Widgets/Dialog.vala"
	((GtkWidgetClass *) klass)->contains = (gboolean (*) (GtkWidget*, gdouble, gdouble)) he_dialog_real_contains;
#line 23 "../lib/Widgets/Dialog.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) he_dialog_real_measure;
#line 23 "../lib/Widgets/Dialog.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) he_dialog_real_size_allocate;
#line 23 "../lib/Widgets/Dialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_dialog_get_property;
#line 23 "../lib/Widgets/Dialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_dialog_set_property;
#line 23 "../lib/Widgets/Dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = he_dialog_constructor;
#line 23 "../lib/Widgets/Dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = he_dialog_finalize;
#line 23 "../lib/Widgets/Dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DIALOG_VISIBLE_PROPERTY, he_dialog_properties[HE_DIALOG_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1602 "Dialog.c"
	/**
	     * Sets the title of the dialog.
	     */
#line 23 "../lib/Widgets/Dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DIALOG_TITLE_PROPERTY, he_dialog_properties[HE_DIALOG_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1608 "Dialog.c"
	/**
	     * Sets the info text of the dialog.
	     */
#line 23 "../lib/Widgets/Dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DIALOG_INFO_PROPERTY, he_dialog_properties[HE_DIALOG_INFO_PROPERTY] = g_param_spec_string ("info", "info", "info", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1614 "Dialog.c"
	/**
	     * Sets the icon of the dialog.
	     */
#line 23 "../lib/Widgets/Dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DIALOG_ICON_PROPERTY, he_dialog_properties[HE_DIALOG_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1620 "Dialog.c"
	/**
	     * Sets the secondary button of the dialog.
	     */
#line 23 "../lib/Widgets/Dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DIALOG_SECONDARY_BUTTON_PROPERTY, he_dialog_properties[HE_DIALOG_SECONDARY_BUTTON_PROPERTY] = g_param_spec_object ("secondary-button", "secondary-button", "secondary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1626 "Dialog.c"
	/**
	     * Sets the primary button of the dialog.
	     */
#line 23 "../lib/Widgets/Dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DIALOG_PRIMARY_BUTTON_PROPERTY, he_dialog_properties[HE_DIALOG_PRIMARY_BUTTON_PROPERTY] = g_param_spec_object ("primary-button", "primary-button", "primary-button", HE_TYPE_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1632 "Dialog.c"
	/**
	     * The hidden signal fires when the dialog is hidden.
	     */
#line 23 "../lib/Widgets/Dialog.vala"
	he_dialog_signals[HE_DIALOG_HIDDEN_SIGNAL] = g_signal_new ("hidden", HE_TYPE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1638 "Dialog.c"
}

static void
he_dialog_instance_init (HeDialog * self,
                         gpointer klass)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkImage* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkWindowHandle* _tmp6_;
#line 23 "../lib/Widgets/Dialog.vala"
	self->priv = he_dialog_get_instance_private (self);
#line 35 "../lib/Widgets/Dialog.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 35 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 35 "../lib/Widgets/Dialog.vala"
	self->priv->title_label = _tmp0_;
#line 36 "../lib/Widgets/Dialog.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 36 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp1_);
#line 36 "../lib/Widgets/Dialog.vala"
	self->priv->info_label = _tmp1_;
#line 37 "../lib/Widgets/Dialog.vala"
	_tmp2_ = (GtkImage*) gtk_image_new ();
#line 37 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp2_);
#line 37 "../lib/Widgets/Dialog.vala"
	self->priv->image = _tmp2_;
#line 38 "../lib/Widgets/Dialog.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 24);
#line 38 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp3_);
#line 38 "../lib/Widgets/Dialog.vala"
	self->priv->info_box = _tmp3_;
#line 39 "../lib/Widgets/Dialog.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 39 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp4_);
#line 39 "../lib/Widgets/Dialog.vala"
	self->priv->child_box = _tmp4_;
#line 40 "../lib/Widgets/Dialog.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 40 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp5_);
#line 40 "../lib/Widgets/Dialog.vala"
	self->priv->button_box = _tmp5_;
#line 41 "../lib/Widgets/Dialog.vala"
	_tmp6_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 41 "../lib/Widgets/Dialog.vala"
	g_object_ref_sink (_tmp6_);
#line 41 "../lib/Widgets/Dialog.vala"
	self->priv->dialog_handle = _tmp6_;
#line 54 "../lib/Widgets/Dialog.vala"
	self->priv->_visible = FALSE;
#line 1698 "Dialog.c"
}

static void
he_dialog_finalize (GObject * obj)
{
	HeDialog * self;
#line 23 "../lib/Widgets/Dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DIALOG, HeDialog);
#line 33 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->dimming);
#line 34 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->dialog_bin);
#line 35 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->title_label);
#line 36 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->info_label);
#line 37 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->image);
#line 38 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->info_box);
#line 39 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->child_box);
#line 40 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->button_box);
#line 41 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->dialog_handle);
#line 42 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->_secondary_button);
#line 43 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->_primary_button);
#line 44 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 49 "../lib/Widgets/Dialog.vala"
	_g_object_unref0 (self->cancel_button);
#line 23 "../lib/Widgets/Dialog.vala"
	G_OBJECT_CLASS (he_dialog_parent_class)->finalize (obj);
#line 1735 "Dialog.c"
}

/**
 * A Dialog is a modal widget that asks the user for input or shows a message.
 */
static GType
he_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDialog), 0, (GInstanceInitFunc) he_dialog_instance_init, NULL };
	GType he_dialog_type_id;
	he_dialog_type_id = g_type_register_static (gtk_widget_get_type (), "HeDialog", &g_define_type_info, 0);
	HeDialog_private_offset = g_type_add_instance_private (he_dialog_type_id, sizeof (HeDialogPrivate));
	return he_dialog_type_id;
}

GType
he_dialog_get_type (void)
{
	static volatile gsize he_dialog_type_id__once = 0;
	if (g_once_init_enter (&he_dialog_type_id__once)) {
		GType he_dialog_type_id;
		he_dialog_type_id = he_dialog_get_type_once ();
		g_once_init_leave (&he_dialog_type_id__once, he_dialog_type_id);
	}
	return he_dialog_type_id__once;
}

static void
_vala_he_dialog_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DIALOG, HeDialog);
#line 23 "../lib/Widgets/Dialog.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_VISIBLE_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		g_value_set_boolean (value, he_dialog_get_visible (self));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_TITLE_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		g_value_set_string (value, he_dialog_get_title (self));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_INFO_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		g_value_set_string (value, he_dialog_get_info (self));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_ICON_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		g_value_set_string (value, he_dialog_get_icon (self));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_SECONDARY_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		g_value_set_object (value, he_dialog_get_secondary_button (self));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_PRIMARY_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		g_value_set_object (value, he_dialog_get_primary_button (self));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 1809 "Dialog.c"
		default:
#line 23 "../lib/Widgets/Dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 1815 "Dialog.c"
	}
}

static void
_vala_he_dialog_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DIALOG, HeDialog);
#line 23 "../lib/Widgets/Dialog.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_VISIBLE_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		he_dialog_set_visible (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_TITLE_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		he_dialog_set_title (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_INFO_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		he_dialog_set_info (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_ICON_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		he_dialog_set_icon (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_SECONDARY_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		he_dialog_set_secondary_button (self, g_value_get_object (value));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 23 "../lib/Widgets/Dialog.vala"
		case HE_DIALOG_PRIMARY_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/Dialog.vala"
		he_dialog_set_primary_button (self, g_value_get_object (value));
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 1865 "Dialog.c"
		default:
#line 23 "../lib/Widgets/Dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Dialog.vala"
		break;
#line 1871 "Dialog.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

