/* Slider.c generated by valac 0.56.18, the Vala compiler
 * generated from Slider.vala, do not modify */

/*
 * Copyright (c) 2024-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <cairo-gobject.h>

#define HE_SLIDER_WAVE_MARGIN 12
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_SLIDER_0_PROPERTY,
	HE_SLIDER_WAVE_AMPLITUDE_PROPERTY,
	HE_SLIDER_WAVE_WAVELENGTH_PROPERTY,
	HE_SLIDER_WAVE_THICKNESS_PROPERTY,
	HE_SLIDER_ANIMATE_PROPERTY,
	HE_SLIDER_VALUE_PROPERTY,
	HE_SLIDER_LEFT_ICON_PROPERTY,
	HE_SLIDER_RIGHT_ICON_PROPERTY,
	HE_SLIDER_STOP_INDICATOR_VISIBILITY_PROPERTY,
	HE_SLIDER_IS_WAVY_PROPERTY,
	HE_SLIDER_NUM_PROPERTIES
};
static GParamSpec* he_slider_properties[HE_SLIDER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _he_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_rgb_color_free (var), NULL)))
enum  {
	HE_SLIDER_VALUE_CHANGED_SIGNAL,
	HE_SLIDER_NUM_SIGNALS
};
static guint he_slider_signals[HE_SLIDER_NUM_SIGNALS] = {0};

struct _HeSliderPrivate {
	GtkBox* main_box;
	GtkBox* stop_indicator;
	GtkImage* left_icon_img;
	GtkImage* right_icon_img;
	GtkOverlay* slider_overlay;
	HeDesktop* desktop;
	gboolean is_dark;
	GdkRGBA accent_color;
	gint64 _last_frame_time;
	GtkDrawingArea* wavy_drawing_area;
	GtkGestureDrag* drag_gesture;
	gint _wave_amplitude;
	gint _wave_wavelength;
	gint _wave_thickness;
	gdouble _wave_phase;
	guint _animation_tick_id;
	gboolean _continuous_animation;
	gboolean _updating_from_scale;
	gboolean _animate;
	gdouble _min_value;
	gdouble _max_value;
	gdouble _value;
	gchar* _left_icon;
	gchar* _right_icon;
	gboolean _stop_indicator_visibility;
	gboolean _is_wavy;
};

static gint HeSlider_private_offset;
static gpointer he_slider_parent_class = NULL;
static GtkBuildableIface * he_slider_gtk_buildable_parent_iface = NULL;

static gboolean he_slider_on_animation_tick (HeSlider* self,
                                      GtkWidget* widget,
                                      GdkFrameClock* frame_clock);
static gboolean _he_slider_on_animation_tick_gtk_tick_callback (GtkWidget* widget,
                                                         GdkFrameClock* frame_clock,
                                                         gpointer self);
static void he_slider_update_stop_indicator_position (HeSlider* self);
static void he_slider_start_continuous_animation (HeSlider* self);
static void he_slider_stop_continuous_animation (HeSlider* self);
static HeApplication* he_slider_get_he_application (HeSlider* self);
static void he_slider_update_accent_color (HeSlider* self);
static void he_slider_on_drag_begin (HeSlider* self,
                              gdouble start_x,
                              gdouble start_y);
static void he_slider_update_value_from_position (HeSlider* self,
                                           gdouble x);
static void he_slider_on_drag_update (HeSlider* self,
                               gdouble offset_x,
                               gdouble offset_y);
static void he_slider_draw_rounded_rectangle (HeSlider* self,
                                       cairo_t* cr,
                                       gdouble x,
                                       gdouble y,
                                       gdouble width,
                                       gdouble height,
                                       gdouble radius);
static void he_slider_draw_wavy_slider (HeSlider* self,
                                 GtkDrawingArea* area,
                                 cairo_t* cr,
                                 gint width,
                                 gint height);
static GObject * he_slider_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void _he_slider_draw_wavy_slider_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                             cairo_t* cr,
                                                             gint width,
                                                             gint height,
                                                             gpointer self);
static void _he_slider_on_drag_begin_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                           gdouble start_x,
                                                           gdouble start_y,
                                                           gpointer self);
static void _he_slider_on_drag_update_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                             gdouble offset_x,
                                                             gdouble offset_y,
                                                             gpointer self);
static void _he_slider___lambda148_ (HeSlider* self);
static void __he_slider___lambda148__gtk_range_value_changed (GtkRange* _sender,
                                                       gpointer self);
static void _he_slider_update_accent_color_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _he_slider___lambda149_ (HeSlider* self);
static void _he_slider_update_accent_color_he_application_accent_color_changed (HeApplication* _sender,
                                                                         gpointer self);
static void __he_slider___lambda149__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
static void he_slider_finalize (GObject * obj);
static GType he_slider_get_type_once (void);
static void _vala_he_slider_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_slider_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_slider_get_instance_private (HeSlider* self)
{
	return G_STRUCT_MEMBER_P (self, HeSlider_private_offset);
}

gint
he_slider_get_wave_amplitude (HeSlider* self)
{
	gint result;
#line 61 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 61 "../lib/Widgets/Slider.vala"
	result = self->priv->_wave_amplitude;
#line 61 "../lib/Widgets/Slider.vala"
	return result;
#line 189 "Slider.c"
}

void
he_slider_set_wave_amplitude (HeSlider* self,
                              gint value)
{
	GtkDrawingArea* _tmp0_;
#line 62 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 63 "../lib/Widgets/Slider.vala"
	self->priv->_wave_amplitude = (gint) fmax ((gdouble) 1, (gdouble) value);
#line 64 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 64 "../lib/Widgets/Slider.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 62 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_WAVE_AMPLITUDE_PROPERTY]);
#line 207 "Slider.c"
}

gint
he_slider_get_wave_wavelength (HeSlider* self)
{
	gint result;
#line 73 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../lib/Widgets/Slider.vala"
	result = self->priv->_wave_wavelength;
#line 73 "../lib/Widgets/Slider.vala"
	return result;
#line 220 "Slider.c"
}

void
he_slider_set_wave_wavelength (HeSlider* self,
                               gint value)
{
	GtkDrawingArea* _tmp0_;
#line 74 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 75 "../lib/Widgets/Slider.vala"
	self->priv->_wave_wavelength = (gint) fmax ((gdouble) 10, (gdouble) value);
#line 76 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 76 "../lib/Widgets/Slider.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 74 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_WAVE_WAVELENGTH_PROPERTY]);
#line 238 "Slider.c"
}

gint
he_slider_get_wave_thickness (HeSlider* self)
{
	gint result;
#line 85 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 85 "../lib/Widgets/Slider.vala"
	result = self->priv->_wave_thickness;
#line 85 "../lib/Widgets/Slider.vala"
	return result;
#line 251 "Slider.c"
}

void
he_slider_set_wave_thickness (HeSlider* self,
                              gint value)
{
	GtkDrawingArea* _tmp0_;
#line 86 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 87 "../lib/Widgets/Slider.vala"
	self->priv->_wave_thickness = (gint) fmax ((gdouble) 1, (gdouble) value);
#line 88 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 88 "../lib/Widgets/Slider.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 86 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_WAVE_THICKNESS_PROPERTY]);
#line 269 "Slider.c"
}

gboolean
he_slider_get_animate (HeSlider* self)
{
	gboolean result;
#line 110 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 110 "../lib/Widgets/Slider.vala"
	result = self->priv->_animate;
#line 110 "../lib/Widgets/Slider.vala"
	return result;
#line 282 "Slider.c"
}

static gboolean
_he_slider_on_animation_tick_gtk_tick_callback (GtkWidget* widget,
                                                GdkFrameClock* frame_clock,
                                                gpointer self)
{
	gboolean result;
	result = he_slider_on_animation_tick ((HeSlider*) self, widget, frame_clock);
#line 115 "../lib/Widgets/Slider.vala"
	return result;
#line 294 "Slider.c"
}

void
he_slider_set_animate (HeSlider* self,
                       gboolean value)
{
#line 111 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 112 "../lib/Widgets/Slider.vala"
	self->priv->_animate = value;
#line 113 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 307 "Slider.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 114 "../lib/Widgets/Slider.vala"
		if (self->priv->_animate) {
#line 114 "../lib/Widgets/Slider.vala"
			_tmp1_ = self->priv->_continuous_animation;
#line 314 "Slider.c"
		} else {
#line 114 "../lib/Widgets/Slider.vala"
			_tmp1_ = FALSE;
#line 318 "Slider.c"
		}
#line 114 "../lib/Widgets/Slider.vala"
		if (_tmp1_) {
#line 114 "../lib/Widgets/Slider.vala"
			_tmp0_ = self->priv->_animation_tick_id == ((guint) 0);
#line 324 "Slider.c"
		} else {
#line 114 "../lib/Widgets/Slider.vala"
			_tmp0_ = FALSE;
#line 328 "Slider.c"
		}
#line 114 "../lib/Widgets/Slider.vala"
		if (_tmp0_) {
#line 332 "Slider.c"
			GtkDrawingArea* _tmp2_;
#line 115 "../lib/Widgets/Slider.vala"
			_tmp2_ = self->priv->wavy_drawing_area;
#line 115 "../lib/Widgets/Slider.vala"
			self->priv->_animation_tick_id = gtk_widget_add_tick_callback ((GtkWidget*) _tmp2_, _he_slider_on_animation_tick_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 338 "Slider.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 116 "../lib/Widgets/Slider.vala"
			if (!self->priv->_animate) {
#line 116 "../lib/Widgets/Slider.vala"
				_tmp3_ = self->priv->_animation_tick_id != ((guint) 0);
#line 345 "Slider.c"
			} else {
#line 116 "../lib/Widgets/Slider.vala"
				_tmp3_ = FALSE;
#line 349 "Slider.c"
			}
#line 116 "../lib/Widgets/Slider.vala"
			if (_tmp3_) {
#line 353 "Slider.c"
				GtkDrawingArea* _tmp4_;
#line 117 "../lib/Widgets/Slider.vala"
				_tmp4_ = self->priv->wavy_drawing_area;
#line 117 "../lib/Widgets/Slider.vala"
				gtk_widget_remove_tick_callback ((GtkWidget*) _tmp4_, self->priv->_animation_tick_id);
#line 118 "../lib/Widgets/Slider.vala"
				self->priv->_animation_tick_id = (guint) 0;
#line 361 "Slider.c"
			}
		}
	}
#line 111 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_ANIMATE_PROPERTY]);
#line 367 "Slider.c"
}

gdouble
he_slider_get_value (HeSlider* self)
{
	gdouble result;
#line 140 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 141 "../lib/Widgets/Slider.vala"
	result = self->priv->_value;
#line 141 "../lib/Widgets/Slider.vala"
	return result;
#line 380 "Slider.c"
}

void
he_slider_set_value (HeSlider* self,
                     gdouble value)
{
	GtkScale* _tmp1_;
#line 143 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 144 "../lib/Widgets/Slider.vala"
	self->priv->_value = fmax (self->priv->_min_value, fmin (self->priv->_max_value, value));
#line 145 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 394 "Slider.c"
		GtkDrawingArea* _tmp0_;
#line 146 "../lib/Widgets/Slider.vala"
		_tmp0_ = self->priv->wavy_drawing_area;
#line 146 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 147 "../lib/Widgets/Slider.vala"
		he_slider_update_stop_indicator_position (self);
#line 402 "Slider.c"
	}
#line 150 "../lib/Widgets/Slider.vala"
	self->priv->_updating_from_scale = TRUE;
#line 151 "../lib/Widgets/Slider.vala"
	_tmp1_ = self->scale;
#line 151 "../lib/Widgets/Slider.vala"
	gtk_range_set_value ((GtkRange*) _tmp1_, self->priv->_value);
#line 152 "../lib/Widgets/Slider.vala"
	self->priv->_updating_from_scale = FALSE;
#line 154 "../lib/Widgets/Slider.vala"
	g_signal_emit (self, he_slider_signals[HE_SLIDER_VALUE_CHANGED_SIGNAL], 0);
#line 143 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_VALUE_PROPERTY]);
#line 416 "Slider.c"
}

const gchar*
he_slider_get_left_icon (HeSlider* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 163 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->_left_icon;
#line 164 "../lib/Widgets/Slider.vala"
	result = _tmp0_;
#line 164 "../lib/Widgets/Slider.vala"
	return result;
#line 432 "Slider.c"
}

void
he_slider_set_left_icon (HeSlider* self,
                         const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 166 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 167 "../lib/Widgets/Slider.vala"
	_tmp0_ = g_strdup (value);
#line 167 "../lib/Widgets/Slider.vala"
	_g_free0 (self->priv->_left_icon);
#line 167 "../lib/Widgets/Slider.vala"
	self->priv->_left_icon = _tmp0_;
#line 168 "../lib/Widgets/Slider.vala"
	_tmp1_ = self->priv->_left_icon;
#line 168 "../lib/Widgets/Slider.vala"
	if (_tmp1_ != NULL) {
#line 453 "Slider.c"
		GtkImage* _tmp2_;
		GtkImage* _tmp3_;
		const gchar* _tmp4_;
#line 169 "../lib/Widgets/Slider.vala"
		_tmp2_ = self->priv->left_icon_img;
#line 169 "../lib/Widgets/Slider.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 170 "../lib/Widgets/Slider.vala"
		_tmp3_ = self->priv->left_icon_img;
#line 170 "../lib/Widgets/Slider.vala"
		_tmp4_ = self->priv->_left_icon;
#line 170 "../lib/Widgets/Slider.vala"
		gtk_image_set_from_icon_name (_tmp3_, _tmp4_);
#line 467 "Slider.c"
	} else {
		GtkImage* _tmp5_;
#line 172 "../lib/Widgets/Slider.vala"
		_tmp5_ = self->priv->left_icon_img;
#line 172 "../lib/Widgets/Slider.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 474 "Slider.c"
	}
#line 166 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_LEFT_ICON_PROPERTY]);
#line 478 "Slider.c"
}

const gchar*
he_slider_get_right_icon (HeSlider* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 182 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 183 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->_right_icon;
#line 183 "../lib/Widgets/Slider.vala"
	result = _tmp0_;
#line 183 "../lib/Widgets/Slider.vala"
	return result;
#line 494 "Slider.c"
}

void
he_slider_set_right_icon (HeSlider* self,
                          const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 185 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/Widgets/Slider.vala"
	_tmp0_ = g_strdup (value);
#line 186 "../lib/Widgets/Slider.vala"
	_g_free0 (self->priv->_right_icon);
#line 186 "../lib/Widgets/Slider.vala"
	self->priv->_right_icon = _tmp0_;
#line 187 "../lib/Widgets/Slider.vala"
	_tmp1_ = self->priv->_right_icon;
#line 187 "../lib/Widgets/Slider.vala"
	if (_tmp1_ != NULL) {
#line 515 "Slider.c"
		GtkImage* _tmp2_;
		GtkImage* _tmp3_;
		const gchar* _tmp4_;
#line 188 "../lib/Widgets/Slider.vala"
		_tmp2_ = self->priv->right_icon_img;
#line 188 "../lib/Widgets/Slider.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 189 "../lib/Widgets/Slider.vala"
		_tmp3_ = self->priv->right_icon_img;
#line 189 "../lib/Widgets/Slider.vala"
		_tmp4_ = self->priv->_right_icon;
#line 189 "../lib/Widgets/Slider.vala"
		gtk_image_set_from_icon_name (_tmp3_, _tmp4_);
#line 529 "Slider.c"
	} else {
		GtkImage* _tmp5_;
#line 191 "../lib/Widgets/Slider.vala"
		_tmp5_ = self->priv->right_icon_img;
#line 191 "../lib/Widgets/Slider.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 536 "Slider.c"
	}
#line 185 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_RIGHT_ICON_PROPERTY]);
#line 540 "Slider.c"
}

gboolean
he_slider_get_stop_indicator_visibility (HeSlider* self)
{
	gboolean result;
#line 201 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../lib/Widgets/Slider.vala"
	result = self->priv->_stop_indicator_visibility;
#line 202 "../lib/Widgets/Slider.vala"
	return result;
#line 553 "Slider.c"
}

void
he_slider_set_stop_indicator_visibility (HeSlider* self,
                                         gboolean value)
{
#line 204 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 205 "../lib/Widgets/Slider.vala"
	self->priv->_stop_indicator_visibility = value;
#line 206 "../lib/Widgets/Slider.vala"
	if (self->priv->_stop_indicator_visibility) {
#line 566 "Slider.c"
		GtkBox* _tmp0_;
#line 207 "../lib/Widgets/Slider.vala"
		_tmp0_ = self->priv->stop_indicator;
#line 207 "../lib/Widgets/Slider.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 572 "Slider.c"
	} else {
		GtkBox* _tmp1_;
#line 209 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->stop_indicator;
#line 209 "../lib/Widgets/Slider.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 579 "Slider.c"
	}
#line 204 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_STOP_INDICATOR_VISIBILITY_PROPERTY]);
#line 583 "Slider.c"
}

gboolean
he_slider_get_is_wavy (HeSlider* self)
{
	gboolean result;
#line 219 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../lib/Widgets/Slider.vala"
	result = self->priv->_is_wavy;
#line 220 "../lib/Widgets/Slider.vala"
	return result;
#line 596 "Slider.c"
}

void
he_slider_set_is_wavy (HeSlider* self,
                       gboolean value)
{
#line 222 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 223 "../lib/Widgets/Slider.vala"
	self->priv->_is_wavy = value;
#line 224 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 609 "Slider.c"
		GtkOverlay* _tmp0_;
		GtkDrawingArea* _tmp1_;
		GtkScale* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkDrawingArea* _tmp9_;
#line 225 "../lib/Widgets/Slider.vala"
		_tmp0_ = self->priv->slider_overlay;
#line 225 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 225 "../lib/Widgets/Slider.vala"
		gtk_overlay_set_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 227 "../lib/Widgets/Slider.vala"
		_tmp2_ = self->scale;
#line 227 "../lib/Widgets/Slider.vala"
		_tmp3_ = gtk_range_get_adjustment ((GtkRange*) _tmp2_);
#line 227 "../lib/Widgets/Slider.vala"
		if (_tmp3_ != NULL) {
#line 627 "Slider.c"
			GtkScale* _tmp4_;
			GtkScale* _tmp5_;
			GtkAdjustment* _tmp6_;
			GtkScale* _tmp7_;
			GtkAdjustment* _tmp8_;
#line 228 "../lib/Widgets/Slider.vala"
			_tmp4_ = self->scale;
#line 228 "../lib/Widgets/Slider.vala"
			self->priv->_value = gtk_range_get_value ((GtkRange*) _tmp4_);
#line 229 "../lib/Widgets/Slider.vala"
			_tmp5_ = self->scale;
#line 229 "../lib/Widgets/Slider.vala"
			_tmp6_ = gtk_range_get_adjustment ((GtkRange*) _tmp5_);
#line 229 "../lib/Widgets/Slider.vala"
			self->priv->_min_value = gtk_adjustment_get_lower (_tmp6_);
#line 230 "../lib/Widgets/Slider.vala"
			_tmp7_ = self->scale;
#line 230 "../lib/Widgets/Slider.vala"
			_tmp8_ = gtk_range_get_adjustment ((GtkRange*) _tmp7_);
#line 230 "../lib/Widgets/Slider.vala"
			self->priv->_max_value = gtk_adjustment_get_upper (_tmp8_);
#line 649 "Slider.c"
		}
#line 232 "../lib/Widgets/Slider.vala"
		_tmp9_ = self->priv->wavy_drawing_area;
#line 232 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp9_);
#line 233 "../lib/Widgets/Slider.vala"
		he_slider_update_stop_indicator_position (self);
#line 235 "../lib/Widgets/Slider.vala"
		he_slider_start_continuous_animation (self);
#line 659 "Slider.c"
	} else {
		GtkOverlay* _tmp10_;
		GtkScale* _tmp11_;
		GtkScale* _tmp12_;
		GtkBox* _tmp13_;
#line 237 "../lib/Widgets/Slider.vala"
		_tmp10_ = self->priv->slider_overlay;
#line 237 "../lib/Widgets/Slider.vala"
		_tmp11_ = self->scale;
#line 237 "../lib/Widgets/Slider.vala"
		gtk_overlay_set_child (_tmp10_, (GtkWidget*) _tmp11_);
#line 239 "../lib/Widgets/Slider.vala"
		_tmp12_ = self->scale;
#line 239 "../lib/Widgets/Slider.vala"
		gtk_range_set_value ((GtkRange*) _tmp12_, self->priv->_value);
#line 241 "../lib/Widgets/Slider.vala"
		_tmp13_ = self->priv->stop_indicator;
#line 241 "../lib/Widgets/Slider.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp13_, 16);
#line 243 "../lib/Widgets/Slider.vala"
		he_slider_stop_continuous_animation (self);
#line 681 "Slider.c"
	}
#line 222 "../lib/Widgets/Slider.vala"
	g_object_notify_by_pspec ((GObject *) self, he_slider_properties[HE_SLIDER_IS_WAVY_PROPERTY]);
#line 685 "Slider.c"
}

/**
     * Constructs a new Slider.
     *
     * @since 1.0
     */
HeSlider*
he_slider_construct (GType object_type)
{
	HeSlider * self = NULL;
#line 258 "../lib/Widgets/Slider.vala"
	self = (HeSlider*) he_bin_construct (object_type);
#line 258 "../lib/Widgets/Slider.vala"
	return self;
#line 701 "Slider.c"
}

HeSlider*
he_slider_new (void)
{
#line 258 "../lib/Widgets/Slider.vala"
	return he_slider_construct (HE_TYPE_SLIDER);
#line 709 "Slider.c"
}

/**
     * Gets the He.Application instance from the widget hierarchy.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 355 "../lib/Widgets/Slider.vala"
	return self ? g_object_ref (self) : NULL;
#line 720 "Slider.c"
}

static HeApplication*
he_slider_get_he_application (HeSlider* self)
{
	GtkRoot* root = NULL;
	GtkRoot* _tmp0_;
	GtkRoot* _tmp1_;
	GtkRoot* _tmp2_;
	HeApplication* result;
#line 354 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 355 "../lib/Widgets/Slider.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 355 "../lib/Widgets/Slider.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 355 "../lib/Widgets/Slider.vala"
	root = _tmp1_;
#line 356 "../lib/Widgets/Slider.vala"
	_tmp2_ = root;
#line 356 "../lib/Widgets/Slider.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ())) {
#line 743 "Slider.c"
		GtkApplication* app = NULL;
		GtkRoot* _tmp3_;
		GtkApplication* _tmp4_;
		GtkApplication* _tmp5_;
		GtkApplication* _tmp6_;
#line 357 "../lib/Widgets/Slider.vala"
		_tmp3_ = root;
#line 357 "../lib/Widgets/Slider.vala"
		_tmp4_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
#line 357 "../lib/Widgets/Slider.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 357 "../lib/Widgets/Slider.vala"
		app = _tmp5_;
#line 358 "../lib/Widgets/Slider.vala"
		_tmp6_ = app;
#line 358 "../lib/Widgets/Slider.vala"
		if (HE_IS_APPLICATION (_tmp6_)) {
#line 761 "Slider.c"
			GtkApplication* _tmp7_;
			HeApplication* _tmp8_;
#line 359 "../lib/Widgets/Slider.vala"
			_tmp7_ = app;
#line 359 "../lib/Widgets/Slider.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, HE_TYPE_APPLICATION, HeApplication));
#line 359 "../lib/Widgets/Slider.vala"
			result = _tmp8_;
#line 359 "../lib/Widgets/Slider.vala"
			_g_object_unref0 (app);
#line 359 "../lib/Widgets/Slider.vala"
			_g_object_unref0 (root);
#line 359 "../lib/Widgets/Slider.vala"
			return result;
#line 776 "Slider.c"
		}
#line 356 "../lib/Widgets/Slider.vala"
		_g_object_unref0 (app);
#line 780 "Slider.c"
	}
#line 362 "../lib/Widgets/Slider.vala"
	result = NULL;
#line 362 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (root);
#line 362 "../lib/Widgets/Slider.vala"
	return result;
#line 788 "Slider.c"
}

/**
     * Updates the stop indicator position to align with the wavy slider end.
     */
static void
he_slider_update_stop_indicator_position (HeSlider* self)
{
	gboolean _tmp0_ = FALSE;
#line 368 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 369 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 369 "../lib/Widgets/Slider.vala"
		_tmp0_ = self->priv->_stop_indicator_visibility;
#line 804 "Slider.c"
	} else {
#line 369 "../lib/Widgets/Slider.vala"
		_tmp0_ = FALSE;
#line 808 "Slider.c"
	}
#line 369 "../lib/Widgets/Slider.vala"
	if (_tmp0_) {
#line 812 "Slider.c"
		GtkBox* _tmp1_;
#line 371 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->stop_indicator;
#line 371 "../lib/Widgets/Slider.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, 10);
#line 818 "Slider.c"
	}
}

static gpointer
_he_rgb_color_dup0 (gpointer self)
{
#line 388 "../lib/Widgets/Slider.vala"
	return self ? he_rgb_color_dup (self) : NULL;
#line 827 "Slider.c"
}

static void
he_slider_update_accent_color (HeSlider* self)
{
	HeRGBColor* effective_color = NULL;
	gboolean is_from_application = FALSE;
	HeApplication* app = NULL;
	HeApplication* _tmp0_;
	HeApplication* _tmp1_;
	HeRGBColor* _tmp11_;
	HeRGBColor* _tmp16_;
#line 375 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 376 "../lib/Widgets/Slider.vala"
	effective_color = NULL;
#line 377 "../lib/Widgets/Slider.vala"
	is_from_application = FALSE;
#line 380 "../lib/Widgets/Slider.vala"
	_tmp0_ = he_slider_get_he_application (self);
#line 380 "../lib/Widgets/Slider.vala"
	app = _tmp0_;
#line 381 "../lib/Widgets/Slider.vala"
	_tmp1_ = app;
#line 381 "../lib/Widgets/Slider.vala"
	if (_tmp1_ != NULL) {
#line 854 "Slider.c"
		HeApplication* _tmp2_;
		HeRGBColor* _tmp3_;
		gboolean _tmp4_ = FALSE;
		HeApplication* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 382 "../lib/Widgets/Slider.vala"
		_tmp2_ = app;
#line 382 "../lib/Widgets/Slider.vala"
		_tmp3_ = he_application_get_effective_accent_color (_tmp2_);
#line 382 "../lib/Widgets/Slider.vala"
		_he_rgb_color_free0 (effective_color);
#line 382 "../lib/Widgets/Slider.vala"
		effective_color = _tmp3_;
#line 383 "../lib/Widgets/Slider.vala"
		_tmp5_ = app;
#line 383 "../lib/Widgets/Slider.vala"
		_tmp6_ = he_application_get_is_content (_tmp5_);
#line 383 "../lib/Widgets/Slider.vala"
		_tmp7_ = _tmp6_;
#line 383 "../lib/Widgets/Slider.vala"
		if (_tmp7_) {
#line 877 "Slider.c"
			HeApplication* _tmp8_;
			HeRGBColor* _tmp9_;
			HeRGBColor* _tmp10_;
#line 383 "../lib/Widgets/Slider.vala"
			_tmp8_ = app;
#line 383 "../lib/Widgets/Slider.vala"
			_tmp9_ = he_application_get_default_accent_color (_tmp8_);
#line 383 "../lib/Widgets/Slider.vala"
			_tmp10_ = _tmp9_;
#line 383 "../lib/Widgets/Slider.vala"
			_tmp4_ = _tmp10_ != NULL;
#line 889 "Slider.c"
		} else {
#line 383 "../lib/Widgets/Slider.vala"
			_tmp4_ = FALSE;
#line 893 "Slider.c"
		}
#line 383 "../lib/Widgets/Slider.vala"
		is_from_application = _tmp4_;
#line 897 "Slider.c"
	}
#line 387 "../lib/Widgets/Slider.vala"
	_tmp11_ = effective_color;
#line 387 "../lib/Widgets/Slider.vala"
	if (_tmp11_ == NULL) {
#line 903 "Slider.c"
		HeDesktop* _tmp12_;
		HeRGBColor* _tmp13_;
		HeRGBColor* _tmp14_;
		HeRGBColor* _tmp15_;
#line 388 "../lib/Widgets/Slider.vala"
		_tmp12_ = self->priv->desktop;
#line 388 "../lib/Widgets/Slider.vala"
		_tmp13_ = he_desktop_get_accent_color (_tmp12_);
#line 388 "../lib/Widgets/Slider.vala"
		_tmp14_ = _tmp13_;
#line 388 "../lib/Widgets/Slider.vala"
		_tmp15_ = _he_rgb_color_dup0 (_tmp14_);
#line 388 "../lib/Widgets/Slider.vala"
		_he_rgb_color_free0 (effective_color);
#line 388 "../lib/Widgets/Slider.vala"
		effective_color = _tmp15_;
#line 920 "Slider.c"
	}
#line 391 "../lib/Widgets/Slider.vala"
	_tmp16_ = effective_color;
#line 391 "../lib/Widgets/Slider.vala"
	if (_tmp16_ != NULL) {
#line 926 "Slider.c"
		gfloat r = 0.0F;
		gfloat g = 0.0F;
		gfloat b = 0.0F;
		GdkRGBA _tmp23_ = {0};
		const gchar* _tmp24_ = NULL;
		HeRGBColor* _tmp25_;
		HeRGBColor* _tmp26_;
		HeRGBColor* _tmp27_;
#line 394 "../lib/Widgets/Slider.vala"
		if (is_from_application) {
#line 937 "Slider.c"
			HeRGBColor* _tmp17_;
			HeRGBColor* _tmp18_;
			HeRGBColor* _tmp19_;
#line 396 "../lib/Widgets/Slider.vala"
			_tmp17_ = effective_color;
#line 396 "../lib/Widgets/Slider.vala"
			r = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp17_).r))) / 255.0f;
#line 397 "../lib/Widgets/Slider.vala"
			_tmp18_ = effective_color;
#line 397 "../lib/Widgets/Slider.vala"
			g = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp18_).g))) / 255.0f;
#line 398 "../lib/Widgets/Slider.vala"
			_tmp19_ = effective_color;
#line 398 "../lib/Widgets/Slider.vala"
			b = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp19_).b))) / 255.0f;
#line 953 "Slider.c"
		} else {
			HeRGBColor* _tmp20_;
			HeRGBColor* _tmp21_;
			HeRGBColor* _tmp22_;
#line 401 "../lib/Widgets/Slider.vala"
			_tmp20_ = effective_color;
#line 401 "../lib/Widgets/Slider.vala"
			r = (gfloat) fmax (0.0, fmin (1.0, (*_tmp20_).r));
#line 402 "../lib/Widgets/Slider.vala"
			_tmp21_ = effective_color;
#line 402 "../lib/Widgets/Slider.vala"
			g = (gfloat) fmax (0.0, fmin (1.0, (*_tmp21_).g));
#line 403 "../lib/Widgets/Slider.vala"
			_tmp22_ = effective_color;
#line 403 "../lib/Widgets/Slider.vala"
			b = (gfloat) fmax (0.0, fmin (1.0, (*_tmp22_).b));
#line 970 "Slider.c"
		}
#line 406 "../lib/Widgets/Slider.vala"
		_tmp23_.red = r;
#line 406 "../lib/Widgets/Slider.vala"
		_tmp23_.green = g;
#line 406 "../lib/Widgets/Slider.vala"
		_tmp23_.blue = b;
#line 406 "../lib/Widgets/Slider.vala"
		_tmp23_.alpha = 1.0f;
#line 406 "../lib/Widgets/Slider.vala"
		self->priv->accent_color = _tmp23_;
#line 410 "../lib/Widgets/Slider.vala"
		if (is_from_application) {
#line 410 "../lib/Widgets/Slider.vala"
			_tmp24_ = "application";
#line 986 "Slider.c"
		} else {
#line 410 "../lib/Widgets/Slider.vala"
			_tmp24_ = "desktop";
#line 990 "Slider.c"
		}
#line 409 "../lib/Widgets/Slider.vala"
		_tmp25_ = effective_color;
#line 409 "../lib/Widgets/Slider.vala"
		_tmp26_ = effective_color;
#line 409 "../lib/Widgets/Slider.vala"
		_tmp27_ = effective_color;
#line 409 "../lib/Widgets/Slider.vala"
		g_print ("Slider accent color updated: r=%f, g=%f, b=%f (from %s, original: %f,%" \
"f,%f)\n", (gdouble) r, (gdouble) g, (gdouble) b, _tmp24_, (*_tmp25_).r, (*_tmp26_).g, (*_tmp27_).b);
#line 1000 "Slider.c"
	} else {
		GdkRGBA _tmp28_ = {0};
#line 414 "../lib/Widgets/Slider.vala"
		_tmp28_.red = 0.2f;
#line 414 "../lib/Widgets/Slider.vala"
		_tmp28_.green = 0.6f;
#line 414 "../lib/Widgets/Slider.vala"
		_tmp28_.blue = 1.0f;
#line 414 "../lib/Widgets/Slider.vala"
		_tmp28_.alpha = 1.0f;
#line 414 "../lib/Widgets/Slider.vala"
		self->priv->accent_color = _tmp28_;
#line 415 "../lib/Widgets/Slider.vala"
		g_print ("Slider using fallback accent color\n");
#line 1015 "Slider.c"
	}
#line 375 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (app);
#line 375 "../lib/Widgets/Slider.vala"
	_he_rgb_color_free0 (effective_color);
#line 1021 "Slider.c"
}

/**
     * Adds a mark with some information along the trough of the Slider.
     */
void
he_slider_add_mark (HeSlider* self,
                    gdouble value,
                    const gchar* text)
{
	GtkScale* _tmp0_;
#line 422 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 423 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->scale;
#line 423 "../lib/Widgets/Slider.vala"
	gtk_scale_add_mark (_tmp0_, value, GTK_POS_BOTTOM, text);
#line 1039 "Slider.c"
}

/**
     * Sets the range of the slider.
     */
void
he_slider_set_range (HeSlider* self,
                     gdouble min,
                     gdouble max)
{
	GtkScale* _tmp0_;
#line 429 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 430 "../lib/Widgets/Slider.vala"
	self->priv->_min_value = min;
#line 431 "../lib/Widgets/Slider.vala"
	self->priv->_max_value = max;
#line 432 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->scale;
#line 432 "../lib/Widgets/Slider.vala"
	gtk_range_set_range ((GtkRange*) _tmp0_, min, max);
#line 433 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 1063 "Slider.c"
		GtkDrawingArea* _tmp1_;
#line 434 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 434 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 1069 "Slider.c"
	}
}

/**
     * Sets the adjustment for the slider.
     */
void
he_slider_set_adjustment (HeSlider* self,
                          GtkAdjustment* adjustment)
{
	GtkScale* _tmp0_;
#line 441 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 441 "../lib/Widgets/Slider.vala"
	g_return_if_fail (adjustment != NULL);
#line 442 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->scale;
#line 442 "../lib/Widgets/Slider.vala"
	gtk_range_set_adjustment ((GtkRange*) _tmp0_, adjustment);
#line 443 "../lib/Widgets/Slider.vala"
	self->priv->_min_value = gtk_adjustment_get_lower (adjustment);
#line 444 "../lib/Widgets/Slider.vala"
	self->priv->_max_value = gtk_adjustment_get_upper (adjustment);
#line 445 "../lib/Widgets/Slider.vala"
	self->priv->_value = gtk_adjustment_get_value (adjustment);
#line 446 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 1097 "Slider.c"
		GtkDrawingArea* _tmp1_;
#line 447 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 447 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 1103 "Slider.c"
	}
}

/**
     * Handles the start of a drag operation on the wavy slider.
     */
static void
he_slider_on_drag_begin (HeSlider* self,
                         gdouble start_x,
                         gdouble start_y)
{
#line 454 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 455 "../lib/Widgets/Slider.vala"
	he_slider_update_value_from_position (self, start_x);
#line 1119 "Slider.c"
}

/**
     * Handles drag updates on the wavy slider.
     */
static void
he_slider_on_drag_update (HeSlider* self,
                          gdouble offset_x,
                          gdouble offset_y)
{
	gdouble start_x = 0.0;
	gdouble start_y = 0.0;
	GtkGestureDrag* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 461 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 463 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->drag_gesture;
#line 463 "../lib/Widgets/Slider.vala"
	gtk_gesture_drag_get_start_point (_tmp0_, &_tmp1_, &_tmp2_);
#line 463 "../lib/Widgets/Slider.vala"
	start_x = _tmp1_;
#line 463 "../lib/Widgets/Slider.vala"
	start_y = _tmp2_;
#line 464 "../lib/Widgets/Slider.vala"
	he_slider_update_value_from_position (self, start_x + offset_x);
#line 1147 "Slider.c"
}

/**
     * Updates the slider value based on mouse position.
     */
static void
he_slider_update_value_from_position (HeSlider* self,
                                      gdouble x)
{
	gint width = 0;
	GtkDrawingArea* _tmp0_;
	gdouble effective_width = 0.0;
	gdouble adjusted_x = 0.0;
	gdouble position = 0.0;
	gdouble new_value = 0.0;
#line 470 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 471 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 471 "../lib/Widgets/Slider.vala"
	width = gtk_widget_get_width ((GtkWidget*) _tmp0_);
#line 472 "../lib/Widgets/Slider.vala"
	if (width <= 0) {
#line 473 "../lib/Widgets/Slider.vala"
		return;
#line 1173 "Slider.c"
	}
#line 477 "../lib/Widgets/Slider.vala"
	effective_width = (gdouble) (width - (2 * HE_SLIDER_WAVE_MARGIN));
#line 478 "../lib/Widgets/Slider.vala"
	adjusted_x = x - HE_SLIDER_WAVE_MARGIN;
#line 480 "../lib/Widgets/Slider.vala"
	position = fmax (0.0, fmin (1.0, adjusted_x / effective_width));
#line 481 "../lib/Widgets/Slider.vala"
	new_value = self->priv->_min_value + (position * (self->priv->_max_value - self->priv->_min_value));
#line 483 "../lib/Widgets/Slider.vala"
	if (new_value != self->priv->_value) {
#line 1185 "Slider.c"
		GtkDrawingArea* _tmp1_;
#line 484 "../lib/Widgets/Slider.vala"
		self->priv->_value = new_value;
#line 485 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 485 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 486 "../lib/Widgets/Slider.vala"
		g_signal_emit (self, he_slider_signals[HE_SLIDER_VALUE_CHANGED_SIGNAL], 0);
#line 1195 "Slider.c"
	}
}

/**
     * Animation tick callback.
     */
static gboolean
he_slider_on_animation_tick (HeSlider* self,
                             GtkWidget* widget,
                             GdkFrameClock* frame_clock)
{
	gboolean _tmp0_ = FALSE;
	gint64 current_time = 0LL;
	gdouble delta_time = 0.0;
	gdouble wave_speed = 0.0;
	GtkDrawingArea* _tmp1_;
	gboolean result;
#line 493 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 493 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 493 "../lib/Widgets/Slider.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 495 "../lib/Widgets/Slider.vala"
	if (!self->priv->_continuous_animation) {
#line 495 "../lib/Widgets/Slider.vala"
		_tmp0_ = TRUE;
#line 1223 "Slider.c"
	} else {
#line 495 "../lib/Widgets/Slider.vala"
		_tmp0_ = !self->priv->_animate;
#line 1227 "Slider.c"
	}
#line 495 "../lib/Widgets/Slider.vala"
	if (_tmp0_) {
#line 496 "../lib/Widgets/Slider.vala"
		self->priv->_animation_tick_id = (guint) 0;
#line 497 "../lib/Widgets/Slider.vala"
		result = FALSE;
#line 497 "../lib/Widgets/Slider.vala"
		return result;
#line 1237 "Slider.c"
	}
#line 501 "../lib/Widgets/Slider.vala"
	current_time = gdk_frame_clock_get_frame_time (frame_clock);
#line 504 "../lib/Widgets/Slider.vala"
	if (self->priv->_last_frame_time == ((gint64) 0)) {
#line 505 "../lib/Widgets/Slider.vala"
		self->priv->_last_frame_time = current_time;
#line 506 "../lib/Widgets/Slider.vala"
		result = TRUE;
#line 506 "../lib/Widgets/Slider.vala"
		return result;
#line 1249 "Slider.c"
	}
#line 510 "../lib/Widgets/Slider.vala"
	delta_time = ((gdouble) (current_time - self->priv->_last_frame_time)) / 1000000.0;
#line 511 "../lib/Widgets/Slider.vala"
	self->priv->_last_frame_time = current_time;
#line 515 "../lib/Widgets/Slider.vala"
	wave_speed = 1.0;
#line 516 "../lib/Widgets/Slider.vala"
	self->priv->_wave_phase = self->priv->_wave_phase + (((2.0 * G_PI) * wave_speed) * delta_time);
#line 518 "../lib/Widgets/Slider.vala"
	if (self->priv->_wave_phase > (2.0 * G_PI)) {
#line 519 "../lib/Widgets/Slider.vala"
		self->priv->_wave_phase = self->priv->_wave_phase - (2.0 * G_PI);
#line 1263 "Slider.c"
	}
#line 522 "../lib/Widgets/Slider.vala"
	_tmp1_ = self->priv->wavy_drawing_area;
#line 522 "../lib/Widgets/Slider.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 523 "../lib/Widgets/Slider.vala"
	result = TRUE;
#line 523 "../lib/Widgets/Slider.vala"
	return result;
#line 1273 "Slider.c"
}

/**
     * Starts continuous wave animation (internal).
     */
static void
he_slider_start_continuous_animation (HeSlider* self)
{
	gboolean _tmp0_ = FALSE;
#line 529 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 530 "../lib/Widgets/Slider.vala"
	self->priv->_continuous_animation = TRUE;
#line 531 "../lib/Widgets/Slider.vala"
	self->priv->_last_frame_time = (gint64) 0;
#line 532 "../lib/Widgets/Slider.vala"
	if (self->priv->_animate) {
#line 532 "../lib/Widgets/Slider.vala"
		_tmp0_ = self->priv->_animation_tick_id == ((guint) 0);
#line 1293 "Slider.c"
	} else {
#line 532 "../lib/Widgets/Slider.vala"
		_tmp0_ = FALSE;
#line 1297 "Slider.c"
	}
#line 532 "../lib/Widgets/Slider.vala"
	if (_tmp0_) {
#line 1301 "Slider.c"
		GtkDrawingArea* _tmp1_;
#line 533 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 533 "../lib/Widgets/Slider.vala"
		self->priv->_animation_tick_id = gtk_widget_add_tick_callback ((GtkWidget*) _tmp1_, _he_slider_on_animation_tick_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 1307 "Slider.c"
	}
}

/**
     * Stops continuous wave animation (internal).
     */
static void
he_slider_stop_continuous_animation (HeSlider* self)
{
#line 540 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 541 "../lib/Widgets/Slider.vala"
	self->priv->_continuous_animation = FALSE;
#line 542 "../lib/Widgets/Slider.vala"
	if (self->priv->_animation_tick_id != ((guint) 0)) {
#line 1323 "Slider.c"
		GtkDrawingArea* _tmp0_;
#line 543 "../lib/Widgets/Slider.vala"
		_tmp0_ = self->priv->wavy_drawing_area;
#line 543 "../lib/Widgets/Slider.vala"
		gtk_widget_remove_tick_callback ((GtkWidget*) _tmp0_, self->priv->_animation_tick_id);
#line 544 "../lib/Widgets/Slider.vala"
		self->priv->_animation_tick_id = (guint) 0;
#line 1331 "Slider.c"
	}
}

/**
     * Helper function to draw a rounded rectangle.
     */
static void
he_slider_draw_rounded_rectangle (HeSlider* self,
                                  cairo_t* cr,
                                  gdouble x,
                                  gdouble y,
                                  gdouble width,
                                  gdouble height,
                                  gdouble radius)
{
#line 551 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 551 "../lib/Widgets/Slider.vala"
	g_return_if_fail (cr != NULL);
#line 552 "../lib/Widgets/Slider.vala"
	cairo_move_to (cr, x + radius, y);
#line 553 "../lib/Widgets/Slider.vala"
	cairo_arc (cr, (x + width) - radius, y + radius, radius, (-G_PI) * 0.5, (gdouble) 0);
#line 554 "../lib/Widgets/Slider.vala"
	cairo_arc (cr, (x + width) - radius, (y + height) - radius, radius, (gdouble) 0, G_PI * 0.5);
#line 555 "../lib/Widgets/Slider.vala"
	cairo_arc (cr, x + radius, (y + height) - radius, radius, G_PI * 0.5, G_PI);
#line 556 "../lib/Widgets/Slider.vala"
	cairo_arc (cr, x + radius, y + radius, radius, G_PI, G_PI * 1.5);
#line 557 "../lib/Widgets/Slider.vala"
	cairo_close_path (cr);
#line 1363 "Slider.c"
}

/**
     * Draws the wavy slider using Cairo.
     */
static void
he_slider_draw_wavy_slider (HeSlider* self,
                            GtkDrawingArea* area,
                            cairo_t* cr,
                            gint width,
                            gint height)
{
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	GdkRGBA bg_color = {0};
	GdkRGBA _tmp3_ = {0};
	gdouble range = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble position = 0.0;
	gdouble effective_width = 0.0;
	gdouble slider_x = 0.0;
	gdouble track_y = 0.0;
	gdouble wave_amplitude = 0.0;
	gdouble wave_frequency = 0.0;
	gdouble handle_center_y = 0.0;
	gdouble handle_width = 0.0;
	gdouble handle_height = 0.0;
	gdouble border_margin = 0.0;
	gdouble border_x = 0.0;
	gdouble border_y = 0.0;
	gdouble border_width = 0.0;
	gdouble border_height = 0.0;
	gdouble inactive_start = 0.0;
	gdouble filled_end = 0.0;
	gdouble handle_x = 0.0;
	gdouble handle_y = 0.0;
	gdouble corner_radius = 0.0;
	gfloat _tmp19_ = 0.0F;
	gfloat _tmp20_ = 0.0F;
	gfloat _tmp21_ = 0.0F;
	GdkRGBA _tmp22_;
	GdkRGBA _tmp23_;
	GdkRGBA _tmp24_;
#line 563 "../lib/Widgets/Slider.vala"
	g_return_if_fail (self != NULL);
#line 563 "../lib/Widgets/Slider.vala"
	g_return_if_fail (area != NULL);
#line 563 "../lib/Widgets/Slider.vala"
	g_return_if_fail (cr != NULL);
#line 565 "../lib/Widgets/Slider.vala"
	if (self->priv->is_dark) {
#line 565 "../lib/Widgets/Slider.vala"
		_tmp0_ = 1.0f;
#line 1418 "Slider.c"
	} else {
#line 565 "../lib/Widgets/Slider.vala"
		_tmp0_ = 0.0f;
#line 1422 "Slider.c"
	}
#line 565 "../lib/Widgets/Slider.vala"
	if (self->priv->is_dark) {
#line 565 "../lib/Widgets/Slider.vala"
		_tmp1_ = 1.0f;
#line 1428 "Slider.c"
	} else {
#line 565 "../lib/Widgets/Slider.vala"
		_tmp1_ = 0.0f;
#line 1432 "Slider.c"
	}
#line 565 "../lib/Widgets/Slider.vala"
	if (self->priv->is_dark) {
#line 565 "../lib/Widgets/Slider.vala"
		_tmp2_ = 1.0f;
#line 1438 "Slider.c"
	} else {
#line 565 "../lib/Widgets/Slider.vala"
		_tmp2_ = 0.0f;
#line 1442 "Slider.c"
	}
#line 565 "../lib/Widgets/Slider.vala"
	_tmp3_.red = _tmp0_;
#line 565 "../lib/Widgets/Slider.vala"
	_tmp3_.green = _tmp1_;
#line 565 "../lib/Widgets/Slider.vala"
	_tmp3_.blue = _tmp2_;
#line 565 "../lib/Widgets/Slider.vala"
	_tmp3_.alpha = 0.12f;
#line 565 "../lib/Widgets/Slider.vala"
	bg_color = _tmp3_;
#line 567 "../lib/Widgets/Slider.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->_wave_thickness);
#line 568 "../lib/Widgets/Slider.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 571 "../lib/Widgets/Slider.vala"
	range = self->priv->_max_value - self->priv->_min_value;
#line 572 "../lib/Widgets/Slider.vala"
	if (range > ((gdouble) 0)) {
#line 572 "../lib/Widgets/Slider.vala"
		_tmp4_ = (self->priv->_value - self->priv->_min_value) / range;
#line 1464 "Slider.c"
	} else {
#line 572 "../lib/Widgets/Slider.vala"
		_tmp4_ = 0.0;
#line 1468 "Slider.c"
	}
#line 572 "../lib/Widgets/Slider.vala"
	position = _tmp4_;
#line 573 "../lib/Widgets/Slider.vala"
	effective_width = (gdouble) (width - (2 * HE_SLIDER_WAVE_MARGIN));
#line 574 "../lib/Widgets/Slider.vala"
	slider_x = HE_SLIDER_WAVE_MARGIN + (effective_width * position);
#line 577 "../lib/Widgets/Slider.vala"
	track_y = height * 0.5;
#line 578 "../lib/Widgets/Slider.vala"
	wave_amplitude = (gdouble) self->priv->_wave_amplitude;
#line 579 "../lib/Widgets/Slider.vala"
	wave_frequency = (2.0 * G_PI) / self->priv->_wave_wavelength;
#line 582 "../lib/Widgets/Slider.vala"
	handle_center_y = track_y;
#line 583 "../lib/Widgets/Slider.vala"
	handle_width = 4.0;
#line 584 "../lib/Widgets/Slider.vala"
	handle_height = 34.0;
#line 585 "../lib/Widgets/Slider.vala"
	border_margin = 6.0;
#line 586 "../lib/Widgets/Slider.vala"
	border_x = (slider_x - (handle_width * 0.5)) - border_margin;
#line 587 "../lib/Widgets/Slider.vala"
	border_y = (handle_center_y - (handle_height * 0.5)) - border_margin;
#line 588 "../lib/Widgets/Slider.vala"
	border_width = handle_width + (border_margin * 2.0);
#line 589 "../lib/Widgets/Slider.vala"
	border_height = handle_height + (border_margin * 2.0);
#line 592 "../lib/Widgets/Slider.vala"
	inactive_start = border_x + border_width;
#line 593 "../lib/Widgets/Slider.vala"
	if (inactive_start < ((gdouble) (width - HE_SLIDER_WAVE_MARGIN))) {
#line 1502 "Slider.c"
		GdkRGBA _tmp5_;
		GdkRGBA _tmp6_;
		GdkRGBA _tmp7_;
		GdkRGBA _tmp8_;
#line 594 "../lib/Widgets/Slider.vala"
		_tmp5_ = bg_color;
#line 594 "../lib/Widgets/Slider.vala"
		_tmp6_ = bg_color;
#line 594 "../lib/Widgets/Slider.vala"
		_tmp7_ = bg_color;
#line 594 "../lib/Widgets/Slider.vala"
		_tmp8_ = bg_color;
#line 594 "../lib/Widgets/Slider.vala"
		cairo_set_source_rgba (cr, (gdouble) _tmp5_.red, (gdouble) _tmp6_.green, (gdouble) _tmp7_.blue, (gdouble) _tmp8_.alpha);
#line 595 "../lib/Widgets/Slider.vala"
		cairo_move_to (cr, inactive_start, track_y);
#line 596 "../lib/Widgets/Slider.vala"
		cairo_line_to (cr, (gdouble) (width - HE_SLIDER_WAVE_MARGIN), track_y);
#line 597 "../lib/Widgets/Slider.vala"
		cairo_stroke (cr);
#line 1523 "Slider.c"
	}
#line 601 "../lib/Widgets/Slider.vala"
	filled_end = fmin (slider_x, (gdouble) (width - HE_SLIDER_WAVE_MARGIN));
#line 602 "../lib/Widgets/Slider.vala"
	if (filled_end > ((gdouble) HE_SLIDER_WAVE_MARGIN)) {
#line 1529 "Slider.c"
		gfloat _tmp9_ = 0.0F;
		gfloat _tmp10_ = 0.0F;
		gfloat _tmp11_ = 0.0F;
		GdkRGBA _tmp12_;
		GdkRGBA _tmp13_;
		GdkRGBA _tmp14_;
		gboolean path_started = FALSE;
#line 603 "../lib/Widgets/Slider.vala"
		if (self->priv->is_dark) {
#line 603 "../lib/Widgets/Slider.vala"
			_tmp9_ = 0.40f;
#line 1541 "Slider.c"
		} else {
#line 603 "../lib/Widgets/Slider.vala"
			_tmp9_ = 0.80f;
#line 1545 "Slider.c"
		}
#line 603 "../lib/Widgets/Slider.vala"
		if (self->priv->is_dark) {
#line 603 "../lib/Widgets/Slider.vala"
			_tmp10_ = 0.40f;
#line 1551 "Slider.c"
		} else {
#line 603 "../lib/Widgets/Slider.vala"
			_tmp10_ = 0.80f;
#line 1555 "Slider.c"
		}
#line 603 "../lib/Widgets/Slider.vala"
		if (self->priv->is_dark) {
#line 603 "../lib/Widgets/Slider.vala"
			_tmp11_ = 0.40f;
#line 1561 "Slider.c"
		} else {
#line 603 "../lib/Widgets/Slider.vala"
			_tmp11_ = 0.80f;
#line 1565 "Slider.c"
		}
#line 603 "../lib/Widgets/Slider.vala"
		_tmp12_ = self->priv->accent_color;
#line 603 "../lib/Widgets/Slider.vala"
		_tmp13_ = self->priv->accent_color;
#line 603 "../lib/Widgets/Slider.vala"
		_tmp14_ = self->priv->accent_color;
#line 603 "../lib/Widgets/Slider.vala"
		cairo_set_source_rgba (cr, (gdouble) (_tmp9_ * _tmp12_.red), (gdouble) (_tmp10_ * _tmp13_.green), (gdouble) (_tmp11_ * _tmp14_.blue), (gdouble) 1.0f);
#line 604 "../lib/Widgets/Slider.vala"
		path_started = FALSE;
#line 1577 "Slider.c"
		{
			gdouble x = 0.0;
#line 605 "../lib/Widgets/Slider.vala"
			x = (gdouble) HE_SLIDER_WAVE_MARGIN;
#line 1582 "Slider.c"
			{
				gboolean _tmp15_ = FALSE;
#line 605 "../lib/Widgets/Slider.vala"
				_tmp15_ = TRUE;
#line 605 "../lib/Widgets/Slider.vala"
				while (TRUE) {
#line 1589 "Slider.c"
					gdouble y = 0.0;
					gboolean _tmp16_ = FALSE;
					gboolean _tmp17_ = FALSE;
					gboolean _tmp18_ = FALSE;
#line 605 "../lib/Widgets/Slider.vala"
					if (!_tmp15_) {
#line 605 "../lib/Widgets/Slider.vala"
						x += 1.0;
#line 1598 "Slider.c"
					}
#line 605 "../lib/Widgets/Slider.vala"
					_tmp15_ = FALSE;
#line 605 "../lib/Widgets/Slider.vala"
					if (!(x <= filled_end)) {
#line 605 "../lib/Widgets/Slider.vala"
						break;
#line 1606 "Slider.c"
					}
#line 606 "../lib/Widgets/Slider.vala"
					y = track_y + (sin ((x * wave_frequency) + self->priv->_wave_phase) * wave_amplitude);
#line 609 "../lib/Widgets/Slider.vala"
					if (x >= border_x) {
#line 609 "../lib/Widgets/Slider.vala"
						_tmp18_ = x <= (border_x + border_width);
#line 1614 "Slider.c"
					} else {
#line 609 "../lib/Widgets/Slider.vala"
						_tmp18_ = FALSE;
#line 1618 "Slider.c"
					}
#line 609 "../lib/Widgets/Slider.vala"
					if (_tmp18_) {
#line 610 "../lib/Widgets/Slider.vala"
						_tmp17_ = y >= border_y;
#line 1624 "Slider.c"
					} else {
#line 609 "../lib/Widgets/Slider.vala"
						_tmp17_ = FALSE;
#line 1628 "Slider.c"
					}
#line 609 "../lib/Widgets/Slider.vala"
					if (_tmp17_) {
#line 610 "../lib/Widgets/Slider.vala"
						_tmp16_ = y <= (border_y + border_height);
#line 1634 "Slider.c"
					} else {
#line 609 "../lib/Widgets/Slider.vala"
						_tmp16_ = FALSE;
#line 1638 "Slider.c"
					}
#line 609 "../lib/Widgets/Slider.vala"
					if (_tmp16_) {
#line 612 "../lib/Widgets/Slider.vala"
						if (path_started) {
#line 613 "../lib/Widgets/Slider.vala"
							cairo_stroke (cr);
#line 614 "../lib/Widgets/Slider.vala"
							path_started = FALSE;
#line 1648 "Slider.c"
						}
					} else {
#line 618 "../lib/Widgets/Slider.vala"
						if (!path_started) {
#line 619 "../lib/Widgets/Slider.vala"
							cairo_move_to (cr, x, y);
#line 620 "../lib/Widgets/Slider.vala"
							path_started = TRUE;
#line 1657 "Slider.c"
						} else {
#line 622 "../lib/Widgets/Slider.vala"
							cairo_line_to (cr, x, y);
#line 1661 "Slider.c"
						}
					}
				}
			}
		}
#line 626 "../lib/Widgets/Slider.vala"
		if (path_started) {
#line 627 "../lib/Widgets/Slider.vala"
			cairo_stroke (cr);
#line 1671 "Slider.c"
		}
	}
#line 632 "../lib/Widgets/Slider.vala"
	cairo_set_line_width (cr, 1.0);
#line 635 "../lib/Widgets/Slider.vala"
	handle_x = slider_x - (handle_width * 0.5);
#line 636 "../lib/Widgets/Slider.vala"
	handle_y = handle_center_y - (handle_height * 0.5);
#line 637 "../lib/Widgets/Slider.vala"
	corner_radius = 2.0;
#line 640 "../lib/Widgets/Slider.vala"
	if (self->priv->is_dark) {
#line 640 "../lib/Widgets/Slider.vala"
		_tmp19_ = 0.40f;
#line 1686 "Slider.c"
	} else {
#line 640 "../lib/Widgets/Slider.vala"
		_tmp19_ = 0.80f;
#line 1690 "Slider.c"
	}
#line 640 "../lib/Widgets/Slider.vala"
	if (self->priv->is_dark) {
#line 640 "../lib/Widgets/Slider.vala"
		_tmp20_ = 0.40f;
#line 1696 "Slider.c"
	} else {
#line 640 "../lib/Widgets/Slider.vala"
		_tmp20_ = 0.80f;
#line 1700 "Slider.c"
	}
#line 640 "../lib/Widgets/Slider.vala"
	if (self->priv->is_dark) {
#line 640 "../lib/Widgets/Slider.vala"
		_tmp21_ = 0.40f;
#line 1706 "Slider.c"
	} else {
#line 640 "../lib/Widgets/Slider.vala"
		_tmp21_ = 0.80f;
#line 1710 "Slider.c"
	}
#line 640 "../lib/Widgets/Slider.vala"
	_tmp22_ = self->priv->accent_color;
#line 640 "../lib/Widgets/Slider.vala"
	_tmp23_ = self->priv->accent_color;
#line 640 "../lib/Widgets/Slider.vala"
	_tmp24_ = self->priv->accent_color;
#line 640 "../lib/Widgets/Slider.vala"
	cairo_set_source_rgba (cr, (gdouble) (_tmp19_ * _tmp22_.red), (gdouble) (_tmp20_ * _tmp23_.green), (gdouble) (_tmp21_ * _tmp24_.blue), (gdouble) 1.0f);
#line 641 "../lib/Widgets/Slider.vala"
	he_slider_draw_rounded_rectangle (self, cr, handle_x, handle_y, handle_width, handle_height, corner_radius);
#line 642 "../lib/Widgets/Slider.vala"
	cairo_fill (cr);
#line 1724 "Slider.c"
}

static void
_he_slider_draw_wavy_slider_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                        cairo_t* cr,
                                                        gint width,
                                                        gint height,
                                                        gpointer self)
{
#line 289 "../lib/Widgets/Slider.vala"
	he_slider_draw_wavy_slider ((HeSlider*) self, drawing_area, cr, width, height);
#line 1736 "Slider.c"
}

static void
_he_slider_on_drag_begin_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                      gdouble start_x,
                                                      gdouble start_y,
                                                      gpointer self)
{
#line 296 "../lib/Widgets/Slider.vala"
	he_slider_on_drag_begin ((HeSlider*) self, start_x, start_y);
#line 1747 "Slider.c"
}

static void
_he_slider_on_drag_update_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                        gdouble offset_x,
                                                        gdouble offset_y,
                                                        gpointer self)
{
#line 297 "../lib/Widgets/Slider.vala"
	he_slider_on_drag_update ((HeSlider*) self, offset_x, offset_y);
#line 1758 "Slider.c"
}

static void
_he_slider___lambda148_ (HeSlider* self)
{
	GtkScale* _tmp0_;
#line 302 "../lib/Widgets/Slider.vala"
	if (self->priv->_updating_from_scale) {
#line 303 "../lib/Widgets/Slider.vala"
		return;
#line 1769 "Slider.c"
	}
#line 306 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->scale;
#line 306 "../lib/Widgets/Slider.vala"
	self->priv->_value = gtk_range_get_value ((GtkRange*) _tmp0_);
#line 307 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 1777 "Slider.c"
		GtkDrawingArea* _tmp1_;
#line 308 "../lib/Widgets/Slider.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 308 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 1783 "Slider.c"
	}
#line 310 "../lib/Widgets/Slider.vala"
	g_signal_emit (self, he_slider_signals[HE_SLIDER_VALUE_CHANGED_SIGNAL], 0);
#line 1787 "Slider.c"
}

static void
__he_slider___lambda148__gtk_range_value_changed (GtkRange* _sender,
                                                  gpointer self)
{
#line 300 "../lib/Widgets/Slider.vala"
	_he_slider___lambda148_ ((HeSlider*) self);
#line 1796 "Slider.c"
}

static void
_he_slider_update_accent_color_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 335 "../lib/Widgets/Slider.vala"
	he_slider_update_accent_color ((HeSlider*) self);
#line 1806 "Slider.c"
}

static void
_he_slider_update_accent_color_he_application_accent_color_changed (HeApplication* _sender,
                                                                    gpointer self)
{
#line 341 "../lib/Widgets/Slider.vala"
	he_slider_update_accent_color ((HeSlider*) self);
#line 1815 "Slider.c"
}

static void
_he_slider___lambda149_ (HeSlider* self)
{
	HeApplication* app = NULL;
	HeApplication* _tmp0_;
	HeApplication* _tmp1_;
#line 339 "../lib/Widgets/Slider.vala"
	_tmp0_ = he_slider_get_he_application (self);
#line 339 "../lib/Widgets/Slider.vala"
	app = _tmp0_;
#line 340 "../lib/Widgets/Slider.vala"
	_tmp1_ = app;
#line 340 "../lib/Widgets/Slider.vala"
	if (_tmp1_ != NULL) {
#line 1832 "Slider.c"
		HeApplication* _tmp2_;
		GtkDrawingArea* _tmp3_;
#line 341 "../lib/Widgets/Slider.vala"
		_tmp2_ = app;
#line 341 "../lib/Widgets/Slider.vala"
		g_signal_connect_object (_tmp2_, "accent-color-changed", (GCallback) _he_slider_update_accent_color_he_application_accent_color_changed, self, 0);
#line 342 "../lib/Widgets/Slider.vala"
		he_slider_update_accent_color (self);
#line 343 "../lib/Widgets/Slider.vala"
		_tmp3_ = self->priv->wavy_drawing_area;
#line 343 "../lib/Widgets/Slider.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
#line 1845 "Slider.c"
	}
#line 338 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (app);
#line 1849 "Slider.c"
}

static void
__he_slider___lambda149__g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
#line 338 "../lib/Widgets/Slider.vala"
	_he_slider___lambda149_ ((HeSlider*) self);
#line 1859 "Slider.c"
}

static GObject *
he_slider_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeSlider * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkBox* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkDrawingArea* _tmp15_;
	GtkDrawingArea* _tmp16_;
	GtkDrawingArea* _tmp17_;
	GtkGestureDrag* _tmp18_;
	GtkGestureDrag* _tmp19_;
	GtkDrawingArea* _tmp20_;
	GtkGestureDrag* _tmp21_;
	GtkEventController* _tmp22_;
	GtkGestureDrag* _tmp23_;
	GtkGestureDrag* _tmp24_;
	GtkScale* _tmp25_;
	GtkOverlay* _tmp26_;
	GtkOverlay* _tmp27_;
	GtkBox* _tmp28_;
	GtkOverlay* _tmp29_;
	GtkScale* _tmp30_;
	GtkBox* _tmp31_;
	GtkImage* _tmp32_;
	GtkBox* _tmp33_;
	GtkOverlay* _tmp34_;
	GtkBox* _tmp35_;
	GtkImage* _tmp36_;
	GtkBox* _tmp37_;
	GtkBox* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkScale* _tmp41_;
	GtkAdjustment* _tmp42_;
	gboolean _tmp48_ = FALSE;
	HeDesktop* _tmp49_;
	HeDesktopColorScheme _tmp50_;
	HeDesktopColorScheme _tmp51_;
	HeDesktop* _tmp52_;
	GtkDrawingArea* _tmp53_;
#line 265 "../lib/Widgets/Slider.vala"
	parent_class = G_OBJECT_CLASS (he_slider_parent_class);
#line 265 "../lib/Widgets/Slider.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 265 "../lib/Widgets/Slider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SLIDER, HeSlider);
#line 266 "../lib/Widgets/Slider.vala"
	_tmp0_ = self->priv->left_icon_img;
#line 266 "../lib/Widgets/Slider.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 267 "../lib/Widgets/Slider.vala"
	_tmp1_ = self->priv->left_icon_img;
#line 267 "../lib/Widgets/Slider.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 268 "../lib/Widgets/Slider.vala"
	_tmp2_ = self->priv->left_icon_img;
#line 268 "../lib/Widgets/Slider.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 270 "../lib/Widgets/Slider.vala"
	_tmp3_ = self->priv->right_icon_img;
#line 270 "../lib/Widgets/Slider.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_END);
#line 271 "../lib/Widgets/Slider.vala"
	_tmp4_ = self->priv->right_icon_img;
#line 271 "../lib/Widgets/Slider.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 272 "../lib/Widgets/Slider.vala"
	_tmp5_ = self->priv->right_icon_img;
#line 272 "../lib/Widgets/Slider.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 274 "../lib/Widgets/Slider.vala"
	_tmp6_ = self->priv->stop_indicator;
#line 274 "../lib/Widgets/Slider.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp6_, 16);
#line 275 "../lib/Widgets/Slider.vala"
	if (self->priv->_is_wavy) {
#line 275 "../lib/Widgets/Slider.vala"
		_tmp7_ = self->priv->_stop_indicator_visibility;
#line 1956 "Slider.c"
	} else {
#line 275 "../lib/Widgets/Slider.vala"
		_tmp7_ = FALSE;
#line 1960 "Slider.c"
	}
#line 275 "../lib/Widgets/Slider.vala"
	if (_tmp7_) {
#line 1964 "Slider.c"
		GtkBox* _tmp8_;
#line 277 "../lib/Widgets/Slider.vala"
		_tmp8_ = self->priv->stop_indicator;
#line 277 "../lib/Widgets/Slider.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp8_, 10);
#line 1970 "Slider.c"
	}
#line 279 "../lib/Widgets/Slider.vala"
	_tmp9_ = self->priv->stop_indicator;
#line 279 "../lib/Widgets/Slider.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp9_, 12);
#line 280 "../lib/Widgets/Slider.vala"
	_tmp10_ = self->priv->stop_indicator;
#line 280 "../lib/Widgets/Slider.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp10_, 12);
#line 281 "../lib/Widgets/Slider.vala"
	_tmp11_ = self->priv->stop_indicator;
#line 281 "../lib/Widgets/Slider.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 282 "../lib/Widgets/Slider.vala"
	_tmp12_ = self->priv->stop_indicator;
#line 282 "../lib/Widgets/Slider.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
#line 283 "../lib/Widgets/Slider.vala"
	_tmp13_ = self->priv->stop_indicator;
#line 283 "../lib/Widgets/Slider.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 284 "../lib/Widgets/Slider.vala"
	_tmp14_ = self->priv->stop_indicator;
#line 284 "../lib/Widgets/Slider.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, "stop-indicator");
#line 287 "../lib/Widgets/Slider.vala"
	_tmp15_ = self->priv->wavy_drawing_area;
#line 287 "../lib/Widgets/Slider.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
#line 288 "../lib/Widgets/Slider.vala"
	_tmp16_ = self->priv->wavy_drawing_area;
#line 288 "../lib/Widgets/Slider.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp16_, -1, 40);
#line 289 "../lib/Widgets/Slider.vala"
	_tmp17_ = self->priv->wavy_drawing_area;
#line 289 "../lib/Widgets/Slider.vala"
	gtk_drawing_area_set_draw_func (_tmp17_, _he_slider_draw_wavy_slider_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 292 "../lib/Widgets/Slider.vala"
	_tmp18_ = (GtkGestureDrag*) gtk_gesture_drag_new ();
#line 292 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->drag_gesture);
#line 292 "../lib/Widgets/Slider.vala"
	self->priv->drag_gesture = _tmp18_;
#line 293 "../lib/Widgets/Slider.vala"
	_tmp19_ = self->priv->drag_gesture;
#line 293 "../lib/Widgets/Slider.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp19_, (guint) 1);
#line 294 "../lib/Widgets/Slider.vala"
	_tmp20_ = self->priv->wavy_drawing_area;
#line 294 "../lib/Widgets/Slider.vala"
	_tmp21_ = self->priv->drag_gesture;
#line 294 "../lib/Widgets/Slider.vala"
	_tmp22_ = _g_object_ref0 ((GtkEventController*) _tmp21_);
#line 294 "../lib/Widgets/Slider.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp20_, _tmp22_);
#line 296 "../lib/Widgets/Slider.vala"
	_tmp23_ = self->priv->drag_gesture;
#line 296 "../lib/Widgets/Slider.vala"
	g_signal_connect_object (_tmp23_, "drag-begin", (GCallback) _he_slider_on_drag_begin_gtk_gesture_drag_drag_begin, self, 0);
#line 297 "../lib/Widgets/Slider.vala"
	_tmp24_ = self->priv->drag_gesture;
#line 297 "../lib/Widgets/Slider.vala"
	g_signal_connect_object (_tmp24_, "drag-update", (GCallback) _he_slider_on_drag_update_gtk_gesture_drag_drag_update, self, 0);
#line 300 "../lib/Widgets/Slider.vala"
	_tmp25_ = self->scale;
#line 300 "../lib/Widgets/Slider.vala"
	g_signal_connect_object ((GtkRange*) _tmp25_, "value-changed", (GCallback) __he_slider___lambda148__gtk_range_value_changed, self, 0);
#line 313 "../lib/Widgets/Slider.vala"
	_tmp26_ = self->priv->slider_overlay;
#line 313 "../lib/Widgets/Slider.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp26_, TRUE);
#line 314 "../lib/Widgets/Slider.vala"
	_tmp27_ = self->priv->slider_overlay;
#line 314 "../lib/Widgets/Slider.vala"
	_tmp28_ = self->priv->stop_indicator;
#line 314 "../lib/Widgets/Slider.vala"
	gtk_overlay_add_overlay (_tmp27_, (GtkWidget*) _tmp28_);
#line 315 "../lib/Widgets/Slider.vala"
	_tmp29_ = self->priv->slider_overlay;
#line 315 "../lib/Widgets/Slider.vala"
	_tmp30_ = self->scale;
#line 315 "../lib/Widgets/Slider.vala"
	gtk_overlay_set_child (_tmp29_, (GtkWidget*) _tmp30_);
#line 317 "../lib/Widgets/Slider.vala"
	_tmp31_ = self->priv->main_box;
#line 317 "../lib/Widgets/Slider.vala"
	_tmp32_ = self->priv->left_icon_img;
#line 317 "../lib/Widgets/Slider.vala"
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 318 "../lib/Widgets/Slider.vala"
	_tmp33_ = self->priv->main_box;
#line 318 "../lib/Widgets/Slider.vala"
	_tmp34_ = self->priv->slider_overlay;
#line 318 "../lib/Widgets/Slider.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 319 "../lib/Widgets/Slider.vala"
	_tmp35_ = self->priv->main_box;
#line 319 "../lib/Widgets/Slider.vala"
	_tmp36_ = self->priv->right_icon_img;
#line 319 "../lib/Widgets/Slider.vala"
	gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
#line 320 "../lib/Widgets/Slider.vala"
	_tmp37_ = self->priv->main_box;
#line 320 "../lib/Widgets/Slider.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
#line 321 "../lib/Widgets/Slider.vala"
	_tmp38_ = self->priv->main_box;
#line 321 "../lib/Widgets/Slider.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp38_, TRUE);
#line 322 "../lib/Widgets/Slider.vala"
	_tmp39_ = self->priv->main_box;
#line 322 "../lib/Widgets/Slider.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp39_, "slider");
#line 323 "../lib/Widgets/Slider.vala"
	_tmp40_ = self->priv->main_box;
#line 323 "../lib/Widgets/Slider.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp40_, (GtkWidget*) self);
#line 326 "../lib/Widgets/Slider.vala"
	_tmp41_ = self->scale;
#line 326 "../lib/Widgets/Slider.vala"
	_tmp42_ = gtk_range_get_adjustment ((GtkRange*) _tmp41_);
#line 326 "../lib/Widgets/Slider.vala"
	if (_tmp42_ != NULL) {
#line 2094 "Slider.c"
		GtkScale* _tmp43_;
		GtkAdjustment* _tmp44_;
		GtkScale* _tmp45_;
		GtkAdjustment* _tmp46_;
		GtkScale* _tmp47_;
#line 327 "../lib/Widgets/Slider.vala"
		_tmp43_ = self->scale;
#line 327 "../lib/Widgets/Slider.vala"
		_tmp44_ = gtk_range_get_adjustment ((GtkRange*) _tmp43_);
#line 327 "../lib/Widgets/Slider.vala"
		self->priv->_min_value = gtk_adjustment_get_lower (_tmp44_);
#line 328 "../lib/Widgets/Slider.vala"
		_tmp45_ = self->scale;
#line 328 "../lib/Widgets/Slider.vala"
		_tmp46_ = gtk_range_get_adjustment ((GtkRange*) _tmp45_);
#line 328 "../lib/Widgets/Slider.vala"
		self->priv->_max_value = gtk_adjustment_get_upper (_tmp46_);
#line 329 "../lib/Widgets/Slider.vala"
		_tmp47_ = self->scale;
#line 329 "../lib/Widgets/Slider.vala"
		self->priv->_value = gtk_range_get_value ((GtkRange*) _tmp47_);
#line 2116 "Slider.c"
	}
#line 332 "../lib/Widgets/Slider.vala"
	_tmp49_ = self->priv->desktop;
#line 332 "../lib/Widgets/Slider.vala"
	_tmp50_ = he_desktop_get_prefers_color_scheme (_tmp49_);
#line 332 "../lib/Widgets/Slider.vala"
	_tmp51_ = _tmp50_;
#line 332 "../lib/Widgets/Slider.vala"
	if (_tmp51_ == HE_DESKTOP_COLOR_SCHEME_DARK) {
#line 332 "../lib/Widgets/Slider.vala"
		_tmp48_ = TRUE;
#line 2128 "Slider.c"
	} else {
#line 332 "../lib/Widgets/Slider.vala"
		_tmp48_ = FALSE;
#line 2132 "Slider.c"
	}
#line 332 "../lib/Widgets/Slider.vala"
	self->priv->is_dark = _tmp48_;
#line 335 "../lib/Widgets/Slider.vala"
	_tmp52_ = self->priv->desktop;
#line 335 "../lib/Widgets/Slider.vala"
	g_signal_connect_object ((GObject*) _tmp52_, "notify::accent-color", (GCallback) _he_slider_update_accent_color_g_object_notify, self, 0);
#line 338 "../lib/Widgets/Slider.vala"
	g_signal_connect_object ((GObject*) self, "notify::root", (GCallback) __he_slider___lambda149__g_object_notify, self, 0);
#line 347 "../lib/Widgets/Slider.vala"
	he_slider_update_accent_color (self);
#line 348 "../lib/Widgets/Slider.vala"
	_tmp53_ = self->priv->wavy_drawing_area;
#line 348 "../lib/Widgets/Slider.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp53_);
#line 265 "../lib/Widgets/Slider.vala"
	return obj;
#line 2150 "Slider.c"
}

static void
he_slider_class_init (HeSliderClass * klass,
                      gpointer klass_data)
{
#line 30 "../lib/Widgets/Slider.vala"
	he_slider_parent_class = g_type_class_peek_parent (klass);
#line 30 "../lib/Widgets/Slider.vala"
	g_type_class_adjust_private_offset (klass, &HeSlider_private_offset);
#line 30 "../lib/Widgets/Slider.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_slider_get_property;
#line 30 "../lib/Widgets/Slider.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_slider_set_property;
#line 30 "../lib/Widgets/Slider.vala"
	G_OBJECT_CLASS (klass)->constructor = he_slider_constructor;
#line 30 "../lib/Widgets/Slider.vala"
	G_OBJECT_CLASS (klass)->finalize = he_slider_finalize;
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_WAVE_AMPLITUDE_PROPERTY, he_slider_properties[HE_SLIDER_WAVE_AMPLITUDE_PROPERTY] = g_param_spec_int ("wave-amplitude", "wave-amplitude", "wave-amplitude", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_WAVE_WAVELENGTH_PROPERTY, he_slider_properties[HE_SLIDER_WAVE_WAVELENGTH_PROPERTY] = g_param_spec_int ("wave-wavelength", "wave-wavelength", "wave-wavelength", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_WAVE_THICKNESS_PROPERTY, he_slider_properties[HE_SLIDER_WAVE_THICKNESS_PROPERTY] = g_param_spec_int ("wave-thickness", "wave-thickness", "wave-thickness", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_ANIMATE_PROPERTY, he_slider_properties[HE_SLIDER_ANIMATE_PROPERTY] = g_param_spec_boolean ("animate", "animate", "animate", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_VALUE_PROPERTY, he_slider_properties[HE_SLIDER_VALUE_PROPERTY] = g_param_spec_double ("value", "value", "value", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_LEFT_ICON_PROPERTY, he_slider_properties[HE_SLIDER_LEFT_ICON_PROPERTY] = g_param_spec_string ("left-icon", "left-icon", "left-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_RIGHT_ICON_PROPERTY, he_slider_properties[HE_SLIDER_RIGHT_ICON_PROPERTY] = g_param_spec_string ("right-icon", "right-icon", "right-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_STOP_INDICATOR_VISIBILITY_PROPERTY, he_slider_properties[HE_SLIDER_STOP_INDICATOR_VISIBILITY_PROPERTY] = g_param_spec_boolean ("stop-indicator-visibility", "stop-indicator-visibility", "stop-indicator-visibility", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../lib/Widgets/Slider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_SLIDER_IS_WAVY_PROPERTY, he_slider_properties[HE_SLIDER_IS_WAVY_PROPERTY] = g_param_spec_boolean ("is-wavy", "is-wavy", "is-wavy", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2187 "Slider.c"
	/**
	     * Signal emitted when the value changes.
	     */
#line 30 "../lib/Widgets/Slider.vala"
	he_slider_signals[HE_SLIDER_VALUE_CHANGED_SIGNAL] = g_signal_new ("value-changed", HE_TYPE_SLIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 262 "../lib/Widgets/Slider.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 2195 "Slider.c"
}

static void
he_slider_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                        gpointer iface_data)
{
#line 30 "../lib/Widgets/Slider.vala"
	he_slider_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 2204 "Slider.c"
}

static void
he_slider_instance_init (HeSlider * self,
                         gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkOverlay* _tmp4_;
	HeDesktop* _tmp5_;
	GtkScale* _tmp6_;
	GtkDrawingArea* _tmp7_;
#line 30 "../lib/Widgets/Slider.vala"
	self->priv = he_slider_get_instance_private (self);
#line 31 "../lib/Widgets/Slider.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 31 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../lib/Widgets/Slider.vala"
	self->priv->main_box = _tmp0_;
#line 32 "../lib/Widgets/Slider.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 32 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp1_);
#line 32 "../lib/Widgets/Slider.vala"
	self->priv->stop_indicator = _tmp1_;
#line 33 "../lib/Widgets/Slider.vala"
	_tmp2_ = (GtkImage*) gtk_image_new ();
#line 33 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp2_);
#line 33 "../lib/Widgets/Slider.vala"
	self->priv->left_icon_img = _tmp2_;
#line 34 "../lib/Widgets/Slider.vala"
	_tmp3_ = (GtkImage*) gtk_image_new ();
#line 34 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp3_);
#line 34 "../lib/Widgets/Slider.vala"
	self->priv->right_icon_img = _tmp3_;
#line 35 "../lib/Widgets/Slider.vala"
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
#line 35 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp4_);
#line 35 "../lib/Widgets/Slider.vala"
	self->priv->slider_overlay = _tmp4_;
#line 36 "../lib/Widgets/Slider.vala"
	_tmp5_ = he_desktop_new ();
#line 36 "../lib/Widgets/Slider.vala"
	self->priv->desktop = _tmp5_;
#line 38 "../lib/Widgets/Slider.vala"
	self->priv->accent_color = (GdkRGBA) {1.0f, 1.0f, 1.0f, 1.0f};
#line 39 "../lib/Widgets/Slider.vala"
	self->priv->_last_frame_time = (gint64) 0;
#line 44 "../lib/Widgets/Slider.vala"
	_tmp6_ = (GtkScale*) gtk_scale_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 44 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp6_);
#line 44 "../lib/Widgets/Slider.vala"
	self->scale = _tmp6_;
#line 49 "../lib/Widgets/Slider.vala"
	_tmp7_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 49 "../lib/Widgets/Slider.vala"
	g_object_ref_sink (_tmp7_);
#line 49 "../lib/Widgets/Slider.vala"
	self->priv->wavy_drawing_area = _tmp7_;
#line 59 "../lib/Widgets/Slider.vala"
	self->priv->_wave_amplitude = 4;
#line 71 "../lib/Widgets/Slider.vala"
	self->priv->_wave_wavelength = 40;
#line 83 "../lib/Widgets/Slider.vala"
	self->priv->_wave_thickness = 8;
#line 95 "../lib/Widgets/Slider.vala"
	self->priv->_wave_phase = 0.0;
#line 100 "../lib/Widgets/Slider.vala"
	self->priv->_animation_tick_id = (guint) 0;
#line 101 "../lib/Widgets/Slider.vala"
	self->priv->_continuous_animation = FALSE;
#line 102 "../lib/Widgets/Slider.vala"
	self->priv->_updating_from_scale = FALSE;
#line 108 "../lib/Widgets/Slider.vala"
	self->priv->_animate = TRUE;
#line 132 "../lib/Widgets/Slider.vala"
	self->priv->_min_value = 0.0;
#line 133 "../lib/Widgets/Slider.vala"
	self->priv->_max_value = 1.0;
#line 138 "../lib/Widgets/Slider.vala"
	self->priv->_value = 0.0;
#line 2293 "Slider.c"
}

static void
he_slider_finalize (GObject * obj)
{
	HeSlider * self;
#line 30 "../lib/Widgets/Slider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SLIDER, HeSlider);
#line 31 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->main_box);
#line 32 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->stop_indicator);
#line 33 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->left_icon_img);
#line 34 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->right_icon_img);
#line 35 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->slider_overlay);
#line 36 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->desktop);
#line 44 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->scale);
#line 49 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->wavy_drawing_area);
#line 54 "../lib/Widgets/Slider.vala"
	_g_object_unref0 (self->priv->drag_gesture);
#line 161 "../lib/Widgets/Slider.vala"
	_g_free0 (self->priv->_left_icon);
#line 180 "../lib/Widgets/Slider.vala"
	_g_free0 (self->priv->_right_icon);
#line 30 "../lib/Widgets/Slider.vala"
	G_OBJECT_CLASS (he_slider_parent_class)->finalize (obj);
#line 2326 "Slider.c"
}

/**
 * A Slider is a widget that is used to select a value by means of a
 * dial running across a trough. Contains optional icons for the slider
 * purpose, and a disable-able Stop Indicator for accessibility purposes.
 * Can display either a standard scale or a custom wavy slider.
 *
 * When using the Stop Indicator, it's advisable to add a mark with the value
 * of 1.0 along the trough of the Slider so that the user can discern why the
 * end point is marked.
 */
static GType
he_slider_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeSliderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_slider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeSlider), 0, (GInstanceInitFunc) he_slider_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_slider_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_slider_type_id;
	he_slider_type_id = g_type_register_static (HE_TYPE_BIN, "HeSlider", &g_define_type_info, 0);
	g_type_add_interface_static (he_slider_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeSlider_private_offset = g_type_add_instance_private (he_slider_type_id, sizeof (HeSliderPrivate));
	return he_slider_type_id;
}

GType
he_slider_get_type (void)
{
	static volatile gsize he_slider_type_id__once = 0;
	if (g_once_init_enter (&he_slider_type_id__once)) {
		GType he_slider_type_id;
		he_slider_type_id = he_slider_get_type_once ();
		g_once_init_leave (&he_slider_type_id__once, he_slider_type_id);
	}
	return he_slider_type_id__once;
}

static void
_vala_he_slider_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeSlider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_SLIDER, HeSlider);
#line 30 "../lib/Widgets/Slider.vala"
	switch (property_id) {
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_WAVE_AMPLITUDE_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_int (value, he_slider_get_wave_amplitude (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_WAVE_WAVELENGTH_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_int (value, he_slider_get_wave_wavelength (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_WAVE_THICKNESS_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_int (value, he_slider_get_wave_thickness (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_ANIMATE_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_boolean (value, he_slider_get_animate (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_VALUE_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_double (value, he_slider_get_value (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_LEFT_ICON_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_string (value, he_slider_get_left_icon (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_RIGHT_ICON_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_string (value, he_slider_get_right_icon (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_STOP_INDICATOR_VISIBILITY_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_boolean (value, he_slider_get_stop_indicator_visibility (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_IS_WAVY_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		g_value_set_boolean (value, he_slider_get_is_wavy (self));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 2427 "Slider.c"
		default:
#line 30 "../lib/Widgets/Slider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 2433 "Slider.c"
	}
}

static void
_vala_he_slider_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeSlider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_SLIDER, HeSlider);
#line 30 "../lib/Widgets/Slider.vala"
	switch (property_id) {
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_WAVE_AMPLITUDE_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_wave_amplitude (self, g_value_get_int (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_WAVE_WAVELENGTH_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_wave_wavelength (self, g_value_get_int (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_WAVE_THICKNESS_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_wave_thickness (self, g_value_get_int (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_ANIMATE_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_animate (self, g_value_get_boolean (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_VALUE_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_value (self, g_value_get_double (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_LEFT_ICON_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_left_icon (self, g_value_get_string (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_RIGHT_ICON_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_right_icon (self, g_value_get_string (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_STOP_INDICATOR_VISIBILITY_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_stop_indicator_visibility (self, g_value_get_boolean (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 30 "../lib/Widgets/Slider.vala"
		case HE_SLIDER_IS_WAVY_PROPERTY:
#line 30 "../lib/Widgets/Slider.vala"
		he_slider_set_is_wavy (self, g_value_get_boolean (value));
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 2501 "Slider.c"
		default:
#line 30 "../lib/Widgets/Slider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../lib/Widgets/Slider.vala"
		break;
#line 2507 "Slider.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

