/* TimePicker.c generated by valac 0.56.18, the Vala compiler
 * generated from TimePicker.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 * Copyright (c) 2014–2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <graphene-gobject.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>

#define HE_TIME_PICKER_CLOCK_WIDGET_SIZE 256.0
#define HE_TIME_PICKER_CLOCK_WIDGET_CENTER (HE_TIME_PICKER_CLOCK_WIDGET_SIZE / 2)
#define HE_TIME_PICKER_CLOCK_WIDGET_RADIUS ((HE_TIME_PICKER_CLOCK_WIDGET_SIZE / 2) - 10.0)
#define HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS 24.0
#define HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS ((HE_TIME_PICKER_CLOCK_WIDGET_RADIUS - HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS) - 30.0)
#define HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS (HE_TIME_PICKER_CLOCK_WIDGET_RADIUS - HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS)
#define HE_TIME_PICKER_CLOCK_WIDGET_HAND_LINE_WIDTH 2.0
#define HE_TIME_PICKER_CLOCK_WIDGET_HAND_CENTER_WIDTH 4.0
#define HE_TIME_PICKER_CLOCK_WIDGET_FONT_FAMILY "Manrope"
#define HE_TIME_PICKER_CLOCK_WIDGET_HOUR_FONT_SIZE 20
#define HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE 18
#define HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY 12
#define HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY 24
#define HE_TIME_PICKER_CLOCK_WIDGET_MINUTES 60
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define HE_TIME_PICKER_TYPE_CLOCK_WIDGET (he_time_picker_clock_widget_get_type ())
#define HE_TIME_PICKER_CLOCK_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget))
#define HE_TIME_PICKER_CLOCK_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidgetClass))
#define HE_TIME_PICKER_IS_CLOCK_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HE_TIME_PICKER_TYPE_CLOCK_WIDGET))
#define HE_TIME_PICKER_IS_CLOCK_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HE_TIME_PICKER_TYPE_CLOCK_WIDGET))
#define HE_TIME_PICKER_CLOCK_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidgetClass))

typedef struct _HeTimePickerClockWidget HeTimePickerClockWidget;
typedef struct _HeTimePickerClockWidgetClass HeTimePickerClockWidgetClass;
enum  {
	HE_TIME_PICKER_0_PROPERTY,
	HE_TIME_PICKER_FORMAT_12_PROPERTY,
	HE_TIME_PICKER_FORMAT_24_PROPERTY,
	HE_TIME_PICKER_TIME_PROPERTY,
	HE_TIME_PICKER_NUM_PROPERTIES
};
static GParamSpec* he_time_picker_properties[HE_TIME_PICKER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _HeTimePickerClockWidgetPrivate HeTimePickerClockWidgetPrivate;
enum  {
	HE_TIME_PICKER_CLOCK_WIDGET_0_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY,
	HE_TIME_PICKER_CLOCK_WIDGET_NUM_PROPERTIES
};
static GParamSpec* he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_NUM_PROPERTIES];
#define _he_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_rgb_color_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _Block16Data Block16Data;
enum  {
	HE_TIME_PICKER_CLOCK_WIDGET_TIME_SELECTED_SIGNAL,
	HE_TIME_PICKER_CLOCK_WIDGET_NUM_SIGNALS
};
static guint he_time_picker_clock_widget_signals[HE_TIME_PICKER_CLOCK_WIDGET_NUM_SIGNALS] = {0};
enum  {
	HE_TIME_PICKER_TIME_CHANGED_SIGNAL,
	HE_TIME_PICKER_NUM_SIGNALS
};
static guint he_time_picker_signals[HE_TIME_PICKER_NUM_SIGNALS] = {0};

struct _HeTimePickerPrivate {
	gchar* _format_12;
	gchar* _format_24;
	GDateTime* _time;
	gboolean changing_time;
	gchar* old_string;
	GtkBox* am_pm_box;
	GtkPopover* popover;
	GtkSpinButton* hours_spinbutton;
	GtkSpinButton* minutes_spinbutton;
	GtkToggleButton* am_togglebutton;
	GtkToggleButton* pm_togglebutton;
	HeTimePickerClockWidget* clock;
};

struct _HeTimePickerClockWidget {
	GtkWidget parent_instance;
	HeTimePickerClockWidgetPrivate * priv;
};

struct _HeTimePickerClockWidgetClass {
	GtkWidgetClass parent_class;
};

struct _HeTimePickerClockWidgetPrivate {
	gboolean _selecting_hour;
	gboolean _is_military_mode;
	gint selected_hour;
	gint selected_minute;
	gdouble last_angle;
	gboolean is_dark;
	HeDesktop* desktop;
	GdkRGBA _accent_color;
};

struct _Block16Data {
	int _ref_count_;
	HeTimePickerClockWidget* self;
	GtkGestureDrag* drag_gesture;
};

static gint HeTimePicker_private_offset;
static gpointer he_time_picker_parent_class = NULL;
static gint HeTimePickerClockWidget_private_offset;
static gpointer he_time_picker_clock_widget_parent_class = NULL;

static GType he_time_picker_clock_widget_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void he_time_picker_update_text (HeTimePicker* self,
                                 gboolean no_signal);
static void he_time_picker_clock_widget_set_hour (HeTimePickerClockWidget* self,
                                           gint value);
static void he_time_picker_clock_widget_set_minute (HeTimePickerClockWidget* self,
                                             gint value);
static gboolean he_time_picker_is_clock_format_12h (void);
static void he_time_picker_update_am_pm (HeTimePicker* self,
                                  gint hours);
static void he_time_picker_update_time (HeTimePicker* self,
                                 gboolean is_hour);
static void he_time_picker_on_icon_press (HeTimePicker* self,
                                   GtkEntryIconPosition position);
static void he_time_picker_clock_widget_set_is_military_mode (HeTimePickerClockWidget* self,
                                                       gboolean value);
static void he_time_picker_is_unfocused (HeTimePicker* self);
static void he_time_picker_parse_time (HeTimePicker* self,
                                const gchar* timestr);
static gint* _int_dup (gint* self);
static gboolean _int_equal (const gint * s1,
                     const gint * s2);
static gboolean he_time_picker_clock_widget_get_selecting_hour (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_set_selecting_hour (HeTimePickerClockWidget* self,
                                                     gboolean value);
static gboolean he_time_picker_clock_widget_get_is_military_mode (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_get_accent_color (HeTimePickerClockWidget* self,
                                                   GdkRGBA * result);
static void he_time_picker_clock_widget_set_accent_color (HeTimePickerClockWidget* self,
                                                   GdkRGBA * value);
static gint he_time_picker_clock_widget_get_hour (HeTimePickerClockWidget* self);
static gint he_time_picker_clock_widget_get_minute (HeTimePickerClockWidget* self);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static HeTimePickerClockWidget* he_time_picker_clock_widget_new (void);
static HeTimePickerClockWidget* he_time_picker_clock_widget_construct (GType object_type);
static void he_time_picker_clock_widget_update_accent_color (HeTimePickerClockWidget* self);
static void _he_time_picker_clock_widget_update_accent_color_g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self);
static void __lambda163_ (HeTimePickerClockWidget* self);
static HeApplication* he_time_picker_clock_widget_get_he_application (HeTimePickerClockWidget* self);
static void _he_time_picker_clock_widget_update_accent_color_he_application_accent_color_changed (HeApplication* _sender,
                                                                                           gpointer self);
static void ___lambda163__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void he_time_picker_clock_widget_real_dispose (GObject* base);
static void he_time_picker_clock_widget_reset_to_hour_selection (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_real_snapshot (GtkWidget* base,
                                                GtkSnapshot* snapshot);
static gdouble he_time_picker_clock_widget_get_hour_angle (HeTimePickerClockWidget* self);
static gdouble he_time_picker_clock_widget_get_minute_angle (HeTimePickerClockWidget* self);
static gdouble he_time_picker_clock_widget_get_hand_radius (HeTimePickerClockWidget* self,
                                                     gdouble base_radius);
static void he_time_picker_clock_widget_emit_time_selected (HeTimePickerClockWidget* self);
static void he_time_picker_clock_widget_update_selection (HeTimePickerClockWidget* self,
                                                   gdouble x,
                                                   gdouble y);
static gdouble he_time_picker_clock_widget_get_angle_from_coords (HeTimePickerClockWidget* self,
                                                           gdouble x,
                                                           gdouble y);
static GObject * he_time_picker_clock_widget_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void _he_time_picker_clock_widget___lambda164_ (HeTimePickerClockWidget* self,
                                                gint n_press,
                                                gdouble x,
                                                gdouble y);
static void __he_time_picker_clock_widget___lambda164__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                           gint n_press,
                                                                           gdouble x,
                                                                           gdouble y,
                                                                           gpointer self);
static void _he_time_picker_clock_widget___lambda165_ (HeTimePickerClockWidget* self);
static void __he_time_picker_clock_widget___lambda165__gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                            gint n_press,
                                                                            gdouble x,
                                                                            gdouble y,
                                                                            gpointer self);
static void _he_time_picker_clock_widget___lambda166_ (Block16Data* _data16_,
                                                gdouble offset_x,
                                                gdouble offset_y);
static void __he_time_picker_clock_widget___lambda166__gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                              gdouble offset_x,
                                                                              gdouble offset_y,
                                                                              gpointer self);
static void he_time_picker_clock_widget_finalize (GObject * obj);
static GType he_time_picker_clock_widget_get_type_once (void);
static void _vala_he_time_picker_clock_widget_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_he_time_picker_clock_widget_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static GObject * he_time_picker_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _he_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                           GtkEntryIconPosition icon_pos,
                                                           gpointer self);
static void _he_time_picker___lambda167_ (HeTimePicker* self);
static void __he_time_picker___lambda167__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                  gpointer self);
static void _he_time_picker___lambda168_ (HeTimePicker* self);
static void __he_time_picker___lambda168__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                  gpointer self);
static gboolean _he_time_picker___lambda169_ (HeTimePicker* self);
static gboolean __he_time_picker___lambda169__gtk_spin_button_output (GtkSpinButton* _sender,
                                                               gpointer self);
static void _he_time_picker___lambda170_ (HeTimePicker* self,
                                   gint hour,
                                   gint minute);
static void __he_time_picker___lambda170__he_time_picker_clock_widget_time_selected (HeTimePickerClockWidget* _sender,
                                                                              gint hour,
                                                                              gint minute,
                                                                              gpointer self);
static void _he_time_picker___lambda171_ (HeTimePicker* self);
static void __he_time_picker___lambda171__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                     gpointer self);
static gboolean _he_time_picker___lambda172_ (HeTimePicker* self,
                                       gdouble dx,
                                       gdouble dy);
static gboolean __he_time_picker___lambda172__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                           gdouble dx,
                                                                           gdouble dy,
                                                                           gpointer self);
static void _he_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                      gpointer self);
static void _he_time_picker___lambda173_ (HeTimePicker* self);
static void __he_time_picker___lambda173__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _he_time_picker___lambda174_ (HeTimePicker* self);
static void __he_time_picker___lambda174__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void he_time_picker_finalize (GObject * obj);
static GType he_time_picker_get_type_once (void);
static void _vala_he_time_picker_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_time_picker_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_time_picker_get_instance_private (HeTimePicker* self)
{
	return G_STRUCT_MEMBER_P (self, HeTimePicker_private_offset);
}

const gchar*
he_time_picker_get_format_12 (HeTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 28 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
	return result;
#line 327 "TimePicker.c"
}

static void
he_time_picker_set_format_12 (HeTimePicker* self,
                              const gchar* value)
{
	gchar* old_value;
#line 28 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 28 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_get_format_12 (self);
#line 28 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 341 "TimePicker.c"
		gchar* _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_12);
#line 28 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_12 = _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_FORMAT_12_PROPERTY]);
#line 351 "TimePicker.c"
	}
}

const gchar*
he_time_picker_get_format_24 (HeTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_24;
#line 33 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
	return result;
#line 368 "TimePicker.c"
}

static void
he_time_picker_set_format_24 (HeTimePicker* self,
                              const gchar* value)
{
	gchar* old_value;
#line 33 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_get_format_24 (self);
#line 33 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 382 "TimePicker.c"
		gchar* _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_24);
#line 33 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_24 = _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_FORMAT_24_PROPERTY]);
#line 392 "TimePicker.c"
	}
}

GDateTime*
he_time_picker_get_time (HeTimePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp3_;
#line 37 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 38 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 408 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 39 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 39 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 39 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp2_);
#line 39 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp2_);
#line 419 "TimePicker.c"
	}
#line 42 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_time;
#line 42 "../lib/Widgets/TimePicker.vala"
	result = _tmp3_;
#line 42 "../lib/Widgets/TimePicker.vala"
	return result;
#line 427 "TimePicker.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 46 "../lib/Widgets/TimePicker.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 435 "TimePicker.c"
}

void
he_time_picker_set_time (HeTimePicker* self,
                         GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	HeTimePickerClockWidget* _tmp4_;
	GDateTime* _tmp5_;
	HeTimePickerClockWidget* _tmp6_;
	GDateTime* _tmp7_;
#line 45 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 46 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 46 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 46 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = _tmp0_;
#line 47 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 49 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_time;
#line 49 "../lib/Widgets/TimePicker.vala"
	if (g_date_time_get_hour (_tmp1_) >= 12) {
#line 462 "TimePicker.c"
		GtkToggleButton* _tmp2_;
#line 50 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->pm_togglebutton;
#line 50 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp2_, TRUE);
#line 468 "TimePicker.c"
	} else {
		GtkToggleButton* _tmp3_;
#line 52 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->am_togglebutton;
#line 52 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp3_, TRUE);
#line 475 "TimePicker.c"
	}
#line 55 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, TRUE);
#line 56 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = self->priv->clock;
#line 56 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = self->priv->_time;
#line 56 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_set_hour (_tmp4_, g_date_time_get_hour (_tmp5_));
#line 57 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = self->priv->clock;
#line 57 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = self->priv->_time;
#line 57 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_set_minute (_tmp6_, g_date_time_get_minute (_tmp7_));
#line 58 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 45 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_TIME_PROPERTY]);
#line 495 "TimePicker.c"
}

/**
     * Creates a new TimePicker widget with the given format strings.
     *
     * @param format_12 The string format of how to display the time when in 12h mode.
     * @param format_24 The string format of how to display the time when in 24h mode.
     */
HeTimePicker*
he_time_picker_construct_with_format (GType object_type,
                                      const gchar* format_12,
                                      const gchar* format_24)
{
	HeTimePicker * self = NULL;
#line 78 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_12 != NULL, NULL);
#line 78 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_24 != NULL, NULL);
#line 79 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePicker*) g_object_new (object_type, "format-12", format_12, "format-24", format_24, NULL);
#line 78 "../lib/Widgets/TimePicker.vala"
	return self;
#line 518 "TimePicker.c"
}

HeTimePicker*
he_time_picker_new_with_format (const gchar* format_12,
                                const gchar* format_24)
{
#line 78 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_construct_with_format (HE_TYPE_TIME_PICKER, format_12, format_24);
#line 527 "TimePicker.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 546 "TimePicker.c"
}

static gboolean
he_time_picker_is_clock_format_12h (void)
{
	gchar* format = NULL;
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 229 "../lib/Widgets/TimePicker.vala"
	format = NULL;
#line 230 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 230 "../lib/Widgets/TimePicker.vala"
	h24_settings = _tmp0_;
#line 231 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
#line 231 "../lib/Widgets/TimePicker.vala"
	_g_free0 (format);
#line 231 "../lib/Widgets/TimePicker.vala"
	format = _tmp1_;
#line 232 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = format;
#line 232 "../lib/Widgets/TimePicker.vala"
	result = string_contains (_tmp2_, "12h");
#line 232 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (h24_settings);
#line 232 "../lib/Widgets/TimePicker.vala"
	_g_free0 (format);
#line 232 "../lib/Widgets/TimePicker.vala"
	return result;
#line 580 "TimePicker.c"
}

static void
he_time_picker_update_am_pm (HeTimePicker* self,
                             gint hours)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 235 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 236 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 237 "../lib/Widgets/TimePicker.vala"
		return;
#line 596 "TimePicker.c"
	}
#line 240 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 240 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_date_time_add_hours (_tmp0_, hours);
#line 240 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 240 "../lib/Widgets/TimePicker.vala"
	he_time_picker_set_time (self, _tmp2_);
#line 240 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (_tmp2_);
#line 241 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 243 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, TRUE);
#line 612 "TimePicker.c"
}

static void
he_time_picker_update_time (HeTimePicker* self,
                            gboolean is_hour)
{
#line 246 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 247 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 248 "../lib/Widgets/TimePicker.vala"
		return;
#line 625 "TimePicker.c"
	}
#line 251 "../lib/Widgets/TimePicker.vala"
	if (is_hour) {
#line 629 "TimePicker.c"
		gint new_hour = 0;
		GtkSpinButton* _tmp0_;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 252 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = self->priv->hours_spinbutton;
#line 252 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = he_time_picker_get_time (self);
#line 252 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 252 "../lib/Widgets/TimePicker.vala"
		new_hour = gtk_spin_button_get_value_as_int (_tmp0_) - g_date_time_get_hour (_tmp2_);
#line 254 "../lib/Widgets/TimePicker.vala"
		if (he_time_picker_is_clock_format_12h ()) {
#line 644 "TimePicker.c"
			gboolean _tmp3_ = FALSE;
			GtkSpinButton* _tmp4_;
#line 255 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = self->priv->hours_spinbutton;
#line 255 "../lib/Widgets/TimePicker.vala"
			if (gtk_spin_button_get_value_as_int (_tmp4_) == 12) {
#line 651 "TimePicker.c"
				GtkToggleButton* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp5_ = self->priv->am_togglebutton;
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp6_ = gtk_toggle_button_get_active (_tmp5_);
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp7_ = _tmp6_;
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = _tmp7_;
#line 663 "TimePicker.c"
			} else {
#line 255 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = FALSE;
#line 667 "TimePicker.c"
			}
#line 255 "../lib/Widgets/TimePicker.vala"
			_tmp3_ = TRUE;
#line 255 "../lib/Widgets/TimePicker.vala"
			if (_tmp3_) {
#line 673 "TimePicker.c"
				GDateTime* _tmp8_;
				GDateTime* _tmp9_;
				GDateTime* _tmp10_;
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp8_ = self->priv->_time;
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp9_ = self->priv->_time;
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp10_ = g_date_time_add_hours (_tmp8_, -g_date_time_get_hour (_tmp9_));
#line 256 "../lib/Widgets/TimePicker.vala"
				_g_date_time_unref0 (self->priv->_time);
#line 256 "../lib/Widgets/TimePicker.vala"
				self->priv->_time = _tmp10_;
#line 687 "TimePicker.c"
			} else {
				gboolean _tmp11_ = FALSE;
				GtkSpinButton* _tmp12_;
#line 257 "../lib/Widgets/TimePicker.vala"
				_tmp12_ = self->priv->hours_spinbutton;
#line 257 "../lib/Widgets/TimePicker.vala"
				if (gtk_spin_button_get_value_as_int (_tmp12_) < 12) {
#line 695 "TimePicker.c"
					GtkToggleButton* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp13_ = self->priv->am_togglebutton;
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp14_ = gtk_toggle_button_get_active (_tmp13_);
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp15_ = _tmp14_;
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = _tmp15_;
#line 707 "TimePicker.c"
				} else {
#line 257 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = FALSE;
#line 711 "TimePicker.c"
				}
#line 257 "../lib/Widgets/TimePicker.vala"
				_tmp11_ = TRUE;
#line 257 "../lib/Widgets/TimePicker.vala"
				if (_tmp11_) {
#line 717 "TimePicker.c"
					GDateTime* _tmp16_;
					GDateTime* _tmp17_;
#line 258 "../lib/Widgets/TimePicker.vala"
					_tmp16_ = self->priv->_time;
#line 258 "../lib/Widgets/TimePicker.vala"
					_tmp17_ = g_date_time_add_hours (_tmp16_, new_hour);
#line 258 "../lib/Widgets/TimePicker.vala"
					_g_date_time_unref0 (self->priv->_time);
#line 258 "../lib/Widgets/TimePicker.vala"
					self->priv->_time = _tmp17_;
#line 728 "TimePicker.c"
				} else {
					gboolean _tmp18_ = FALSE;
					GtkSpinButton* _tmp19_;
#line 259 "../lib/Widgets/TimePicker.vala"
					_tmp19_ = self->priv->hours_spinbutton;
#line 259 "../lib/Widgets/TimePicker.vala"
					if (gtk_spin_button_get_value_as_int (_tmp19_) == 12) {
#line 736 "TimePicker.c"
						GtkToggleButton* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = self->priv->pm_togglebutton;
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp21_ = gtk_toggle_button_get_active (_tmp20_);
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp22_ = _tmp21_;
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = _tmp22_;
#line 748 "TimePicker.c"
					} else {
#line 259 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = FALSE;
#line 752 "TimePicker.c"
					}
#line 259 "../lib/Widgets/TimePicker.vala"
					_tmp18_ = TRUE;
#line 259 "../lib/Widgets/TimePicker.vala"
					if (_tmp18_) {
#line 758 "TimePicker.c"
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
#line 260 "../lib/Widgets/TimePicker.vala"
						_tmp23_ = self->priv->_time;
#line 260 "../lib/Widgets/TimePicker.vala"
						_tmp24_ = self->priv->_time;
#line 260 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = g_date_time_add_hours (_tmp23_, (-g_date_time_get_hour (_tmp24_)) + 12);
#line 260 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (self->priv->_time);
#line 260 "../lib/Widgets/TimePicker.vala"
						self->priv->_time = _tmp25_;
#line 772 "TimePicker.c"
					} else {
						gboolean _tmp26_ = FALSE;
						GtkSpinButton* _tmp27_;
#line 261 "../lib/Widgets/TimePicker.vala"
						_tmp27_ = self->priv->hours_spinbutton;
#line 261 "../lib/Widgets/TimePicker.vala"
						if (gtk_spin_button_get_value_as_int (_tmp27_) < 12) {
#line 780 "TimePicker.c"
							GtkToggleButton* _tmp28_;
							gboolean _tmp29_;
							gboolean _tmp30_;
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp28_ = self->priv->pm_togglebutton;
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp29_ = gtk_toggle_button_get_active (_tmp28_);
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = _tmp29_;
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = _tmp30_;
#line 792 "TimePicker.c"
						} else {
#line 261 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = FALSE;
#line 796 "TimePicker.c"
						}
#line 261 "../lib/Widgets/TimePicker.vala"
						_tmp26_ = TRUE;
#line 261 "../lib/Widgets/TimePicker.vala"
						if (_tmp26_) {
#line 802 "TimePicker.c"
							GDateTime* _tmp31_;
							GDateTime* _tmp32_;
							GDateTime* _tmp33_;
							GDateTime* _tmp34_;
#line 262 "../lib/Widgets/TimePicker.vala"
							_tmp31_ = self->priv->_time;
#line 262 "../lib/Widgets/TimePicker.vala"
							_tmp32_ = g_date_time_add_hours (_tmp31_, new_hour + 12);
#line 262 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (self->priv->_time);
#line 262 "../lib/Widgets/TimePicker.vala"
							self->priv->_time = _tmp32_;
#line 264 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = he_time_picker_get_time (self);
#line 264 "../lib/Widgets/TimePicker.vala"
							_tmp34_ = _tmp33_;
#line 264 "../lib/Widgets/TimePicker.vala"
							if (g_date_time_get_hour (_tmp34_) <= 12) {
#line 821 "TimePicker.c"
								GDateTime* _tmp35_;
								GDateTime* _tmp36_;
#line 265 "../lib/Widgets/TimePicker.vala"
								_tmp35_ = self->priv->_time;
#line 265 "../lib/Widgets/TimePicker.vala"
								_tmp36_ = g_date_time_add_hours (_tmp35_, 12);
#line 265 "../lib/Widgets/TimePicker.vala"
								_g_date_time_unref0 (self->priv->_time);
#line 265 "../lib/Widgets/TimePicker.vala"
								self->priv->_time = _tmp36_;
#line 832 "TimePicker.c"
							}
						}
					}
				}
			}
		} else {
			GDateTime* _tmp37_;
			GDateTime* _tmp38_;
#line 269 "../lib/Widgets/TimePicker.vala"
			_tmp37_ = self->priv->_time;
#line 269 "../lib/Widgets/TimePicker.vala"
			_tmp38_ = g_date_time_add_hours (_tmp37_, new_hour);
#line 269 "../lib/Widgets/TimePicker.vala"
			_g_date_time_unref0 (self->priv->_time);
#line 269 "../lib/Widgets/TimePicker.vala"
			self->priv->_time = _tmp38_;
#line 849 "TimePicker.c"
		}
	} else {
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		GtkSpinButton* _tmp41_;
		GDateTime* _tmp42_;
		GDateTime* _tmp43_;
		GDateTime* _tmp44_;
#line 272 "../lib/Widgets/TimePicker.vala"
		_tmp39_ = he_time_picker_get_time (self);
#line 272 "../lib/Widgets/TimePicker.vala"
		_tmp40_ = _tmp39_;
#line 272 "../lib/Widgets/TimePicker.vala"
		_tmp41_ = self->priv->minutes_spinbutton;
#line 272 "../lib/Widgets/TimePicker.vala"
		_tmp42_ = he_time_picker_get_time (self);
#line 272 "../lib/Widgets/TimePicker.vala"
		_tmp43_ = _tmp42_;
#line 272 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = g_date_time_add_minutes (_tmp40_, gtk_spin_button_get_value_as_int (_tmp41_) - g_date_time_get_minute (_tmp43_));
#line 272 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 272 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp44_;
#line 874 "TimePicker.c"
	}
#line 275 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 878 "TimePicker.c"
}

static void
he_time_picker_on_icon_press (HeTimePicker* self,
                              GtkEntryIconPosition position)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp29_;
	GDateTime* _tmp30_;
	GDateTime* _tmp31_;
	GtkPopover* _tmp32_;
#line 278 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 280 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 281 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 283 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 898 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = he_time_picker_get_time (self);
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_date_time_get_hour (_tmp2_) > 12;
#line 907 "TimePicker.c"
	} else {
#line 283 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 911 "TimePicker.c"
	}
#line 283 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 915 "TimePicker.c"
		GtkSpinButton* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 284 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->hours_spinbutton;
#line 284 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = he_time_picker_get_time (self);
#line 284 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 284 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp3_, (gdouble) (g_date_time_get_hour (_tmp5_) - 12));
#line 927 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
#line 286 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = self->priv->hours_spinbutton;
#line 286 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = he_time_picker_get_time (self);
#line 286 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 286 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp6_, (gdouble) g_date_time_get_hour (_tmp8_));
#line 940 "TimePicker.c"
	}
#line 289 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 944 "TimePicker.c"
		GtkBox* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GtkSpinButton* _tmp21_;
		HeTimePickerClockWidget* _tmp22_;
#line 290 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = self->priv->am_pm_box;
#line 290 "../lib/Widgets/TimePicker.vala"
		gtk_widget_show ((GtkWidget*) _tmp9_);
#line 292 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = he_time_picker_get_time (self);
#line 292 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 292 "../lib/Widgets/TimePicker.vala"
		if (g_date_time_get_hour (_tmp11_) > 12) {
#line 960 "TimePicker.c"
			GtkSpinButton* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 293 "../lib/Widgets/TimePicker.vala"
			_tmp12_ = self->priv->hours_spinbutton;
#line 293 "../lib/Widgets/TimePicker.vala"
			_tmp13_ = he_time_picker_get_time (self);
#line 293 "../lib/Widgets/TimePicker.vala"
			_tmp14_ = _tmp13_;
#line 293 "../lib/Widgets/TimePicker.vala"
			gtk_spin_button_set_value (_tmp12_, (gdouble) (g_date_time_get_hour (_tmp14_) - 12));
#line 972 "TimePicker.c"
		} else {
			GDateTime* _tmp15_;
			GDateTime* _tmp16_;
#line 294 "../lib/Widgets/TimePicker.vala"
			_tmp15_ = he_time_picker_get_time (self);
#line 294 "../lib/Widgets/TimePicker.vala"
			_tmp16_ = _tmp15_;
#line 294 "../lib/Widgets/TimePicker.vala"
			if (g_date_time_get_hour (_tmp16_) == 0) {
#line 982 "TimePicker.c"
				GtkSpinButton* _tmp17_;
#line 295 "../lib/Widgets/TimePicker.vala"
				_tmp17_ = self->priv->hours_spinbutton;
#line 295 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp17_, (gdouble) 12);
#line 988 "TimePicker.c"
			} else {
				GtkSpinButton* _tmp18_;
				GDateTime* _tmp19_;
				GDateTime* _tmp20_;
#line 297 "../lib/Widgets/TimePicker.vala"
				_tmp18_ = self->priv->hours_spinbutton;
#line 297 "../lib/Widgets/TimePicker.vala"
				_tmp19_ = he_time_picker_get_time (self);
#line 297 "../lib/Widgets/TimePicker.vala"
				_tmp20_ = _tmp19_;
#line 297 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp18_, (gdouble) g_date_time_get_hour (_tmp20_));
#line 1001 "TimePicker.c"
			}
		}
#line 301 "../lib/Widgets/TimePicker.vala"
		_tmp21_ = self->priv->hours_spinbutton;
#line 301 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp21_, (gdouble) 1, (gdouble) 12);
#line 302 "../lib/Widgets/TimePicker.vala"
		_tmp22_ = self->priv->clock;
#line 302 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp22_, FALSE);
#line 1012 "TimePicker.c"
	} else {
		GtkBox* _tmp23_;
		GtkSpinButton* _tmp24_;
		GDateTime* _tmp25_;
		GDateTime* _tmp26_;
		GtkSpinButton* _tmp27_;
		HeTimePickerClockWidget* _tmp28_;
#line 304 "../lib/Widgets/TimePicker.vala"
		_tmp23_ = self->priv->am_pm_box;
#line 304 "../lib/Widgets/TimePicker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp23_);
#line 305 "../lib/Widgets/TimePicker.vala"
		_tmp24_ = self->priv->hours_spinbutton;
#line 305 "../lib/Widgets/TimePicker.vala"
		_tmp25_ = he_time_picker_get_time (self);
#line 305 "../lib/Widgets/TimePicker.vala"
		_tmp26_ = _tmp25_;
#line 305 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp24_, (gdouble) g_date_time_get_hour (_tmp26_));
#line 307 "../lib/Widgets/TimePicker.vala"
		_tmp27_ = self->priv->hours_spinbutton;
#line 307 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp27_, (gdouble) 0, (gdouble) 23);
#line 308 "../lib/Widgets/TimePicker.vala"
		_tmp28_ = self->priv->clock;
#line 308 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp28_, TRUE);
#line 1040 "TimePicker.c"
	}
#line 311 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = self->priv->minutes_spinbutton;
#line 311 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = he_time_picker_get_time (self);
#line 311 "../lib/Widgets/TimePicker.vala"
	_tmp31_ = _tmp30_;
#line 311 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_value (_tmp29_, (gdouble) g_date_time_get_minute (_tmp31_));
#line 312 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 314 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = self->priv->popover;
#line 314 "../lib/Widgets/TimePicker.vala"
	gtk_popover_popup (_tmp32_);
#line 1056 "TimePicker.c"
}

static void
he_time_picker_is_unfocused (HeTimePicker* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 317 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 318 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->popover;
#line 318 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 318 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 318 "../lib/Widgets/TimePicker.vala"
	if (!_tmp3_) {
#line 1076 "TimePicker.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = self->priv->old_string;
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = gtk_editable_get_text ((GtkEditable*) self);
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_utf8_collate (_tmp4_, _tmp6_) != 0;
#line 1088 "TimePicker.c"
	} else {
#line 318 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 1092 "TimePicker.c"
	}
#line 318 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 1096 "TimePicker.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = gtk_editable_get_text ((GtkEditable*) self);
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 319 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 319 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->old_string);
#line 319 "../lib/Widgets/TimePicker.vala"
		self->priv->old_string = _tmp9_;
#line 320 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 320 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 320 "../lib/Widgets/TimePicker.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 320 "../lib/Widgets/TimePicker.vala"
		_tmp13_ = _tmp12_;
#line 320 "../lib/Widgets/TimePicker.vala"
		he_time_picker_parse_time (self, _tmp13_);
#line 320 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp13_);
#line 1126 "TimePicker.c"
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1616 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1617 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1617 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1617 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1618 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1618 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1618 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1618 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1620 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1621 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1621 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1621 "glib-2.0.vapi"
	if (result_length1) {
#line 1621 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 1175 "TimePicker.c"
	}
#line 1621 "glib-2.0.vapi"
	result = _tmp4_;
#line 1621 "glib-2.0.vapi"
	return result;
#line 1181 "TimePicker.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 340 "../lib/Widgets/TimePicker.vala"
	dup = g_new0 (gint, 1);
#line 340 "../lib/Widgets/TimePicker.vala"
	memcpy (dup, self, sizeof (gint));
#line 340 "../lib/Widgets/TimePicker.vala"
	return dup;
#line 1194 "TimePicker.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 340 "../lib/Widgets/TimePicker.vala"
	return self ? _int_dup (self) : NULL;
#line 1202 "TimePicker.c"
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
#line 368 "../lib/Widgets/TimePicker.vala"
	if (s1 == s2) {
#line 368 "../lib/Widgets/TimePicker.vala"
		return TRUE;
#line 1213 "TimePicker.c"
	}
#line 368 "../lib/Widgets/TimePicker.vala"
	if (s1 == NULL) {
#line 368 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 1219 "TimePicker.c"
	}
#line 368 "../lib/Widgets/TimePicker.vala"
	if (s2 == NULL) {
#line 368 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 1225 "TimePicker.c"
	}
#line 368 "../lib/Widgets/TimePicker.vala"
	return (*s1) == (*s2);
#line 1229 "TimePicker.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1256 "TimePicker.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1262 "TimePicker.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1268 "TimePicker.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1272 "TimePicker.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1280 "TimePicker.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1284 "TimePicker.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1296 "TimePicker.c"
}

static void
he_time_picker_parse_time (HeTimePicker* self,
                           const gchar* timestr)
{
	gchar* current = NULL;
	gchar* _tmp0_;
	gboolean is_hours = FALSE;
	gboolean is_suffix = FALSE;
	gboolean has_suffix = FALSE;
	gint* hour = NULL;
	gint* minute = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gint* _tmp71_;
	gboolean _tmp96_ = FALSE;
	gint* _tmp97_;
#line 324 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 324 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (timestr != NULL);
#line 325 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 325 "../lib/Widgets/TimePicker.vala"
	current = _tmp0_;
#line 326 "../lib/Widgets/TimePicker.vala"
	is_hours = TRUE;
#line 327 "../lib/Widgets/TimePicker.vala"
	is_suffix = FALSE;
#line 328 "../lib/Widgets/TimePicker.vala"
	has_suffix = FALSE;
#line 330 "../lib/Widgets/TimePicker.vala"
	hour = NULL;
#line 331 "../lib/Widgets/TimePicker.vala"
	minute = NULL;
#line 332 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_utf8_strdown (timestr, (gssize) -1);
#line 332 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 332 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = string_to_utf8 (_tmp2_, &_tmp3_);
#line 332 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = _tmp4_;
#line 332 "../lib/Widgets/TimePicker.vala"
	_tmp5__length1 = _tmp3_;
#line 332 "../lib/Widgets/TimePicker.vala"
	_g_free0 (_tmp2_);
#line 1351 "TimePicker.c"
	{
		gchar* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 332 "../lib/Widgets/TimePicker.vala"
		c_collection = _tmp5_;
#line 332 "../lib/Widgets/TimePicker.vala"
		c_collection_length1 = _tmp5__length1;
#line 332 "../lib/Widgets/TimePicker.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 1363 "TimePicker.c"
			gchar c = '\0';
#line 332 "../lib/Widgets/TimePicker.vala"
			c = c_collection[c_it];
#line 1367 "TimePicker.c"
			{
#line 333 "../lib/Widgets/TimePicker.vala"
				if (g_ascii_isdigit (c)) {
#line 1371 "TimePicker.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 334 "../lib/Widgets/TimePicker.vala"
					_tmp6_ = current;
#line 334 "../lib/Widgets/TimePicker.vala"
					_tmp7_ = g_strdup_printf ("%s%c", _tmp6_, (gint) c);
#line 334 "../lib/Widgets/TimePicker.vala"
					_g_free0 (current);
#line 334 "../lib/Widgets/TimePicker.vala"
					current = _tmp7_;
#line 1382 "TimePicker.c"
				} else {
					gboolean _tmp25_ = FALSE;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_;
#line 336 "../lib/Widgets/TimePicker.vala"
					if (!is_suffix) {
#line 1390 "TimePicker.c"
						const gchar* _tmp8_;
						gboolean _tmp17_ = FALSE;
						gchar* _tmp18_;
						gchar* _tmp19_;
						gboolean _tmp20_;
#line 337 "../lib/Widgets/TimePicker.vala"
						_tmp8_ = current;
#line 337 "../lib/Widgets/TimePicker.vala"
						if (g_strcmp0 (_tmp8_, "") != 0) {
#line 338 "../lib/Widgets/TimePicker.vala"
							if (is_hours) {
#line 1402 "TimePicker.c"
								const gchar* _tmp9_;
								gint _tmp10_;
								gint* _tmp11_;
								gchar* _tmp12_;
#line 339 "../lib/Widgets/TimePicker.vala"
								is_hours = FALSE;
#line 340 "../lib/Widgets/TimePicker.vala"
								_tmp9_ = current;
#line 340 "../lib/Widgets/TimePicker.vala"
								_tmp10_ = atoi (_tmp9_);
#line 340 "../lib/Widgets/TimePicker.vala"
								_tmp11_ = __int_dup0 (&_tmp10_);
#line 340 "../lib/Widgets/TimePicker.vala"
								_g_free0 (hour);
#line 340 "../lib/Widgets/TimePicker.vala"
								hour = _tmp11_;
#line 341 "../lib/Widgets/TimePicker.vala"
								_tmp12_ = g_strdup ("");
#line 341 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 341 "../lib/Widgets/TimePicker.vala"
								current = _tmp12_;
#line 1425 "TimePicker.c"
							} else {
								const gchar* _tmp13_;
								gint _tmp14_;
								gint* _tmp15_;
								gchar* _tmp16_;
#line 343 "../lib/Widgets/TimePicker.vala"
								_tmp13_ = current;
#line 343 "../lib/Widgets/TimePicker.vala"
								_tmp14_ = atoi (_tmp13_);
#line 343 "../lib/Widgets/TimePicker.vala"
								_tmp15_ = __int_dup0 (&_tmp14_);
#line 343 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 343 "../lib/Widgets/TimePicker.vala"
								minute = _tmp15_;
#line 344 "../lib/Widgets/TimePicker.vala"
								_tmp16_ = g_strdup ("");
#line 344 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 344 "../lib/Widgets/TimePicker.vala"
								current = _tmp16_;
#line 1447 "TimePicker.c"
							}
						}
#line 348 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = g_strdup_printf ("%c", c);
#line 348 "../lib/Widgets/TimePicker.vala"
						_tmp19_ = _tmp18_;
#line 348 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = string_contains (_tmp19_, "a");
#line 348 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp19_);
#line 348 "../lib/Widgets/TimePicker.vala"
						if (_tmp20_) {
#line 348 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = TRUE;
#line 1462 "TimePicker.c"
						} else {
							gchar* _tmp21_;
							gchar* _tmp22_;
#line 348 "../lib/Widgets/TimePicker.vala"
							_tmp21_ = g_strdup_printf ("%c", c);
#line 348 "../lib/Widgets/TimePicker.vala"
							_tmp22_ = _tmp21_;
#line 348 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = string_contains (_tmp22_, "p");
#line 348 "../lib/Widgets/TimePicker.vala"
							_g_free0 (_tmp22_);
#line 1474 "TimePicker.c"
						}
#line 348 "../lib/Widgets/TimePicker.vala"
						if (_tmp17_) {
#line 1478 "TimePicker.c"
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 349 "../lib/Widgets/TimePicker.vala"
							is_suffix = TRUE;
#line 350 "../lib/Widgets/TimePicker.vala"
							_tmp23_ = current;
#line 350 "../lib/Widgets/TimePicker.vala"
							_tmp24_ = g_strdup_printf ("%s%c", _tmp23_, (gint) c);
#line 350 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 350 "../lib/Widgets/TimePicker.vala"
							current = _tmp24_;
#line 1491 "TimePicker.c"
						}
					}
#line 354 "../lib/Widgets/TimePicker.vala"
					_tmp26_ = g_strdup_printf ("%c", c);
#line 354 "../lib/Widgets/TimePicker.vala"
					_tmp27_ = _tmp26_;
#line 354 "../lib/Widgets/TimePicker.vala"
					_tmp28_ = string_contains (_tmp27_, "m");
#line 354 "../lib/Widgets/TimePicker.vala"
					_g_free0 (_tmp27_);
#line 354 "../lib/Widgets/TimePicker.vala"
					if (_tmp28_) {
#line 354 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = is_suffix;
#line 1506 "TimePicker.c"
					} else {
#line 354 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = FALSE;
#line 1510 "TimePicker.c"
					}
#line 354 "../lib/Widgets/TimePicker.vala"
					if (_tmp25_) {
#line 1514 "TimePicker.c"
						gint* _tmp29_;
						gboolean _tmp33_ = FALSE;
						const gchar* _tmp34_;
						gboolean _tmp50_ = FALSE;
						const gchar* _tmp51_;
						GDateTime* _tmp58_;
						GDateTime* _tmp59_;
						gint* _tmp60_;
						GDateTime* _tmp61_;
						GDateTime* _tmp62_;
						GDateTime* _tmp63_;
						GDateTime* _tmp64_;
#line 355 "../lib/Widgets/TimePicker.vala"
						_tmp29_ = hour;
#line 355 "../lib/Widgets/TimePicker.vala"
						if (_tmp29_ == NULL) {
#line 356 "../lib/Widgets/TimePicker.vala"
							c_collection = (g_free (c_collection), NULL);
#line 356 "../lib/Widgets/TimePicker.vala"
							_g_free0 (minute);
#line 356 "../lib/Widgets/TimePicker.vala"
							_g_free0 (hour);
#line 356 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 356 "../lib/Widgets/TimePicker.vala"
							return;
#line 1541 "TimePicker.c"
						} else {
							gint* _tmp30_;
#line 357 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = minute;
#line 357 "../lib/Widgets/TimePicker.vala"
							if (_tmp30_ == NULL) {
#line 1548 "TimePicker.c"
								gint _tmp31_;
								gint* _tmp32_;
#line 358 "../lib/Widgets/TimePicker.vala"
								_tmp31_ = 0;
#line 358 "../lib/Widgets/TimePicker.vala"
								_tmp32_ = __int_dup0 (&_tmp31_);
#line 358 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 358 "../lib/Widgets/TimePicker.vala"
								minute = _tmp32_;
#line 1559 "TimePicker.c"
							}
						}
#line 362 "../lib/Widgets/TimePicker.vala"
						_tmp34_ = current;
#line 362 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp34_, "a")) {
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = TRUE;
#line 1568 "TimePicker.c"
						} else {
							gint* _tmp35_;
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp35_ = hour;
#line 362 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = (*_tmp35_) >= 12;
#line 1575 "TimePicker.c"
						}
#line 362 "../lib/Widgets/TimePicker.vala"
						if (_tmp33_) {
#line 1579 "TimePicker.c"
							GDateTime* _tmp36_;
							GDateTime* _tmp37_;
							gint* _tmp38_;
							GDateTime* _tmp39_;
							GDateTime* _tmp40_;
							GDateTime* _tmp41_;
							GDateTime* _tmp42_;
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp36_ = he_time_picker_get_time (self);
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp37_ = _tmp36_;
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp38_ = hour;
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp39_ = he_time_picker_get_time (self);
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp40_ = _tmp39_;
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp41_ = g_date_time_add_hours (_tmp37_, (*_tmp38_) - g_date_time_get_hour (_tmp40_));
#line 363 "../lib/Widgets/TimePicker.vala"
							_tmp42_ = _tmp41_;
#line 363 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp42_);
#line 363 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp42_);
#line 1605 "TimePicker.c"
						} else {
							GDateTime* _tmp43_;
							GDateTime* _tmp44_;
							gint* _tmp45_;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
							GDateTime* _tmp48_;
							GDateTime* _tmp49_;
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp43_ = he_time_picker_get_time (self);
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp44_ = _tmp43_;
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp45_ = hour;
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp46_ = he_time_picker_get_time (self);
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp47_ = _tmp46_;
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp48_ = g_date_time_add_hours (_tmp44_, ((*_tmp45_) + 12) - g_date_time_get_hour (_tmp47_));
#line 365 "../lib/Widgets/TimePicker.vala"
							_tmp49_ = _tmp48_;
#line 365 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp49_);
#line 365 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp49_);
#line 1632 "TimePicker.c"
						}
#line 368 "../lib/Widgets/TimePicker.vala"
						_tmp51_ = current;
#line 368 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp51_, "a")) {
#line 1638 "TimePicker.c"
							gint* _tmp52_;
							gint _tmp53_;
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp52_ = hour;
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp53_ = 12;
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = _int_equal (_tmp52_, &_tmp53_) == TRUE;
#line 1647 "TimePicker.c"
						} else {
#line 368 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = FALSE;
#line 1651 "TimePicker.c"
						}
#line 368 "../lib/Widgets/TimePicker.vala"
						if (_tmp50_) {
#line 1655 "TimePicker.c"
							GDateTime* _tmp54_;
							GDateTime* _tmp55_;
							GDateTime* _tmp56_;
							GDateTime* _tmp57_;
#line 369 "../lib/Widgets/TimePicker.vala"
							_tmp54_ = he_time_picker_get_time (self);
#line 369 "../lib/Widgets/TimePicker.vala"
							_tmp55_ = _tmp54_;
#line 369 "../lib/Widgets/TimePicker.vala"
							_tmp56_ = g_date_time_add_hours (_tmp55_, -12);
#line 369 "../lib/Widgets/TimePicker.vala"
							_tmp57_ = _tmp56_;
#line 369 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp57_);
#line 369 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp57_);
#line 1672 "TimePicker.c"
						}
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp58_ = he_time_picker_get_time (self);
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp59_ = _tmp58_;
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp60_ = minute;
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp61_ = he_time_picker_get_time (self);
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp62_ = _tmp61_;
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp63_ = g_date_time_add_minutes (_tmp59_, (*_tmp60_) - g_date_time_get_minute (_tmp62_));
#line 372 "../lib/Widgets/TimePicker.vala"
						_tmp64_ = _tmp63_;
#line 372 "../lib/Widgets/TimePicker.vala"
						he_time_picker_set_time (self, _tmp64_);
#line 372 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (_tmp64_);
#line 373 "../lib/Widgets/TimePicker.vala"
						has_suffix = TRUE;
#line 1694 "TimePicker.c"
					}
				}
			}
		}
#line 332 "../lib/Widgets/TimePicker.vala"
		c_collection = (g_free (c_collection), NULL);
#line 1701 "TimePicker.c"
	}
#line 378 "../lib/Widgets/TimePicker.vala"
	if (is_hours == FALSE) {
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = is_suffix == FALSE;
#line 1707 "TimePicker.c"
	} else {
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = FALSE;
#line 1711 "TimePicker.c"
	}
#line 378 "../lib/Widgets/TimePicker.vala"
	if (_tmp66_) {
#line 1715 "TimePicker.c"
		const gchar* _tmp67_;
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp67_ = current;
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = g_strcmp0 (_tmp67_, "") != 0;
#line 1721 "TimePicker.c"
	} else {
#line 378 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = FALSE;
#line 1725 "TimePicker.c"
	}
#line 378 "../lib/Widgets/TimePicker.vala"
	if (_tmp65_) {
#line 1729 "TimePicker.c"
		const gchar* _tmp68_;
		gint _tmp69_;
		gint* _tmp70_;
#line 379 "../lib/Widgets/TimePicker.vala"
		_tmp68_ = current;
#line 379 "../lib/Widgets/TimePicker.vala"
		_tmp69_ = atoi (_tmp68_);
#line 379 "../lib/Widgets/TimePicker.vala"
		_tmp70_ = __int_dup0 (&_tmp69_);
#line 379 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 379 "../lib/Widgets/TimePicker.vala"
		minute = _tmp70_;
#line 1743 "TimePicker.c"
	}
#line 382 "../lib/Widgets/TimePicker.vala"
	_tmp71_ = hour;
#line 382 "../lib/Widgets/TimePicker.vala"
	if (_tmp71_ == NULL) {
#line 1749 "TimePicker.c"
		const gchar* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
#line 383 "../lib/Widgets/TimePicker.vala"
		_tmp72_ = current;
#line 383 "../lib/Widgets/TimePicker.vala"
		_tmp73_ = strlen (_tmp72_);
#line 383 "../lib/Widgets/TimePicker.vala"
		_tmp74_ = _tmp73_;
#line 383 "../lib/Widgets/TimePicker.vala"
		if (_tmp74_ < 3) {
#line 1761 "TimePicker.c"
			const gchar* _tmp75_;
			gint _tmp76_;
			gint* _tmp77_;
			gint _tmp78_;
			gint* _tmp79_;
#line 384 "../lib/Widgets/TimePicker.vala"
			_tmp75_ = current;
#line 384 "../lib/Widgets/TimePicker.vala"
			_tmp76_ = atoi (_tmp75_);
#line 384 "../lib/Widgets/TimePicker.vala"
			_tmp77_ = __int_dup0 (&_tmp76_);
#line 384 "../lib/Widgets/TimePicker.vala"
			_g_free0 (hour);
#line 384 "../lib/Widgets/TimePicker.vala"
			hour = _tmp77_;
#line 385 "../lib/Widgets/TimePicker.vala"
			_tmp78_ = 0;
#line 385 "../lib/Widgets/TimePicker.vala"
			_tmp79_ = __int_dup0 (&_tmp78_);
#line 385 "../lib/Widgets/TimePicker.vala"
			_g_free0 (minute);
#line 385 "../lib/Widgets/TimePicker.vala"
			minute = _tmp79_;
#line 1785 "TimePicker.c"
		} else {
			const gchar* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
#line 386 "../lib/Widgets/TimePicker.vala"
			_tmp80_ = current;
#line 386 "../lib/Widgets/TimePicker.vala"
			_tmp81_ = strlen (_tmp80_);
#line 386 "../lib/Widgets/TimePicker.vala"
			_tmp82_ = _tmp81_;
#line 386 "../lib/Widgets/TimePicker.vala"
			if (_tmp82_ == 4) {
#line 1798 "TimePicker.c"
				const gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gint _tmp86_;
				gint* _tmp87_;
				const gchar* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				gint _tmp91_;
				gint* _tmp92_;
				gboolean _tmp93_ = FALSE;
				gint* _tmp94_;
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp83_ = current;
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp84_ = string_slice (_tmp83_, (glong) 0, (glong) 2);
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp85_ = _tmp84_;
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp86_ = atoi (_tmp85_);
#line 387 "../lib/Widgets/TimePicker.vala"
				_tmp87_ = __int_dup0 (&_tmp86_);
#line 387 "../lib/Widgets/TimePicker.vala"
				_g_free0 (hour);
#line 387 "../lib/Widgets/TimePicker.vala"
				hour = _tmp87_;
#line 387 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp85_);
#line 388 "../lib/Widgets/TimePicker.vala"
				_tmp88_ = current;
#line 388 "../lib/Widgets/TimePicker.vala"
				_tmp89_ = string_slice (_tmp88_, (glong) 2, (glong) 4);
#line 388 "../lib/Widgets/TimePicker.vala"
				_tmp90_ = _tmp89_;
#line 388 "../lib/Widgets/TimePicker.vala"
				_tmp91_ = atoi (_tmp90_);
#line 388 "../lib/Widgets/TimePicker.vala"
				_tmp92_ = __int_dup0 (&_tmp91_);
#line 388 "../lib/Widgets/TimePicker.vala"
				_g_free0 (minute);
#line 388 "../lib/Widgets/TimePicker.vala"
				minute = _tmp92_;
#line 388 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp90_);
#line 389 "../lib/Widgets/TimePicker.vala"
				_tmp94_ = hour;
#line 389 "../lib/Widgets/TimePicker.vala"
				if ((*_tmp94_) > 23) {
#line 389 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = TRUE;
#line 1849 "TimePicker.c"
				} else {
					gint* _tmp95_;
#line 389 "../lib/Widgets/TimePicker.vala"
					_tmp95_ = minute;
#line 389 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = (*_tmp95_) > 59;
#line 1856 "TimePicker.c"
				}
#line 389 "../lib/Widgets/TimePicker.vala"
				if (_tmp93_) {
#line 390 "../lib/Widgets/TimePicker.vala"
					_g_free0 (hour);
#line 390 "../lib/Widgets/TimePicker.vala"
					hour = NULL;
#line 391 "../lib/Widgets/TimePicker.vala"
					_g_free0 (minute);
#line 391 "../lib/Widgets/TimePicker.vala"
					minute = NULL;
#line 1868 "TimePicker.c"
				}
			}
		}
	}
#line 396 "../lib/Widgets/TimePicker.vala"
	_tmp97_ = hour;
#line 396 "../lib/Widgets/TimePicker.vala"
	if (_tmp97_ == NULL) {
#line 396 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = TRUE;
#line 1879 "TimePicker.c"
	} else {
		gint* _tmp98_;
#line 396 "../lib/Widgets/TimePicker.vala"
		_tmp98_ = minute;
#line 396 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = _tmp98_ == NULL;
#line 1886 "TimePicker.c"
	}
#line 396 "../lib/Widgets/TimePicker.vala"
	if (_tmp96_) {
#line 397 "../lib/Widgets/TimePicker.vala"
		he_time_picker_update_text (self, FALSE);
#line 398 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 398 "../lib/Widgets/TimePicker.vala"
		_g_free0 (hour);
#line 398 "../lib/Widgets/TimePicker.vala"
		_g_free0 (current);
#line 398 "../lib/Widgets/TimePicker.vala"
		return;
#line 1900 "TimePicker.c"
	}
#line 401 "../lib/Widgets/TimePicker.vala"
	if (has_suffix == FALSE) {
#line 1904 "TimePicker.c"
		GDateTime* _tmp99_;
		GDateTime* _tmp100_;
		gint* _tmp101_;
		GDateTime* _tmp102_;
		GDateTime* _tmp103_;
		GDateTime* _tmp104_;
		GDateTime* _tmp105_;
		GDateTime* _tmp106_;
		GDateTime* _tmp107_;
		gint* _tmp108_;
		GDateTime* _tmp109_;
		GDateTime* _tmp110_;
		GDateTime* _tmp111_;
		GDateTime* _tmp112_;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp99_ = he_time_picker_get_time (self);
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp100_ = _tmp99_;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp101_ = hour;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp102_ = he_time_picker_get_time (self);
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp103_ = _tmp102_;
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp104_ = g_date_time_add_hours (_tmp100_, (*_tmp101_) - g_date_time_get_hour (_tmp103_));
#line 402 "../lib/Widgets/TimePicker.vala"
		_tmp105_ = _tmp104_;
#line 402 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp105_);
#line 402 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp105_);
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp106_ = he_time_picker_get_time (self);
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp107_ = _tmp106_;
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp108_ = minute;
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp109_ = he_time_picker_get_time (self);
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp110_ = _tmp109_;
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp111_ = g_date_time_add_minutes (_tmp107_, (*_tmp108_) - g_date_time_get_minute (_tmp110_));
#line 403 "../lib/Widgets/TimePicker.vala"
		_tmp112_ = _tmp111_;
#line 403 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp112_);
#line 403 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp112_);
#line 1955 "TimePicker.c"
	}
#line 406 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 324 "../lib/Widgets/TimePicker.vala"
	_g_free0 (minute);
#line 324 "../lib/Widgets/TimePicker.vala"
	_g_free0 (hour);
#line 324 "../lib/Widgets/TimePicker.vala"
	_g_free0 (current);
#line 1965 "TimePicker.c"
}

static void
he_time_picker_update_text (HeTimePicker* self,
                            gboolean no_signal)
{
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 409 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 410 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 1979 "TimePicker.c"
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 411 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = he_time_picker_get_time (self);
#line 411 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = _tmp0_;
#line 411 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->_format_12;
#line 411 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = g_date_time_format (_tmp1_, _tmp2_);
#line 411 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = _tmp3_;
#line 411 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp4_);
#line 411 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp4_);
#line 1999 "TimePicker.c"
	} else {
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 413 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = he_time_picker_get_time (self);
#line 413 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 413 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = self->priv->_format_24;
#line 413 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 413 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = _tmp8_;
#line 413 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp9_);
#line 413 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp9_);
#line 2020 "TimePicker.c"
	}
#line 416 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 416 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = _tmp10_;
#line 416 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 416 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 416 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp12_;
#line 418 "../lib/Widgets/TimePicker.vala"
	if (no_signal == FALSE) {
#line 419 "../lib/Widgets/TimePicker.vala"
		g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 2036 "TimePicker.c"
	}
}

HeTimePicker*
he_time_picker_construct (GType object_type)
{
	HeTimePicker * self = NULL;
#line 19 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePicker*) g_object_new (object_type, NULL);
#line 19 "../lib/Widgets/TimePicker.vala"
	return self;
#line 2048 "TimePicker.c"
}

HeTimePicker*
he_time_picker_new (void)
{
#line 19 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_construct (HE_TYPE_TIME_PICKER);
#line 2056 "TimePicker.c"
}

static inline gpointer
he_time_picker_clock_widget_get_instance_private (HeTimePickerClockWidget* self)
{
	return G_STRUCT_MEMBER_P (self, HeTimePickerClockWidget_private_offset);
}

static gboolean
he_time_picker_clock_widget_get_selecting_hour (HeTimePickerClockWidget* self)
{
	gboolean result;
#line 439 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 439 "../lib/Widgets/TimePicker.vala"
	result = self->priv->_selecting_hour;
#line 439 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2075 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_selecting_hour (HeTimePickerClockWidget* self,
                                                gboolean value)
{
	gboolean old_value;
#line 439 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 439 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_clock_widget_get_selecting_hour (self);
#line 439 "../lib/Widgets/TimePicker.vala"
	if (old_value != value) {
#line 439 "../lib/Widgets/TimePicker.vala"
		self->priv->_selecting_hour = value;
#line 439 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY]);
#line 2093 "TimePicker.c"
	}
}

static gboolean
he_time_picker_clock_widget_get_is_military_mode (HeTimePickerClockWidget* self)
{
	gboolean result;
#line 440 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 440 "../lib/Widgets/TimePicker.vala"
	result = self->priv->_is_military_mode;
#line 440 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2107 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_is_military_mode (HeTimePickerClockWidget* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 440 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 440 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_clock_widget_get_is_military_mode (self);
#line 440 "../lib/Widgets/TimePicker.vala"
	if (old_value != value) {
#line 440 "../lib/Widgets/TimePicker.vala"
		self->priv->_is_military_mode = value;
#line 440 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY]);
#line 2125 "TimePicker.c"
	}
}

static void
he_time_picker_clock_widget_get_accent_color (HeTimePickerClockWidget* self,
                                              GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 450 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 450 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_accent_color;
#line 450 "../lib/Widgets/TimePicker.vala"
	*result = _tmp0_;
#line 450 "../lib/Widgets/TimePicker.vala"
	return;
#line 2142 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_accent_color (HeTimePickerClockWidget* self,
                                              GdkRGBA * value)
{
	GdkRGBA _tmp0_;
#line 451 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 451 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = *value;
#line 451 "../lib/Widgets/TimePicker.vala"
	self->priv->_accent_color = _tmp0_;
#line 451 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 451 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY]);
#line 2160 "TimePicker.c"
}

static gint
he_time_picker_clock_widget_get_hour (HeTimePickerClockWidget* self)
{
	gint result;
#line 455 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 455 "../lib/Widgets/TimePicker.vala"
	result = self->priv->selected_hour;
#line 455 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2173 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_hour (HeTimePickerClockWidget* self,
                                      gint value)
{
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
#line 456 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 457 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_is_military_mode;
#line 457 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_) {
#line 457 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2192 "TimePicker.c"
	} else {
#line 457 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2196 "TimePicker.c"
	}
#line 457 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_is_military_mode;
#line 457 "../lib/Widgets/TimePicker.vala"
	if (_tmp3_) {
#line 457 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2204 "TimePicker.c"
	} else {
#line 457 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2208 "TimePicker.c"
	}
#line 457 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_hour = (((gint) ((value * _tmp0_) / (2 * G_PI))) + 3) % _tmp2_;
#line 458 "../lib/Widgets/TimePicker.vala"
	if (self->priv->selected_hour == 0) {
#line 2214 "TimePicker.c"
		gint _tmp4_ = 0;
		gboolean _tmp5_;
#line 458 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = self->priv->_is_military_mode;
#line 458 "../lib/Widgets/TimePicker.vala"
		if (_tmp5_) {
#line 458 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 2223 "TimePicker.c"
		} else {
#line 458 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 2227 "TimePicker.c"
		}
#line 458 "../lib/Widgets/TimePicker.vala"
		self->priv->selected_hour = _tmp4_;
#line 2231 "TimePicker.c"
	}
#line 459 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 456 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY]);
#line 2237 "TimePicker.c"
}

static gint
he_time_picker_clock_widget_get_minute (HeTimePickerClockWidget* self)
{
	gint result;
#line 464 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 464 "../lib/Widgets/TimePicker.vala"
	result = self->priv->selected_minute;
#line 464 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2250 "TimePicker.c"
}

static void
he_time_picker_clock_widget_set_minute (HeTimePickerClockWidget* self,
                                        gint value)
{
#line 465 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 466 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_minute = ((gint) round (((value * 30) / G_PI) + 15)) % HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 467 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 465 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY]);
#line 2265 "TimePicker.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 423 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (n_param_values == 3);
#line 423 "../lib/Widgets/TimePicker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 423 "../lib/Widgets/TimePicker.vala"
		data1 = closure->data;
#line 423 "../lib/Widgets/TimePicker.vala"
		data2 = param_values->data[0].v_pointer;
#line 2290 "TimePicker.c"
	} else {
#line 423 "../lib/Widgets/TimePicker.vala"
		data1 = param_values->data[0].v_pointer;
#line 423 "../lib/Widgets/TimePicker.vala"
		data2 = closure->data;
#line 2296 "TimePicker.c"
	}
#line 423 "../lib/Widgets/TimePicker.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 423 "../lib/Widgets/TimePicker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2302 "TimePicker.c"
}

static void
_he_time_picker_clock_widget_update_accent_color_g_object_notify (GObject* _sender,
                                                                  GParamSpec* pspec,
                                                                  gpointer self)
{
#line 477 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_accent_color ((HeTimePickerClockWidget*) self);
#line 2312 "TimePicker.c"
}

static void
_he_time_picker_clock_widget_update_accent_color_he_application_accent_color_changed (HeApplication* _sender,
                                                                                      gpointer self)
{
#line 483 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_accent_color ((HeTimePickerClockWidget*) self);
#line 2321 "TimePicker.c"
}

static void
__lambda163_ (HeTimePickerClockWidget* self)
{
	HeApplication* app = NULL;
	HeApplication* _tmp0_;
	HeApplication* _tmp1_;
#line 481 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = he_time_picker_clock_widget_get_he_application (self);
#line 481 "../lib/Widgets/TimePicker.vala"
	app = _tmp0_;
#line 482 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = app;
#line 482 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_ != NULL) {
#line 2338 "TimePicker.c"
		HeApplication* _tmp2_;
#line 483 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = app;
#line 483 "../lib/Widgets/TimePicker.vala"
		g_signal_connect_object (_tmp2_, "accent-color-changed", (GCallback) _he_time_picker_clock_widget_update_accent_color_he_application_accent_color_changed, self, 0);
#line 484 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_update_accent_color (self);
#line 2346 "TimePicker.c"
	}
#line 480 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (app);
#line 2350 "TimePicker.c"
}

static void
___lambda163__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 480 "../lib/Widgets/TimePicker.vala"
	__lambda163_ ((HeTimePickerClockWidget*) self);
#line 2360 "TimePicker.c"
}

static HeTimePickerClockWidget*
he_time_picker_clock_widget_construct (GType object_type)
{
	HeTimePickerClockWidget * self = NULL;
	gboolean _tmp0_ = FALSE;
	HeDesktop* _tmp1_;
	HeDesktopColorScheme _tmp2_;
	HeDesktopColorScheme _tmp3_;
	HeDesktop* _tmp4_;
#line 473 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePickerClockWidget*) g_object_new (object_type, NULL);
#line 474 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->desktop;
#line 474 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = he_desktop_get_prefers_color_scheme (_tmp1_);
#line 474 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 474 "../lib/Widgets/TimePicker.vala"
	if (_tmp3_ == HE_DESKTOP_COLOR_SCHEME_DARK) {
#line 474 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = TRUE;
#line 2384 "TimePicker.c"
	} else {
#line 474 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 2388 "TimePicker.c"
	}
#line 474 "../lib/Widgets/TimePicker.vala"
	self->priv->is_dark = _tmp0_;
#line 477 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = self->priv->desktop;
#line 477 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::accent-color", (GCallback) _he_time_picker_clock_widget_update_accent_color_g_object_notify, self, 0);
#line 480 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GObject*) self, "notify::root", (GCallback) ___lambda163__g_object_notify, self, 0);
#line 488 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_accent_color (self);
#line 473 "../lib/Widgets/TimePicker.vala"
	return self;
#line 2402 "TimePicker.c"
}

static HeTimePickerClockWidget*
he_time_picker_clock_widget_new (void)
{
#line 473 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_clock_widget_construct (HE_TIME_PICKER_TYPE_CLOCK_WIDGET);
#line 2410 "TimePicker.c"
}

/**
         * Gets the He.Application instance from the widget hierarchy.
         */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 495 "../lib/Widgets/TimePicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 2421 "TimePicker.c"
}

static HeApplication*
he_time_picker_clock_widget_get_he_application (HeTimePickerClockWidget* self)
{
	GtkRoot* root = NULL;
	GtkRoot* _tmp0_;
	GtkRoot* _tmp1_;
	GtkRoot* _tmp2_;
	HeApplication* result;
#line 494 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 495 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 495 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 495 "../lib/Widgets/TimePicker.vala"
	root = _tmp1_;
#line 496 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = root;
#line 496 "../lib/Widgets/TimePicker.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ())) {
#line 2444 "TimePicker.c"
		GtkApplication* app = NULL;
		GtkRoot* _tmp3_;
		GtkApplication* _tmp4_;
		GtkApplication* _tmp5_;
		GtkApplication* _tmp6_;
#line 497 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = root;
#line 497 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
#line 497 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 497 "../lib/Widgets/TimePicker.vala"
		app = _tmp5_;
#line 498 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = app;
#line 498 "../lib/Widgets/TimePicker.vala"
		if (HE_IS_APPLICATION (_tmp6_)) {
#line 2462 "TimePicker.c"
			GtkApplication* _tmp7_;
			HeApplication* _tmp8_;
#line 499 "../lib/Widgets/TimePicker.vala"
			_tmp7_ = app;
#line 499 "../lib/Widgets/TimePicker.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, HE_TYPE_APPLICATION, HeApplication));
#line 499 "../lib/Widgets/TimePicker.vala"
			result = _tmp8_;
#line 499 "../lib/Widgets/TimePicker.vala"
			_g_object_unref0 (app);
#line 499 "../lib/Widgets/TimePicker.vala"
			_g_object_unref0 (root);
#line 499 "../lib/Widgets/TimePicker.vala"
			return result;
#line 2477 "TimePicker.c"
		}
#line 496 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (app);
#line 2481 "TimePicker.c"
	}
#line 502 "../lib/Widgets/TimePicker.vala"
	result = NULL;
#line 502 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (root);
#line 502 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2489 "TimePicker.c"
}

static gpointer
_he_rgb_color_dup0 (gpointer self)
{
#line 518 "../lib/Widgets/TimePicker.vala"
	return self ? he_rgb_color_dup (self) : NULL;
#line 2497 "TimePicker.c"
}

static void
he_time_picker_clock_widget_update_accent_color (HeTimePickerClockWidget* self)
{
	HeRGBColor* effective_color = NULL;
	gboolean is_from_application = FALSE;
	HeApplication* app = NULL;
	HeApplication* _tmp0_;
	HeApplication* _tmp1_;
	HeRGBColor* _tmp11_;
	HeRGBColor* _tmp16_;
#line 505 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 506 "../lib/Widgets/TimePicker.vala"
	effective_color = NULL;
#line 507 "../lib/Widgets/TimePicker.vala"
	is_from_application = FALSE;
#line 510 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = he_time_picker_clock_widget_get_he_application (self);
#line 510 "../lib/Widgets/TimePicker.vala"
	app = _tmp0_;
#line 511 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = app;
#line 511 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_ != NULL) {
#line 2524 "TimePicker.c"
		HeApplication* _tmp2_;
		HeRGBColor* _tmp3_;
		gboolean _tmp4_ = FALSE;
		HeApplication* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 512 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = app;
#line 512 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = he_application_get_effective_accent_color (_tmp2_);
#line 512 "../lib/Widgets/TimePicker.vala"
		_he_rgb_color_free0 (effective_color);
#line 512 "../lib/Widgets/TimePicker.vala"
		effective_color = _tmp3_;
#line 513 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = app;
#line 513 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = he_application_get_is_content (_tmp5_);
#line 513 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = _tmp6_;
#line 513 "../lib/Widgets/TimePicker.vala"
		if (_tmp7_) {
#line 2547 "TimePicker.c"
			HeApplication* _tmp8_;
			HeRGBColor* _tmp9_;
			HeRGBColor* _tmp10_;
#line 513 "../lib/Widgets/TimePicker.vala"
			_tmp8_ = app;
#line 513 "../lib/Widgets/TimePicker.vala"
			_tmp9_ = he_application_get_default_accent_color (_tmp8_);
#line 513 "../lib/Widgets/TimePicker.vala"
			_tmp10_ = _tmp9_;
#line 513 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = _tmp10_ != NULL;
#line 2559 "TimePicker.c"
		} else {
#line 513 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = FALSE;
#line 2563 "TimePicker.c"
		}
#line 513 "../lib/Widgets/TimePicker.vala"
		is_from_application = _tmp4_;
#line 2567 "TimePicker.c"
	}
#line 517 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = effective_color;
#line 517 "../lib/Widgets/TimePicker.vala"
	if (_tmp11_ == NULL) {
#line 2573 "TimePicker.c"
		HeDesktop* _tmp12_;
		HeRGBColor* _tmp13_;
		HeRGBColor* _tmp14_;
		HeRGBColor* _tmp15_;
#line 518 "../lib/Widgets/TimePicker.vala"
		_tmp12_ = self->priv->desktop;
#line 518 "../lib/Widgets/TimePicker.vala"
		_tmp13_ = he_desktop_get_accent_color (_tmp12_);
#line 518 "../lib/Widgets/TimePicker.vala"
		_tmp14_ = _tmp13_;
#line 518 "../lib/Widgets/TimePicker.vala"
		_tmp15_ = _he_rgb_color_dup0 (_tmp14_);
#line 518 "../lib/Widgets/TimePicker.vala"
		_he_rgb_color_free0 (effective_color);
#line 518 "../lib/Widgets/TimePicker.vala"
		effective_color = _tmp15_;
#line 2590 "TimePicker.c"
	}
#line 521 "../lib/Widgets/TimePicker.vala"
	_tmp16_ = effective_color;
#line 521 "../lib/Widgets/TimePicker.vala"
	if (_tmp16_ != NULL) {
#line 2596 "TimePicker.c"
		gfloat r = 0.0F;
		gfloat g = 0.0F;
		gfloat b = 0.0F;
		GdkRGBA _tmp23_ = {0};
		const gchar* _tmp24_ = NULL;
		HeRGBColor* _tmp25_;
		HeRGBColor* _tmp26_;
		HeRGBColor* _tmp27_;
#line 524 "../lib/Widgets/TimePicker.vala"
		if (is_from_application) {
#line 2607 "TimePicker.c"
			HeRGBColor* _tmp17_;
			HeRGBColor* _tmp18_;
			HeRGBColor* _tmp19_;
#line 526 "../lib/Widgets/TimePicker.vala"
			_tmp17_ = effective_color;
#line 526 "../lib/Widgets/TimePicker.vala"
			r = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp17_).r))) / 255.0f;
#line 527 "../lib/Widgets/TimePicker.vala"
			_tmp18_ = effective_color;
#line 527 "../lib/Widgets/TimePicker.vala"
			g = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp18_).g))) / 255.0f;
#line 528 "../lib/Widgets/TimePicker.vala"
			_tmp19_ = effective_color;
#line 528 "../lib/Widgets/TimePicker.vala"
			b = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp19_).b))) / 255.0f;
#line 2623 "TimePicker.c"
		} else {
			HeRGBColor* _tmp20_;
			HeRGBColor* _tmp21_;
			HeRGBColor* _tmp22_;
#line 531 "../lib/Widgets/TimePicker.vala"
			_tmp20_ = effective_color;
#line 531 "../lib/Widgets/TimePicker.vala"
			r = (gfloat) fmax (0.0, fmin (1.0, (*_tmp20_).r));
#line 532 "../lib/Widgets/TimePicker.vala"
			_tmp21_ = effective_color;
#line 532 "../lib/Widgets/TimePicker.vala"
			g = (gfloat) fmax (0.0, fmin (1.0, (*_tmp21_).g));
#line 533 "../lib/Widgets/TimePicker.vala"
			_tmp22_ = effective_color;
#line 533 "../lib/Widgets/TimePicker.vala"
			b = (gfloat) fmax (0.0, fmin (1.0, (*_tmp22_).b));
#line 2640 "TimePicker.c"
		}
#line 536 "../lib/Widgets/TimePicker.vala"
		_tmp23_.red = r;
#line 536 "../lib/Widgets/TimePicker.vala"
		_tmp23_.green = g;
#line 536 "../lib/Widgets/TimePicker.vala"
		_tmp23_.blue = b;
#line 536 "../lib/Widgets/TimePicker.vala"
		_tmp23_.alpha = 1.0f;
#line 536 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_accent_color (self, &_tmp23_);
#line 540 "../lib/Widgets/TimePicker.vala"
		if (is_from_application) {
#line 540 "../lib/Widgets/TimePicker.vala"
			_tmp24_ = "application";
#line 2656 "TimePicker.c"
		} else {
#line 540 "../lib/Widgets/TimePicker.vala"
			_tmp24_ = "desktop";
#line 2660 "TimePicker.c"
		}
#line 539 "../lib/Widgets/TimePicker.vala"
		_tmp25_ = effective_color;
#line 539 "../lib/Widgets/TimePicker.vala"
		_tmp26_ = effective_color;
#line 539 "../lib/Widgets/TimePicker.vala"
		_tmp27_ = effective_color;
#line 539 "../lib/Widgets/TimePicker.vala"
		g_print ("TimePicker accent color updated: r=%f, g=%f, b=%f (from %s, original: " \
"%f,%f,%f)\n", (gdouble) r, (gdouble) g, (gdouble) b, _tmp24_, (*_tmp25_).r, (*_tmp26_).g, (*_tmp27_).b);
#line 2670 "TimePicker.c"
	} else {
		GdkRGBA _tmp28_ = {0};
#line 544 "../lib/Widgets/TimePicker.vala"
		_tmp28_.red = 0.2f;
#line 544 "../lib/Widgets/TimePicker.vala"
		_tmp28_.green = 0.6f;
#line 544 "../lib/Widgets/TimePicker.vala"
		_tmp28_.blue = 1.0f;
#line 544 "../lib/Widgets/TimePicker.vala"
		_tmp28_.alpha = 1.0f;
#line 544 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_accent_color (self, &_tmp28_);
#line 545 "../lib/Widgets/TimePicker.vala"
		g_print ("TimePicker using fallback accent color\n");
#line 2685 "TimePicker.c"
	}
#line 505 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (app);
#line 505 "../lib/Widgets/TimePicker.vala"
	_he_rgb_color_free0 (effective_color);
#line 2691 "TimePicker.c"
}

static void
he_time_picker_clock_widget_real_dispose (GObject* base)
{
	HeTimePickerClockWidget * self;
#line 579 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePickerClockWidget*) base;
#line 580 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_reset_to_hour_selection (self);
#line 581 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_clock_widget_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 2704 "TimePicker.c"
}

static void
he_time_picker_clock_widget_real_snapshot (GtkWidget* base,
                                           GtkSnapshot* snapshot)
{
	HeTimePickerClockWidget * self;
	graphene_rect_t rect = {0};
	cairo_t* cr = NULL;
	graphene_rect_t _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	cairo_t* _tmp7_;
	GdkRGBA _tmp8_ = {0};
	GdkRGBA _tmp9_;
	GdkRGBA _tmp10_ = {0};
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_ = {0};
	GdkRGBA _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
	gdouble _tmp16_ = 0.0;
	gboolean _tmp17_;
	gdouble hand_angle = 0.0;
	gdouble hand_radius = 0.0;
	gdouble hand_x = 0.0;
	gdouble hand_y = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	cairo_t* _tmp21_;
	GdkRGBA _tmp22_ = {0};
	GdkRGBA _tmp23_;
	GdkRGBA _tmp24_ = {0};
	GdkRGBA _tmp25_;
	GdkRGBA _tmp26_ = {0};
	GdkRGBA _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	cairo_t* _tmp33_;
	GdkRGBA _tmp34_ = {0};
	GdkRGBA _tmp35_;
	GdkRGBA _tmp36_ = {0};
	GdkRGBA _tmp37_;
	GdkRGBA _tmp38_ = {0};
	GdkRGBA _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	gdouble _tmp46_ = 0.0;
	cairo_t* _tmp47_;
	GdkRGBA _tmp48_ = {0};
	GdkRGBA _tmp49_;
	GdkRGBA _tmp50_ = {0};
	GdkRGBA _tmp51_;
	GdkRGBA _tmp52_ = {0};
	GdkRGBA _tmp53_;
	cairo_t* _tmp54_;
	cairo_t* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp92_;
#line 584 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePickerClockWidget*) base;
#line 584 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (snapshot != NULL);
#line 585 "../lib/Widgets/TimePicker.vala"
	memset (&rect, 0, sizeof (graphene_rect_t));
#line 586 "../lib/Widgets/TimePicker.vala"
	graphene_rect_init (&rect, (gfloat) 0, (gfloat) 0, (gfloat) HE_TIME_PICKER_CLOCK_WIDGET_SIZE, (gfloat) HE_TIME_PICKER_CLOCK_WIDGET_SIZE);
#line 587 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = rect;
#line 587 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = gtk_snapshot_append_cairo (snapshot, &_tmp0_);
#line 587 "../lib/Widgets/TimePicker.vala"
	cr = _tmp1_;
#line 588 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = cr;
#line 588 "../lib/Widgets/TimePicker.vala"
	cairo_set_line_width (_tmp2_, 1.0);
#line 591 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = cr;
#line 591 "../lib/Widgets/TimePicker.vala"
	cairo_select_font_face (_tmp3_, HE_TIME_PICKER_CLOCK_WIDGET_FONT_FAMILY, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
#line 594 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 594 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = 0.92;
#line 2802 "TimePicker.c"
	} else {
#line 594 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = 0.17;
#line 2806 "TimePicker.c"
	}
#line 594 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 594 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = 0.92;
#line 2812 "TimePicker.c"
	} else {
#line 594 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = 0.17;
#line 2816 "TimePicker.c"
	}
#line 594 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 594 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = 0.92;
#line 2822 "TimePicker.c"
	} else {
#line 594 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = 0.17;
#line 2826 "TimePicker.c"
	}
#line 594 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = cr;
#line 594 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp8_);
#line 594 "../lib/Widgets/TimePicker.vala"
	_tmp9_ = _tmp8_;
#line 594 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp10_);
#line 594 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = _tmp10_;
#line 594 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp12_);
#line 594 "../lib/Widgets/TimePicker.vala"
	_tmp13_ = _tmp12_;
#line 594 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp7_, _tmp4_ * _tmp9_.red, _tmp5_ * _tmp11_.green, _tmp6_ * _tmp13_.blue, 0.08);
#line 595 "../lib/Widgets/TimePicker.vala"
	_tmp14_ = cr;
#line 595 "../lib/Widgets/TimePicker.vala"
	cairo_arc (_tmp14_, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_RADIUS, (gdouble) 0, 2 * G_PI);
#line 596 "../lib/Widgets/TimePicker.vala"
	_tmp15_ = cr;
#line 596 "../lib/Widgets/TimePicker.vala"
	cairo_fill (_tmp15_);
#line 599 "../lib/Widgets/TimePicker.vala"
	_tmp17_ = self->priv->_selecting_hour;
#line 599 "../lib/Widgets/TimePicker.vala"
	if (_tmp17_) {
#line 599 "../lib/Widgets/TimePicker.vala"
		_tmp16_ = he_time_picker_clock_widget_get_hour_angle (self);
#line 2858 "TimePicker.c"
	} else {
#line 599 "../lib/Widgets/TimePicker.vala"
		_tmp16_ = he_time_picker_clock_widget_get_minute_angle (self);
#line 2862 "TimePicker.c"
	}
#line 599 "../lib/Widgets/TimePicker.vala"
	hand_angle = _tmp16_;
#line 600 "../lib/Widgets/TimePicker.vala"
	hand_radius = he_time_picker_clock_widget_get_hand_radius (self, HE_TIME_PICKER_CLOCK_WIDGET_RADIUS);
#line 601 "../lib/Widgets/TimePicker.vala"
	hand_x = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (hand_radius * cos (hand_angle));
#line 602 "../lib/Widgets/TimePicker.vala"
	hand_y = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (hand_radius * sin (hand_angle));
#line 603 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 603 "../lib/Widgets/TimePicker.vala"
		_tmp18_ = 0.50;
#line 2876 "TimePicker.c"
	} else {
#line 603 "../lib/Widgets/TimePicker.vala"
		_tmp18_ = 0.60;
#line 2880 "TimePicker.c"
	}
#line 603 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 603 "../lib/Widgets/TimePicker.vala"
		_tmp19_ = 0.50;
#line 2886 "TimePicker.c"
	} else {
#line 603 "../lib/Widgets/TimePicker.vala"
		_tmp19_ = 0.60;
#line 2890 "TimePicker.c"
	}
#line 603 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 603 "../lib/Widgets/TimePicker.vala"
		_tmp20_ = 0.50;
#line 2896 "TimePicker.c"
	} else {
#line 603 "../lib/Widgets/TimePicker.vala"
		_tmp20_ = 0.60;
#line 2900 "TimePicker.c"
	}
#line 603 "../lib/Widgets/TimePicker.vala"
	_tmp21_ = cr;
#line 603 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp22_);
#line 603 "../lib/Widgets/TimePicker.vala"
	_tmp23_ = _tmp22_;
#line 603 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp24_);
#line 603 "../lib/Widgets/TimePicker.vala"
	_tmp25_ = _tmp24_;
#line 603 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp26_);
#line 603 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = _tmp26_;
#line 603 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp21_, _tmp18_ * _tmp23_.red, _tmp19_ * _tmp25_.green, _tmp20_ * _tmp27_.blue, (gdouble) 1);
#line 604 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = cr;
#line 604 "../lib/Widgets/TimePicker.vala"
	cairo_arc (_tmp28_, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_HAND_CENTER_WIDTH, (gdouble) 0, 2 * G_PI);
#line 605 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = cr;
#line 605 "../lib/Widgets/TimePicker.vala"
	cairo_fill_preserve (_tmp29_);
#line 606 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 606 "../lib/Widgets/TimePicker.vala"
		_tmp30_ = 0.50;
#line 2930 "TimePicker.c"
	} else {
#line 606 "../lib/Widgets/TimePicker.vala"
		_tmp30_ = 0.60;
#line 2934 "TimePicker.c"
	}
#line 606 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 606 "../lib/Widgets/TimePicker.vala"
		_tmp31_ = 0.50;
#line 2940 "TimePicker.c"
	} else {
#line 606 "../lib/Widgets/TimePicker.vala"
		_tmp31_ = 0.60;
#line 2944 "TimePicker.c"
	}
#line 606 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 606 "../lib/Widgets/TimePicker.vala"
		_tmp32_ = 0.50;
#line 2950 "TimePicker.c"
	} else {
#line 606 "../lib/Widgets/TimePicker.vala"
		_tmp32_ = 0.60;
#line 2954 "TimePicker.c"
	}
#line 606 "../lib/Widgets/TimePicker.vala"
	_tmp33_ = cr;
#line 606 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp34_);
#line 606 "../lib/Widgets/TimePicker.vala"
	_tmp35_ = _tmp34_;
#line 606 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp36_);
#line 606 "../lib/Widgets/TimePicker.vala"
	_tmp37_ = _tmp36_;
#line 606 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp38_);
#line 606 "../lib/Widgets/TimePicker.vala"
	_tmp39_ = _tmp38_;
#line 606 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp33_, _tmp30_ * _tmp35_.red, _tmp31_ * _tmp37_.green, _tmp32_ * _tmp39_.blue, (gdouble) 1);
#line 607 "../lib/Widgets/TimePicker.vala"
	_tmp40_ = cr;
#line 607 "../lib/Widgets/TimePicker.vala"
	cairo_set_line_width (_tmp40_, HE_TIME_PICKER_CLOCK_WIDGET_HAND_LINE_WIDTH);
#line 608 "../lib/Widgets/TimePicker.vala"
	_tmp41_ = cr;
#line 608 "../lib/Widgets/TimePicker.vala"
	cairo_move_to (_tmp41_, HE_TIME_PICKER_CLOCK_WIDGET_CENTER, HE_TIME_PICKER_CLOCK_WIDGET_CENTER);
#line 609 "../lib/Widgets/TimePicker.vala"
	_tmp42_ = cr;
#line 609 "../lib/Widgets/TimePicker.vala"
	cairo_line_to (_tmp42_, hand_x, hand_y);
#line 610 "../lib/Widgets/TimePicker.vala"
	_tmp43_ = cr;
#line 610 "../lib/Widgets/TimePicker.vala"
	cairo_stroke (_tmp43_);
#line 611 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 611 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = 0.50;
#line 2992 "TimePicker.c"
	} else {
#line 611 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = 0.60;
#line 2996 "TimePicker.c"
	}
#line 611 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 611 "../lib/Widgets/TimePicker.vala"
		_tmp45_ = 0.50;
#line 3002 "TimePicker.c"
	} else {
#line 611 "../lib/Widgets/TimePicker.vala"
		_tmp45_ = 0.60;
#line 3006 "TimePicker.c"
	}
#line 611 "../lib/Widgets/TimePicker.vala"
	if (self->priv->is_dark) {
#line 611 "../lib/Widgets/TimePicker.vala"
		_tmp46_ = 0.50;
#line 3012 "TimePicker.c"
	} else {
#line 611 "../lib/Widgets/TimePicker.vala"
		_tmp46_ = 0.60;
#line 3016 "TimePicker.c"
	}
#line 611 "../lib/Widgets/TimePicker.vala"
	_tmp47_ = cr;
#line 611 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp48_);
#line 611 "../lib/Widgets/TimePicker.vala"
	_tmp49_ = _tmp48_;
#line 611 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp50_);
#line 611 "../lib/Widgets/TimePicker.vala"
	_tmp51_ = _tmp50_;
#line 611 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_get_accent_color (self, &_tmp52_);
#line 611 "../lib/Widgets/TimePicker.vala"
	_tmp53_ = _tmp52_;
#line 611 "../lib/Widgets/TimePicker.vala"
	cairo_set_source_rgba (_tmp47_, _tmp44_ * _tmp49_.red, _tmp45_ * _tmp51_.green, _tmp46_ * _tmp53_.blue, (gdouble) 1);
#line 612 "../lib/Widgets/TimePicker.vala"
	_tmp54_ = cr;
#line 612 "../lib/Widgets/TimePicker.vala"
	cairo_arc (_tmp54_, hand_x, hand_y, HE_TIME_PICKER_CLOCK_WIDGET_SELECTION_CIRCLE_RADIUS, (gdouble) 0, 2 * G_PI);
#line 613 "../lib/Widgets/TimePicker.vala"
	_tmp55_ = cr;
#line 613 "../lib/Widgets/TimePicker.vala"
	cairo_fill (_tmp55_);
#line 616 "../lib/Widgets/TimePicker.vala"
	_tmp56_ = self->priv->_selecting_hour;
#line 616 "../lib/Widgets/TimePicker.vala"
	if (!_tmp56_) {
#line 3046 "TimePicker.c"
		{
			gint i = 0;
#line 617 "../lib/Widgets/TimePicker.vala"
			i = 0;
#line 3051 "TimePicker.c"
			{
				gboolean _tmp57_ = FALSE;
#line 617 "../lib/Widgets/TimePicker.vala"
				_tmp57_ = TRUE;
#line 617 "../lib/Widgets/TimePicker.vala"
				while (TRUE) {
#line 3058 "TimePicker.c"
					gdouble minute_angle = 0.0;
					gdouble minute_x = 0.0;
					gdouble minute_y = 0.0;
					gdouble selection_angle = 0.0;
					gdouble label_angle = 0.0;
					gboolean is_selected = FALSE;
#line 617 "../lib/Widgets/TimePicker.vala"
					if (!_tmp57_) {
#line 617 "../lib/Widgets/TimePicker.vala"
						i += 5;
#line 3069 "TimePicker.c"
					}
#line 617 "../lib/Widgets/TimePicker.vala"
					_tmp57_ = FALSE;
#line 617 "../lib/Widgets/TimePicker.vala"
					if (!(i < HE_TIME_PICKER_CLOCK_WIDGET_MINUTES)) {
#line 617 "../lib/Widgets/TimePicker.vala"
						break;
#line 3077 "TimePicker.c"
					}
#line 618 "../lib/Widgets/TimePicker.vala"
					minute_angle = ((i - 15) * (2 * G_PI)) / HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 619 "../lib/Widgets/TimePicker.vala"
					minute_x = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS * cos (minute_angle));
#line 620 "../lib/Widgets/TimePicker.vala"
					minute_y = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS * sin (minute_angle));
#line 622 "../lib/Widgets/TimePicker.vala"
					selection_angle = he_time_picker_clock_widget_get_minute_angle (self);
#line 623 "../lib/Widgets/TimePicker.vala"
					if (selection_angle < ((-G_PI) / 2)) {
#line 624 "../lib/Widgets/TimePicker.vala"
						selection_angle += 2 * G_PI;
#line 3091 "TimePicker.c"
					}
#line 626 "../lib/Widgets/TimePicker.vala"
					label_angle = minute_angle;
#line 627 "../lib/Widgets/TimePicker.vala"
					if (label_angle < ((-G_PI) / 2)) {
#line 628 "../lib/Widgets/TimePicker.vala"
						label_angle += 2 * G_PI;
#line 3099 "TimePicker.c"
					}
#line 631 "../lib/Widgets/TimePicker.vala"
					is_selected = fabs (selection_angle - label_angle) < (G_PI / HE_TIME_PICKER_CLOCK_WIDGET_MINUTES);
#line 633 "../lib/Widgets/TimePicker.vala"
					if (is_selected) {
#line 3105 "TimePicker.c"
						gdouble _tmp58_ = 0.0;
						gdouble _tmp61_ = 0.0;
						gdouble _tmp64_ = 0.0;
						cairo_t* _tmp67_;
						cairo_t* _tmp68_;
						cairo_t* _tmp72_;
						gchar* _tmp73_;
						gchar* _tmp74_;
#line 634 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3116 "TimePicker.c"
							GdkRGBA _tmp59_ = {0};
							GdkRGBA _tmp60_;
#line 634 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp59_);
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp60_ = _tmp59_;
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp58_ = 0.20 * _tmp60_.red;
#line 3125 "TimePicker.c"
						} else {
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp58_ = 1.0;
#line 3129 "TimePicker.c"
						}
#line 634 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3133 "TimePicker.c"
							GdkRGBA _tmp62_ = {0};
							GdkRGBA _tmp63_;
#line 634 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp62_);
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp63_ = _tmp62_;
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp61_ = 0.20 * _tmp63_.green;
#line 3142 "TimePicker.c"
						} else {
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp61_ = 1.0;
#line 3146 "TimePicker.c"
						}
#line 634 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3150 "TimePicker.c"
							GdkRGBA _tmp65_ = {0};
							GdkRGBA _tmp66_;
#line 634 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp65_);
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp66_ = _tmp65_;
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp64_ = 0.20 * _tmp66_.blue;
#line 3159 "TimePicker.c"
						} else {
#line 634 "../lib/Widgets/TimePicker.vala"
							_tmp64_ = 1.0;
#line 3163 "TimePicker.c"
						}
#line 634 "../lib/Widgets/TimePicker.vala"
						_tmp67_ = cr;
#line 634 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp67_, _tmp58_, _tmp61_, _tmp64_, (gdouble) 1);
#line 635 "../lib/Widgets/TimePicker.vala"
						_tmp68_ = cr;
#line 635 "../lib/Widgets/TimePicker.vala"
						cairo_set_font_size (_tmp68_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 637 "../lib/Widgets/TimePicker.vala"
						if (i >= 6) {
#line 3175 "TimePicker.c"
							cairo_t* _tmp69_;
#line 638 "../lib/Widgets/TimePicker.vala"
							_tmp69_ = cr;
#line 638 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp69_, minute_x - (18 / 2.0), minute_y + (16 / 2.0));
#line 3181 "TimePicker.c"
						} else {
#line 639 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 3185 "TimePicker.c"
								cairo_t* _tmp70_;
#line 640 "../lib/Widgets/TimePicker.vala"
								_tmp70_ = cr;
#line 640 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp70_, minute_x - (6 / 2.0), minute_y + (16 / 2.0));
#line 3191 "TimePicker.c"
							} else {
								cairo_t* _tmp71_;
#line 642 "../lib/Widgets/TimePicker.vala"
								_tmp71_ = cr;
#line 642 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp71_, minute_x - (10 / 2.0), minute_y + (16 / 2.0));
#line 3198 "TimePicker.c"
							}
						}
#line 644 "../lib/Widgets/TimePicker.vala"
						_tmp72_ = cr;
#line 644 "../lib/Widgets/TimePicker.vala"
						_tmp73_ = g_strdup_printf ("%i", i);
#line 644 "../lib/Widgets/TimePicker.vala"
						_tmp74_ = _tmp73_;
#line 644 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp72_, _tmp74_);
#line 644 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp74_);
#line 3211 "TimePicker.c"
					} else {
						gdouble _tmp75_ = 0.0;
						gdouble _tmp76_ = 0.0;
						gdouble _tmp77_ = 0.0;
						cairo_t* _tmp78_;
						GdkRGBA _tmp79_ = {0};
						GdkRGBA _tmp80_;
						GdkRGBA _tmp81_ = {0};
						GdkRGBA _tmp82_;
						GdkRGBA _tmp83_ = {0};
						GdkRGBA _tmp84_;
						cairo_t* _tmp85_;
						cairo_t* _tmp89_;
						gchar* _tmp90_;
						gchar* _tmp91_;
#line 646 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 646 "../lib/Widgets/TimePicker.vala"
							_tmp75_ = 0.99;
#line 3231 "TimePicker.c"
						} else {
#line 646 "../lib/Widgets/TimePicker.vala"
							_tmp75_ = 0.10;
#line 3235 "TimePicker.c"
						}
#line 646 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 646 "../lib/Widgets/TimePicker.vala"
							_tmp76_ = 0.99;
#line 3241 "TimePicker.c"
						} else {
#line 646 "../lib/Widgets/TimePicker.vala"
							_tmp76_ = 0.10;
#line 3245 "TimePicker.c"
						}
#line 646 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 646 "../lib/Widgets/TimePicker.vala"
							_tmp77_ = 0.99;
#line 3251 "TimePicker.c"
						} else {
#line 646 "../lib/Widgets/TimePicker.vala"
							_tmp77_ = 0.10;
#line 3255 "TimePicker.c"
						}
#line 646 "../lib/Widgets/TimePicker.vala"
						_tmp78_ = cr;
#line 646 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp79_);
#line 646 "../lib/Widgets/TimePicker.vala"
						_tmp80_ = _tmp79_;
#line 646 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp81_);
#line 646 "../lib/Widgets/TimePicker.vala"
						_tmp82_ = _tmp81_;
#line 646 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp83_);
#line 646 "../lib/Widgets/TimePicker.vala"
						_tmp84_ = _tmp83_;
#line 646 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp78_, _tmp75_ * _tmp80_.red, _tmp76_ * _tmp82_.green, _tmp77_ * _tmp84_.blue, (gdouble) 1);
#line 647 "../lib/Widgets/TimePicker.vala"
						_tmp85_ = cr;
#line 647 "../lib/Widgets/TimePicker.vala"
						cairo_set_font_size (_tmp85_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 649 "../lib/Widgets/TimePicker.vala"
						if (i >= 6) {
#line 3279 "TimePicker.c"
							cairo_t* _tmp86_;
#line 650 "../lib/Widgets/TimePicker.vala"
							_tmp86_ = cr;
#line 650 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp86_, minute_x - (18 / 2.0), minute_y + (16 / 2.0));
#line 3285 "TimePicker.c"
						} else {
#line 651 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 3289 "TimePicker.c"
								cairo_t* _tmp87_;
#line 652 "../lib/Widgets/TimePicker.vala"
								_tmp87_ = cr;
#line 652 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp87_, minute_x - (6 / 2.0), minute_y + (16 / 2.0));
#line 3295 "TimePicker.c"
							} else {
								cairo_t* _tmp88_;
#line 654 "../lib/Widgets/TimePicker.vala"
								_tmp88_ = cr;
#line 654 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp88_, minute_x - (10 / 2.0), minute_y + (16 / 2.0));
#line 3302 "TimePicker.c"
							}
						}
#line 656 "../lib/Widgets/TimePicker.vala"
						_tmp89_ = cr;
#line 656 "../lib/Widgets/TimePicker.vala"
						_tmp90_ = g_strdup_printf ("%i", i);
#line 656 "../lib/Widgets/TimePicker.vala"
						_tmp91_ = _tmp90_;
#line 656 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp89_, _tmp91_);
#line 656 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp91_);
#line 3315 "TimePicker.c"
					}
				}
			}
		}
	}
#line 662 "../lib/Widgets/TimePicker.vala"
	_tmp92_ = self->priv->_selecting_hour;
#line 662 "../lib/Widgets/TimePicker.vala"
	if (_tmp92_) {
#line 3325 "TimePicker.c"
		gint _tmp93_ = 0;
		gboolean _tmp94_;
		gint hour_count = 0;
#line 663 "../lib/Widgets/TimePicker.vala"
		_tmp94_ = self->priv->_is_military_mode;
#line 663 "../lib/Widgets/TimePicker.vala"
		if (_tmp94_) {
#line 663 "../lib/Widgets/TimePicker.vala"
			_tmp93_ = HE_TIME_PICKER_CLOCK_WIDGET_FULL_DAY;
#line 3335 "TimePicker.c"
		} else {
#line 663 "../lib/Widgets/TimePicker.vala"
			_tmp93_ = HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3339 "TimePicker.c"
		}
#line 663 "../lib/Widgets/TimePicker.vala"
		hour_count = _tmp93_;
#line 3343 "TimePicker.c"
		{
			gint i = 0;
#line 665 "../lib/Widgets/TimePicker.vala"
			i = 1;
#line 3348 "TimePicker.c"
			{
				gboolean _tmp95_ = FALSE;
#line 665 "../lib/Widgets/TimePicker.vala"
				_tmp95_ = TRUE;
#line 665 "../lib/Widgets/TimePicker.vala"
				while (TRUE) {
#line 3355 "TimePicker.c"
					gdouble hour_angle = 0.0;
					gdouble _tmp97_ = 0.0;
					gboolean _tmp98_ = FALSE;
					gdouble label_radius = 0.0;
					gdouble label_x = 0.0;
					gdouble label_y = 0.0;
					gdouble selection_angle = 0.0;
					gdouble label_angle = 0.0;
					gboolean is_selected = FALSE;
#line 665 "../lib/Widgets/TimePicker.vala"
					if (!_tmp95_) {
#line 3367 "TimePicker.c"
						gint _tmp96_;
#line 665 "../lib/Widgets/TimePicker.vala"
						_tmp96_ = i;
#line 665 "../lib/Widgets/TimePicker.vala"
						i = _tmp96_ + 1;
#line 3373 "TimePicker.c"
					}
#line 665 "../lib/Widgets/TimePicker.vala"
					_tmp95_ = FALSE;
#line 665 "../lib/Widgets/TimePicker.vala"
					if (!(i <= hour_count)) {
#line 665 "../lib/Widgets/TimePicker.vala"
						break;
#line 3381 "TimePicker.c"
					}
#line 666 "../lib/Widgets/TimePicker.vala"
					hour_angle = ((i - 3) * G_PI) / (HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY / 2);
#line 667 "../lib/Widgets/TimePicker.vala"
					if (i > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3387 "TimePicker.c"
						gboolean _tmp99_;
#line 667 "../lib/Widgets/TimePicker.vala"
						_tmp99_ = self->priv->_is_military_mode;
#line 667 "../lib/Widgets/TimePicker.vala"
						_tmp98_ = _tmp99_;
#line 3393 "TimePicker.c"
					} else {
#line 667 "../lib/Widgets/TimePicker.vala"
						_tmp98_ = FALSE;
#line 3397 "TimePicker.c"
					}
#line 667 "../lib/Widgets/TimePicker.vala"
					if (_tmp98_) {
#line 667 "../lib/Widgets/TimePicker.vala"
						_tmp97_ = HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS;
#line 3403 "TimePicker.c"
					} else {
#line 667 "../lib/Widgets/TimePicker.vala"
						_tmp97_ = HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS;
#line 3407 "TimePicker.c"
					}
#line 667 "../lib/Widgets/TimePicker.vala"
					label_radius = _tmp97_;
#line 668 "../lib/Widgets/TimePicker.vala"
					label_x = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (label_radius * cos (hour_angle));
#line 669 "../lib/Widgets/TimePicker.vala"
					label_y = HE_TIME_PICKER_CLOCK_WIDGET_CENTER + (label_radius * sin (hour_angle));
#line 671 "../lib/Widgets/TimePicker.vala"
					selection_angle = he_time_picker_clock_widget_get_hour_angle (self);
#line 672 "../lib/Widgets/TimePicker.vala"
					if (selection_angle < ((-G_PI) / 2)) {
#line 673 "../lib/Widgets/TimePicker.vala"
						selection_angle += 2 * G_PI;
#line 3421 "TimePicker.c"
					}
#line 675 "../lib/Widgets/TimePicker.vala"
					label_angle = hour_angle;
#line 676 "../lib/Widgets/TimePicker.vala"
					if (label_angle < ((-G_PI) / 2)) {
#line 677 "../lib/Widgets/TimePicker.vala"
						label_angle += 2 * G_PI;
#line 3429 "TimePicker.c"
					}
#line 680 "../lib/Widgets/TimePicker.vala"
					is_selected = fabs (selection_angle - label_angle) < (G_PI / HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY);
#line 682 "../lib/Widgets/TimePicker.vala"
					if (is_selected) {
#line 3435 "TimePicker.c"
						gdouble _tmp100_ = 0.0;
						gdouble _tmp103_ = 0.0;
						gdouble _tmp106_ = 0.0;
						cairo_t* _tmp109_;
						gint _tmp115_ = 0;
						cairo_t* _tmp117_;
						gchar* _tmp118_;
						gchar* _tmp119_;
#line 683 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3446 "TimePicker.c"
							GdkRGBA _tmp101_ = {0};
							GdkRGBA _tmp102_;
#line 683 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp101_);
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp102_ = _tmp101_;
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp100_ = 0.20 * _tmp102_.red;
#line 3455 "TimePicker.c"
						} else {
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp100_ = 1.0;
#line 3459 "TimePicker.c"
						}
#line 683 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3463 "TimePicker.c"
							GdkRGBA _tmp104_ = {0};
							GdkRGBA _tmp105_;
#line 683 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp104_);
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp105_ = _tmp104_;
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp103_ = 0.20 * _tmp105_.green;
#line 3472 "TimePicker.c"
						} else {
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp103_ = 1.0;
#line 3476 "TimePicker.c"
						}
#line 683 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 3480 "TimePicker.c"
							GdkRGBA _tmp107_ = {0};
							GdkRGBA _tmp108_;
#line 683 "../lib/Widgets/TimePicker.vala"
							he_time_picker_clock_widget_get_accent_color (self, &_tmp107_);
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp108_ = _tmp107_;
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp106_ = 0.20 * _tmp108_.blue;
#line 3489 "TimePicker.c"
						} else {
#line 683 "../lib/Widgets/TimePicker.vala"
							_tmp106_ = 1.0;
#line 3493 "TimePicker.c"
						}
#line 683 "../lib/Widgets/TimePicker.vala"
						_tmp109_ = cr;
#line 683 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp109_, _tmp100_, _tmp103_, _tmp106_, (gdouble) 1);
#line 684 "../lib/Widgets/TimePicker.vala"
						if (i >= 10) {
#line 3501 "TimePicker.c"
							cairo_t* _tmp110_;
#line 685 "../lib/Widgets/TimePicker.vala"
							_tmp110_ = cr;
#line 685 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp110_, label_x - (18 / 2.0), label_y + (16 / 2.0));
#line 3507 "TimePicker.c"
						} else {
#line 686 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 3511 "TimePicker.c"
								cairo_t* _tmp111_;
#line 687 "../lib/Widgets/TimePicker.vala"
								_tmp111_ = cr;
#line 687 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp111_, label_x - (6 / 2.0), label_y + (16 / 2.0));
#line 3517 "TimePicker.c"
							} else {
								cairo_t* _tmp112_;
#line 689 "../lib/Widgets/TimePicker.vala"
								_tmp112_ = cr;
#line 689 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp112_, label_x - (10 / 2.0), label_y + (16 / 2.0));
#line 3524 "TimePicker.c"
							}
						}
#line 692 "../lib/Widgets/TimePicker.vala"
						if (i <= HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3529 "TimePicker.c"
							cairo_t* _tmp113_;
#line 693 "../lib/Widgets/TimePicker.vala"
							_tmp113_ = cr;
#line 693 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp113_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_HOUR_FONT_SIZE);
#line 3535 "TimePicker.c"
						} else {
							cairo_t* _tmp114_;
#line 695 "../lib/Widgets/TimePicker.vala"
							_tmp114_ = cr;
#line 695 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp114_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 3542 "TimePicker.c"
						}
#line 701 "../lib/Widgets/TimePicker.vala"
						if (i > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3546 "TimePicker.c"
							gint _tmp116_ = 0;
#line 701 "../lib/Widgets/TimePicker.vala"
							if (i == 24) {
#line 701 "../lib/Widgets/TimePicker.vala"
								_tmp116_ = 0;
#line 3552 "TimePicker.c"
							} else {
#line 701 "../lib/Widgets/TimePicker.vala"
								_tmp116_ = i;
#line 3556 "TimePicker.c"
							}
#line 701 "../lib/Widgets/TimePicker.vala"
							_tmp115_ = _tmp116_;
#line 3560 "TimePicker.c"
						} else {
#line 701 "../lib/Widgets/TimePicker.vala"
							_tmp115_ = i;
#line 3564 "TimePicker.c"
						}
#line 701 "../lib/Widgets/TimePicker.vala"
						_tmp117_ = cr;
#line 701 "../lib/Widgets/TimePicker.vala"
						_tmp118_ = g_strdup_printf ("%i", _tmp115_);
#line 701 "../lib/Widgets/TimePicker.vala"
						_tmp119_ = _tmp118_;
#line 701 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp117_, _tmp119_);
#line 701 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp119_);
#line 3576 "TimePicker.c"
					} else {
						gdouble _tmp120_ = 0.0;
						gdouble _tmp121_ = 0.0;
						gdouble _tmp122_ = 0.0;
						cairo_t* _tmp123_;
						GdkRGBA _tmp124_ = {0};
						GdkRGBA _tmp125_;
						GdkRGBA _tmp126_ = {0};
						GdkRGBA _tmp127_;
						GdkRGBA _tmp128_ = {0};
						GdkRGBA _tmp129_;
						gint _tmp135_ = 0;
						cairo_t* _tmp137_;
						gchar* _tmp138_;
						gchar* _tmp139_;
#line 703 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 703 "../lib/Widgets/TimePicker.vala"
							_tmp120_ = 0.99;
#line 3596 "TimePicker.c"
						} else {
#line 703 "../lib/Widgets/TimePicker.vala"
							_tmp120_ = 0.10;
#line 3600 "TimePicker.c"
						}
#line 703 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 703 "../lib/Widgets/TimePicker.vala"
							_tmp121_ = 0.99;
#line 3606 "TimePicker.c"
						} else {
#line 703 "../lib/Widgets/TimePicker.vala"
							_tmp121_ = 0.10;
#line 3610 "TimePicker.c"
						}
#line 703 "../lib/Widgets/TimePicker.vala"
						if (self->priv->is_dark) {
#line 703 "../lib/Widgets/TimePicker.vala"
							_tmp122_ = 0.99;
#line 3616 "TimePicker.c"
						} else {
#line 703 "../lib/Widgets/TimePicker.vala"
							_tmp122_ = 0.10;
#line 3620 "TimePicker.c"
						}
#line 703 "../lib/Widgets/TimePicker.vala"
						_tmp123_ = cr;
#line 703 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp124_);
#line 703 "../lib/Widgets/TimePicker.vala"
						_tmp125_ = _tmp124_;
#line 703 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp126_);
#line 703 "../lib/Widgets/TimePicker.vala"
						_tmp127_ = _tmp126_;
#line 703 "../lib/Widgets/TimePicker.vala"
						he_time_picker_clock_widget_get_accent_color (self, &_tmp128_);
#line 703 "../lib/Widgets/TimePicker.vala"
						_tmp129_ = _tmp128_;
#line 703 "../lib/Widgets/TimePicker.vala"
						cairo_set_source_rgba (_tmp123_, _tmp120_ * _tmp125_.red, _tmp121_ * _tmp127_.green, _tmp122_ * _tmp129_.blue, (gdouble) 1);
#line 704 "../lib/Widgets/TimePicker.vala"
						if (i >= 10) {
#line 3640 "TimePicker.c"
							cairo_t* _tmp130_;
#line 705 "../lib/Widgets/TimePicker.vala"
							_tmp130_ = cr;
#line 705 "../lib/Widgets/TimePicker.vala"
							cairo_move_to (_tmp130_, label_x - (18 / 2.0), label_y + (16 / 2.0));
#line 3646 "TimePicker.c"
						} else {
#line 706 "../lib/Widgets/TimePicker.vala"
							if (i == 1) {
#line 3650 "TimePicker.c"
								cairo_t* _tmp131_;
#line 707 "../lib/Widgets/TimePicker.vala"
								_tmp131_ = cr;
#line 707 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp131_, label_x - (6 / 2.0), label_y + (16 / 2.0));
#line 3656 "TimePicker.c"
							} else {
								cairo_t* _tmp132_;
#line 709 "../lib/Widgets/TimePicker.vala"
								_tmp132_ = cr;
#line 709 "../lib/Widgets/TimePicker.vala"
								cairo_move_to (_tmp132_, label_x - (10 / 2.0), label_y + (16 / 2.0));
#line 3663 "TimePicker.c"
							}
						}
#line 712 "../lib/Widgets/TimePicker.vala"
						if (i <= HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3668 "TimePicker.c"
							cairo_t* _tmp133_;
#line 713 "../lib/Widgets/TimePicker.vala"
							_tmp133_ = cr;
#line 713 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp133_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_HOUR_FONT_SIZE);
#line 3674 "TimePicker.c"
						} else {
							cairo_t* _tmp134_;
#line 715 "../lib/Widgets/TimePicker.vala"
							_tmp134_ = cr;
#line 715 "../lib/Widgets/TimePicker.vala"
							cairo_set_font_size (_tmp134_, (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_FONT_SIZE);
#line 3681 "TimePicker.c"
						}
#line 721 "../lib/Widgets/TimePicker.vala"
						if (i > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) {
#line 3685 "TimePicker.c"
							gint _tmp136_ = 0;
#line 721 "../lib/Widgets/TimePicker.vala"
							if (i == 24) {
#line 721 "../lib/Widgets/TimePicker.vala"
								_tmp136_ = 0;
#line 3691 "TimePicker.c"
							} else {
#line 721 "../lib/Widgets/TimePicker.vala"
								_tmp136_ = i;
#line 3695 "TimePicker.c"
							}
#line 721 "../lib/Widgets/TimePicker.vala"
							_tmp135_ = _tmp136_;
#line 3699 "TimePicker.c"
						} else {
#line 721 "../lib/Widgets/TimePicker.vala"
							_tmp135_ = i;
#line 3703 "TimePicker.c"
						}
#line 721 "../lib/Widgets/TimePicker.vala"
						_tmp137_ = cr;
#line 721 "../lib/Widgets/TimePicker.vala"
						_tmp138_ = g_strdup_printf ("%i", _tmp135_);
#line 721 "../lib/Widgets/TimePicker.vala"
						_tmp139_ = _tmp138_;
#line 721 "../lib/Widgets/TimePicker.vala"
						cairo_show_text (_tmp137_, _tmp139_);
#line 721 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp139_);
#line 3715 "TimePicker.c"
					}
				}
			}
		}
	}
#line 584 "../lib/Widgets/TimePicker.vala"
	_cairo_destroy0 (cr);
#line 3723 "TimePicker.c"
}

static void
he_time_picker_clock_widget_emit_time_selected (HeTimePickerClockWidget* self)
{
#line 727 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 728 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_clock_widget_signals[HE_TIME_PICKER_CLOCK_WIDGET_TIME_SELECTED_SIGNAL], 0, self->priv->selected_hour, self->priv->selected_minute);
#line 3733 "TimePicker.c"
}

static void
he_time_picker_clock_widget_reset_to_hour_selection (HeTimePickerClockWidget* self)
{
#line 731 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 732 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_set_selecting_hour (self, TRUE);
#line 733 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3745 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_hour_angle (HeTimePickerClockWidget* self)
{
	gdouble hour = 0.0;
	gdouble angle = 0.0;
	gdouble result;
#line 736 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 737 "../lib/Widgets/TimePicker.vala"
	hour = (gdouble) (self->priv->selected_hour % HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY);
#line 738 "../lib/Widgets/TimePicker.vala"
	if (hour == ((gdouble) 0)) {
#line 738 "../lib/Widgets/TimePicker.vala"
		hour = (gdouble) HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3762 "TimePicker.c"
	}
#line 739 "../lib/Widgets/TimePicker.vala"
	angle = (hour * ((2 * G_PI) / HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY)) - (G_PI / 2);
#line 740 "../lib/Widgets/TimePicker.vala"
	result = angle;
#line 740 "../lib/Widgets/TimePicker.vala"
	return result;
#line 3770 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_minute_angle (HeTimePickerClockWidget* self)
{
	gdouble result;
#line 743 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 744 "../lib/Widgets/TimePicker.vala"
	result = ((self->priv->selected_minute % HE_TIME_PICKER_CLOCK_WIDGET_MINUTES) * ((2 * G_PI) / HE_TIME_PICKER_CLOCK_WIDGET_MINUTES)) - (G_PI / 2);
#line 744 "../lib/Widgets/TimePicker.vala"
	return result;
#line 3783 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_hand_radius (HeTimePickerClockWidget* self,
                                             gdouble base_radius)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gdouble result;
#line 747 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 748 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = self->priv->_selecting_hour;
#line 748 "../lib/Widgets/TimePicker.vala"
	if (_tmp2_) {
#line 3800 "TimePicker.c"
		gboolean _tmp3_;
#line 748 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->_is_military_mode;
#line 748 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = _tmp3_;
#line 3806 "TimePicker.c"
	} else {
#line 748 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = FALSE;
#line 3810 "TimePicker.c"
	}
#line 748 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_) {
#line 748 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = self->priv->selected_hour > HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3816 "TimePicker.c"
	} else {
#line 748 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 3820 "TimePicker.c"
	}
#line 748 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 749 "../lib/Widgets/TimePicker.vala"
		result = HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS;
#line 749 "../lib/Widgets/TimePicker.vala"
		return result;
#line 3828 "TimePicker.c"
	} else {
#line 751 "../lib/Widgets/TimePicker.vala"
		result = HE_TIME_PICKER_CLOCK_WIDGET_OUTER_RADIUS;
#line 751 "../lib/Widgets/TimePicker.vala"
		return result;
#line 3834 "TimePicker.c"
	}
}

static void
he_time_picker_clock_widget_update_selection (HeTimePickerClockWidget* self,
                                              gdouble x,
                                              gdouble y)
{
	gdouble dx = 0.0;
	gdouble dy = 0.0;
	gdouble distance = 0.0;
	gdouble angle = 0.0;
	gboolean _tmp0_;
#line 755 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 756 "../lib/Widgets/TimePicker.vala"
	dx = x - HE_TIME_PICKER_CLOCK_WIDGET_CENTER;
#line 757 "../lib/Widgets/TimePicker.vala"
	dy = y - HE_TIME_PICKER_CLOCK_WIDGET_CENTER;
#line 759 "../lib/Widgets/TimePicker.vala"
	distance = sqrt ((dx * dx) + (dy * dy));
#line 760 "../lib/Widgets/TimePicker.vala"
	angle = atan2 (dy, dx) + (G_PI / 2);
#line 761 "../lib/Widgets/TimePicker.vala"
	if (angle < ((gdouble) 0)) {
#line 762 "../lib/Widgets/TimePicker.vala"
		angle += 2 * G_PI;
#line 3862 "TimePicker.c"
	}
#line 765 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_selecting_hour;
#line 765 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 3868 "TimePicker.c"
		gint temp_hour = 0;
		gboolean _tmp1_;
#line 766 "../lib/Widgets/TimePicker.vala"
		temp_hour = (gint) round ((angle * HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY) / (2 * G_PI));
#line 767 "../lib/Widgets/TimePicker.vala"
		if (temp_hour <= 0) {
#line 767 "../lib/Widgets/TimePicker.vala"
			temp_hour += HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3877 "TimePicker.c"
		}
#line 768 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->_is_military_mode;
#line 768 "../lib/Widgets/TimePicker.vala"
		if (_tmp1_) {
#line 769 "../lib/Widgets/TimePicker.vala"
			if (distance < HE_TIME_PICKER_CLOCK_WIDGET_INNER_RADIUS) {
#line 770 "../lib/Widgets/TimePicker.vala"
				temp_hour += HE_TIME_PICKER_CLOCK_WIDGET_HALF_DAY;
#line 3887 "TimePicker.c"
			}
		}
#line 773 "../lib/Widgets/TimePicker.vala"
		self->priv->selected_hour = temp_hour;
#line 3892 "TimePicker.c"
	} else {
#line 775 "../lib/Widgets/TimePicker.vala"
		self->priv->selected_minute = ((gint) round ((angle * HE_TIME_PICKER_CLOCK_WIDGET_MINUTES) / (2 * G_PI))) % HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 776 "../lib/Widgets/TimePicker.vala"
		if (self->priv->selected_minute < 0) {
#line 776 "../lib/Widgets/TimePicker.vala"
			self->priv->selected_minute = self->priv->selected_minute + HE_TIME_PICKER_CLOCK_WIDGET_MINUTES;
#line 3900 "TimePicker.c"
		}
	}
#line 779 "../lib/Widgets/TimePicker.vala"
	self->priv->last_angle = angle;
#line 781 "../lib/Widgets/TimePicker.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3907 "TimePicker.c"
}

static gdouble
he_time_picker_clock_widget_get_angle_from_coords (HeTimePickerClockWidget* self,
                                                   gdouble x,
                                                   gdouble y)
{
	gdouble angle = 0.0;
	gdouble result;
#line 784 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 785 "../lib/Widgets/TimePicker.vala"
	angle = atan2 (y - HE_TIME_PICKER_CLOCK_WIDGET_CENTER, x - HE_TIME_PICKER_CLOCK_WIDGET_CENTER);
#line 786 "../lib/Widgets/TimePicker.vala"
	if (angle < ((-G_PI) / 2)) {
#line 787 "../lib/Widgets/TimePicker.vala"
		angle += 2 * G_PI;
#line 3925 "TimePicker.c"
	}
#line 790 "../lib/Widgets/TimePicker.vala"
	result = angle;
#line 790 "../lib/Widgets/TimePicker.vala"
	return result;
#line 3931 "TimePicker.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 549 "../lib/Widgets/TimePicker.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 549 "../lib/Widgets/TimePicker.vala"
	return _data16_;
#line 3941 "TimePicker.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 549 "../lib/Widgets/TimePicker.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 3951 "TimePicker.c"
		HeTimePickerClockWidget* self;
#line 549 "../lib/Widgets/TimePicker.vala"
		self = _data16_->self;
#line 549 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (_data16_->drag_gesture);
#line 549 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self);
#line 549 "../lib/Widgets/TimePicker.vala"
		g_slice_free (Block16Data, _data16_);
#line 3961 "TimePicker.c"
	}
}

static void
_he_time_picker_clock_widget___lambda164_ (HeTimePickerClockWidget* self,
                                           gint n_press,
                                           gdouble x,
                                           gdouble y)
{
#line 552 "../lib/Widgets/TimePicker.vala"
	self->priv->last_angle = he_time_picker_clock_widget_get_angle_from_coords (self, x, y);
#line 3973 "TimePicker.c"
}

static void
__he_time_picker_clock_widget___lambda164__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                      gint n_press,
                                                                      gdouble x,
                                                                      gdouble y,
                                                                      gpointer self)
{
#line 551 "../lib/Widgets/TimePicker.vala"
	_he_time_picker_clock_widget___lambda164_ ((HeTimePickerClockWidget*) self, n_press, x, y);
#line 3985 "TimePicker.c"
}

static void
_he_time_picker_clock_widget___lambda165_ (HeTimePickerClockWidget* self)
{
	gboolean _tmp0_;
#line 555 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_selecting_hour;
#line 555 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 556 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_selecting_hour (self, FALSE);
#line 557 "../lib/Widgets/TimePicker.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 4000 "TimePicker.c"
	} else {
#line 559 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_emit_time_selected (self);
#line 560 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_reset_to_hour_selection (self);
#line 4006 "TimePicker.c"
	}
}

static void
__he_time_picker_clock_widget___lambda165__gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self)
{
#line 554 "../lib/Widgets/TimePicker.vala"
	_he_time_picker_clock_widget___lambda165_ ((HeTimePickerClockWidget*) self);
#line 4019 "TimePicker.c"
}

static void
_he_time_picker_clock_widget___lambda166_ (Block16Data* _data16_,
                                           gdouble offset_x,
                                           gdouble offset_y)
{
	HeTimePickerClockWidget* self;
	gdouble x = 0.0;
	gdouble y = 0.0;
	GtkGestureDrag* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 566 "../lib/Widgets/TimePicker.vala"
	self = _data16_->self;
#line 568 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = _data16_->drag_gesture;
#line 568 "../lib/Widgets/TimePicker.vala"
	gtk_gesture_get_bounding_box_center ((GtkGesture*) _tmp0_, &_tmp1_, &_tmp2_);
#line 568 "../lib/Widgets/TimePicker.vala"
	x = _tmp1_;
#line 568 "../lib/Widgets/TimePicker.vala"
	y = _tmp2_;
#line 569 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_update_selection (self, x, y);
#line 4045 "TimePicker.c"
}

static void
__he_time_picker_clock_widget___lambda166__gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                         gdouble offset_x,
                                                                         gdouble offset_y,
                                                                         gpointer self)
{
#line 566 "../lib/Widgets/TimePicker.vala"
	_he_time_picker_clock_widget___lambda166_ (self, offset_x, offset_y);
#line 4056 "TimePicker.c"
}

static GObject *
he_time_picker_clock_widget_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTimePickerClockWidget * self;
	Block16Data* _data16_;
	GtkGestureClick* click_gesture = NULL;
	GtkGestureClick* _tmp0_;
	GtkGestureClick* _tmp1_;
	GtkGestureClick* _tmp2_;
	GtkGestureClick* _tmp3_;
	GtkEventController* _tmp4_;
	GtkGestureDrag* _tmp5_;
	GtkGestureDrag* _tmp6_;
	GtkGestureDrag* _tmp7_;
	GtkEventController* _tmp8_;
#line 549 "../lib/Widgets/TimePicker.vala"
	parent_class = G_OBJECT_CLASS (he_time_picker_clock_widget_parent_class);
#line 549 "../lib/Widgets/TimePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 549 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 549 "../lib/Widgets/TimePicker.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 549 "../lib/Widgets/TimePicker.vala"
	_data16_->_ref_count_ = 1;
#line 549 "../lib/Widgets/TimePicker.vala"
	_data16_->self = g_object_ref (self);
#line 550 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 550 "../lib/Widgets/TimePicker.vala"
	click_gesture = _tmp0_;
#line 551 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = click_gesture;
#line 551 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp1_, "pressed", (GCallback) __he_time_picker_clock_widget___lambda164__gtk_gesture_click_pressed, self, 0);
#line 554 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = click_gesture;
#line 554 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp2_, "released", (GCallback) __he_time_picker_clock_widget___lambda165__gtk_gesture_click_released, self, 0);
#line 563 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = click_gesture;
#line 563 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = _g_object_ref0 ((GtkEventController*) _tmp3_);
#line 563 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp4_);
#line 565 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = (GtkGestureDrag*) gtk_gesture_drag_new ();
#line 565 "../lib/Widgets/TimePicker.vala"
	_data16_->drag_gesture = _tmp5_;
#line 566 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = _data16_->drag_gesture;
#line 566 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_data (_tmp6_, "drag-update", (GCallback) __he_time_picker_clock_widget___lambda166__gtk_gesture_drag_drag_update, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 571 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = _data16_->drag_gesture;
#line 571 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = _g_object_ref0 ((GtkEventController*) _tmp7_);
#line 571 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp8_);
#line 573 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 574 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 575 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkWidget*) self, "width-request", (gint) HE_TIME_PICKER_CLOCK_WIDGET_SIZE, NULL);
#line 576 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkWidget*) self, "height-request", (gint) HE_TIME_PICKER_CLOCK_WIDGET_SIZE, NULL);
#line 549 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (click_gesture);
#line 549 "../lib/Widgets/TimePicker.vala"
	block16_data_unref (_data16_);
#line 549 "../lib/Widgets/TimePicker.vala"
	_data16_ = NULL;
#line 549 "../lib/Widgets/TimePicker.vala"
	return obj;
#line 4138 "TimePicker.c"
}

static void
he_time_picker_clock_widget_class_init (HeTimePickerClockWidgetClass * klass,
                                        gpointer klass_data)
{
#line 423 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_parent_class = g_type_class_peek_parent (klass);
#line 423 "../lib/Widgets/TimePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeTimePickerClockWidget_private_offset);
#line 423 "../lib/Widgets/TimePicker.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) he_time_picker_clock_widget_real_dispose;
#line 423 "../lib/Widgets/TimePicker.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) he_time_picker_clock_widget_real_snapshot;
#line 423 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_time_picker_clock_widget_get_property;
#line 423 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_time_picker_clock_widget_set_property;
#line 423 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_time_picker_clock_widget_constructor;
#line 423 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_time_picker_clock_widget_finalize;
#line 423 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY] = g_param_spec_boolean ("selecting-hour", "selecting-hour", "selecting-hour", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 423 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY] = g_param_spec_boolean ("is-military-mode", "is-military-mode", "is-military-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 423 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("accent-color", "accent-color", "accent-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 423 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY] = g_param_spec_int ("hour", "hour", "hour", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 423 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY, he_time_picker_clock_widget_properties[HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY] = g_param_spec_int ("minute", "minute", "minute", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 423 "../lib/Widgets/TimePicker.vala"
	he_time_picker_clock_widget_signals[HE_TIME_PICKER_CLOCK_WIDGET_TIME_SELECTED_SIGNAL] = g_signal_new ("time-selected", HE_TIME_PICKER_TYPE_CLOCK_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 4173 "TimePicker.c"
}

static void
he_time_picker_clock_widget_instance_init (HeTimePickerClockWidget * self,
                                           gpointer klass)
{
	HeDesktop* _tmp0_;
#line 423 "../lib/Widgets/TimePicker.vala"
	self->priv = he_time_picker_clock_widget_get_instance_private (self);
#line 439 "../lib/Widgets/TimePicker.vala"
	self->priv->_selecting_hour = TRUE;
#line 440 "../lib/Widgets/TimePicker.vala"
	self->priv->_is_military_mode = FALSE;
#line 442 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_hour = 0;
#line 443 "../lib/Widgets/TimePicker.vala"
	self->priv->selected_minute = 0;
#line 444 "../lib/Widgets/TimePicker.vala"
	self->priv->last_angle = 0.0;
#line 445 "../lib/Widgets/TimePicker.vala"
	self->priv->is_dark = FALSE;
#line 447 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = he_desktop_new ();
#line 447 "../lib/Widgets/TimePicker.vala"
	self->priv->desktop = _tmp0_;
#line 448 "../lib/Widgets/TimePicker.vala"
	self->priv->_accent_color = (GdkRGBA) {(gfloat) 1, (gfloat) 1, (gfloat) 1, (gfloat) 1};
#line 4201 "TimePicker.c"
}

static void
he_time_picker_clock_widget_finalize (GObject * obj)
{
	HeTimePickerClockWidget * self;
#line 423 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 447 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->desktop);
#line 423 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_clock_widget_parent_class)->finalize (obj);
#line 4214 "TimePicker.c"
}

static GType
he_time_picker_clock_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTimePickerClockWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_time_picker_clock_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTimePickerClockWidget), 0, (GInstanceInitFunc) he_time_picker_clock_widget_instance_init, NULL };
	GType he_time_picker_clock_widget_type_id;
	he_time_picker_clock_widget_type_id = g_type_register_static (gtk_widget_get_type (), "HeTimePickerClockWidget", &g_define_type_info, 0);
	HeTimePickerClockWidget_private_offset = g_type_add_instance_private (he_time_picker_clock_widget_type_id, sizeof (HeTimePickerClockWidgetPrivate));
	return he_time_picker_clock_widget_type_id;
}

static GType
he_time_picker_clock_widget_get_type (void)
{
	static volatile gsize he_time_picker_clock_widget_type_id__once = 0;
	if (g_once_init_enter (&he_time_picker_clock_widget_type_id__once)) {
		GType he_time_picker_clock_widget_type_id;
		he_time_picker_clock_widget_type_id = he_time_picker_clock_widget_get_type_once ();
		g_once_init_leave (&he_time_picker_clock_widget_type_id__once, he_time_picker_clock_widget_type_id);
	}
	return he_time_picker_clock_widget_type_id__once;
}

static void
_vala_he_time_picker_clock_widget_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	HeTimePickerClockWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 423 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		g_value_set_boolean (value, he_time_picker_clock_widget_get_selecting_hour (self));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		g_value_set_boolean (value, he_time_picker_clock_widget_get_is_military_mode (self));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY:
#line 4263 "TimePicker.c"
		{
			GdkRGBA boxed;
#line 423 "../lib/Widgets/TimePicker.vala"
			he_time_picker_clock_widget_get_accent_color (self, &boxed);
#line 423 "../lib/Widgets/TimePicker.vala"
			g_value_set_boxed (value, &boxed);
#line 4270 "TimePicker.c"
		}
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		g_value_set_int (value, he_time_picker_clock_widget_get_hour (self));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		g_value_set_int (value, he_time_picker_clock_widget_get_minute (self));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 4286 "TimePicker.c"
		default:
#line 423 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 4292 "TimePicker.c"
	}
}

static void
_vala_he_time_picker_clock_widget_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	HeTimePickerClockWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TIME_PICKER_TYPE_CLOCK_WIDGET, HeTimePickerClockWidget);
#line 423 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_SELECTING_HOUR_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_selecting_hour (self, g_value_get_boolean (value));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_IS_MILITARY_MODE_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (self, g_value_get_boolean (value));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_ACCENT_COLOR_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_accent_color (self, g_value_get_boxed (value));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_HOUR_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_hour (self, g_value_get_int (value));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 423 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_CLOCK_WIDGET_MINUTE_PROPERTY:
#line 423 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_minute (self, g_value_get_int (value));
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 4336 "TimePicker.c"
		default:
#line 423 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 423 "../lib/Widgets/TimePicker.vala"
		break;
#line 4342 "TimePicker.c"
	}
}

static void
_he_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                      GtkEntryIconPosition icon_pos,
                                                      gpointer self)
{
#line 93 "../lib/Widgets/TimePicker.vala"
	he_time_picker_on_icon_press ((HeTimePicker*) self, icon_pos);
#line 4353 "TimePicker.c"
}

static void
_he_time_picker___lambda167_ (HeTimePicker* self)
{
#line 125 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, TRUE);
#line 4361 "TimePicker.c"
}

static void
__he_time_picker___lambda167__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                             gpointer self)
{
#line 125 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda167_ ((HeTimePicker*) self);
#line 4370 "TimePicker.c"
}

static void
_he_time_picker___lambda168_ (HeTimePicker* self)
{
#line 132 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, FALSE);
#line 4378 "TimePicker.c"
}

static void
__he_time_picker___lambda168__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                             gpointer self)
{
#line 132 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda168_ ((HeTimePicker*) self);
#line 4387 "TimePicker.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 4418 "TimePicker.c"
}

static gboolean
_he_time_picker___lambda169_ (HeTimePicker* self)
{
	gdouble val = 0.0;
	GtkSpinButton* _tmp0_;
	gboolean result;
#line 135 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->minutes_spinbutton;
#line 135 "../lib/Widgets/TimePicker.vala"
	val = gtk_spin_button_get_value (_tmp0_);
#line 136 "../lib/Widgets/TimePicker.vala"
	if (val < ((gdouble) 10)) {
#line 4433 "TimePicker.c"
		GtkSpinButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 137 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->minutes_spinbutton;
#line 137 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = double_to_string (val);
#line 137 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = _tmp2_;
#line 137 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_strconcat ("0", _tmp3_, NULL);
#line 137 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 137 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp1_, _tmp5_);
#line 137 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 137 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp3_);
#line 138 "../lib/Widgets/TimePicker.vala"
		result = TRUE;
#line 138 "../lib/Widgets/TimePicker.vala"
		return result;
#line 4459 "TimePicker.c"
	}
#line 141 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 141 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4465 "TimePicker.c"
}

static gboolean
__he_time_picker___lambda169__gtk_spin_button_output (GtkSpinButton* _sender,
                                                      gpointer self)
{
	gboolean result;
	result = _he_time_picker___lambda169_ ((HeTimePicker*) self);
#line 134 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4476 "TimePicker.c"
}

static void
_he_time_picker___lambda170_ (HeTimePicker* self,
                              gint hour,
                              gint minute)
{
	GtkSpinButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 158 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->hours_spinbutton;
#line 158 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_strdup_printf ("%i", hour);
#line 158 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 158 "../lib/Widgets/TimePicker.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, _tmp2_);
#line 158 "../lib/Widgets/TimePicker.vala"
	_g_free0 (_tmp2_);
#line 159 "../lib/Widgets/TimePicker.vala"
	if (minute < 10) {
#line 4499 "TimePicker.c"
		GtkSpinButton* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 160 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->minutes_spinbutton;
#line 160 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_strdup_printf ("%i", minute);
#line 160 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 160 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = g_strconcat ("0", _tmp5_, NULL);
#line 160 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = _tmp6_;
#line 160 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp3_, _tmp7_);
#line 160 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp7_);
#line 160 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 4521 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 162 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = self->priv->minutes_spinbutton;
#line 162 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = g_strdup_printf ("%i", minute);
#line 162 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = _tmp9_;
#line 162 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp8_, _tmp10_);
#line 162 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp10_);
#line 4536 "TimePicker.c"
	}
#line 165 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 166 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, TRUE);
#line 167 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, FALSE);
#line 4544 "TimePicker.c"
}

static void
__he_time_picker___lambda170__he_time_picker_clock_widget_time_selected (HeTimePickerClockWidget* _sender,
                                                                         gint hour,
                                                                         gint minute,
                                                                         gpointer self)
{
#line 157 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda170_ ((HeTimePicker*) self, hour, minute);
#line 4555 "TimePicker.c"
}

static void
_he_time_picker___lambda171_ (HeTimePicker* self)
{
#line 198 "../lib/Widgets/TimePicker.vala"
	he_time_picker_is_unfocused (self);
#line 4563 "TimePicker.c"
}

static void
__he_time_picker___lambda171__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                gpointer self)
{
#line 197 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda171_ ((HeTimePicker*) self);
#line 4572 "TimePicker.c"
}

static gboolean
_he_time_picker___lambda172_ (HeTimePicker* self,
                              gdouble dx,
                              gdouble dy)
{
	gdouble _tmp0_ = 0.0;
	gdouble largest = 0.0;
	gboolean result;
#line 202 "../lib/Widgets/TimePicker.vala"
	if (fabs (dx) > fabs (dy)) {
#line 202 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dx;
#line 4587 "TimePicker.c"
	} else {
#line 202 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dy;
#line 4591 "TimePicker.c"
	}
#line 202 "../lib/Widgets/TimePicker.vala"
	largest = _tmp0_;
#line 203 "../lib/Widgets/TimePicker.vala"
	if (largest < ((gdouble) 0)) {
#line 4597 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 204 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->_time;
#line 204 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = g_date_time_add_minutes (_tmp1_, 1);
#line 204 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 204 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp2_;
#line 4608 "TimePicker.c"
	} else {
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 206 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->_time;
#line 206 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_date_time_add_minutes (_tmp3_, -1);
#line 206 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 206 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp4_;
#line 4620 "TimePicker.c"
	}
#line 209 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 210 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 210 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4628 "TimePicker.c"
}

static gboolean
__he_time_picker___lambda172__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                  gdouble dx,
                                                                  gdouble dy,
                                                                  gpointer self)
{
	gboolean result;
	result = _he_time_picker___lambda172_ ((HeTimePicker*) self, dx, dy);
#line 201 "../lib/Widgets/TimePicker.vala"
	return result;
#line 4641 "TimePicker.c"
}

static void
_he_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                 gpointer self)
{
#line 213 "../lib/Widgets/TimePicker.vala"
	he_time_picker_is_unfocused ((HeTimePicker*) self);
#line 4650 "TimePicker.c"
}

static void
_he_time_picker___lambda173_ (HeTimePicker* self)
{
#line 216 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_am_pm (self, -12);
#line 4658 "TimePicker.c"
}

static void
__he_time_picker___lambda173__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 215 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda173_ ((HeTimePicker*) self);
#line 4667 "TimePicker.c"
}

static void
_he_time_picker___lambda174_ (HeTimePicker* self)
{
#line 220 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_am_pm (self, 12);
#line 4675 "TimePicker.c"
}

static void
__he_time_picker___lambda174__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 219 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda174_ ((HeTimePicker*) self);
#line 4684 "TimePicker.c"
}

static GObject *
he_time_picker_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTimePicker * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GThemedIcon* _tmp2_;
	GThemedIcon* _tmp3_;
	GtkToggleButton* _tmp4_ = NULL;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	GtkToggleButton* _tmp7_ = NULL;
	GtkBox* _tmp8_ = NULL;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkBox* _tmp12_;
	GtkToggleButton* _tmp13_;
	HeTimePickerClockWidget* _tmp14_;
	GtkSpinButton* _tmp19_;
	GtkSpinButton* _tmp20_;
	GtkSpinButton* _tmp21_;
	GtkSpinButton* _tmp22_;
	GtkSpinButton* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkSpinButton* _tmp25_;
	GtkSpinButton* _tmp26_;
	GtkSpinButton* _tmp27_;
	GtkSpinButton* _tmp28_;
	GtkSpinButton* _tmp29_;
	GtkSpinButton* _tmp30_;
	GtkLabel* separation_label = NULL;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkBox* pop_grid_top = NULL;
	GtkBox* _tmp33_ = NULL;
	GtkBox* _tmp34_;
	GtkSpinButton* _tmp35_;
	GtkBox* _tmp36_;
	GtkLabel* _tmp37_;
	GtkBox* _tmp38_;
	GtkSpinButton* _tmp39_;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	HeTimePickerClockWidget* _tmp42_;
	GtkBox* pop_grid_middle = NULL;
	GtkBox* _tmp43_ = NULL;
	GtkBox* _tmp44_;
	HeTimePickerClockWidget* _tmp45_;
	GtkBox* pop_grid = NULL;
	GtkBox* _tmp46_;
	GtkBox* _tmp47_;
	GtkBox* _tmp48_;
	GtkBox* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkWidget* _tmp52_;
	GtkPopover* _tmp53_ = NULL;
	GtkPopover* _tmp54_;
	GtkPopover* _tmp55_;
	GtkEventControllerFocus* focus_controller = NULL;
	GtkEventControllerFocus* _tmp56_;
	GtkEventControllerScroll* scroll_controller = NULL;
	GtkEventControllerScroll* _tmp57_;
	GtkEventControllerFocus* _tmp58_;
	GtkEventController* _tmp59_;
	GtkEventControllerScroll* _tmp60_;
	GtkEventController* _tmp61_;
	GtkEventControllerFocus* _tmp62_;
	GtkEventControllerScroll* _tmp63_;
	GtkToggleButton* _tmp64_;
	GtkToggleButton* _tmp65_;
#line 82 "../lib/Widgets/TimePicker.vala"
	parent_class = G_OBJECT_CLASS (he_time_picker_parent_class);
#line 82 "../lib/Widgets/TimePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 82 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 83 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 83 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 84 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_12 (self, _ ("%-l:%M %p"));
#line 4775 "TimePicker.c"
	}
#line 87 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_format_24;
#line 87 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_ == NULL) {
#line 88 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_24 (self, _ ("%H:%M"));
#line 4783 "TimePicker.c"
	}
#line 91 "../lib/Widgets/TimePicker.vala"
	gtk_editable_set_width_chars ((GtkEditable*) self, 8);
#line 92 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("clock-symbolic");
#line 92 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 92 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp3_, NULL);
#line 92 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp3_);
#line 93 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) _he_time_picker_on_icon_press_gtk_entry_icon_release, self, 0);
#line 95 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("AM"));
#line 95 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp4_, TRUE);
#line 95 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp4_);
#line 95 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 95 "../lib/Widgets/TimePicker.vala"
	self->priv->am_togglebutton = _tmp4_;
#line 98 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = self->priv->am_togglebutton;
#line 98 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 98 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("PM"));
#line 98 "../lib/Widgets/TimePicker.vala"
	gtk_toggle_button_set_group (_tmp7_, _tmp6_);
#line 98 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp6_);
#line 98 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp7_, TRUE);
#line 98 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp7_);
#line 98 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 98 "../lib/Widgets/TimePicker.vala"
	self->priv->pm_togglebutton = _tmp7_;
#line 103 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 103 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
#line 103 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 16);
#line 103 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp8_);
#line 103 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 103 "../lib/Widgets/TimePicker.vala"
	self->priv->am_pm_box = _tmp8_;
#line 107 "../lib/Widgets/TimePicker.vala"
	_tmp9_ = self->priv->am_pm_box;
#line 107 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "segmented-button");
#line 108 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = self->priv->am_pm_box;
#line 108 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = self->priv->am_togglebutton;
#line 108 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 109 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = self->priv->am_pm_box;
#line 109 "../lib/Widgets/TimePicker.vala"
	_tmp13_ = self->priv->pm_togglebutton;
#line 109 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 111 "../lib/Widgets/TimePicker.vala"
	_tmp14_ = he_time_picker_clock_widget_new ();
#line 111 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp14_);
#line 111 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->clock);
#line 111 "../lib/Widgets/TimePicker.vala"
	self->priv->clock = _tmp14_;
#line 113 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 4863 "TimePicker.c"
		GtkSpinButton* _tmp15_;
		HeTimePickerClockWidget* _tmp16_;
#line 114 "../lib/Widgets/TimePicker.vala"
		_tmp15_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 12, (gdouble) 1);
#line 114 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp15_);
#line 114 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 114 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp15_;
#line 115 "../lib/Widgets/TimePicker.vala"
		_tmp16_ = self->priv->clock;
#line 115 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp16_, FALSE);
#line 4878 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp17_;
		HeTimePickerClockWidget* _tmp18_;
#line 117 "../lib/Widgets/TimePicker.vala"
		_tmp17_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 23, (gdouble) 1);
#line 117 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp17_);
#line 117 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 117 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp17_;
#line 118 "../lib/Widgets/TimePicker.vala"
		_tmp18_ = self->priv->clock;
#line 118 "../lib/Widgets/TimePicker.vala"
		he_time_picker_clock_widget_set_is_military_mode (_tmp18_, TRUE);
#line 4894 "TimePicker.c"
	}
#line 121 "../lib/Widgets/TimePicker.vala"
	_tmp19_ = self->priv->hours_spinbutton;
#line 121 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp19_, GTK_ORIENTATION_VERTICAL);
#line 122 "../lib/Widgets/TimePicker.vala"
	_tmp20_ = self->priv->hours_spinbutton;
#line 122 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp20_, TRUE);
#line 123 "../lib/Widgets/TimePicker.vala"
	_tmp21_ = self->priv->hours_spinbutton;
#line 123 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "display");
#line 124 "../lib/Widgets/TimePicker.vala"
	_tmp22_ = self->priv->hours_spinbutton;
#line 124 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp22_, "flat");
#line 125 "../lib/Widgets/TimePicker.vala"
	_tmp23_ = self->priv->hours_spinbutton;
#line 125 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp23_, "value-changed", (GCallback) __he_time_picker___lambda167__gtk_spin_button_value_changed, self, 0);
#line 127 "../lib/Widgets/TimePicker.vala"
	_tmp24_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
#line 127 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp24_);
#line 127 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 127 "../lib/Widgets/TimePicker.vala"
	self->priv->minutes_spinbutton = _tmp24_;
#line 128 "../lib/Widgets/TimePicker.vala"
	_tmp25_ = self->priv->minutes_spinbutton;
#line 128 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp25_, GTK_ORIENTATION_VERTICAL);
#line 129 "../lib/Widgets/TimePicker.vala"
	_tmp26_ = self->priv->minutes_spinbutton;
#line 129 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp26_, TRUE);
#line 130 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = self->priv->minutes_spinbutton;
#line 130 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp27_, "display");
#line 131 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = self->priv->minutes_spinbutton;
#line 131 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp28_, "flat");
#line 132 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = self->priv->minutes_spinbutton;
#line 132 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp29_, "value-changed", (GCallback) __he_time_picker___lambda168__gtk_spin_button_value_changed, self, 0);
#line 134 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = self->priv->minutes_spinbutton;
#line 134 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp30_, "output", (GCallback) __he_time_picker___lambda169__gtk_spin_button_output, self, 0);
#line 144 "../lib/Widgets/TimePicker.vala"
	_tmp31_ = (GtkLabel*) gtk_label_new (":");
#line 144 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp31_);
#line 144 "../lib/Widgets/TimePicker.vala"
	separation_label = _tmp31_;
#line 145 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = separation_label;
#line 145 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp32_, "display");
#line 147 "../lib/Widgets/TimePicker.vala"
	_tmp33_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 147 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp33_, 12);
#line 147 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp33_, 12);
#line 147 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp33_, 12);
#line 147 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp33_);
#line 147 "../lib/Widgets/TimePicker.vala"
	pop_grid_top = _tmp33_;
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp34_ = pop_grid_top;
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp35_ = self->priv->hours_spinbutton;
#line 152 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp34_, (GtkWidget*) _tmp35_);
#line 153 "../lib/Widgets/TimePicker.vala"
	_tmp36_ = pop_grid_top;
#line 153 "../lib/Widgets/TimePicker.vala"
	_tmp37_ = separation_label;
#line 153 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp36_, (GtkWidget*) _tmp37_);
#line 154 "../lib/Widgets/TimePicker.vala"
	_tmp38_ = pop_grid_top;
#line 154 "../lib/Widgets/TimePicker.vala"
	_tmp39_ = self->priv->minutes_spinbutton;
#line 154 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp38_, (GtkWidget*) _tmp39_);
#line 155 "../lib/Widgets/TimePicker.vala"
	_tmp40_ = pop_grid_top;
#line 155 "../lib/Widgets/TimePicker.vala"
	_tmp41_ = self->priv->am_pm_box;
#line 155 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp40_, (GtkWidget*) _tmp41_);
#line 157 "../lib/Widgets/TimePicker.vala"
	_tmp42_ = self->priv->clock;
#line 157 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp42_, "time-selected", (GCallback) __he_time_picker___lambda170__he_time_picker_clock_widget_time_selected, self, 0);
#line 170 "../lib/Widgets/TimePicker.vala"
	_tmp43_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 170 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp43_, 12);
#line 170 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp43_, 12);
#line 170 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp43_);
#line 170 "../lib/Widgets/TimePicker.vala"
	pop_grid_middle = _tmp43_;
#line 174 "../lib/Widgets/TimePicker.vala"
	_tmp44_ = pop_grid_middle;
#line 174 "../lib/Widgets/TimePicker.vala"
	_tmp45_ = self->priv->clock;
#line 174 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp44_, (GtkWidget*) _tmp45_);
#line 176 "../lib/Widgets/TimePicker.vala"
	_tmp46_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 24);
#line 176 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp46_);
#line 176 "../lib/Widgets/TimePicker.vala"
	pop_grid = _tmp46_;
#line 177 "../lib/Widgets/TimePicker.vala"
	_tmp47_ = pop_grid;
#line 177 "../lib/Widgets/TimePicker.vala"
	_tmp48_ = pop_grid_top;
#line 177 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp47_, (GtkWidget*) _tmp48_);
#line 178 "../lib/Widgets/TimePicker.vala"
	_tmp49_ = pop_grid;
#line 178 "../lib/Widgets/TimePicker.vala"
	_tmp50_ = pop_grid_middle;
#line 178 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp49_, (GtkWidget*) _tmp50_);
#line 180 "../lib/Widgets/TimePicker.vala"
	_tmp51_ = pop_grid;
#line 180 "../lib/Widgets/TimePicker.vala"
	_tmp52_ = _g_object_ref0 ((GtkWidget*) _tmp51_);
#line 180 "../lib/Widgets/TimePicker.vala"
	_tmp53_ = (GtkPopover*) gtk_popover_new ();
#line 180 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_autohide (_tmp53_, TRUE);
#line 180 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_child (_tmp53_, _tmp52_);
#line 180 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp52_);
#line 180 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp53_, FALSE);
#line 180 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_position (_tmp53_, GTK_POS_BOTTOM);
#line 180 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp53_);
#line 180 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 180 "../lib/Widgets/TimePicker.vala"
	self->priv->popover = _tmp53_;
#line 186 "../lib/Widgets/TimePicker.vala"
	_tmp54_ = self->priv->popover;
#line 186 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp54_, (GtkWidget*) self);
#line 187 "../lib/Widgets/TimePicker.vala"
	_tmp55_ = self->priv->popover;
#line 187 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp55_, FALSE);
#line 189 "../lib/Widgets/TimePicker.vala"
	_tmp56_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 189 "../lib/Widgets/TimePicker.vala"
	focus_controller = _tmp56_;
#line 190 "../lib/Widgets/TimePicker.vala"
	_tmp57_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 190 "../lib/Widgets/TimePicker.vala"
	scroll_controller = _tmp57_;
#line 194 "../lib/Widgets/TimePicker.vala"
	_tmp58_ = focus_controller;
#line 194 "../lib/Widgets/TimePicker.vala"
	_tmp59_ = _g_object_ref0 ((GtkEventController*) _tmp58_);
#line 194 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp59_);
#line 195 "../lib/Widgets/TimePicker.vala"
	_tmp60_ = scroll_controller;
#line 195 "../lib/Widgets/TimePicker.vala"
	_tmp61_ = _g_object_ref0 ((GtkEventController*) _tmp60_);
#line 195 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp61_);
#line 197 "../lib/Widgets/TimePicker.vala"
	_tmp62_ = focus_controller;
#line 197 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp62_, "leave", (GCallback) __he_time_picker___lambda171__gtk_event_controller_focus_leave, self, 0);
#line 201 "../lib/Widgets/TimePicker.vala"
	_tmp63_ = scroll_controller;
#line 201 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp63_, "scroll", (GCallback) __he_time_picker___lambda172__gtk_event_controller_scroll_scroll, self, 0);
#line 213 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "activate", (GCallback) _he_time_picker_is_unfocused_gtk_entry_activate, self, 0);
#line 215 "../lib/Widgets/TimePicker.vala"
	_tmp64_ = self->priv->am_togglebutton;
#line 215 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp64_, "clicked", (GCallback) __he_time_picker___lambda173__gtk_button_clicked, self, 0);
#line 219 "../lib/Widgets/TimePicker.vala"
	_tmp65_ = self->priv->pm_togglebutton;
#line 219 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp65_, "clicked", (GCallback) __he_time_picker___lambda174__gtk_button_clicked, self, 0);
#line 223 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "text-field");
#line 225 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (scroll_controller);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (focus_controller);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid_middle);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid_top);
#line 82 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (separation_label);
#line 82 "../lib/Widgets/TimePicker.vala"
	return obj;
#line 5118 "TimePicker.c"
}

static void
he_time_picker_class_init (HeTimePickerClass * klass,
                           gpointer klass_data)
{
#line 19 "../lib/Widgets/TimePicker.vala"
	he_time_picker_parent_class = g_type_class_peek_parent (klass);
#line 19 "../lib/Widgets/TimePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeTimePicker_private_offset);
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_time_picker_get_property;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_time_picker_set_property;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_time_picker_constructor;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_time_picker_finalize;
#line 5137 "TimePicker.c"
	/**
	     *  The string format of how to display the time when in 12h mode.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_FORMAT_12_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_FORMAT_12_PROPERTY] = g_param_spec_string ("format-12", "format-12", "format-12", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 5143 "TimePicker.c"
	/**
	     *  The string format of how to display the time when in 24h mode.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_FORMAT_24_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_FORMAT_24_PROPERTY] = g_param_spec_string ("format-24", "format-24", "format-24", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_TIME_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_TIME_PROPERTY] = g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5151 "TimePicker.c"
	/**
	     *  The signal when time is changed with this widget.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL] = g_signal_new ("time-changed", HE_TYPE_TIME_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5157 "TimePicker.c"
}

static void
he_time_picker_instance_init (HeTimePicker * self,
                              gpointer klass)
{
	gchar* _tmp0_;
#line 19 "../lib/Widgets/TimePicker.vala"
	self->priv = he_time_picker_get_instance_private (self);
#line 35 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = NULL;
#line 62 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 63 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 63 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp0_;
#line 5175 "TimePicker.c"
}

static void
he_time_picker_finalize (GObject * obj)
{
	HeTimePicker * self;
#line 19 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 28 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_12);
#line 33 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_24);
#line 35 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 63 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 64 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 65 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 66 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->hours_spinbutton);
#line 67 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 68 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 69 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 70 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->clock);
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_parent_class)->finalize (obj);
#line 5208 "TimePicker.c"
}

static GType
he_time_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTimePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_time_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTimePicker), 0, (GInstanceInitFunc) he_time_picker_instance_init, NULL };
	GType he_time_picker_type_id;
	he_time_picker_type_id = g_type_register_static (gtk_entry_get_type (), "HeTimePicker", &g_define_type_info, 0);
	HeTimePicker_private_offset = g_type_add_instance_private (he_time_picker_type_id, sizeof (HeTimePickerPrivate));
	return he_time_picker_type_id;
}

GType
he_time_picker_get_type (void)
{
	static volatile gsize he_time_picker_type_id__once = 0;
	if (g_once_init_enter (&he_time_picker_type_id__once)) {
		GType he_time_picker_type_id;
		he_time_picker_type_id = he_time_picker_get_type_once ();
		g_once_init_leave (&he_time_picker_type_id__once, he_time_picker_type_id);
	}
	return he_time_picker_type_id__once;
}

static void
_vala_he_time_picker_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 19 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, he_time_picker_get_format_12 (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, he_time_picker_get_format_24 (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_TIME_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_boxed (value, he_time_picker_get_time (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 5261 "TimePicker.c"
		default:
#line 19 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 5267 "TimePicker.c"
	}
}

static void
_vala_he_time_picker_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 19 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_12 (self, g_value_get_string (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_24 (self, g_value_get_string (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_TIME_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, g_value_get_boxed (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 5299 "TimePicker.c"
		default:
#line 19 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 5305 "TimePicker.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

